/*	cgi structure definition	*/

/*
 * CGI general type definition
 */

typedef	struct	{
	int	x;
	int	y;
}	Point;

typedef	struct	{
	Point	first;
	Point	second;
}	Rectangle;

typedef	struct	{
	int	x;
	int	y;
}	Vector;


/*
 * Device Coordinate
 *	data type & meaning depend on DEVICE VIEWPORT SPECIFICATION
 *		2*R	% of default viewport
 *		2*I	deci-millimeters
 *		2*I	native device units
 */

typedef	union	{
	struct	{
		float	x;
		float	y;
	}	Per;
	struct	{
		int	x;
		int	y;
	}	Dec;
	Point	Nat;
}	DC;

/*
 * Colour Value
 */
typedef	struct	{
	int	red;
	int	green;
	int	blue;
}	Colour_Direct;

typedef	union	{
	Colour_Direct	Direct;
	int		Index;
}	Colour;


/*
 * Error Stack
 */
typedef	struct	{
	char	*func_id;
	int	message;
}	ER;

typedef union {
	int	error_Reaction; /* ON or OFF */
	char	*font_name;
	int	zoom;		/* ON or OFF */
	char	*prompt;	/* XCreate's prompt */
	char	*geometry;	/* XCreate's geometry */
	int	(*expose)();	/* user's exposure event handler */
	int	(*unmap)();	/* user's unmap event handler */
	int	reservedSeg;	/* ON or OFF */
	int	nColours;	/* > 0 -> dynamic; = 0 -> static */
	int	kanji;		/* EUC or Shift-JIS */
} EscapeDataRecord;

typedef struct {
	short	width;
	short	height;
	short	cap;
	short	bottom;
} FontSize;

typedef union {
	FontSize	font_size;
/*	Window		windowId;	*/
} EscapeOutputDataRecord;

/* type Size -- for LINE_WIDTH, MARKER_SIZE, etc. */
typedef union {
	int	vdc;
	float	scaled;
} Size;

/* type FlaggedPoint -- for POLYGON_SET */
typedef struct {
	Point	point;
	char	flag;
} FlaggedPoint;

/* type PatternSize */
typedef struct {
	short	hx, hy;		/* pattern height vector */
	short	wx, wy;		/* pattern width vector */
} PatternSize;


typedef struct {
	float	m11, m12, m13, m21, m22, m23;
} TransformationMatrix;

#define MAX_STRING_LENGTH       255     /* maximum string buffer size */

/*	typedef char String[MAX_STRING_LENGTH + 1];	*/

typedef struct {	/* not supported */
	int status;
	int pickId;
	int segId;
} Seg;

#define MAX_STROKE_POINTS       10      /* not supported */

typedef union {
	Point	locator_Value;
	float	valuator_Value;				/* not supported */
	Point	stroke_Value[MAX_STROKE_POINTS];	/* not supported */
	int	choice_Value;
/*	String	string_Value;	*/
	Seg	pick_Value;				/* not supported */
} InputValue;

typedef struct {
	union {
		union {
			struct {
				int	number_Of_Alternatives;
/*				String	string_Array[MAX_STRING_ARRAY];	*/
			} echo3;
		} choice;
		union {
			struct {
				Point initial_Position;
			} echo4;
			struct {
				Point initial_Position;
			} echo5;
		} locator;
	} echo;
	union {
		int	prompt_Tone_Identifier;		 /* not supported */
/*		String	prompt_Message;	*/
	} prompt;
	union {
		int	acknowledgement_Tone_Identifier; /* not supported */
/*		String	acknowledgement_Message;	*/
	} acknowledgement;
} EchoDataRecord;

typedef union {
	/* standard items */
	struct {					/* not supported */
		Point pick_Aperture_Size;
	} pick;
	struct {
		int maximum_String_Size;
	} string;
	struct {					/* not supported */
		int	maximum_Number_Of_Points;
		Point	xy_Intervals;
		int	time_Interval;
	} stroke;
	struct {					/* not supported */
		float minimum_Value_Of_Range;
		float maximum_Value_Of_Range;
	} valuator;
	/* non-standard items */
	struct {
		int motion_Threshold;
		int motion_Magnifier;
	} locator;
	struct {
		int maximum_Alternatives;
	} choice;
} InputDataRecord;

typedef struct {
	int maximum_Number_Of_Alternatives;	/* for CHOICE */
	int maximum_String_Buffer_Size;		/* for STRING */
	int maximum_Number_Of_Stroke_Points;	/* not supported */
} InputMaxima;

