static makebitwiseimage(image,nx,ny,nplane,bitmap)
	unsigned char *image;
	unsigned short *bitmap;
	int nx,ny,nplane;
{
	int x,y,ni,xx,yy,xr,yr,z,linesize,mapsize;
	unsigned short wmask, *wp, w[8], avr;
	unsigned char b, *bp, *bp0, *ip, *ip0;
	static int level[64]	= {
		0,0,0,0,0,0,0,0,0,0,
		1,1,1,1,
		2,2,2,2,
		3,3,3,3,
		4,4,4,4,
		5,5,5,5,
		6,6,6,6,
		7,7,7,7,
		8,8,8,8,
		9,9,9,9,
		10,10,10,10,
		11,11,11,11,
		12,12,12,12,12,12,12,12,12,12	};
	static unsigned char dither8x8[13][8] =	{
		0,0,0,0,0,0,0,0,					/*	0 dot	*/
		0,0,0, 0x08, 0,0,0,0,				/*	1 dot	*/
		0,0,0, 0x22, 0,0,0,0,				/*	2 dots	*/
		0,0x08, 0, 0x08, 0, 0x08, 0,0,		/*	3 dots	*/
		0, 0x44, 0,0, 0, 0x44, 0,0,			/*	4 dots	*/
		0, 0x42, 0, 0x08, 0x20, 0, 0x42, 0,		/*	6 dots	*/
		0, 0x44, 0, 0x88, 0, 0x44, 0, 0x88,		/*	8 dots	*/
		0x11, 0, 0x55, 0, 0x11, 0, 0x55, 0,		/*	12 dots	*/
		0x55, 0, 0x55, 0, 0x55, 0, 0x55, 0,		/*	16 dots	*/
		0x55, 0x44, 0x55, 0x88, 0x55, 0x44, 0x55, 0x88,	/*	24 dots	*/
		0xcc, 0x55, 0xcc, 0x55, 0xcc, 0x55, 0xcc, 0x55,	/*	32 dots	*/
		0xff, 0xcc, 0xff, 0xcc, 0xff, 0xcc, 0xff, 0xcc,	/*	48 dots	*/
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff	/*	64 dots	*/
		};
	static unsigned char dither4x4[17][4] = 	{
		0, 0, 0, 0,		/*	0	*/
		0, 4, 0, 0,		/*	1	*/
		0, 5, 0, 0,		/*	2	*/
		0, 5, 0, 4,		/*	3	*/
		0, 5, 0, 5,		/*	4	*/
		0, 5, 2, 5,		/*	5	*/
		2, 5, 2, 5,		/*	6	*/
		2, 5, 10, 5,	/*	7	*/
		6, 5, 10, 5,	/*	8	*/
		6, 13, 10, 5,	/*	9	*/
		7, 13, 10, 5,	/*	10	*/
		7, 13, 10, 13,	/*	11	*/
		7, 13, 11, 13,	/*	12	*/
		7, 13, 11, 15,	/*	13	*/
		7, 15, 11, 15,	/*	14	*/
		7, 15, 15, 15,	/*	15	*/
		15, 15, 15, 15	/*	16	*/
		};

/*
	image(x,y)=image[y][x] -- 8-bit-deep image data
	bitmap(i,y,z)=bitmap[z][y][i] -- bitmap
		y = 0 to ny
		x = 0 to nx
		i = 0 to ni
	size of one bitmap plane = mapsize *16 bits
	if nplane =1, halftone is represented by dithering
*/

	ni = ( (15+ nx) / 16 )  -1;
	if (nplane == 1) goto dither4;
	if (nplane < 1 ) goto dither8;

	mapsize = (ni+1)*ny;	/*	in words	*/
	for (y=0; y< ny; y++)	{
		for (x=0; x< nx-15; x+=16, bitmap++ )	{
			for (xx=0; xx<16 ; xx++, image++)	{
				b= *image;
/*
				for (z=0; z<8; z++)	{
					w[z] <<= 1;
					w[z] |= (b & 1);
					b >>= 1;
				}
				expand do loop	*/
				w[0] <<= 1;
				w[0] |= (b & 1);
				b >>= 1;
				w[1] <<= 1;
				w[1] |= (b & 1);
				b >>= 1;
				w[2] <<= 1;
				w[2] |= (b & 1);
				b >>= 1;
				w[3] <<= 1;
				w[3] |= (b & 1);
				b >>= 1;
				w[4] <<= 1;
				w[4] |= (b & 1);
				b >>= 1;
				w[5] <<= 1;
				w[5] |= (b & 1);
				b >>= 1;
				w[6] <<= 1;
				w[6] |= (b & 1);
				b >>= 1;
				w[7] <<= 1;
				w[7] |= (b & 1);
				b >>= 1;
			}
/*
			for (z=0,wp=bitmap; z<8; z++, wp+=mapsize)
				*wp = w[z];	
			expand do loop	*/
			wp=bitmap;
			*wp=w[0]; wp+=mapsize;
			*wp=w[1]; wp+=mapsize;
			*wp=w[2]; wp+=mapsize;
			*wp=w[3]; wp+=mapsize;
			*wp=w[4]; wp+=mapsize;
			*wp=w[5]; wp+=mapsize;
			*wp=w[6]; wp+=mapsize;
			*wp=w[7]; wp+=mapsize;
		}
/*		for remaining columns if any	*/
		if ( x == nx )	continue;
		wmask = 1;
		for (xx=0 ; xx<16; xx++)	{
			if (xx >= nx - x ) wmask=0;
			b= *image;
			for (z=0; z<8; z++)	{
				w[z] <<= 1;
				w[z] |= ( wmask & ( b & 1) );
				b >>= 1;
			}
			if (wmask) ++image;
		}
		for (z=0,wp=bitmap; z<8; z++, wp+=mapsize)
			*wp = w[z];	
		bitmap++;
	}
	return;

dither4:
	linesize= 2*(ni+1);		/*	in bytes	*/
	ip0 = image;
	bp0 = (char *) bitmap;
      for (y=0; y< ny ; y+=4 )  {
		if ( ny - y >= 4 )	yr = 4;
		else				yr = ny - y;

		for (x=0; x< nx-7; x+=8, ip0 +=8, bp0++ )	{
			avr=0;
			for (yy=0, ip=ip0; yy<yr; yy++, ip+=nx )	{
				for (xx=0; xx<4; xx++)	avr+= *(ip++);
				ip -= 4;
			}
			avr /= (4*yr);
			avr = (avr+1)/16;	/*	avr <= 16	*/

			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)
				*bp = dither4x4[avr][yy] << 4;

			avr=0;
			for (yy=0, ip=ip0+4; yy<yr; yy++, ip+=nx )	{
				for (xx=4; xx<8; xx++)	avr+= *(ip++);
				ip -= 4;
			}
			avr /= (4*yr);
			avr = (avr+1)/16;	/*	avr <= 16	*/

			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)	
				*bp |= dither4x4[avr][yy];
		}

/*		remaining columns if any	*/
		if ( ( xr = nx-x ) > 4 ) {
           		avr=0;
			for (yy=0, ip=ip0; yy<yr; yy++, ip+=nx )	{
				for (xx=0; xx< 4; xx++)	avr+= *(ip++);
				ip -= 4;
			}
			avr /= (4*yr);
			avr = (avr+1)/16;	/*	avr <= 16	*/
			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)
				*bp = dither4x4[avr][yy] << 4;

			xr -=4;
           		avr=0;
			for (yy=0, ip=ip0+4; yy<yr; yy++, ip+=nx )	{
				for (xx=0; xx< xr; xx++)	avr+= *(ip++);
				ip -= xr;
			}
			avr /= xr*yr;
			avr = (avr+1)/16;	/*	avr <= 16	*/
			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)	{
				*bp |= dither4x4[avr][yy];
				*bp >>= (4-xr);
				*bp <<= (4-xr);
			}
			x+=8;
			ip0+= 4+xr;
			bp0++;
		}
		else if ( xr > 0 )	{
           		avr=0;
			for (yy=0, ip=ip0; yy<yr; yy++, ip+=nx )	{
				for (xx=0; xx< xr; xx++)	avr+= *(ip++);
				ip -= xr;
			}
			avr /= (xr*yr);
			avr = (avr+1)/16;	/*	avr <= 16	*/

			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)	{
				*bp = dither4x4[avr][yy];
				*bp >>= (4-xr);
				*bp <<= (4-xr);
				*bp <<= 4;
			}
			ip0 += xr;
			bp0++;
			x +=8;
		}
		if ( x % 16 == 8 )	{
			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)	*bp = 0;
			bp0++;
		}
	ip0 += (yr-1)*nx;
	bp0 += (yr-1)*linesize;
	}

	return;

dither8:
	linesize= 2*(ni+1);		/*	in bytes	*/
	ip0 = image;
	bp0 = (char *) bitmap;
      for (y=0; y< ny ; y+=8 )  {
		if ( ny - y >= 8 )	yr = 8;
		else				yr = ny - y;

		for (x=0; x< nx-7; x+=8, ip0 +=8, bp0++ )	{
			avr=0;
			for (yy=0, ip=ip0; yy<yr; yy++, ip+=nx )	{
				for (xx=0; xx<8; xx++)	avr+= *(ip++);
				ip -= 8;
			}
			avr /= (4*8*yr);	/* 	avr < 64, level[avr] < 13	*/

			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)	
				*bp = dither8x8[level[avr]][yy];
		}

/*		remaining columns if any	*/
		if ( ( xr = nx-x ) > 0 ) {
           		avr=0;
			for (yy=0, ip=ip0; yy<yr; yy++, ip+=nx )	{
				for (xx=0; xx< xr; xx++)	avr+= *(ip++);
				ip -= xr;
			}
			avr /= (4*xr*yr);
			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)	{
				*bp = dither8x8[level[avr]][yy];
				*bp >>= (8-xr);
				*bp <<= (8-xr);
			}
			ip0 += xr;
			bp0++;
			x +=8;
		}
		if ( x % 16 == 8 )	{
			for (yy=0, bp=bp0; yy<yr; yy++, bp+=linesize)	*bp = 0;
			bp0++;
		}
	ip0 += (yr-1)*nx;
	bp0 += (yr-1)*linesize;
	}
}

