c  MAGPACK2 binary star model: main program
c
	include 'sys.fc'
	include 'fileio.fc'
	include 'string.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'mdata.fc'
	include 'fcntl.fc'
	include 'procs.fc'
	include 'auxparam.fc'
c
	character chr*1,cfile*80,line*80,line1*80,line2*80
	dimension multi(20)
	data multi/20*0/
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	msglvl = 1
c
c  character code should either be ASCII or EBCDIC
c  binary integer should either be big endian or 
c  full-byte-swap little endian
	include 'sysconf.cfg'
c
	if(mycode.eq.0 .or. myint.eq.0) stop
	if(errflg.gt.0) stop
c
c  initialize commons /fcntl/ and /procs/
	call initfc
c
        call openfl(list,lname(list),lst,' ',fprint,wrt,0)
c
c  print version number
	call vsn
c
c  common variables should be static
	call static(ist)
	if(ist.gt.1) stop
c  algorithm for byte swap should be correct
        call swap(iswap)
        if(iswap.gt.0) stop
c
      if(myargc().eq.1) then
        call myargv(1,cfile)
      else
	  cfile=' '
	  write(msg,*,err=2)
     &	'enter control file name (default=control.bin)'
	  go to 3
 2	  msg=lst
	  write(msg,*) 'enter control file name (default=control.bin)'
 3	  read(keyin,'(a)',end=4) cfile
 4	  if(cfile.eq.' ') cfile='control.bin'
	endif
c
        call openfl(cntrol,lname(cntrol),stdin,cfile,text,rdo,0)
	write(lst,*) '(proc.binary) start'
c
c  the first column of the first line gives the global msglvl
	read(stdin,'(a1,a)') chr,line
	if (chr.eq.'0') then
	  msglvl=0
	else if(chr.eq.'1') then
	  msglvl=1
	else if(chr.eq.'2') then
	  msglvl=2
	else if(chr.eq.'3') then
	  msglvl=3
	endif
c  current version number of control file
        iver0=0
c  check the version number
        call split(line,'=',line1,line2,len1,len2)
        if(len2.eq.0) then
          iver1=0
        else
          read(line2,*) iver1
        endif
        if(iver1.ne.iver0.and.
     &	  .not.(iver0.eq.1.and.iver1.eq.0)) then
          write(msg,*) 'error: version of control file should be',
     &    iver0
          errflg=2
          stop
        endif
c
c  initialize common variables and read auxdata
	multi1=0
	call assign( init,multi1 )
	if(errflg.gt.0) stop
	if(multi1.ne.0) stop
	call initc( funit(auxdat) )
	call clsfl(auxdat)
c
	if(nbytem.ne.0) then
	  nbytem=sign(nbytem,myint)
	else
	  nbytem=myint
	endif
	if(nbytel.ne.0) then
	  nbytel=sign(nbytel,myint)
	else
	  nbytel=myint
	endif
c
 1000	continue
	errflg=0
	ms=0
c
c
c  proc.integp
c  integrate potential field lines
c
c  subr.assign reads msglvl,rdfpt,irefpt,rds1,rds2
c
	nsp=2
	rds1=.true.
	rds2=.false.
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( integp,multi(ms) )
	if(errflg.gt.1) go to 1008
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  kindm=0
	  kindl=12
c
	  call sets12( rds1, funit(s1data) )
	  if(errflg.gt.1) go to 1008
c
c  irefpt gt 0  : footpoints are taken from reflof-file
c       =.false.: footpoints will be distributed proportional to
c                 magnetic flux
c
	  kindl=mod(kindl,1000)
	  read(stdin,*) nf0,cancel,flxpwr,ds0
	  nf=nf0
c  nf is updated by ftpflx and integ
	  if (irefpt.gt.0 .and. irefpt.le.3) then
	    call fptref( funit(reflof) )
	    if(errflg.gt.1) go to 1008
	  else 
	    call fptflx
	    if(errflg.gt.1) go to 1008
	  endif
	  if (rdfpt) then
	    call readfp( funit(footpt) )
	    if(errflg.gt.1) go to 1008
	  endif
c
	  call integ( funit(potlof) )
	  call weof( funit(potlof) )
	  if(errflg.gt.1) go to 1008
	endif
c
 1008	continue
	if(errflg.ne.1) then
	  call clsfl (s1data)
	  if (irefpt.gt.0 .and. irefpt.le.3) call clsfl (reflof)
	  if (rdfpt) call clsfl (footpt)
	  call clsfl (potlof)
	endif
	if(errflg.gt.1) go to 1900
c
c
c  proc.eval
c  evaluate magnetic fields at specified points
c
c  subr.assign reads msglvl,rds1,rds2,rds123,mkmmap
	rds1=.true.
	rds2=.false.
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( eval,multi(ms) )
 	if(errflg.gt.1) go to 1010
	if(multi(ms).lt.0) stop
c
 	if(errflg.eq.0) then
	  kindm=0
	  kindl=12
c
	  call sets12( rds1, funit(s1data) )
	  if(errflg.gt.1) go to 1010
c
	  call evalb( funit(evalpt), funit(gmgram) )
	  if(errflg.gt.1) go to 1010
	endif
c
 1010	continue
	if(errflg.ne.1) then
	  call clsfl (s1data)
	  call clsfl (evalpt)
	endif
	if(errflg.gt.1) go to 1900
c
 1900	continue
        do 1100 i=1,20
        if(multi(i).ne.0) then
          if(errflg.le.1) go to 1000
        endif
 1100   continue
c  it is better stop the job here if errflg=2, because the correspondence
c  between the input and output files may become non-synchronous
c
	write(lst,*) '(proc.binary) end'
	stop
	end
