c  calculate current-free fields on the mesh points
c
	subroutine cff0(bxp,byp,bzp,ndim)
c
	include 'sys.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'mparam.fc'
cx	include 'fline.fc'
c
	dimension xx(3),xx1(3),bb(3)
	dimension bxp(ndim,ndim),byp(ndim,ndim),bzp(ndim,ndim)
c
	do 1000 j=1,ny
	do 1000 i=1,nx
	xx1(1)=xs+dx*float(i-1)
	xx1(2)=ys+dy*float(j-1)
	xx1(3)=0.0
	call dtoc(xx1,xx)
	if(mesh.eq.1) then
	  call projt(xx,xt,yt)
	else if(mesh.eq.2) then
	  call projs(xx,ap,al)
	else if(mesh.ge.3) then
	  call projr(xx,ap,al)
	endif
c
	call field(xx,bb,1,1,1)
	bxp(i,j)=bb(1)
	byp(i,j)=bb(2)
	bzp(i,j)=bb(3)
c
	if(errflg.gt.1) return
 1000	continue
c
	if(msglvl.gt.0) write(lst,*) '(subr.cff0  ) end: mesh=',mesh
	return
	end
c
c  current-free field by FFT
c  input:  bz given in rdata(*,*,kz), and amat matrix
c  output: bxp and byp given in rdata(*,*,kxp),rdata(*,*,kyp)
c
	subroutine cff1(kz,amat,kxp,kyp)
c
	include 'sys.fc'
	include 'coord.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'fileio.fc'
	parameter (MM1D=8*MX*MY)
c
	complex cx0,cy0,cx,cy,cdx,cdy
	dimension ndims(2),work(MMX,2)
	dimension amat(3,3)
	dimension datax(MM1D),datay(MM1D),dataz(MM1D)
	equivalence (qdata(1,1,1),datax(1)),
     &	      (qdata(1,1,9),datay(1),dataz(1))
c
	data pi/3.141592/
c
	call allocm(1,16,'cff1')
	if(errflg.gt.1) then
	  write(msg,*) '(subr.cff1  ) error'
	  return
	endif
c
c  set bz into data for Fourier transform
c  calculate flux
c
	nx2=2*nx
	ny2=2*ny
	if(nx2.gt.MMX .or. ny2.gt.MMY) then
	  write(msg,*) '(subr.cff1  ) error: data size nx2,ny2=',nx2,ny2
	  errflg=2
	  return
	endif
c
	ndims(1)=nx2
	ndims(2)=ny2
	alx=dx*float(nx2)/(2.0*pi)
	aly=dy*float(ny2)/(2.0*pi)
c
	bzsump=0.0
	bzsumm=0.0
	do 1100 j=1,ny
	do 1100 i=1,nx
	if(rdata(i,j,kz).gt.0.0) bzsump=bzsump+rdata(i,j,kz)
	if(rdata(i,j,kz).lt.0.0) bzsumm=bzsumm-rdata(i,j,kz)
 1100	continue
	bl00=(bzsump-bzsumm)/float(nx*ny)
c
c  bl00 is the dc component if bz
c
	nn=nx2*ny2
	do 1200 j=1,ny2
	do 1200 i=1,nx2
	l=i+nx2*(j-1)
	dataz(2*l-1)=bl00
 1200	dataz(2*l)=0.0
c
	do 1300 j=1,ny
	do 1300 i=1,nx
	l=i+nx2*(j-1)
	dataz(2*l-1)=rdata(i,j,kz)
 1300	continue
c
c  Fourier transform of bz
c
	if(msglvl.gt.2) write(lst,*)
     &  '(subr.cff1  ) FFT start (BZ)',ndims
	call fourt(dataz,ndims,2,-1,0,work)
	if(msglvl.gt.2) write(lst,*)
     &  '              FFT end'
c
c  amat=unit matrix if (mesh,mesho)=(1,1), (0,0) or (-1,0)
c  amat=atmat if (mesh,mesho)=(0,-1) or (-1,-1)
c  (if mesh=-1, FFT is done as if mesh=0)
c
	bn00=bl00/amat(3,3)
	bx00=amat(1,3)*bn00
	by00=amat(2,3)*bn00
	if(msglvl.gt.2) then
	  write(lst,*) '(subr.cff1  ) bx00,by00,bl00,bn00=',
     &	  bx00,by00,bl00,bn00
	endif
c
c  potential field bxp,byp by fourier method
c
	do 2000 j=1,ny2
	do 2000 i=1,nx2
	l=i+nx2*(j-1)
	dataz(2*l-1)=dataz(2*l-1)/float(nn)
	dataz(2*l)  =dataz(2*l)  /float(nn)
	if(i.eq.1.and.j.eq.1) go to 2000
	kwx=i-1
	if(kwx.gt.nx) kwx=kwx-nx2
	kwy=j-1
	if(kwy.gt.ny) kwy=kwy-ny2
c
	call setbtp(kwx,kwy,alx,aly,cx0,cy0,amat)
	cx=cx0
	cy=cy0
	if(kwx.eq.nx) then
	  af=0.5
	  if(kwy.eq.ny) af=0.25
	  call setbtp(-kwx,kwy,alx,aly,cdx,cdy,amat)
	  cx=cx+af*(cdx-cx0)
	  cy=cy+af*(cdy-cy0)
	endif
	if(kwy.eq.ny) then
	  af=0.5
	  if(kwx.eq.nx) af=0.25
	  call setbtp(kwx,-kwy,alx,aly,cdx,cdy,amat)
	  cx=cx+af*(cdx-cx0)
	  cy=cy+af*(cdy-cy0)
	endif
	if(kwx.eq.nx.and.kwy.eq.ny) then
	  call setbtp(-kwx,-kwy,alx,aly,cdx,cdy,amat)
	  cx=cx+0.25*(cdx-cx0)
	  cy=cy+0.25*(cdy-cy0)
	endif
	cx=cx*cmplx(dataz(2*l-1),dataz(2*l))
	cy=cy*cmplx(dataz(2*l-1),dataz(2*l))
	datax(2*l-1)=real(cx)
	datax(2*l)=aimag(cx)
	datay(2*l-1)=real(cy)
	datay(2*l)=aimag(cy)
c  now dataz(2*l-1) and datax(2*l) were destroyed
c
 2000	continue
	datax(1)=0.0
	datax(2)=0.0
	datay(1)=0.0
	datay(2)=0.0
c
	if(msglvl.gt.2) write(lst,*)
     &   '(subr.cff1  ) rev-FFT start (BX)',ndims
	call fourt(datax,ndims,2,1,1,work)
	if(msglvl.gt.2) write(lst,*)
     &   '              rev-FFT end'
c
	if(msglvl.gt.2) write(lst,*)
     &   '(subr.cff1  ) rev-FFT start (BY)',ndims
	call fourt(datay,ndims,2,1,1,work)
	if(msglvl.gt.2) write(lst,*)
     &   '              rev-FFT end'
c
	errx=0.0
	erry=0.0
	do 2100 j=1,ny
	do 2100 i=1,nx
	l=i+nx2*(j-1)
	errx=max(errx,abs(datax(2*l)))
	erry=max(erry,abs(datay(2*l)))
	rdata(i,j,kxp)=datax(2*l-1)+bx00
	rdata(i,j,kyp)=datay(2*l-1)+by00
 2100	continue
c
c  imaginary parts of datax&y are eliminated
c  dc components (bx00,by00) are added to (bxp,byp)
c  this is equivalent to the assumption that the dc component is due to 
c  a constant vector directed in the n-direction
c
	if(msglvl.gt.2) write(lst,*) '(subr.cff1  ) errx,y=',errx,erry
	call freem(1,16)
	return
	end
c
c  factor in front of the fourier coefficients for btp
c
	subroutine setbtp(kwx,kwy,alx,aly,cx,cy,amat)
	complex ckz,cx,cy,ci
	dimension amat(3,3)
	ci=(0.0,1.0)
	akwx=float(kwx)/alx
	akwy=float(kwy)/aly
	akx=akwx*amat(1,1)
	aky=akwx*amat(1,2)+akwy*amat(2,2)
	akz=sqrt(akx**2+aky**2)
	ckz=ci*akz-akwx*amat(1,3)-akwy*amat(2,3)
	cx=(akwx+ckz*amat(1,3))/(ckz*amat(3,3))
	cy=(akwy+ckz*amat(2,3))/(ckz*amat(3,3))
	return
c
c  factor in front of the fourier coefficients for curl bh
c
	entry setc(kwx,kwy,alx,aly,cx,cy,amat)
	ci=(0.0,1.0)
	akwx=float(kwx)/alx*amat(1,1)
	akwy=float(kwy)/aly*amat(2,2)+float(kwx)/alx*amat(1,2)
	cx=ci*akwy
	cy=ci*akwx
	return
c
	entry setkw(kwx,kwy,alx,aly,akwx1,akwy1,akw2,amat)
	akwx1=float(kwx)/alx*amat(1,1)
	akwy1=float(kwy)/aly*amat(2,2)+float(kwx)/alx*amat(1,2)
	akw2=akwx1**2+akwy1**2
	return
	end
