c  contour plot
c  plotting is made by calling a subroutine 'pline2(np,xp,yp)'
c
c
	subroutine cntr2(nx,ny,xs,ys,dx,dy,ndim,data,nv,value,
     &	                idot,ds,ksw)
c
c  data array is data(nx,ny), ksw(nx,ny) is working space
c  data points: origin=(xs,ys), increment=(dx,dy)
c  data values = ufl are regarded as unfilled data points
c  contour levels are value(1-nv)
c  contours are dotted lines if idot=1, otherwise solid lines
c  ds<0 : output is line segment
c         otherwise : spline curve with step ds
c
	include 'sys.fc'
	include 'fline.fc'
c
	dimension xp(ML),yp(ML)
	dimension data(ndim,ndim),value(nv),ksw(ndim,ndim)
	dimension xxp(2,ML),s(ML),
     &	          a0(ML,2),a1(ML,2),a2(ML,2),a3(ML,2),
     &	          aw(ML),bw(ML),cw(ML)
c
c  ML is defined in fline.fc
c
        equivalence (a0(1,1),xyzr(1,1))
        equivalence (a0(1,2),xyzr(1,2))
        equivalence (a1(1,1),xyzr(1,3))
        equivalence (a1(1,2),xyzr(1,4))
        equivalence (a2(1,1),xyzr(1,5))
        equivalence (a2(1,2),xyzr(1,6))
        equivalence (a3(1,1),xyzr(1,7))
        equivalence (a3(1,2),xyzr(1,8))
        equivalence (xp(1),xyzpr(1,1))
        equivalence (yp(1),xyzpr(1,2))
        equivalence (s (1),xyzpr(1,3))
        equivalence (aw(1),xyzpr(1,4))
        equivalence (bw(1),xyzpr(1,5))
        equivalence (cw(1),xyzpr(1,6))
        equivalence (xxp(1,1),xyzpr(1,7))
c
	dimension id(4),jd(4),ir0(4),jr0(4),is0(6),js0(6),ie0(6),je0(6)
	data ir0/0,1,0,-1/, jr0/-1,0,1,0/ ,id/1,0,-1,0/,jd/0,1,0,-1/
c
	fx(i)=xs+dx*float(i-1)
	fy(j)=ys+dy*float(j-1)
c
c  ufl=1.0e-15
c  ufl is defined in sys.fc
	eps=1.0e-5
	nx1=nx-1
	ny1=ny-1
	ncntr=0
c
	do 4000 iv=1,nv
	ncntr1=0
	v=value(iv)
c
	do 1100 j=1,ny
	do 1100 i=1,nx
 1100	ksw(i,j)=0
c
	is0(1)=1
	is0(2)=1
	is0(3)=nx
	is0(4)=2
	is0(5)=2
	is0(6)=1
	ie0(1)=1
	ie0(2)=nx1
	ie0(3)=nx
	ie0(4)=nx
	ie0(5)=nx1
	ie0(6)=nx1
	js0(1)=2
	js0(2)=1
	js0(3)=1
	js0(4)=ny
	js0(5)=2
	js0(6)=2
	je0(1)=ny
	je0(2)=1
	je0(3)=ny1
	je0(4)=ny
	je0(5)=ny
	je0(6)=ny1
c
	do 1000 ld00=1,6
	ld0=mod(ld00-1,4)+1
	is=is0(ld00)
	ie=ie0(ld00)
	js=js0(ld00)
	je=je0(ld00)
	do 1000 j=js,je
	do 1000 i=is,ie
	il=i
	jl=j
 1220	ir=il+ir0(ld0)
	jr=jl+jr0(ld0)
	if(data(il,jl).ne.ufl.and.data(ir,jr).ne.ufl) go to 1210
	il=il+id(ld0)
	jl=jl+jd(ld0)
	if(il.lt.1.or.il.gt.nx.or.jl.lt.1.or.jl.gt.ny) go to 1000
	go to 1220
 1210	fl=data(il,jl)-v
	fr=data(ir,jr)-v
c
 1250	if(fl*fr) 1300,1200,1000
 1200	fr=fr+eps
	fl=fl+eps
	go to 1250
 1300	ib0=(il+ir)/2
	jb0=(jl+jr)/2
	if(mod(ld0,2).eq.1.and.ksw(ib0,jb0)/10.ne.0) go to 1000
	if(mod(ld0,2).eq.0.and.mod(ksw(ib0,jb0),10).ne.0) go to 1000
	ld=ld0
	np=0
c
 3000	continue
	xl=fx(il)
	xr=fx(ir)
	yl=fy(jl)
	yr=fy(jr)
	dlr=fl-fr
	if(dlr.eq.0.0) go to 3100
	r=fl/dlr
	if(r.lt.0.0.or.r.gt.1.0) go to 8000
	if(np.ge.ML) go to 6000
	np=np+1
	xp(np)=xl+r*(xr-xl)
	yp(np)=yl+r*(yr-yl)
	lr=1
	if(r.lt.0.5) lr=-1
	ib=(il+ir)/2
	jb=(jl+jr)/2
	l=mod(ld,2)
	if(l.eq.1) ksw(ib,jb)=ksw(ib,jb)+10
	if(l.eq.0) ksw(ib,jb)=ksw(ib,jb)+1
	if(np.gt.1.and.ib.eq.ib0.and.jb.eq.jb0.and.l.eq.mod(ld0,2))
     &	  go to 3200
	if(lr) 1950,1950,2150
c
 1900	if(lr.eq.-1) go to 2500
 1950	continue
	i1=il+id(ld)
	j1=jl+jd(ld)
	if(i1.lt.1.or.i1.gt.nx.or.j1.lt.1.or.j1.gt.ny)
     &	  if(lr) 2150,2150,3100
	if(data(i1,j1).eq.ufl) if(lr) 2150,2150,3100
	f1=data(i1,j1)-v
c
 2250	if(fl*f1) 2000,2200,2100
 2200	fl=fl+eps
	f1=f1+eps
	go to 2250
 2000	continue
	ld1=mod(ld,4)+1
	ib=(il+i1)/2
	jb=(jl+j1)/2
	if(ib.eq.ib0.and.jb.eq.jb0.and.mod(ld1,2).eq.mod(ld0,2))
     &     go to 2050
	if(mod(ld1,2).eq.1.and.ksw(ib,jb)/10.ne.0) go to 2100
	if(mod(ld1,2).eq.0.and.mod(ksw(ib,jb),10).ne.0) go to 2100
 2050	ld=ld1
	x1=fx(i1)
	y1=fy(j1)
	fr=f1
	ir=i1
	jr=j1
	go to 3000
c
 2100	if(lr.eq.1) go to 2500
 2150	continue
	i2=ir+id(ld)
	j2=jr+jd(ld)
	if(i2.lt.1.or.i2.gt.nx.or.j2.lt.1.or.j2.gt.ny)
     &	  if(lr) 3100,1950,1950
	if(data(i2,j2).eq.ufl) if(lr) 3100,1950,1950
	f2=data(i2,j2)-v
c
 2350	if(fr*f2) 2400,2300,1900
 2300	fr=fr+eps
	f2=f2+eps
	go to 2350
 2400	continue
	ld2=mod(ld+2,4)+1
	ib=(ir+i2)/2
	jb=(jr+j2)/2
	if(ib.eq.ib0.and.jb.eq.jb0.and.mod(ld2,2).eq.mod(ld0,2))
     &    go to 2450
	if(mod(ld2,2).eq.1.and.ksw(ib,jb)/10.ne.0) go to 1900
	if(mod(ld2,2).eq.0.and.mod(ksw(ib,jb),10).ne.0) go to 1900
 2450	ld=ld2
	x2=fx(i2)
	y2=fy(j2)
	il=i2
	jl=j2
	fl=f2
	go to 3000
c
 2500	continue
	il=i1
	jl=j1
	ir=i2
	jr=j2
	fl=f1
	fr=f2
	go to 3000
c
 3100	iret=0
	go to 3500
 3200	iret=1
 3500	if(np.lt.2) go to 1000
	if(ds.le.0.0) go to 5000
c
	do 3400 n=1,np
	xxp(1,n)=xp(n)
	xxp(2,n)=yp(n)
 3400	continue
c
c  eliminates points too close with each other
c
	n=1
	do 3600 l=2,np
	if(abs(xxp(1,l)-xxp(1,l-1)).lt.eps .and.
     &	   abs(xxp(2,l)-xxp(2,l-1)).lt.eps ) go to 3600
	n=n+1
	xxp(1,n)=xxp(1,l)
	xxp(2,n)=xxp(2,l)
 3600	continue
	np=n
c
	if(np.lt.2.or.(iret.eq.1.and.np.lt.3)) go to 1000
	if(iret.eq.1) then
	  xxp(1,np)=xxp(1,1)
	  xxp(2,np)=xxp(2,1)
	endif
c
	call spline(2,ML,np,1,s,xxp,a0,a1,a2,a3,aw,bw,cw)
c
	npp=s(np)/(2.0*ds)
	nn=max0(2*ifix(s(np)/ds/2.0)+1,5)
	if(nn.gt.ML) go to 7000
	dss=s(np)/float(nn-1)
	l=2
	do 4400 n=2,nn
	if(n.ne.nn) go to 4420
	l=np
	t=1.0
	go to 4410
 4420	t=(dss*float(n-1)-s(l-1))/(s(l)-s(l-1))
c
	if(t.gt.1.01.and.l.eq.np) go to 4405
	if(t.le.1.01) go to 4410
	l=l+1
	go to 4420
 4405	t=1.0
 4410	do 4500 k=1,2
 4500  	xxp(k,n)=((a3(l-1,k)*t+a2(l-1,k))*t+a1(l-1,k))*t+a0(l-1,k)
 4400	continue
	np=nn
c
	do 5100 n=1,np
	xp(n)=xxp(1,n)
 5100	yp(n)=xxp(2,n)
 5000	continue
c
	if(idot.eq.1) then
	  do 5300 n=1,np-1,2
 5300	  call pline2(2,xp(n),yp(n))
	else
	  call pline2(np,xp,yp)
	endif
c
	ncntr1=ncntr1+1
	ncntr=ncntr+1
	go to 1000
 6000	write(lst,*)
     &	  '(subr.cntr2 ) warning: working area overflow, npmax=',ML
	go to 3100
 7000	write(lst,*)  
     &	  '(subr.cntr2 ) warning: working area overflow, npmax=',ML
	np=ML
	go to 5000
 8000	if(msglvl.gt.2) write(lst,300) v,np,il,jl,ir,jr,r
 300	format(1x,'(subr.cntr2 ) warning: error in search, v=',
     &	       1pe12.5,5x,
     &        'np=',i5,5x, /1x,' il,jl,ir,jr=',4i5,5x,'r=',e12.4)
	go to 3100
 1000	continue
	if(msglvl.gt.2 .and. ncntr1.gt.0) write(lst,*)
     &	  '(subr.cntr2 )',ncntr1,'-contour(s) for level ',v
c
 4000	continue
	if(msglvl.gt.1) write(lst,*)
     &	  '(subr.cntr2 )',ncntr,'-contours in total'
	return
	end
