c  calculation of electric currents curl(bh),
c                 curl[bn(bh-bhp)],
c                 div(bh)
c
	subroutine curlb1(kx,ky,kz,kxp,kyp, kj,kf,kdiv,amat,
     &                  bxs,bys,bzs, wkx,wky,wkz,ndim)
c
	include 'sys.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'fileio.fc'
	include 'auxparam.fc'
c
	dimension wk(MX),awk(MX),bwk(MX),cwk(MX),dwk(MX)
	equivalence (qdata(1,1,17),wk(1)),
     &	            (qdata(1,2,17),awk(1)),
     &	            (qdata(1,3,17),bwk(1)),
     &	            (qdata(1,4,17),cwk(1)),
     &	            (qdata(1,5,17),dwk(1))
c
	dimension amat(3,3),b(3)
c  ndim=MX, but ndim should be in the argument list in order to make
c  bxs etc. adjustable arrays
c
	dimension bxs(ndim,ndim),bys(ndim,ndim),bzs(ndim,ndim)
	dimension wkx(ndim,ndim,4),wky(ndim,ndim,4),
     &	          wkz(ndim,ndim,4)
	logical smooth
c
	data pi/3.14159265/
c
	call allocm(17,17,'curlb1')
	if(errflg.gt.1) then
	  write(msg,*) '(subr.curlb1) error'
	  return
	endif
c
c  aj = Jacobian
      aj=amat(1,1)*amat(2,2)-amat(1,2)*amat(2,1)
      area=dx*dy*ulen**2/aj
c
c  (Bh,Bn)=(transpose of amat) * (Bt,Bl)
c
cc
	jpeek=-1
	if(jpeek.gt.0) write(lst,*) 'amat=',amat
cc
	do 1000 j=1,ny
	do 1000 i=1,nx
	b(1)=rdata(i,j,kx)
	b(2)=rdata(i,j,ky)
	b(3)=rdata(i,j,kz)
	wkx(i,j,1)=b(1)*amat(1,1)+b(2)*amat(2,1)+b(3)*amat(3,1)
	wky(i,j,1)=b(1)*amat(1,2)+b(2)*amat(2,2)+b(3)*amat(3,2)
	wkz(i,j,1)=b(1)*amat(1,3)+b(2)*amat(2,3)+b(3)*amat(3,3)
	bxs(i,j)=wkx(i,j,1)
	bys(i,j)=wky(i,j,1)
	bzs(i,j)=wkz(i,j,1)
	b(1)=rdata(i,j,kxp)
	b(2)=rdata(i,j,kyp)
	bxp=b(1)*amat(1,1)+b(2)*amat(2,1)+b(3)*amat(3,1)
	byp=b(1)*amat(1,2)+b(2)*amat(2,2)+b(3)*amat(3,2)
	wkx(i,j,2)=wkx(i,j,1)-bxp
	wky(i,j,2)=wky(i,j,1)-byp
	wkx(i,j,3)=wkx(i,j,2)
	wky(i,j,3)=wky(i,j,2)
 1000	continue
cc
	if(jpeek.gt.0) then
	  write(lst,*) 'bx-bxp=',(wkx(i,jpeek,2),i=1,nx)
	  write(lst,*) 'by-byp=',(wky(i,jpeek,2),i=1,nx)
	endif
cc
c
c  now (wkx(1),wky(1),wkz(1)) = (Bhx,Bhy,Bn),
c      (wkx(2),wky(2)) = (Bhx-Bhxp,Bhy-Bhyp),
c      (bxp,byp) = (Bhxp,Bhyp)
c  the grid is still D-grid
c
c  subscripts 'h' are omitted from here; bhx is written as bx
c
	smooth=ifiltr.gt.1
c
	if(smooth) then
	  call flt3x3(wkx(1,1,1),nx,ny,ndim,bxs,filter(1,1,ifiltr))
	  call flt3x3(wky(1,1,1),nx,ny,ndim,bys,filter(1,1,ifiltr))
	  call flt3x3(wkz(1,1,1),nx,ny,ndim,bzs,filter(1,1,ifiltr))
	  call flt3x3(wkx(1,1,2),nx,ny,ndim,wkx(1,1,3),
     &	            filter(1,1,ifiltr))
	  call flt3x3(wky(1,1,2),nx,ny,ndim,wky(1,1,3),
     &	            filter(1,1,ifiltr))
	  if(msglvl.gt.2) then
	  write(lst,*) '(subr.curlb1) filter=',
     &	               (filter(i,1,ifiltr),i=1,3)
	  write(lst,*) '                     ',
     &	               (filter(i,2,ifiltr),i=1,3)
	  write(lst,*) '                     ',
     &	               (filter(i,3,ifiltr),i=1,3)
	  endif
	endif
c
c  bxs=smoothed Bx
c  bys=smoothed By
c  bzs=smoothed Bz
c  wkx(3)=smoothed Bx-Bxp
c  wky(3)=smoothed By-Byp
c
c  kf needs kj as well
c  if kj=0 but kf>0, calculate kj and store it temporarily on kf  
	if(kj.eq.0 .and. kf.gt.0) then
	  kjf=kf
	else
	  kjf=kj
	endif
c
c  rdata(*,*,kj)=d(By)/dx*amat(1,1)-d(Bx)/dy*amat(2,2)
c               -d(Bx)/dx*amat(1,2)
c
	if(kjf.gt.0) then
	  do 2000 j=1,ny
	  do 2100 i=1,nx
 2100	  wk(i)= bys(i,j)
	  call splin1(nx,dx,wk,dwk,awk,bwk,cwk)
	  do 2200 i=1,nx
 2200	  rdata(i,j,kjf)=dwk(i)*amat(1,1)
 2000	  continue
c  d(By)/dx*amat(1,1)
c
	  do 2300 i=1,nx
	  do 2400 j=1,ny
 2400	  wk(j)= bxs(i,j)
	  call splin1(ny,dy,wk,dwk,awk,bwk,cwk)
	  do 2500 j=1,ny
 2500	  rdata(i,j,kjf)=rdata(i,j,kjf)-dwk(j)*amat(2,2)
 2300	  continue
c  -d(Bx)/dy*amat(2,2)
c
	  do 2600 j=1,ny
	  do 2700 i=1,nx
 2700	  wk(i)= bxs(i,j)
	  call splin1(nx,dx,wk,dwk,awk,bwk,cwk)
	  do 2800 i=1,nx
 2800	  rdata(i,j,kjf)=rdata(i,j,kjf)-dwk(i)*amat(1,2)
 2600	  continue
c  -d(Bx)/dx*amat(1,2)
	endif
c
c  rdata(*,*,kf)=grad(smoothed Bn) x (Bh-Bhp) + Bn curl[smoothed Bh]
c               =wkx(4)*wky(2) - wky(4)*wkx(2) + wkz(1)*rdata(kj)
c
	if(kf.gt.0) then
	  do 3000 j=1,ny
	  do 3100 i=1,nx
 3100	  wk(i)= bzs(i,j)
	  call splin1(nx,dx,wk,dwk,awk,bwk,cwk)
	  do 3200 i=1,nx
 3200	  wkx(i,j,4)=dwk(i)*amat(1,1)
 3000	  continue
c  wkx(*,*,4)=d[Bn]/dx*amat(1,1)
c
	  do 3300 i=1,nx
	  do 3400 j=1,ny
 3400	  wk(j)= bzs(i,j)
	  call splin1(ny,dy,wk,dwk,awk,bwk,cwk)
	  do 3500 j=1,ny
 3500	  wky(i,j,4)=dwk(j)*amat(2,2)
 3300	  continue
c  wky(*,*,4)=d[Bn]/dy*amat(2,2)
c
	  do 3600 j=1,ny
	  do 3700 i=1,nx
 3700	  wk(i)= bzs(i,j)
	  call splin1(nx,dx,wk,dwk,awk,bwk,cwk)
	  do 3800 i=1,nx
	  wky(i,j,4) =wky(i,j,4)+dwk(i)*amat(1,2)
	  rdata(i,j,kf)=wkx(i,j,4)*wky(i,j,2)
     &	         -wky(i,j,4)*wkx(i,j,2)
     &	         +wkz(i,j,1)*rdata(i,j,kjf)
 3800	  continue
 3600	  continue
c  wky(*,*,4)=d[Bn]/dy*amat(2,2) + d[Bn]/dx*amat(1,2)
c
	endif
c
c  rdata(*,*,kdiv)=d(Bx)/dx*amat(1,1)+d(By)/dy*amat(2,2)
c               +d(By)/dx*amat(1,2)
c
	if(kdiv.gt.0) then
	  do 4000 j=1,ny
	  do 4100 i=1,nx
 4100	  wk(i)= bxs(i,j)
	  call splin1(nx,dx,wk,dwk,awk,bwk,cwk)
	  do 4200 i=1,nx
 4200	  rdata(i,j,kdiv)=dwk(i)*amat(1,1)
 4000	  continue
c  d(Bx)/dx*amat(1,1)
c
	  do 4300 i=1,nx
	  do 4400 j=1,ny
 4400	  wk(j)= bys(i,j)
	  call splin1(ny,dy,wk,dwk,awk,bwk,cwk)
	  do 4500 j=1,ny
 4500	  rdata(i,j,kdiv)=rdata(i,j,kdiv)+dwk(j)*amat(2,2)
 4300	  continue
c  d(By)/dy*amat(2,2)
c
	  do 4600 j=1,ny
	  do 4700 i=1,nx
 4700	  wk(i)= bys(i,j)
	  call splin1(nx,dx,wk,dwk,awk,bwk,cwk)
	  do 4800 i=1,nx
 4800	  rdata(i,j,kdiv)=rdata(i,j,kdiv)+dwk(i)*amat(1,2)
 4600	  continue
c
c  d(By)/dx*amat(1,2)
	endif
c
cc
	if(jpeek.gt.1) then
	  write(lst,*) 'jn=',(rdata(i,jpeek,kj),i=1,nx)
	  write(lst,*) 'fn=',(rdata(i,jpeek,kf),i=1,nx)
	endif
cc
c
	if(kj.eq.0) return
c
	cpsum=0.0
	cmsum=0.0
	cpmax=0.0
	cmmax=0.0
	do 5000 j=1,ny
	do 5000 i=1,nx
	cpmax=max(cpmax, rdata(i,j,kj))
	cmmax=max(cmmax,-rdata(i,j,kj))
	if(rdata(i,j,kj).gt.0.0) cpsum=cpsum+rdata(i,j,kj)
	if(rdata(i,j,kj).lt.0.0) cmsum=cmsum-rdata(i,j,kj)
 5000 continue
c
c  cgs gauss unit: curl B = (4*pi/c) j
c                  B in gauss, j in cgs-esu, c=3.0e10
c  SI unit       : curl B = mu0 * j
c                  B in Tesla, j in A/m**2, mu0=1.0e-7/(4*pi)
c  Ampere = c/10 cgs-esu
c  Tesla  = 10**4/c gauss
c
c  curl B in gauss/cm        ==> 10**5/(4*pi) A/m**2 
c  curl B * area in gauss*cm ==> 10/(4*pi) A
c
	cpmax=cpmax/ulen
	cmmax=cmmax/ulen
	cpsum=cpsum/ulen*area
	cmsum=cmsum/ulen*area
	fjd=1.0e5/(4.0*pi)
	fja=10.0/(4.0*pi)
	cpmax1=fjd*cpmax
	cmmax1=fjd*cmmax
	cpsum1=fja*cpsum
	cmsum1=fja*cmsum
	if(msglvl.gt.0) then
	  write(lst,*) '(subr.curlb1) electric currents: smoothing=',
     &	                smooth
	  write(lst,*) '  positive max.=',cpmax,' gauss/cm=',
     &	                            cpmax1,' A/m**2'
	  write(lst,*) '  negative max.=',cmmax,' gauss/cm=',
     &	                            cmmax1,' A/m**2'
	  write(lst,*) '  positive sum =',cpsum,' gauss*cm=',
     &	                            cpsum1,' A'
	  write(lst,*) '  negative sum =',cmsum,' gauss*cm=',
     &	                            cmsum1,' A'
	endif
c
	call freem(17,17)
	return
	end
