c  determine byte order of integers and character code
c
c  code= 1 - ascii
c      = 2 - ebcdic
c      = 0 - unknown character code
c  abs(int) = byte length of default integer
c  int > 0 - big endian
c      < 0 - little endian
c      = 0 - unknown integer format
c
c  blank(1/2) = 2-byte blank in ascii/ebcdic
c
	subroutine mcode(code,int,blank)
c
	include 'sys.fc'
	integer code
	integer*2 i2,ia2
	integer*2 i2020,i4040
	integer*4 ia4
	character buf*2,j1*1,j2*1,blank*(*)
	dimension ia2(2),ia4(2),ia(2),blank(2)
	equivalence (ia2(1),ia4(1)), (ia2(1),ia(1))
	common/cexchg/j1,j2
c
c  i2020='2020'hex, i4040='4040'hex
	i2020=16*2+16*16*16*2
	i4040=16*4+16*16*16*4
c
c  determine byte length of integer (2 or 4)
c
	if(msglvl.gt.1) write(lst,*) '(subr.mcode )'
	ia(1)=0
	ia(2)=0
	ia2(1)=1
	ia2(2)=1
c
	if(ia(1).eq.ia2(1) .and. ia(2).eq.ia2(2)) then
	  if(msglvl.gt.1)
     &	    write(lst,*) '  default integer = integer*2'
	  intlen = 2
	else
	  ia(1)=0
	  ia(2)=0
	  ia4(1)=1
	  ia4(1)=1
	  if(ia(1).eq.ia4(1) .and. ia(2).eq.ia4(2)) then
            if(msglvl.gt.1)
     &	      write(lst,*) '  default integer = integer*4'
	    intlen = 4
	  else
	    write(lst,*) '  unknown integer'
	    intlen = 0
	  endif
	endif
c
c  determine byte order of integer*2
c
	method=2
c
	if(method.eq.1) then
	  i2=1
	  call exchg(i2)
	  i2=1
	else if(method.eq.2) then
	  i2=1
  	  write(buf,'(a2)') i2
  	  read(buf,'(2a1)') j1,j2
	endif
c
	if(msglvl.gt.2)
     &	  write(lst,*) '  i2,j1,j2=',i2,ichar(j1),ichar(j2)
	if(ichar(j1).eq.0 .and. ichar(j2).eq.1) then 
	  if(msglvl.gt.1)
     &	    write(lst,*) '  integer*2 = big endian'
	  int =  intlen
	else if(ichar(j1).eq.1 .and. ichar(j2).eq.0) then 
	  if(msglvl.gt.1)
     &	    write(lst,*) '  integer*2 = little endian'
	  int = -intlen
	else
	  write(lst,*) '  unkown form of integer*2'
	  int =  0
	endif
c
c  determine byte order of integer*4
c
	ia4(1)=0
	ia2(1)=0
	ia2(2)=1
	if(ia4(1).eq.1) then
	  if(msglvl.gt.1)
     &	    write(lst,*) '  integer*4 = big endian'
	elseif(ia4(1).eq.65536) then
	  if(msglvl.gt.1)
     &	    write(lst,*) '  integer*4 = little endian (4-byte swap)'
	else
	  write(lst,*) '  unknown form of integer*4'
	  endif
c
c	Should 2x2byte swap be included?
c
c  determine character code (ascii or ebcdic)
c
	if(method.eq.1) then
	  j1=' '
	  j2=' '
	  call exchg(i2)
	else if(method.eq.2) then
	  buf='  '
	  read(buf,'(a2)') i2
	endif
c
 	if(msglvl.gt.2) write(lst,*) i2,i2020,i4040
c
	if(i2.eq.i2020) then
	  if(msglvl.gt.1) write(lst,*) '  code = ASCII'
	  code = 1
	else if(i2.eq.i4040) then
	  if(msglvl.gt.1) write(lst,*) '  code = EBCDIC'
	  code = 2
	else
	  write(lst,*) '  unknown character code'
	  code = 0
	endif
c
c  give blank in ascii and ebcdic
c
	if(method.eq.1) then
	  call exchg(i2020)
	  blank(1)=j1//j2
	  call exchg(i4040)
	  blank(2)=j1//j2
c
	else if(method.eq.2) then
	  write(blank(1),'(a2)') i2020
	  write(blank(2),'(a2)') i4040
	endif
c
	return
	end
c
	subroutine exchg(i2)
	integer*2 i2,j2,k2
	common/cexchg/j2
	k2=j2
	j2=i2
	i2=k2
	return
	end
c
c  check whether local variables in a subroutine is static or not
c
c  return value: ist = 0 -- variables are static
c                    = 1 -- local variables are not static
c                    = 2 -- local commons are not static
c                    = 3 -- both commons and locals are not static
c
	subroutine static(ist)
	include 'sys.fc'
c
	i=1234
	call sub1(i,j,k)
  	call sub2(i,j,k)
	if(msglvl.gt.2) write(lst,*) i,j,k
c
	ist=0
	if(i.eq.k) then
	  if(msglvl.gt.1)
     &      write(lst,*) '(subr.static) local commons are static'
	else
	  ist=2
	  write(lst,*) '(subr.static) local commons are not static'
	endif
c
	if(i.eq.j) then
	  if(msglvl.gt.1)
     &      write(lst,*) '(subr.static) local variables are static'
	else
	  ist=ist+1
	  if(msglvl.gt.1)
     &	write(lst,*) '(subr.static) local variables are not static'
	endif
c
	return
	end
c
	subroutine sub1(i,j,k)
	common/sub/lcom
	j=local1
	k=lcom
	local1=i
	lcom=i
	return
	end
	subroutine sub2(i,j,k)
	call sub1(i,j,k)
	return
	end
c
c  check whether byte swap is done correctly
c
c  return value: iswap = 0 -- success
c                      = 1 -- error in 2-byte swap
c                      = 2 -- error in 4-byte swap
c                      = 3 -- error in 2- and 4-byte swaps
c
	subroutine swap(iswap)
	include 'sys.fc'
c
	integer*2 i2,i2a(2),i2b(2)
	integer*4 i4,i4a(3),i4b(3)
	data i2a/1,-2/, i2b/256,-257/
	data i4a/1,256,-2/, i4b/16777216,65536,-16777217/
c
	iswap2=0
	do 10 i=1,2
	i2=i2a(i)
	call sswap2(i2)
	if(i2.ne.i2b(i)) iswap2=1
 10	continue
c
	iswap4=0
	do 20 i=1,3
	i4=i4a(i)
	call sswap4(i4)
	if(i4.ne.i4b(i)) iswap4=2
 20	continue
c
	iswap=iswap2+iswap4
	if(iswap.gt.0) then
	  write(lst,*) '(subr.swap  ) error in byte swap'
	  do 30 i=1,2
	  i2=i2a(i)
	  call sswap2(i2)
	  write(lst,100) i2a(i),i2
 100	  format(4x,'in=',z10,' out=',z10)
 30	  continue
	  do 40 i=1,3
	  i4=i4a(i)
	  call sswap4(i4)
	  write(lst,200) i4a(i),i4
 200	  format(4x,'in=',z10,' out=',z10)
 40	  continue
	endif
	return
	end
