c  plot field lines : binary star model
c  graphic interface : cgi subroutines
c
c  this program does not forlow the conventional fortran77
c  in that variable names longer than 6 characters are used
c
	subroutine dispmb( iunitp, iunitl, mfname, lfname )
c
	include 'sys.fc'
	include 'ss.fc'
	include 'mdata.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'mparam.fc'
	include 'string.fc'
	include 'fileio.fc'
	include 'fline.fc'
	include 'graph.fc'
c
	integer iunit, iunitp, iunitl
	integer*4 chksm1
	dimension xf(5),yf(5),xxc4(3,4),xxc40(3,4)
	dimension dlp(20),dlm(20),blp(20),blm(20),flp(20),flm(20),
     &	          alp(20),alm(20),slp(20),slm(20)
	real intlvl(20),jlp(20),jlm(20)
	dimension iovr(4)
	dimension xp(ML),yp(ML),zp(ML),hp(ML)
	equivalence (xp(1),xyzr(1,1))
	equivalence (yp(1),xyzr(1,2))
	equivalence (zp(1),xyzr(1,3))
	equivalence (hp(1),xyzr(1,4))
c
	character esc*1, cls*10, cll*10, home*6, strid*8,keybuf*10,
     &	buf*10, dumstr*8, comma*1, commnt*80,
     &	title1*80, title4*80,
     &	files*80, mfname*(*), lfname*(*)
c
	logical update
	logical ask,vt100,lonlat,clip
	logical redraw,first,ready
	integer redmap,bluemap,whitemap,greenmap,
     &	  graylvl,cuelvl
	integer colors(5)
c
	xconv(x)=gfact*(x-gxc) +xfc
	yconv(y)=gfact*(y-gyc) +yfc
	data colors/5*1/
c
c  DEC VT100 terminal control
	esc=char(27)
	home=esc//'[1;1H'
	cls=home//esc//'[2J'
	cll=home//esc//'[2K'
	vt100=.false.
c  vt100=.true. in order to avoid scroll
cx	vt100=.true.
c
	ask= stdin.eq.keyin
	first=.true.
	comma=','
c
c  abs(lpout) : 1=portrait
	lpout=0
	if(ask) write(msg,*) 
     &	       'output mode? 0=graphics, 1=graphics+LBP, -1=LBP'
	read(stdin,*) lpout
	if(ask) write(msg,*) cls
c
c  gmode=0 : fixed view angle
c        1 : arbitrary view angle and scaling
c
	gmode=0
	if(ask) write(msg,*)
     &	'enable coordinate transform? 0=no, 1=yes'
	read(stdin,*) gmode
c
	do 11 i=1,3
 11	iovr(i)=0
	iovr(4)=2
c  default is to reset cl0deg
c
c  sizecm=x-width of screen in cm
c  default sizecm = 16cm, resolution unit=0.01cm
c  scale is the scaling factor, cm / unit length(=10^4 km)
c  if scale =0, observed region is scaled to fill the display window
c
	sizecm=16.0
	scale=0.0
	if(ask) write(msg,*) 'enter display size (cm) and scale factor'
	read(stdin,*) sizecm,scale
c
	read(stdin,*) colors
c
c  meshl specifies initial projection mode
c  default value of meshl = 2 (by subr.initc)
c  if fieldline file is avaiable, meshl is overridden by kindli
c 
c  current version number of input file
	iver0 = 1
c  check version number
	read(iunitp,*) strid,iver1
	call upper(strid)
	if(strid.ne.'PSETUP') then
	  write(msg,*) 
     &	  '(subr.dispmb) error: this is not the psetup file'
	  errflg=2
	  return
	endif
	if(iver1.ne.iver0) then
	  write(msg,*)
     &	  '(subr.dispmb) error: version of psetup should be',
     &	  iver0
	  errflg=2
	  return
	endif
c
c  y-offset in cm = yoffcm
c  line separation in cm = vmicm
c  character size in cm = chrcm
c  eye distance = eyed
c  mesh separation in cm in plotting arrows = asepcm
c
	yoffcm=4.0
	chrcm = 0.35
	clip=.false.
	asepcm=0.4
	read(iunitp,*) meshl, yoffcm, vmicm, chrcm, clip
	read(iunitp,*) eyed
	read(iunitp,*) asepcm
	devcm=100.0
	xsize = devcm*sizecm
	yoff = yoffcm*devcm
	ysize = xsize + yoff
	yfsize = xsize
	vmi = vmicm*devcm
	chrsiz = chrcm*devcm
	arrsep = asepcm*devcm
c
	write(title1,400) inst,dateo,stime,etime,tsys,mfile
 400	format(a8,2x,a8,1x,a8,' - ',a8,'(',a6,')',2x,a8,24x)
c
c  read parameters for plotting from iunitp
c  contour levels should be from the smallest to the largest values in
c  order to detect level over(under)flows
c  if number of levels are <0, automatic level adjustment will be made
c
	read(iunitp,*) rblmin,nbl,blp
	do 30 i=1,20
 30	blm(i)=-blp(i)
	read(iunitp,*) rdmin,ndl,dlp
	do 31 i=1,20
 31	dlm(i)=-dlp(i)
	read(iunitp,*) rimin,nint,intlvl
c  intensity is normalized to nearly 1
	read(iunitp,*) rjmin,njl,jlp
	do 32 i=1,20
 32	jlm(i)=-jlp(i)
	read(iunitp,*) rfmin,nfl,flp
	do 33 i=1,20
 33	flm(i)=-flp(i)
	read(iunitp,*) ramin,nal,alp
	do 34 i=1,20
 34	alm(i)=-alp(i)
	read(iunitp,*) rsmin,nsl,slp
	do 35 i=1,20
 35	slm(i)=-slp(i)
	read(iunitp,*) btmax0,rbtmin
	btmin0=btmax0*abs(rbtmin)
c
c  if rbtmin<0, bars displayed will be for btmin<bt<btmax
c  where btmax(min) are max(min) values of the data bt
c  if rbtmin>0, bars displayed are for btmin0<bt<btmax0
c
c  number of gray levels
	read(iunitp,*) graylvl,cuelvl
c
c  parameters for depth cuing of field lines
	read(iunitp,*) hmax0,rcue
c
c  initialize display
c
	call initialize(lpout)
c
	call vdcextent(0,0,int(xsize),int(ysize) )
	call viewportunits(1)
c*	NEWS 1720
c*	call viewport(200,400+int(ysize),200+int(xsize),400)
c*	NEWS 3460
	call viewport(0,int(ysize),int(xsize),0)
c
c  line width
	call linefwidth(1.0)
c  interiostyle 2=solid
	call interiorstyle(2)
c  markertype 2=dot
	call markertype(2)
c  character height in vdc space, unit = 0.01 cm
	call chrheight(int(chrsiz))
c  character width/height ratio
	call chrwidth(1.0)
c  normal spacing = 0
cx	call chrspacing(0.05)
c
c  set color table
c  background is assumed to be black
c  white is color No.1 (default foreground color)
	call colortable(white, 1, 255,255,255)
	call colortable(red,   1, 255,128,  0)
	call colortable(green, 1,   0,255,  0)
	call colortable(blue,  1,   0,128,255)
	call colortable(yellow,1, 255,255,  0)
	call colortable(pink,  1, 255,  0,255)
	call colortable(cyan,  1,   0,255,255)
	call colortable(black, 1,   0,  0,  0)
	redmap=8
	n=redmap
	mult=256/graylvl
	do 20 i=1,graylvl
	call colortable(n,1,mult*(i-1),0,0)
 20	n=n+1
	bluemap=n
	do 21 i=1,graylvl
	call colortable(n,1,0,0,mult*(i-1))
 21	n=n+1
	whitemap=n
	do 22 i=1,graylvl
	call colortable(n,1,mult*(i-1),mult*(i-1),mult*(i-1))
 22	n=n+1
	greenmap=n
	multg=256/cuelvl
	do 23 i=1,cuelvl
	call colortable(n,1,0,multg*(i-1),0)
 23	n=n+1
c
	mesh=0
c
	rotdeg=0.0
	zdeg=0.0
	xdeg=0.0
	dxc1=0.0
	dyc1=0.0
	if(nx.eq.0.and.ny.eq.0) then
	  dxy=min(dx,dy)/300.0
	else
	  dxy=min(dx,dy)/3.0
	endif
c
c  four corners of observed region
c
	xf(1)=xs
	yf(1)=ys
	xf(2)=xs+dx*float(max(1,nx-1))
	yf(2)=ys
	xf(3)=xs+dx*float(max(1,nx-1))
	yf(3)=ys+dy*float(max(1,ny-1))
	xf(4)=xs
	yf(4)=ys+dy*float(max(1,ny-1))
	xf(5)=xf(1)
	yf(5)=yf(1)
c  xf and yf are in D-coordinates
c
        if(meshl.lt.0) then
          do 50 n=1,4
          xxc4(1,n)=xf(n)
          xxc4(2,n)=yf(n)
          xxc4(3,n)=0.0
 50       continue
        else if(mesh.eq.0) then
          do 51 n=1,4
          call dtoc2(xf(n),yf(n), xxc4(1,n),xxc4(2,n))
          call projsr(xxc4(1,n), rsp)
 51       continue
        else if(mesh.eq.1) then
          do 52 n=1,4
          xxc4(1,n)=xf(n)
          xxc4(2,n)=yf(n)
          xxc4(3,n)=0.0
          call ttoc(xxc4(1,n),xxc4(1,n))
 52       continue
        else if(mesh.ge.2.and.meshl.ge.0) then
          call transf(mesh,mesho,
     &                nx, ny, xs, ys, dx, dy,
     &                nx1,ny1,xs1,ys1,dx1,dy1,xe1,ye1)
          xxc4(1,1)=xs1
          xxc4(2,1)=ys1
          xxc4(1,2)=xe1
          xxc4(2,2)=xxc4(2,1)
          xxc4(1,3)=xxc4(1,2)
          xxc4(2,3)=ye1
          xxc4(1,4)=xxc4(1,1)
          xxc4(2,4)=xxc4(2,3)
          do 53 n=1,4
          call dtoc2(xxc4(1,n),xxc4(2,n), xxc4(1,n),xxc4(2,n))
          call projsr(xxc4(1,n), rsp)
 53       continue
        endif
        do 54 n=1,4
        do 54 i=1,3
 54     xxc40(i,n)=xxc4(i,n)
c
c  xxc4 are in C-coordinates
c
c  drawable area
c  (xfl,xfr) = lower left corner
c  (yfl,yfr) = upper right corner
c  (xfc,yfc) = center of window
c
c  clipping window
c  (xclipl,yclipb) = lower left corner
c  (xclipr,yclipt) = upper right corner
c
	xfl=0.0
	xfr=xsize
	yfl=0.0
	yfr=yfsize
	xfc=0.5*(xfl+xfr)
	yfc=0.5*(yfl+yfr)
	gxc = 0.25*(xxc4(1,1)+xxc4(1,2)+xxc4(1,3)+xxc4(1,4))
	gyc = 0.25*(xxc4(2,1)+xxc4(2,2)+xxc4(2,3)+xxc4(2,4))
c
	if(scale.gt.0.0) then
	  gfact=devcm*scale
	  scale1=scale
	else
	  gfact = min( xsize / (abs(xxc4(1,2)-xxc4(1,1))
     &	                 + abs(xxc4(1,4)-xxc4(1,1)) ),
     &	         yfsize / (abs(xxc4(2,2)-xxc4(2,1))
     &	                 + abs(xxc4(2,4)-xxc4(2,1)) ) )
	  scale1=gfact/devcm
	endif
c
	mlof0=0
	if(iunitl.gt.0) then
	  mlof0=1
	  update=.true.
	  chksm1=chksum
c  chksm1 is the check sum of s1data which has been read
c  in the main program
	  call readlh(iunitl,update)
	  meshl=mod(kindli,10)
        if(chksum.ne.chksm1) then
          write(lst,*)
     &   '(subr.dispmb) warning: mismatch in checksum of s1data'
        endif
c
	else
	  mlof0=0
	endif
c
	mauto=0
	if(ask) then
	  if(vt100) write(msg,*) cls
	  write(msg,100)
     &'select 0(manual), 1(standard-sequence), or 2(local-sequence) : '
 100	  format(2x, a,$)
	endif
	read(stdin,*) mauto
	if(mauto.eq.1) then
	  iunit=iunitp
	  ask=.false.
	elseif(mauto.eq.2) then
	  iunit=stdin
	  ask=.false.
	else
	  iunit=keyin
	  ask=.true.
	endif
c
	iredrw=0
	keybuf=' '
	buf=' '
	iptr=0
 1	continue
	if(redraw()) go to 1
c
	mlof=0
	mglobe=0
	title4=' '
	commnt=' '
	isp=1
c
c  rotation angle and view angles
c
	if(gmode.eq.1) then
	  if(vt100) write(msg,100) cls
	  write(msg,100)
     &	  'enter rotation and view angles (roty,rotz,rotx) '
	endif
 91	if(gmode.eq.1 .or. .not.ask)
     &	  read(iunit,*,end=97) rotdeg, zdeg,xdeg
	if(gmode.eq.1 .and. .not.ask) 
     &	write(msg,*) rotdeg,zdeg,xdeg
c  if eof, try keyin
	if(gmode.eq.1) then
	  if(vt100) write(msg,100) cls
c  the unit of dxc1 and dyc1 is ulen (=10^4 km)
	  write(msg,100)
     &	  'enter scale factor(=0.0 for reset), offset (dx,dy) '
	endif
	if(gmode.eq.1 .or. .not.ask)
     &	  read(iunit,*,end=99) scale,dxc1,dyc1
	if(gmode.eq.1 .and. .not.ask) 
     &	write(msg,*) scale,dxc1,dyc1
c
	if(gmode.eq.1) then
          if(rotdeg.ne.0.0 .or. zdeg.ne.0.0 .or.
     &       xdeg.ne.0.0 .or. scale.ne.0.0) then
            clip=.false.
          else
cx          clip=.true.
            clip=clip
          endif
c
          call setmat(rotdeg, zdeg,xdeg)
          do 55 n=1,3
 55       call rotpt(xxc40(1,n),xxc4(1,n))
          gxc = 0.25*(xxc4(1,1)+xxc4(1,2)+xxc4(1,3)+xxc4(1,4))
          gyc = 0.25*(xxc4(2,1)+xxc4(2,2)+xxc4(2,3)+xxc4(2,4))
c
	  if(scale.gt.0.0) then
	    gfact=devcm*scale
	    scale1=scale
	  else
	    gfact = min( xsize / (abs(xxc4(1,2)-xxc4(1,1))
     &	                   + abs(xxc4(1,4)-xxc4(1,1)) ),
     &	           yfsize / (abs(xxc4(2,2)-xxc4(2,1))
     &	                   + abs(xxc4(2,4)-xxc4(2,1)) ) )
	    if(scale.lt.0.0) gfact=gfact*abs(scale)
	    scale1=gfact/devcm
	  endif
c
	endif
c
	if(gmode.eq.0) then
	  write(title4,300) scale1
	else
	  write(title4,310) rotdeg,zdeg,xdeg,scale1
	endif
 300	format('SCALE FACTOR=',f8.4)
 310	format('ROTR=',f6.1,4x,'(ROTZ,ROTX)=',2f6.1,4x,
     &	  'SCALE FACTOR=',f8.4)
c
cx 4	continue
cx 3	continue
c
c  beginning of drawing
c
 2	continue
c
c  longitude/latitude circles
c
 3500	continue
	lonlat=.true.
	clip=.false.
c
	do 3100 n=1,nsp
	call linecolor(colors(n),0,0)
	call spherm(n, xxc4,dxy, lonlat,clip)
 3100	continue
c
c  if clip=T, long./lat. circles are only drawn inside the
c  observed region
c
c  title
c
 6500	continue
	call textcolor(white,0,0)
	ipos=lenstr(mfname)
	files='FILE='//lfname
	call text(int(xfl), int(ysize-1.0*vmi), files )
	call text(int(xfl), int(ysize-2.0*vmi), title4)
c
c  field lines
c
	msav=msglvl
	if(.not.first) msglvl=0
	call linefwidth(2.0)
	update=.false.
	call readlh(iunitl,update)
	first=.false.
c
 1100	continue
	call readl(iunitl,np,xyzp)
	if(np.eq.0) go to 9000
c
	hmax=0.0
	eps=0.005*rsp
	do 1200 n=1,np
	xp(n)=xyzp(1,n)
	yp(n)=xyzp(2,n)
	zp(n)=xyzp(3,n)
	hp(n)=height(xyzp(1,n),meshl)
	hmax=max(hmax,hp(n))
 1200	continue
c
	do 1300 n=2,np
c
c  intensity cuing
c  loops taller than hmax0: footpoint brightness is grmax*rcue and
c  brightens toward loop top and saturates to grmax far from footpoints
c  shorter loops: loop top brightness is grmax, and dims toward
c  footpoints
c
	grmax=cuelvl-1
	if(hmax.gt.hmax0) then
	  lcolr=grmax*(rcue + (1.0-rcue)*hp(n)/hmax0 )
	else
	  lcolr=grmax*(rcue + (1.0-rcue)*(hp(n)+hmax0-hmax)/hmax0 )
	endif
	if(lcolr.lt.0) lcolr=0
	if(lcolr.gt.grmax) lcolr=grmax
c
	call linecolor(greenmap+lcolr,0,0)
	call pline3(2,xp(n-1),yp(n-1),zp(n-1))
c  arguments of pline3 should be C-coordinates
 1300	continue
c
	if(msglvl.gt.3) then
	  read(keyin,'(a)') dumstr
	endif
	go to 1100
c
 9000	continue
	msglvl=msav
c
	call linefwidth(1.0)
 9100	if(redraw()) go to 2
	if(iredrw.eq.0) then
	  if(vt100) write(msg,100) cll
	  if(lpout.eq.0) then
	    write(msg,*) 'enter 1(restart),9(end) : '
	  else
	    write(msg,*) 'enter 1(restart),2(hardcopy),9(end) : '
	  endif
c  write statement here should complete output by crlf,
c  thereby avoiding interference with kbhit
c  therefore format 100 is not used here
	endif
c
c  idling loop: wait for keyboard input and redraw request
c
 9150	continue
	if(ask) then
 9200	  if(redraw()) then
	    iredrw=1
	    go to 2
	  endif
	  if(.not.ready(keybuf,iptr,mode1)) go to 9200
	else
	  read(iunit,*,end=98) mode1
	  write(msg,*) mode1
	endif
	iredrw=0
c
c  erase screen and restart
	if(mode1.eq.1) then
	  call clear
	  go to 1
c  hardcopy
	else if (lpout.ne.0 .and. mode1.eq.2) then
	  if(ask.and.commnt.eq.' ') then
            write(msg,*) 'enter comment : '
	    read(iunit,'(a)') commnt
	    call text(int(xfl), int(ysize-3.0*vmi), commnt)
	  endif
	  call hcopy
	  go to 9100
c  end of plot
	else if(mode1.eq.9) then
	  go to 99
	else
	  iunit=keyin
	  ask=.true.
	  mauto=0
	  go to 9100
	endif
c
 97	if(iunit.eq.keyin) go to 99
	iunit=keyin
	ask=.true.
	mauto=0
	go to 1
c
 98	if(iunit.eq.keyin) go to 99
	iunit=keyin
	ask=.true.
	mauto=0
	go to 9150
c
 99	call clear
	call terminate
	if(lfname.ne.' ') 
     &	write(lst,*) 'field lines id=',lfile,
     &	', filename=',lfname(1:lenstr(lfname))
	return
c
	end
c
	logical function ready(keybuf,iptr,mode1)
c
	character*(*) keybuf
c
c  kbhit returns the input character code, or -1 if no input exists
c
	ready =.false.
c
	ic = kbhit()
	if(ic.lt.0) return
	if(ic.eq.8.or.ic.eq.127) then
	  if(iptr.gt.0) iptr=iptr-1
	  return
	else if (ic.ne.10) then
	  iptr=iptr+1
	  keybuf(iptr:iptr)=char(ic)
	  return
	else if(iptr.gt.0) then
	  read(keybuf(1:iptr),*) mode1
	  keybuf=' '
	  iptr=0
	endif
	ready=.true.
	return
	end
c
c  interface to polyline subroutine
c  gmode=0 : fixed view angle
c        1 : arbitrary view angle and scaling
c
	subroutine pline3(np,xp,yp,zp)
c
	include 'graph.fc'
	include 'fline.fc'
	dimension xp(np),yp(np),zp(np),ixp(ML),iyp(ML),xx(3)
c  ML is defined in fline.fc
	logical l1,l2,visibl
	equivalence (ixp(1),xyzr(1,5))
	equivalence (iyp(1),xyzr(1,6))
c
	xconv(x)=gfact*(x-gxc) +xfc
	yconv(y)=gfact*(y-gyc) +yfc
c
c
c  this subroutine is for field line plot and for spherical grid
c  (xp,yp,zp) are in C-coordinates
c
	if(np.le.1) return
	l1=.false.
	delta1=1.0
c
	do 30 n=1,np
	xx(1)=xp(n)
	xx(2)=yp(n)
	xx(3)=zp(n)
	if(gmode.eq.1) call rotpt(xx,xx)
	ixp(n)=xconv(xx(1))
	iyp(n)=yconv(xx(2))
	l2=   ixp(n).ge.int(xfl-delta1)
     &	.and. ixp(n).le.int(xfr+delta1)
     &	.and. iyp(n).ge.int(yfl-delta1)
     &	.and. iyp(n).le.int(yfr+delta1)
     &	.and. visibl(xx)
	if(l1.and.l2) call polyline(2,ixp(n-1),iyp(n-1))
	l1=l2
 30	continue
	return
c
	end
c
c  plot a sphere representing star no.nsp1
c  if lonlat=.true., longitude/latitude circles are also drawn
c  clipping limits are given by rectangle spanned by four corner
c  points xx4
c
	subroutine spherm(nsp1,xx4,dl,lonlat,clip)
c
	logical l1,l2,lonlat,clip,inside
	include 'graph.fc'
	include 'coord.fc'
	include 'fline.fc'
	dimension xp(ML),yp(ML),zp(ML), xx4(3,4)
	equivalence (xp(1),xyzr(1,1))
	equivalence (yp(1),xyzr(1,2))
	equivalence (zp(1),xyzr(1,3))
	data pi/3.141593/
c
	n=nsp1
	rsp1 = rspm(n)
c
c  set matrix armat
	call setarm(n)
c
	eps=-1.0e-2
	nc=min(int(2.0*pi*rsp1/dl),ML)
c
c  plot latitude circles
c
 1	if(.not.lonlat) return
c
	do 2000 i=1,17
	th=10.0/180.0*pi*float(i)
	ux2=rsp1*cos(th)
	np=float(nc)*sin(th)
	if(np.lt.6) np=6
	l1=.false.
	do 2100 j=1,np
	ph=2.0*pi*float(j-1)/float(np-1)
	ux1=rsp1*sin(th)*sin(ph)
	ux3=rsp1*sin(th)*cos(ph)
	xp(j)=armatm(1,1,n)*ux1
     &     +armatm(1,2,n)*ux2
     &     +armatm(1,3,n)*ux3 +xxspm(1,n)
	yp(j)=armatm(2,1,n)*ux1
     &     +armatm(2,2,n)*ux2
     &     +armatm(2,3,n)*ux3 +xxspm(2,n)
	zp(j)=armatm(3,1,n)*ux1
     &     +armatm(3,2,n)*ux2
     &     +armatm(3,3,n)*ux3 +xxspm(3,n)
	l2=(.not.clip).or.inside(xp(j),yp(j), xx4)
	if(l1.and.l2) call pline3(2,xp(j-1),yp(j-1),zp(j-1))
	l1=l2
 2100	continue
 2000	continue
c
c  plot longitude circles
c
	do 3000 i=1,36
	ph=10.0/180.0*pi*float(i-1)
	dth=1.0
	if(mod(i-1,9).eq.0) dth=0.0
	wth=18.0-2.0*dth
	nt=nc/2
	l1=.false.
	do 3100 j=1,nt
	th=pi*(wth*float(j-1)/float(nt-1)+dth)/18.0
	ux1=rsp1*sin(th)*sin(ph)
	ux2=rsp1*cos(th)
	ux3=rsp1*sin(th)*cos(ph)
	xp(j)=armatm(1,1,n)*ux1
     &     +armatm(1,2,n)*ux2
     &     +armatm(1,3,n)*ux3 +xxspm(1,n)
	yp(j)=armatm(2,1,n)*ux1
     &     +armatm(2,2,n)*ux2
     &     +armatm(2,3,n)*ux3 +xxspm(2,n)
	zp(j)=armatm(3,1,n)*ux1
     &     +armatm(3,2,n)*ux2
     &     +armatm(3,3,n)*ux3 +xxspm(3,n)
	l2=(.not.clip).or.inside(xp(j),yp(j), xx4)
	if(l1.and.l2) call pline3(2,xp(j-1),yp(j-1),zp(j-1))
 	l1=l2
 3100	continue
 3000	continue
c
	return
	end
