c  calculation of magnetic energy
c
	subroutine engy
c
	include 'sys.fc'
	include 'solar.fc'
	include 'coord.fc'
	include 'ss.fc'
	include 's1.fc'
	include 's2.fc'
	include 's3.fc'
	include 'ff0.fc'
	dimension a(3),b(3)
	data eps,dmin,dmax/0.01,0.1,1.0/, pi/3.141592/
c
	ulen1 = ulen*rsun/rsp
	wsss=0.0
	wssm=0.0
	wss=0.0
	wsm=0.0
	wmp=0.0
	wc=0.0
c
	if(ns1.gt.0) then
	  do 1000 l=1,ns1
	  do 1000 j=1,ns1
c
c  energy of solenoid coils
c
	  call engs(l,j,ww,eps,dmin,dmax)
	  if(l.eq.j) wsss=wsss+ww
	  if(l.ne.j) wssm=wssm+ww
 1000	  continue
	  wss=wsss+wssm
	endif
c
	if(ns1.gt.0.and.ns2.gt.0) then
	  do 2000 l=1,ns2
c
c  mutual energy between solenoids and monopoles
c
	  call vpot(xxs2(1,l),a,1,-1)
	  call field(xxs2(1,l),b,-1,1,-1)
	  wsm=wsm-pi*aa2(l)**2*(
     &	          direc2(1,l)*(a(2)*b(3)-a(3)*b(2))+
     &	          direc2(2,l)*(a(3)*b(1)-a(1)*b(3))+
     &	          direc2(3,l)*(a(1)*b(2)-a(2)*b(1)))
 2000	  continue
	  wsm=wsm/(8.0*pi)
	endif
c
	if(ns2.gt.0) then
	  do 3000 l=1,ns2
c
c  energy of monople sources
c
	  call pot(xxs2(1,l),psi)
	  call field(xxs2(1,l),b,-1,1,-1)
	  bn=b(1)*direc2(1,l)+b(2)*direc2(2,l)+b(3)*direc2(3,l)
	  wmp=wmp+bn*psi
 3000	  continue
	  wmp=wmp/(8.0*pi)
	endif
c
c  energy of current tubes
c
c  sqrt(3/2)=1.224745
c
	wsp=wss+wsm
	wp=wsp+wmp
	if(ns3.gt.0) then
	  do 4000 l=1,ns3
	  if(xxs3(3,l).lt.0.0) go to 4000
	  call vpot(xxs3(1,l),a,-1,1)
	  call vpotc(0.0,            0.0,       aa3(l),el3(l),a0)
	  call vpotc(1.224745*aa3(l),0.0,       aa3(l),el3(l),a1)
	  call vpotc(0.0,            0.5*el3(l),aa3(l),el3(l),a2)
	  wc=wc+cj3(l)*el3(l)
     &	    *(a(1)*direc3(1,l)+a(2)*direc3(2,l)+a(3)*direc3(3,l)
     &	    +cj3(l)*((2.0*a1+a2)/3.0-a0))
 4000	  continue
	  wc=wc/2.0
	endif
c
	wp=wp*ulen1**3
	wc=wc*ulen1**3
	w=wp+wc
c
c  w=total energy = wc + wp
c  wc=w(current)
c  wp=w(potential) = wmp+wsp+wss
c  wmp=w(monopole-potential)
c  wsp=w(solenoid-potential) =wsp+wsm
c  wsm=w(solenoid-monopole)
c  wss=w(solenoid-solenoid) = wsss+wssm
c  wsss=wss(self)
c  wssm=wss(mutual)
c
	if(msglvl.gt.0) write(lst,*) '(subr.engy  ) w,wc=',w,wc 
	return
	end
c
c  energy of solenoids: integral of AxB
c  A is due to the la-th coil and B is due to the lb-th coil
c
	subroutine engs(la,lb,w,eps,dmin0,dmax0)
c
	include 'sys.fc'
	include 'ss.fc'
	include 's1.fc'
	include 'coord.fc'
c
	finc(axb)=amax1(dmin,amin1(dmax,axbmax*dmin/(abs(axb)+1.0e-6)))
c
	pi=3.141592
	lm=1000
	aa=aa1(la)
	ab=aa1(lb)
	za= direc1(1,la)*(xxc1(1,la)-xxs1(1,la))
     &	   +direc1(2,la)*(xxc1(2,la)-xxs1(2,la))
     &	   +direc1(3,la)*(xxc1(3,la)-xxs1(3,la))
	zb= direc1(1,lb)*(xxc1(1,lb)-xxs1(1,lb))
     &	   +direc1(2,lb)*(xxc1(2,lb)-xxs1(2,lb))
     &	   +direc1(3,lb)*(xxc1(3,la)-xxs1(3,lb))
	ela=el1(la)
	elb=el1(lb)
	da=amax1(aa,za)
	db=amax1(ab,zb)
c
	if(la.eq.lb) go to 1
	sep=sqrt((xxs1(1,la)-xxs1(1,lb))**2
     &	   +(xxs1(2,la)-xxs1(2,lb))**2
     &	   +(xxs1(3,la)-xxs1(3,lb))**2 )
	if(abs(sep).lt.1.0e-4) sep=0.0
	if(sep.ne.0.0 .and. mesh.le.1) go to 2
	if(sep.lt.0.1*rsp .and. mesh.ge.2) go to 2
c
c  neglect the case of spherical boundary with separation of
c  coils > 0.1*rsp
c
	w=0.0
	return
c
c  self energy or coaxial case : 1-d. integration (trapezoidal formula)
c  integration is carried out on the z=0 plane
c
 1	continue
	axbmax=0.0
	ca=0.0
	dw=0.0
	w=0.0
	axb=0.0
	dmin=dmin0*aa
	dmax=dmax0*aa
	do 1000 l=1,lm
	dc=finc(axb)
	ca=ca+dc
	call vpots(ca,za,aa,ela,af)
	call fields(ca,zb,ab,elb,bc,bz)
	axb=af*bc
	if(dc.gt.dmin) then
	  dc1=finc(axb)
	  if(dc1.lt.dc) then
	    ca=ca-dc+dc1
	    dc=dc1
	    call vpots(ca,za,aa,ela,af)
	    call fields(ca,zb,ab,elb,bc,bz)
	    axb=af*bc
	  endif
	endif
	w=w+0.5*dw*dc
	if(abs(axb).gt.axbmax) axbmax=abs(axb)
	dw1=dw
	dw=pi*axb*ca
	w=w+0.5*dw*dc
	if(abs(dw).lt.abs(dw1).and.abs(dw).lt.eps) go to 3
 1000	continue
	write(lst,100) la,lb
 100	format(1x,
     &	'(subr.engs  ) warning: integration not converged, la=',
     &	       i2,3x,'lb=',i2)
 3	w=w*cj1(la)*cj1(lb)/(8.0*pi)
	return
c
c  mutual energy : 2-d. integration (trapezoidal formula)
c  only for cases that the axes of two solenoids are parallel
c
 2   	continue
	axbmax=0.0
	ca=0.0
	dw=0.0
	w=0.0
	th=0.0
	axb=0.0
	dmin=dmin0*aa
	dmax=dmax0*aa
c
	do 2000 l=1,lm
	th=0.0
	dc=finc(axb)
	ca=ca+dc
	cb=abs(sep-ca)
	call vpots(ca,za,aa,ela,af)
	call fields(cb,zb,ab,elb,bc,bz)
	axb=sign(af*bc,ca-sep)
	if(dc.gt.dmin) then
	  dc1=finc(axb)
	  if(dc1.lt.dc) then
	    ca=ca-dc+dc1
	    dc=dc1
	    cb=abs(sep-ca)
	    call vpots(ca,za,aa,ela,af)
	    call fields(cb,zb,ab,elb,bc,bz)
	    axb=sign(af*bc,ca-sep)
	  endif
	endif
	w=w+0.5*dw*dc
	if(abs(axb).gt.axbmax) axbmax=abs(axb)
	dw1=dw
	dw=0.0
	ddw=axb*ca
c
 3000	continue
	dth=finc(axb)/ca
	if(th+dth.gt.3.14) dth=pi-th
	th=th+dth
	costh=cos(th)
	cb=sqrt(abs(ca*ca+sep*sep-2.0*sep*ca*costh))
	call fields(cb,zb,ab,elb,bc,bz)
	axb=af*bc*(ca-sep*costh)
	if(cb.gt.1.0e-4) axb=axb/cb
	if(dth.le.dmin/ca) go to 3100
	dth1=finc(axb)/ca
	if(dth1.ge.dth) go to 3100
	th=th-dth+dth1
	dth=dth1
	costh=cos(th)
	cb=sqrt(abs(ca*ca+sep*sep-2.0*sep*ca*costh))
	call fields(cb,zb,ab,elb,bc,bz)
	axb=af*bc*(ca-sep*costh)
	if(cb.gt.1.0e-4) axb=axb/cb
 3100	continue
	dw=dw+0.5*ddw*dth
	if(abs(axb).gt.axbmax) axbmax=abs(axb)
	ddw=axb*ca
	dw=dw+0.5*ddw*dth
	if(th.lt.3.14) go to 3000
c
	w=w+0.5*dw*dc
	if(ca.lt.sep+ab) go to 2000
	if(abs(dw).lt.abs(dw1).and.abs(dw).lt.eps) go to 4
c
 2000	continue
	write(lst,100) la,lb
 4	w=w*cj1(la)*cj1(lb)/(8.0*pi)
c
	return
	end
