c  evaluate magnetic fields at specified points
c  if uout.gt.0, a magnetogram is generated
c
	subroutine evalb( uin, uout )
c
	external range
c
	integer uin, uout
	logical range,bnset
	include 'sys.fc'
	include 'ss.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'mdata.fc'
	include 'fline.fc'
	include 'fileio.fc'
	include 'string.fc'
c
	dimension xx(3),xx0(3),xx1(3),dxx(3),nxx(3),bb(3),b(3)
	character extr*10
	character*4 chrc(3,4)
	data chrc/'XD =','YD =','ZD =','XL =','YL =','ZL =',
     &	    'AP =','AL =','H  =','APR=','ALR=','H  ='/
	rad(deg1)=3.141592*deg1/180.0
	deg(rad1)=180.0*rad1/3.141592
c
c  mesh1         : specify kind of mesh used to specify xx0
c  mesh1>4 or <0 : end of data
c
c  iproj=0       : no projection
c  iproj=1,2,3,4 : projection onto the solar surface of mesh=iproj
c  iproj=12,13,14: projection onto the source surface of mesh=2,3,4
c
c  bnlvl=0        : sampling points on both polarities
c  bnlvl>0        : sampling points with bn>bnlvl
c  bnlvl<0        : sampling points with bn<bnlvl
c
	if(uout.gt.0) then
	  mode=2
	else
	  mode=1
	endif
c
	if(mode.eq.1) then
	  write(lst,*) '(subr.evalb ) field strengths: kindl=',
     &	       kindl
	else
c
	  kx=kxloc()
	  ky=kyloc()
	  kz=kzloc()
	  if(kx.eq.0.0 .or. ky.eq.0 .or. kz.eq.0) then
	    write(msg,*) '(subr.evalb ) error: kx,ky,kz=',kx,ky,kz
	    errflg=2
	    return
	  endif
	endif
	go to 1
c
c  set footpoints manually
c
	entry readfp(uin)
	mode=3
	kindl=20000 +kindl
c
 1	continue
	do 10 m=1,3
	dxx(m)=0.0
	nxx(m)=1
 10	continue
	iproj=0
	bnlvl=0.0
	zfact=1.0
c
	cl0sav=cl0eff
 1000	continue
	if(nsp.gt.1) then
	  read( uin,*, end=2900) nsp1,xx0,dxx,nxx
c
c	for binary star model
c	nsp1=0: xx0 and dxx are in C-coordinates
c	nsp1=1,,nsp: xx0 and dxx are in R-coordinates of sphere No.nsp1
c	nsp1>nsp: xx0 and dxx are in C-coordinates and then projected onto a sphere
c
	  if(nsp1.lt.0) go to 2900
	  if(nsp1.eq.0) then
	    mesh1=0
	    iproj=0
	  else if(nsp1.gt.nsp) then
	    mesh1=0
	    iproj=3
	  else
	    mesh1=3
	    iproj=0
	  endif
	  bnlvl=0.0
	else
	  read( uin,*, end=2900) mesh1,iproj,xx0,dxx,nxx,bnlvl
	  if(mesh1.lt.0 .or. mesh1.gt.4) go to 2900
	endif
c
c  nxx(3)<0 means that dxx(3) is a multiplication factor on z rather
c  than an additive constant
	if(nxx(3).lt.0) then
	  zfact=dxx(3)
	  dxx(3)=0.0
	  nxx(3)=-nxx(3)
	endif
	nxx(1)=max(1,nxx(1))
	nxx(2)=max(1,nxx(2))
	nxx(3)=max(1,nxx(3))
	if(nsp.lt.2) then
	  if(mesh1.eq.3) cl0eff=0.0
	  if(mesh1.eq.4) cl0eff=cl0
	  if(mesh1.ge.3) call setar
	endif
c
	do 2000 k=1,nxx(3)
	do 2000 j=1,nxx(2)
	do 2000 i=1,nxx(1)
	xx1(1)=xx0(1)+dxx(1)*float(i-1)
	xx1(2)=xx0(2)+dxx(2)*float(j-1)
	xx1(3)=xx0(3)+dxx(3)*float(k-1)
	xx0(3)=xx0(3)*zfact
c
	if(nsp.gt.1 .and. mesh1.eq.3 ) then
	  call rtocm(nsp1, rad(xx1(1)),rad(xx1(2)),xx1(3),xx)
	else if(nsp.gt.1 .and. mesh1.eq.0 ) then
	  xx(1)=xx1(1)
	  xx(2)=xx1(2)
	  xx(3)=xx1(3)
	else if(mesh1.eq.0) then
	  call dtoc(xx1,xx)
	else if(mesh1.eq.1) then
	  call ttoc(xx1,xx)
	else if(mesh1.eq.2) then
	  call stoc(rad(xx1(1)),rad(xx1(2)),xx1(3),xx)
	else if(mesh1.ge.3) then
	  call rtoc(rad(xx1(1)),rad(xx1(2)),xx1(3),xx)
	endif
c
	if(nsp.gt.1 .and. iproj.eq.3) then
	  call projm(xx,nsp1a,ap,al)
	else if(iproj.eq.1) then
	  call projt(xx,xt,yt)
	else if(iproj.eq.2) then
	  call projs(xx,ap,al)
	else if(iproj.eq.3.or.iproj.eq.4) then
	  call projr(xx,ap,al)
	else if(iproj.eq.12) then
	  call projs2(xx,ap,al)
	else if(iproj.eq.13.or.iproj.eq.14) then
	  call projr2(xx,ap,al)
	endif
c
c	set x1lim etc for subr.range
	call setlim(mesh1)
c
	bnset=.false.
	if(.not.(mode.eq.3.and.bnlvl.eq.0.0)) then
c  footpoint allocation (mode=3) does not need bn if bnlvl=0
	  if(iproj.eq.0.and..not.range(xx,h)) then
	    bb(1)=ufl
	    bb(2)=ufl
	    bb(3)=ufl
	  else
	    call field(xx,bb,1,1,1)
	  endif
	  if(nsp.lt.2) then
	    call vectoc(bb,b,mesh1,xx)
	    bn=b(3)
	    if(mesh1.ne.0) bnset=.true.
	  endif
	else
	  bn=0.0
	endif
c
	if(mode.eq.1) then
	  if(nsp.gt.1 .and. mesh1.eq.3) then
	    call ctorm(nsp1,xx,xx1(1),xx1(2),xx1(3))
	    xx1(1)=deg(xx1(1))
	    xx1(2)=deg(xx1(2))
	  else if(nsp.gt.1 .and. mesh1.eq.0) then
	    xx1(1)=xx(1)
	    xx1(2)=xx(2)
	    xx1(3)=xx(3)
	  else if(mesh1.eq.0) then
	    call ctod(xx,xx1)
	  else if(mesh1.eq.1) then
	    call ctot(xx,xx1)
	  else if(mesh1.eq.2) then
	    call ctos(xx,xx1(1),xx1(2),xx1(3))
	    xx1(1)=deg(xx1(1))
	    xx1(2)=deg(xx1(2))
	  else if(mesh1.ge.3) then
	    call ctor(xx,xx1(1),xx1(2),xx1(3))
	    xx1(1)=deg(xx1(1))
	    xx1(2)=deg(xx1(2))
	  endif
c
	  extr=' '
	  if(nsp.gt.1 .and. mesh1.eq.3)
     &	    write(extr,200) nsp1
 200	    format('SPHERE=',i1)
c
	  if(bnlvl.eq.0.0 .or.
     &	     bnlvl*bn.gt.0.0 .and. abs(bn).gt.abs(bnlvl) ) then
	    if(bnset) then
     	      write(lst,100) (chrc(m,mesh1+1),xx1(m),m=1,3), xx,bb,bn
 100	      format(2x,3(a4,1pe10.3,2x)
     &	 /2x,'X =',e10.3,2x,'Y =',e10.3,2x,'Z =',e10.3
     &	 /2x,'BX=',e10.3,2x,'BY=',e10.3,2x,'BZ=',e10.3,2x,'BN=',e10.3/)
	    else
     	      write(lst,110) (chrc(m,mesh1+1),xx1(m),m=1,3), extr,
     &	                      xx,bb
 110	      format(2x,3(a4,1pe10.3,2x),a10
     &	 /2x,'X =',e10.3,2x,'Y =',e10.3,2x,'Z =',e10.3
     &	 /2x,'BX=',e10.3,2x,'BY=',e10.3,2x,'BZ=',e10.3/)
	    endif
	  endif
c
	else if (mode.eq.2) then
	  m5=0
	  call vectoc(bb,b,m5, xx)
	  rdata(i,j,kx)=b(1)
	  rdata(i,j,ky)=b(2)
	  rdata(i,j,kz)=b(3)
c
	else if (mode.eq.3) then
	  if(bnlvl.eq.0.0 .or.
     &	     bnlvl*bn.gt.0.0 .and. abs(bn).gt.abs(bnlvl) ) then
	    nf=nf+1
	    foot(1,nf)=xx(1)
	    foot(2,nf)=xx(2)
	    foot(3,nf)=xx(3)
	  endif
	endif
c
	if(errflg.gt.1) return
 2000	continue
c  for mode=2, parameters are read only once
	if(mode.ne.2) go to 1000
c
 2900	continue
c
	if(mode.eq.2) then
c  output contains D-components of B
	  kindm=3
	  mesh=mesh1
	  kindmo=3
	  kloc(lspecs(kx))=0
	  kloc(lspecs(ky))=0
	  kloc(lspecs(kz))=0
	  lspecs(kx)=lspec('BX')
	  lspecs(ky)=lspec('BY')
	  lspecs(kz)=lspec('BL')
	  kloc(lspecs(kx))=kx
	  kloc(lspecs(ky))=ky
	  kloc(lspecs(kz))=kz
	  nx=nxx(1)
	  ny=nxx(2)
	  if(mesh1.lt.2) then
	    xs=xx0(1)
	    ys=xx0(2)
	    dx=dxx(1)
	    dy=dxx(2)
	  else
	    xs=rad(xx0(1))
	    ys=rad(xx0(2))
	    dx=rad(dxx(1))
	    dy=rad(dxx(2))
	  endif
	  title='generated by subr.evalb+field'
	  call writem (uout)
	endif
c
	cl0eff=cl0sav
	call setar
	if(msglvl.gt.0) then
	  if(mode.eq.3) write(lst,*) '(subr.readfp) nf=',nf
	endif
	return
	end
