c initial setting  for force-free-field calculation
c
	subroutine fffini( iunitl, ounitb )
c
c  setting for element : aspect ratio aratio=h/a (h=half-length, a=radius)
c                        elmin1=lower limit for arc-length
c                        elmax1=upper limit for arc-length
c
	include 'sys.fc'
	include 'mparam.fc'
	include 'lparam.fc'
	include 'auxparam.fc'
	include 'coord.fc'
	include 'fline.fc'
	include 'ss.fc'
	include 's3.fc'
	include 'ff0.fc'
	include 'fff.fc'
c
c	iunitl : inilof file
c	ounitb : ffbase file
c
	external range
c
	integer iunitl, ounitb
	logical update, range, ldummy
	dimension sa(ML),dd(3),vu1(3),vu2(3),vu3(3)
	equivalence (xyzr(1,1),sa(1))
c
	if(nff.le.0) then
	  write(lst,*) '(subr.fffini) error: nff=',nff,
     &	               ' at the beginning'
	  errflg=2
	  return
	endif
c
	update=.true.
	call readlh( iunitl,update)
c  read field line header
c
	l=0
	ls(1)=1
	nn=0
	almax0=0.0
	almax=0.0
	elmax0=0.0
	twmax=0.0
c
	do 1000 n=1,nff
c
	r0=sqrt(abs(ss0(n))/3.141592)
	elmin1=elminr*r0
	call readl( iunitl, np, xyzp )
	if(np.lt.2 .or. abs(xyzp(4,np)).lt.elmin1) then
	  if(msglvl.gt.1) write(lst,*)
     &    '(subr.fffini) field line too short: length=',abs(xyzp(4,np))
	  go to 1000
	endif
c
	elmax1=elmaxr*r0
	if(abs(xyzp(4,np)).gt.elmax1) then
	  if(msglvl.gt.1) write(lst,*)
     &	  '(subr.fffini) field line too long: length=',abs(xyzp(4,np))
	  go to 1000
	endif
c
	ldummy=range(xyzp(1,np),h)
	if(h.gt.1.0e-3) then
	  if(msglvl.gt.1) write(lst,*)
     &	  '(subr.fffini) open field line: skip'
	  go to 1000
	endif
c
	l0=l
	call vu(xyzp(1,1),vu1,vu2,vu3)
c
c  use bn00 instead of bn0(n) because actual bn00 may be different
c  from bn0. Particularly if an element with weak field is surrounded
c  by strong fields, bn00 may have opposite sign from bn0.
c
	bn00=vu3(1)*xyzp(5,1)+vu3(2)*xyzp(6,1)+vu3(3)*xyzp(7,1)
c
c  because of fixed point representation of floating point numbers
c  in the field-line file, bn can be 0.0
	if(bn00.eq.0.0) then
	  if(msglvl.gt.1) write(lst,*)
     &	  '(subr.fffini) bn=0 at initial point: skip'
	  go to 1000
	endif
cc
cc	write(6,*) 'n,bn0,bn00=',n,bn0(n),bn00
cc	write(6,*) 'b=',xyzp(5,1),xyzp(6,1),xyzp(7,1)
cc	write(6,*) 'vu3=',vu3
cc
	flx0=abs(bn00)*ss0(n)/3.141592
cx	flx0=abs(bn0(n))*ss0(n)/3.141592
	ip0=1
	flux=flx0*3.141592
c
c  set nodal points xxn0, radius aa3, length el3, and
c  direction vectors direc0
c
	do 2000 ip=2,np
c
c  advance pointer ip until the element's aspect ratio (el/2)/a exceeds
c  aratio or the length el exceeds elmax1
c
	if( ((xyzp(4,ip)-xyzp(4,ip0))/2.0)**2 .lt. 
     &	  aratio*aratio*flx0/amax1(xyzp(8,ip0),xyzp(8,ip)) .and.
     &	  abs(xyzp(4,ip)-xyzp(4,ip0)) .lt. elmax1 .and. ip.lt.np)
     &	  go to 2000
c
c  xyzp(4,*)=arc-length
c  xyzp(7,*)=Bz
c  xyzp(8,*)=Bs
c
	l=l+1
	if(l.gt.NODE0) then
	  write(lst,*)
     &    '(subr.fffini) error: dimension overflow, node0=',NODE0
	  errflg=2
	  return
	endif
c
	sa(l) =xyzp(4,ip)
	bs0(l)=sqrt(abs(xyzp(8,ip0)*xyzp(8,ip)))
	el3(l)=abs(xyzp(4,ip)-xyzp(4,ip0))
	do 2100 m=1,3
	xxn0(m,l)   =xyzp(m,ip)
	direc0(m,l)=xyzp(m,ip)-xyzp(m,ip0)
 2100	continue
	if(ip0.eq.1) then
c  radius of the first element is determined geometrically
	  call vu(xyzp(1,1),vu1,vu2,vu3)
	  d=sqrt(direc0(1,l)**2+direc0(2,l)**2+direc0(3,l)**2)
	  dc=(vu3(1)*direc0(1,l)+vu3(2)*direc0(2,l)+vu3(3)*direc0(3,l))
     &	/d
	  aa3(l)=sqrt(abs(ss0(n)/3.141592*dc))
	else
c  use flux conservation to determine the radius 
	  aa3(l)=sqrt(abs(flx0/max( xyzp(8,ip0),xyzp(8,ip)) ) )
	endif
c  smallest value of aa3 is adopted here
c  if larger values are used, the calculated distribution of curl B
c  of a single current loop will have a peak value on the boundary
c  lower than given from the boundary condition, although the total
c  current is correctly recovered.
c  
c
	if(ip.eq.np) go to  3500
	ip1=ip0
	ip0=ip
	dsm2=0.5*aratio*aratio*flx0/amax1(xyzp(8,ip),xyzp(8,np))
c
c  escape the loop if the last element can be constructed extending
c  from the current ip to the last point np
c  (the last elememt is shorter than elmax1 and its aspect ratio
c  is smaller than aratio/sqrt(2) )
c
	if(((xyzp(4,ip)-xyzp(4,np))/2.0)**2.lt.dsm2 .and.
     &	  abs(xyzp(4,ip)-xyzp(4,np)).lt.elmax1) go to 3000
 2000	continue
c
 3000	continue
	l=l+1
	if(l.gt.NODE0) then
	  write(lst,*)
     &    '(subr.fffini) error: dimension overflow, node0=',NODE0
	  errflg=2
	  return
	endif
c
c  ip1 < ip < np
	if(((xyzp(4,ip)-xyzp(4,np))/2.0)**2.lt.0.25*dsm2) then
	  ip0=(ip1+np+1)/2
	  if(np.eq.ip0+1) then
c  the last element is too short; combine it with the next element
	    l=l-1
cx	    aa3(l)=sqrt(abs(flx0/max( xyzp(8,ip1),xyzp(8,np)) ) )
	    sa(l) =xyzp(4,np)
	    bs0(l)=sqrt(abs( xyzp(8,ip1)*xyzp(8,np) ))
	    el3(l)=abs(xyzp(4,np)-xyzp(4,ip1))
	    do 3100 m=1,3
	    xxn0(m,l)   =xyzp(m,np)
 3100	    direc0(m,l)=xyzp(m,np)-xyzp(m,ip1)
	  else
c  make two elements (ip1,ip0),(ip0,np)
	    aa3(l-1)=sqrt(abs( flx0/ max( xyzp(8,ip1),xyzp(8,ip0) )))
c	    aa3(l) is set later
	    sa(l-1) =xyzp(4,ip0)
	    sa(l  ) =xyzp(4,np)
	    bs0(l-1)=sqrt(abs( xyzp(8,ip1)*xyzp(8,ip0)) )
	    bs0(l  )=sqrt(abs( xyzp(8,ip0)*xyzp(8,np)) )
	    el3(l-1)=abs(xyzp(4,ip0)-xyzp(4,ip1))
	    el3(l  )=abs(xyzp(4,np) -xyzp(4,ip0))
	    do 3200 m=1,3
	    xxn0(m,l-1)   =xyzp(m,ip0)
	    xxn0(m,l  )   =xyzp(m,np)
	    direc0(m,l-1)=xyzp(m,ip0)-xyzp(m,ip1)
	    direc0(m,l ) =xyzp(m,np) -xyzp(m,ip0)
 3200	    continue
	  endif
	else
c  last element is long enough
c	  aa3(l) is set later
	  sa(l) =xyzp(4,np)
	  bs0(l)=sqrt(abs( xyzp(8,ip)*xyzp(8,np) ))
	  el3(l)=abs(xyzp(4,ip)-xyzp(4,np))
	  do 3300 m=1,3
	  xxn0(m,l)   =xyzp(m,np)
	  direc0(m,l)=xyzp(m,np)-xyzp(m,ip)
 3300	  continue
	endif 
	call vu(xyzp(1,np),vu1,vu2,vu3)
	d=sqrt(direc0(1,l)**2+direc0(2,l)**2+direc0(3,l)**2)
	dc=(vu3(1)*direc0(1,l)+vu3(2)*direc0(2,l)+vu3(3)*direc0(3,l))/d
	bn1=vu3(1)*xyzp(5,np)+vu3(2)*xyzp(6,np)+vu3(3)*xyzp(7,np)
	aa3(l)=sqrt(abs(ss0(n)*(bn00/bn1)/3.141592*dc))
c  here bn00 is used instead of bn0 because sometimes bn00 and bn0
c  have opposite signes.
c
cx	aa3(l)=sqrt(abs(ss0(n)*(bn0(n)/bn1)/3.141592*dc))
cc
	if(bn00*bn1*dc .le.0.0) then
	  write(lst,*) 'l,aa3=',l,aa3(l)
	  write(lst,*) 'n,ss0,bn0,bn00=',n,ss0(n),bn0(n),bn00
	  write(lst,*) 'bn1,dc=',bn1,dc
	  write(lst,*) 'vu3=',vu3
	  write(lst,*) 'direc0=',(direc0(m,l),m=1,3)
	  write(lst,*) 'xyzp='
	  do 9999 kkk=1,np
 9999	  write(lst,*) (xyzp(m,kkk),m=5,7)
	  stop 'abort'
	endif
cc
c  radius of the last element is determined geometrically
c
 3500	continue
c
	if(l-l0.lt.3) then
	  if(msglvl.gt.1) write(lst,*)
     &	  '(subr.fffini) number of elements too small'
	  l=l0
	  go to 1000
	endif
c
	nn=nn+1
	bn0(nn)=bn0(n)
	ss0(nn)=ss0(n)
	ell0(nn)=abs(xyzp(4,np))
	ell(nn)=ell0(nn)
	rotb0(nn)=rotb0(n)
	alpha0(nn)=alpha0(n)
	alpha(nn)=alpha(n)
	almax0=max( almax0, abs(alpha0(nn)) )
	almax=max( almax, abs(alpha(nn)) )
	elmax0=max( elmax0,ell0(nn) )
	twmax=max(twmax,0.5*abs(alpha0(nn))*ell0(nn))
c
	bngx0(nn)=bngx0(n)
	bngy0(nn)=bngy0(n)
	rotbb0(nn)=rotbb0(n)
	do 3600 m=1,3
	xxs(m,nn)=xyzp(m,1)
 3600	continue
c
c  rotbb0 = rot(bnbh)*n
c         = [grad(bn) x bh]*n + bn rot(bh)*n
c         = [n x grad(bn)]*bh + bn rot(bh)*n
c         = (bngx0,bngy0)*bh    + bn * rotb0
c
	le(nn)=l
	ls(nn+1)=l+1
c
	l1=ls(nn)
	l2=le(nn)
	if(msglvl.gt.1) then
	  write(lst,200) nn,flux
 200	  format(/2x, i3,5x,'flux=',1pe10.2/2x, t10,'s',t20,'b',
     &	         t30,'a',t40,'l',t50,'x',t60,'y',t70,'z')
	  write(lst,210) xyzp(4,1),xyzp(8,1),(xxs(m,nn),m=1,3)
 210	  format(2x, 3x,1p2e10.2,20x,3e10.2)
	  do 4000 ll=l1,l2
	  write(lst,220) ll,sa(ll),bs0(ll),aa3(ll),el3(ll),
     &	                (xxn0(m,ll),m=1,3)
 220	  format(2x, i3,1p7e10.2)
 4000	  continue
	endif
c
	if(l2.eq.l1) then
	  errflg=2
	  write(lst,*) '(subr.fffini) error in setting element'
	  return
	endif
c
c  direc0 is not yet normalized
c
c  set ve1,ve2,vf1,vf2 vectors
c  ve1(ll) is in the direction of direc0(ll+1)-direc0(ll)
c  dd      is in the direction of direc0(ll+1)+direc0(ll)
c  ve2 = dd x ve1
c  vf1(ll) is in the direction of ve1(ll+1)+ve1(ll)
c  vf2 = direc0 x vf1
c
	do 5000 ll=l1,l2
	cj3(ll)=0.0
	if(ll.eq.l2) then
	  call vu(xxn0(1,l2), ve1(1,l2),ve2(1,l2), vu3)
c
	else
	  do 5200 m=1,3
	  ve1(m,ll)=direc0(m,ll+1)-direc0(m,ll)
	  dd(m)=direc0(m,ll)+direc0(m,ll+1)
 5200	  continue
	  e1=(direc0(1,ll+1)**2+direc0(2,ll+1)**2+direc0(3,ll+1)**2)
     &	    *(direc0(1,ll  )**2+direc0(2,ll  )**2+direc0(3,ll  )**2)
     &	    -(direc0(1,ll+1)*direc0(1,ll)+
     &	      direc0(2,ll+1)*direc0(2,ll)+
     &	      direc0(3,ll+1)*direc0(3,ll))**2
	  d=sqrt(dd(1)**2+dd(2)**2+dd(3)**2)
	  do 5300 m=1,3
 5300	  dd(m)=dd(m)/d
c
	  if(e1.eq.0.0) then
c  direc0(ll) and direc0(ll+1) are (anti)parallel
c  ve1 should be determined from different methods
	    call vu( xxn0(1,ll), vu1,vu2,vu3)
	    p1=dd(1)*vu1(1)+dd(2)*vu1(2)+dd(3)*vu1(3)
	    p2=dd(1)*vu2(1)+dd(2)*vu2(2)+dd(3)*vu2(3)
	    if(abs(p1).gt.abs(p2)) then
	      do 5400 m=1,3
 5400	      ve1(m,ll)=vu2(m)
	    else
	      do 5450 m=1,3
 5450	      ve1(m,ll)=vu1(m)
	    endif
	  endif
c
	  de1=dd(1)*ve1(1,ll)+dd(2)*ve1(2,ll)+dd(3)*ve1(3,ll)
	  e1=0.0
	  do 5500 m=1,3
	  ve1(m,ll)=ve1(m,ll)-de1*dd(m)
	  e1=e1+ve1(m,ll)**2
 5500	  continue
	  e1=sqrt(e1)
	  do 5600 m=1,3
 5600	  ve1(m,ll)=ve1(m,ll)/e1
	  ve2(1,ll)=dd(2)*ve1(3,ll)-dd(3)*ve1(2,ll)
	  ve2(2,ll)=dd(3)*ve1(1,ll)-dd(1)*ve1(3,ll)
	  ve2(3,ll)=dd(1)*ve1(2,ll)-dd(2)*ve1(1,ll)
	endif
 5000	continue
c
	if(msglvl.gt.1) write(lst,230)
 230	  format(/2x,t12,'ve1',t28,'ve2',t44,'vf1',t60,'vf2')
c
	do 6000 ll=l1,l2
	if(ll.eq.l1) then
	  do 6100 m=1,3
 6100	  vf1(m,ll)=ve1(m,l1)
	elseif(ll.eq.l2) then
	  do 6200 m=1,3
 6200	  vf1(m,ll)=ve1(m,l2-1)
	else
	  do 6300 m=1,3
 6300	  vf1(m,ll)=ve1(m,ll-1)+ve1(m,ll)
	endif
	d=sqrt(direc0(1,ll)**2+direc0(2,ll)**2+direc0(3,ll)**2)
	do 6400 m=1,3
 6400	direc0(m,ll)=direc0(m,ll)/d
	df1=direc0(1,ll)*vf1(1,ll)+direc0(2,ll)*vf1(2,ll)
     &	   +direc0(3,ll)*vf1(3,ll)
	f1=0.0
	do 6500 m=1,3
	vf1(m,ll)=vf1(m,ll)-df1*direc0(m,ll)
	f1=f1+vf1(m,ll)**2
 6500	continue
	f1=sqrt(f1)
	do 6600 m=1,3
 6600	vf1(m,ll)=vf1(m,ll)/f1
	vf2(1,ll)=direc0(2,ll)*vf1(3,ll)-direc0(3,ll)*vf1(2,ll)
	vf2(2,ll)=direc0(3,ll)*vf1(1,ll)-direc0(1,ll)*vf1(3,ll)
	vf2(3,ll)=direc0(1,ll)*vf1(2,ll)-direc0(2,ll)*vf1(1,ll)
	if(msglvl.gt.1)
     &	  write(lst,240) ll,(ve1(m,ll),m=1,3), 
     &	                    (ve2(m,ll),m=1,3),
     &	                    (vf1(m,ll),m=1,3),
     &	                    (vf2(m,ll),m=1,3)
 240	format(2x, i3,4(3f5.2,1x))
 6000	continue
c
 1000	continue
c
	nff=nn
	if(nff.le.0) then
	  write(lst,*) '(subr.fffini) error: nff=',nff
	  errflg=2
	  return
	endif
c
	if(modeff.eq.1) then
c
c  estimate dalpha and nloop
c  alpha/2 x length is an estimated twist angle in radian
c  dalpha will be multiplied later by factda
c  if one iteration may follow twist of pi/6,
c  then factda = 1/3
	    facta=0.0
	    aux=0.0
	    do 7100 n=1,nff
 	    facta=min(facta,abs(alpha(n)/alpha0(n)))
	    dalpha(nn)= sign( 3.141592/ell0(n), alpha0(n))
	    aux=max(aux,abs(alpha0(n)-alpha(n))/abs(factda*dalpha(n)))
 7100	  continue
	  nloop= aux +1.5
	else
	  facta=almax/almax0
	  do 7200 n=1,nff
 7200	dalpha(n)=3.141592/elmax0
	  nloop = (almax0-almax)/(factda*dalpha(1)) +1.5
	endif
c
c  write data to 'ffbase' file
	lmax=l
	modeff=1
c  modeff will be specified by subr.fffitr
	nvar=2*lmax+nff*(modeff-1)
	rewind ounitb
	write(ounitb) nff,lmax,nvar,modeff
	write(ounitb) bdc, (ls(n),    n=1,nff),
     &	             (le(n),    n=1,nff),
     &	             (bn0(n),   n=1,nff),
     &	             (ss0(n),   n=1,nff),
     &	             (ell0(n),   n=1,nff),
     &	             (rotb0(n), n=1,nff),
     &	             (alpha0(n),n=1,nff),
     &	             (dalpha(n),n=1,nff),
     &	             (bngx0(n), n=1,nff),
     &	             (bngy0(n), n=1,nff),
     &	             (rotbb0(n),n=1,nff),
     &	             ((xxs(m,n),   m=1,3),n=1,nff),
     &	             ((xxn0(m,l),  m=1,3),l=1,lmax),
     &	             ((direc0(m,l),m=1,3),l=1,lmax),
     &	             ( bs0(l),            l=1,lmax),
     &	             ((ve1(m,l),   m=1,3),l=1,lmax),
     &	             ((ve2(m,l),   m=1,3),l=1,lmax),
     &	             ((vf1(m,l),   m=1,3),l=1,lmax),
     &	             ((vf2(m,l),   m=1,3),l=1,lmax)
c
	if(msglvl.gt.0) write(lst,100) aratio,elmax0,lmax,nloop,twmax
 100	  format(' (subr.fffini) aratio=',f10.4,3x,'elmax0=',f10.4,3x,
     &	         'lmax=',i5
     &	        /'               estimated nloop,twmax=',
     &	         f10.4,i4)
	if(msglvl.gt.1) write(lst,110) elmaxr,elminr
 110	  format('               elmaxr=',f10.4,3x,'elminr=',f10.4)
c
	nrezon=nrezon+1
c
	return
	end
c
        subroutine curlf
c
	parameter (NDIM=100)
        include 'ff0.fc'
        include 'fff.fc'
        include 's3.fc'
c
        dimension xx(3),bb(3),bbp(3),bbm(3)
	dimension rhs(NDIM),nans(NDIM),resp(NDIM,NDIM)
c
	del=0.01
        lmax2=2*lmax
        do 10 l=1,lmax2
	cj3(l)=0.0
 10     ksw3(l)=0
c
        do 1000 n=1,nff
	rhs(n)=rotbb0(n)
	l1=ls(n)
	l2=le(n)
	do 1100 l=l1,l2
	cj3(l)=ss0(n)/(4.0*3.141592)
	cj3(l+lmax)=ss0(n)/(4.0*3.141592)
	ksw3(l)=1
	ksw3(l+lmax)=1
 1100	continue
c
        do 2000 m=1,nff
	l1=ls(n)
	xx(1)=xxs(1,m)
	xx(2)=xxs(2,m)
	xx(3)=xxs(3,m)
        call field(xx,bb,-1,-1,0)
	bhx=bb(1)
	bhy=bb(2)
c
	xx(1)=xxs(1,m)+del
	call field(xx,bbp,-1,-1,0)
	xx(1)=xxs(1,m)-del
	call field(xx,bbm,-1,-1,0)
	dbydx=(bbp(2)-bbm(2))/(2.0*del)
	xx(1)=xxs(1,m)
c
	xx(2)=xxs(2,m)+del
	call field(xx,bbp,-1,-1,0)
	xx(2)=xxs(2,m)-del
	call field(xx,bbm,-1,-1,0)
	dbxdy=(bbp(1)-bbm(1))/(2.0*del)
	xx(2)=xxs(2,m)
c
        resp(m,n)=bngx0(m)*bhy - bngy0(m)*bhx + bn0(m)*(dbydx-dbxdy)
cc
cc	if(n.eq.m) write(6,*) 'n,a,b,rotb=',n,aa3(l1),bb,dbydx-dbxdy
cc
 2000	continue
c
	do 1200 l=l1,l2
	cj3(l)=0.0
	cj3(l+lmax)=0.0
	ksw3(l)=0
	ksw3(l+lmax)=0
 1200	continue
 1000	continue
c
cc	write(6,*) 'resp=',((resp(m,n),m=1,nff),n=1,nff)
c
	nstop=1
	call lins2(resp,nff,NDIM,rhs,nans,nstop,1.0e-5)
c
	write(6,*) 'derived rotb=',(rhs(n),n=1,nff)
	return
	end
