c  MAGPACK2 force-free field computation
c
	program fff
c
	include 'sys.fc'
	include 'fileio.fc'
	include 'string.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'mdata.fc'
	include 'fcntl.fc'
	include 'procs.fc'
	include 'auxparam.fc'
	include 'ff0.fc'
	include 'fff.fc'
c
	character chr*1,cfile*80
	logical cancl0
	integer xold,xnew
	dimension multi(20)
	integer*4 kindm1
	data multi/20*0/
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	msglvl = 1
c
c  character code should either be ASCII or EBCDIC
c  binary integer should either be big endian or
c  full-byte-swap little endian
        include 'sysconf.cfg'
c
        if(mycode.eq.0 .or. myint.eq.0) stop
        if(errflg.gt.0) stop
c
c  initialize commons /fcntl/ and /procs/
        call initfc
c
c  open list file
	lst = lstini()
c
c  print version number
	call vsn
c
c  common variables should be static
        call static(ist)
        if(ist.gt.1) stop
c  algorithm for byte swap should be correct
        call swap(iswap)
        if(iswap.gt.0) stop
c
	if(myargc().eq.1) then
	  call myargv(1,cfile)
	else
	  cfile=' '
	  write(msg,*,err=2)
     &	 'enter control file name (default=control.dat)'
	  go to 3
 2	  msg=lst
	  write(msg,*) 'enter control file name (default=control.dat)'
 3	  read(keyin,'(a)',end=4) cfile
 4	  if(cfile.eq.' ') cfile='control.dat'
	endif
c
        call openfl(cntrol,lname(cntrol),stdin,cfile,text,rdo,0)
c
	read(stdin,'(a1)') chr
	if(chr.eq.'0') then
	  msglvl=0
	else if(chr.eq.'1') then
	  msglvl=1
	else if(chr.eq.'2') then
	  msglvl=2
	else if(chr.eq.'3') then
	  msglvl=3
	endif
c
c  initialize common variables and read auxdata
	write(lst,*) '(proc.fff   ) start'
	multi1=0
	call assign( init,multi1 )
	if(errflg.gt.0) stop
	call initc( funit(auxdat) )
	call clsfl (auxdat)
c
        if(nbytem.ne.0) then
          nbytem=sign(nbytem,myint)
        else
          nbytem=myint
        endif
        if(nbytel.ne.0) then
          nbytel=sign(nbytel,myint)
        else
          nbytel=myint
        endif
c
 1000	continue
	errflg=0
	ms=0
c
c
c  proc.ffinit
c  initialization for force-free field calculation
c  read mgram and make s123,ffbase,inilof,itrlof,xvect1/2
c
c  subr.assign reads msglvl,rdfpt,mansel,rds1,rds2
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( ffinit,multi(ms) )
	if(errflg.gt.1) go to 1001
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  kindm=0
	  kindl=0
	  read(stdin,*) kindm,kindl
	  kindl=mod(kindl,1000)
	  call load(mgram)
	  if(errflg.gt.1) go to 1001
c
	  call sets12( rds1, funit(s1data) )
	  if(errflg.gt.1) go to 1001
c
	  read(stdin,*) nff,ds0,region,minjz,minbz
	  call select( funit(falpha) )
	  if(errflg.gt.1) go to 1001
	  nf0=nff
	  nf=nff
c
c! option to read s123?
c
	  cancl0=cancel
	  cancel=.false.
	  ncomp0=ncomp
	  ncomp=8
	  call umake(kindl, l5,l4,l3,l2,l1)
	  kindl=make(l5+4,0,l3,l2,l1)
	  call integ( funit(inilof) )
	  if(errflg.gt.1) go to 1001
	  nff=nf
	  cancel=cancl0
c
c  fffini reads inilof from the beginning
	  almax=0.0
	  call fffini( funit(inilof), funit(ffbase) )
	  if(errflg.gt.1) go to 1001
c
	  call clearx
	  call writex( funit(xvect1) )
	  call writex( funit(xvect2) )
	  if(errflg.gt.1) go to 1001
	  call sets3
	  if(errflg.gt.1) go to 1001
cc
cc	call curlf
cc
	  call writes( funit(s123) )
	  if(errflg.gt.1) go to 1001
	  call spllof( funit(itrlof) )
	  if(errflg.gt.1) go to 1001
	  ncomp=ncomp0
c
	endif
	rds1=.false.
	rds2=.true.
c
 1001	continue
	if(errflg.ne.1) then
	  call clsfl (mgram)
	  if(rds1) call clsfl (s1data)
	  call clsfl(falpha)
	  call clsfl(inilof)
	  call clsfl(ffbase)
	  call clsfl (xvect1)
	  call clsfl (xvect2)
	  call clsfl (s123)
	  call clsfl (itrlof)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.ffitr
c  iterative solution of force-free field
c
c  subr.assign reads msglvl
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( ffitr,multi(ms) )
	if(errflg.gt.1) go to 1002
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  call reads( funit(s123), funit(ffbase) )
	  if(errflg.gt.1) go to 1002
	  call readx( funit(xvect1), funit(xvect2), xold, xnew )
	  if(errflg.gt.1) go to 1002
c
cx	  if (rezone .and. nitr.gt.0) then
cx	    write(lst,*) '(proc.fff   ) rezoning'
cx	    call fffini( funit(itrlof), funit(ffbase) )
cx	    if(errflg.gt.1) go to 1002
cx	    call clearx
cx	    if(errflg.gt.1) go to 1002
cx	  endif
c
cx        if(nvar*(nvar+2).gt.MMX*MMY) then
cx	    write(lst,*)
cx     &	  '(prog.fff   ) insufficient working space (required,actual)=',
cx     &	    nvar*(nvar+2),MMX*MMY
cx	    errflg=2
cx	    go to 1002
cx	  endif
c
	  read(stdin,*) itrmax,nloop,facta,factda,modeff
c  value of facta given here overrides the value stored in xvector1/2
	  if(errflg.gt.1) go to 1002
c
	  ncomp0=ncomp
	  ncomp=8
	  call fffitr( funit(itrlof), funit(ffbase), funit(s123), xold )
cc	  if(errflg.gt.1) go to 1002
	  call spllof( funit(itrlof) )
	  if(errflg.gt.1) go to 1002
	  ncomp=ncomp0
cx	  call writes( funit(s123) )
	  if(errflg.gt.1) go to 1002
c  xvector is updated only when no errors are found in fffitr
cx	  call writex( xold )
	  if(errflg.gt.1) go to 1002
	endif
c
 1002	continue
	if(msglvl.gt.1) call lstnod(xvect,gvect,wdata)
c  wdata contains h-vector
	if(errflg.ne.1) then
	  call clsfl (ffbase)
	  call clsfl (xvect1)
	  call clsfl (xvect2)
	  call clsfl (s123)
	  call clsfl (itrlof)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.integf
c  integrate force-free field lines
c
c  subr.assign reads msglvl,rdfpt,irefpt
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( integf,multi(ms) )
	if(errflg.gt.1) go to 1003
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  call reads( funit(s123), 0 )
c  second argument=0: ffbase is not neccesary
c  reads sets default values for ds0, *lim0
	  read(stdin,*) nf0,cancel,flxpwr,ds0
	  nf=nf0
cx	  x1lim=x1lim0+x1del
cx	  x2lim=x2lim0+x2del
cx	  y1lim=y1lim0+y1del
cx	  y2lim=y2lim0+y2del
cx	  if(z2lim.eq.0.0) z2lim=z2lim0
	  if(errflg.gt.1) go to 1003
c
	  kindl=mod(kindl,10000)
	  if (irefpt.gt.0 .and. irefpt.le.3) then
	    call fptref( funit(reflof) )
	    if(errflg.gt.1) go to 1003
	  else 
	    call fptflx
	    if(errflg.gt.1) go to 1003
	  endif
	  if (rdfpt) then
	    call readfp( funit(footpt) )
	    if(errflg.gt.1) go to 1003
	  endif
c
	  call integ( funit(fflof) )
	  if(errflg.gt.1) go to 1003
	endif
c
 1003	continue
	if(errflg.ne.1) then
	  call clsfl (s123)
	  if (irefpt.gt.0 .and. irefpt.le.3) call clsfl (reflof)
	  if (rdfpt) call clsfl (footpt)
	  call clsfl (fflof)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.energy
c  calculate magnetic energy
c
c  subr.assign reads msglvl,rds1,rds2,rds123
c  the data in commons s1-3 are used, without reading data from file
c  rds1 and rds2 are set to F
c
	if(errflg.gt.1) go to 1900
	ms=ms+1
	rds1=.false.
	rds2=.false.
	rds123=.true.
	call assign( energy,multi(ms) )
	if(errflg.gt.1) go to 1004
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
        call reads( funit(s123), 0 )
c  second argument=0: ffbase is not neccesary
        if(errflg.gt.1) go to 1004
c
        read(stdin,*) kindm1
c  this read is a dummy
	  call engy
	  if(errflg.gt.1) go to 1004
c
	endif
	rds1=.false.
	rds2=.true.
	rds123=.false.
c
 1004	continue
	if(errflg.ne.1) then
	  call clsfl (s123)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.eval
c  evaluate magnetic fields at specified points
c
c  subr.assign reads msglvl,rds1,rds2,rds123,mkmmap
c  the data in commons s1-3 are used, without reading data from file
c  rds1 and rds2 are set to F
c
	if(errflg.gt.1) go to 1900
	ms=ms+1
	rds1=.false.
	rds2=.false.
	rds123=.true.
	call assign( eval,multi(ms) )
 	if(errflg.gt.1) go to 1005
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
        call reads( funit(s123), 0 )
c  second argument=0: ffbase is not neccesary
        if(errflg.gt.1) go to 1005
c
	  read(stdin,*) kindm1,kindl1
c  this read is a dummy
	  call evalb( funit(evalpt), funit(gmgram) )
	  if(errflg.gt.1) go to 1005
c
	endif
	rds1=.false.
	rds2=.true.
	rds123=.false.
c
 1005	continue
	if(errflg.ne.1) then
	  call clsfl (s123)
	  call clsfl (evalpt)
	  if(mkmmap) call clsfl(gmgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.test
c
c  subr.assign reads msglvl,rds1,rds2,rds123
	if(errflg.gt.1) go to 1900
	ms=ms+1
	rds1=.false.
	rds2=.false.
	rds123=.true.
 	call assign( test,multi(ms) )
 	if(errflg.gt.1) go to 1006
c
 	if(errflg.eq.0) then
        call reads( funit(s123), 0 )
c  second argument=0: ffbase is not neccesary
        if(errflg.gt.1) go to 1006
c
	  read(stdin,*) itest
	  read(stdin,*) kindm1,kindl1
c  this read is a dummy
c
	  call tests(itest)
	  if(errflg.gt.1) go to 1006
	endif
	rds1=.false.
	rds2=.true.
	rds123=.false.
c
 1006	continue
	if(errflg.ne.1) then
	  call clsfl (s123)
	endif
	if(errflg.gt.1) go to 1900
c
 1900	continue
	do 1100 i=1,20
	if(multi(i).ne.0) then
	  if(errflg.le.1) go to 1000
	endif
 1100	continue
c  it is better stop the job here if errflg=2, because the correspondence
c  between the input and output files may become non-synchronous

c
	write(lst,*) '(proc.fff   ) end'
	stop
	end
c
	subroutine tests(itest)
c
c  test1: create magnetogram by using subr.field
	if(itest.eq.1) call test1
c  test2: cross check with dipole field
	if(itest.eq.2) call test2
c  test3: cross check with nonlinear force-free field
	if(itest.eq.3) call test3
c  test4: energy routine
	if(itest.eq.4) call test4
c
	return
	end

