c  direction vector of magnetic field
c  return with dxx(1-3)=b-vector/|b|, dxx(4)=1.0
c              dxx(5-7)=b-vector, dxx(8)=bs
c
 	subroutine dxds(ndim,xx,dxx)
 	dimension xx(8),dxx(8),xxarg(3),bvectr(3)
c
 	do 10 m=1,3
  10	xxarg(m)=xx(m)
 	call field(xxarg,bvectr,1,1,1)
 	bs=sqrt(bvectr(1)**2+bvectr(2)**2+bvectr(3)**2)
	if (bs.lt.1.0e-30) bs=1.0e-30
 	do 20 m=1,3
 	dxx(m)=bvectr(m)/bs
 	dxx(m+4)=bvectr(m)
  20	continue
 	dxx(4)=1.0
 	dxx(8)=bs
 	return
 	end
c
c  calculation of magnetic field
c  return with field vector in bvectr(1-3)
c
	subroutine field(xx,bvectr,is1,is2,is3)
c
c  for z<0 in s2 : b is the field of monopole sheet
c
	dimension bb(3),bbb(3),bvectr(3)
	dimension xx(3),b(3),cu(3),xx0(3),xx1(3),xx2(3)
	dimension xxo1(3),xxo2(3),xxi1(3),xxi2(3),vn1(3),vn2(3),
     &	  xxout(3),xxin(3)
	dimension aj(3)
c
	include 'sys.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'ss.fc'
	include 's1.fc'
	include 's2.fc'
	include 's3.fc'
	include 'ff0.fc'
	include 'coord.fc'
	include 'auxparam.fc'
c
	dimension am(7),dm(7)
	integer*4 kindl1
c
	data am,dm/7.699525, -20.40468, 17.55048, -4.345321,
     &	     1.0,-0.5, 0.5,
     &           2.200483,  1.741699, 1.353484,  1.123245,
     &	     0.5, 1.0, 0.0/
	data eps/1.e-4/, rc/10.0/, pi/3.141592/
c
	if(modelf.eq.0) go to 1
	if(modelf.eq.7) then
	  call dipole(xx,bvectr,psi,xxsaux,diraux,dmom)
	else if (modelf.eq.8) then 
	  call nlfff(xx,bvectr,alpha,xxsaux,diraux,b0fff,alfff,
     &	       odrfff,symfff,akfff,dmufff,nmufff,pval,pdval)
	else if (modelf.eq.9) then
	  call nonfff(xx,bvectr,aj,xxsaux,a0nff,axnff,aynff,akznff)
	endif
	return
c
 1	continue
	isw1=is1
	isw2=is2
	isw3=is3
c
c  Bdc is the DC component of magnetic field
	do 10 m=1,3
 10	b(m)=bdc(m)
c
c  isw = 1 : on
c        0 : selective
c            ksw.ne.0 : on
c            ksw =  0 : off
c       -1 : off
c
	bvectr(1)=0.0
	bvectr(2)=0.0
	bvectr(3)=0.0
c
c  s1-source
c
	if(isw1.lt.0) go to 1900
	if(ns1.le.0) go to 1900
c
	do 1000 l=1,ns1
	if(cj1(l).eq.0.0) go to 1000
	if(isw1.eq.0.and.ksw1(l).eq.0) go to 1000
c
	z=direc1(1,l)*(xx(1)-xxs1(1,l))
     &	 +direc1(2,l)*(xx(2)-xxs1(2,l))
     &	 +direc1(3,l)*(xx(3)-xxs1(3,l))
	cu(1)=xx(1)-xxs1(1,l)-z*direc1(1,l)
	cu(2)=xx(2)-xxs1(2,l)-z*direc1(2,l)
	cu(3)=xx(3)-xxs1(3,l)-z*direc1(3,l)
	c=cu(1)**2+cu(2)**2+cu(3)**2
	if (c.ne.0.0) then
	  c=sqrt(c)
	  cu(1)=cu(1)/c
	  cu(2)=cu(2)/c
	  cu(3)=cu(3)/c
	endif 
	call fields(c,z,aa1(l),el1(l),bc,bz)
	b(1)=b(1) + (bz*direc1(1,l)+bc*cu(1))*cj1(l)
	b(2)=b(2) + (bz*direc1(2,l)+bc*cu(2))*cj1(l)
	b(3)=b(3) + (bz*direc1(3,l)+bc*cu(3))*cj1(l)
 1000	continue
 1900	continue
c
c  s2-source
c
c  sum(m)=0.5
c  sum(m/d**2)=1.0
c  normalized bb = roughly gaussian
c	 flux(z>0)=3.141592
c	 radius   =1.0
c	 bn at center=1.0
c  b=sum(bb*flux/area)
c
	kindl1=mod(kindl,1000)
	if(isw2.le.0) go to 2900
	if(ns2.le.0) go to 2900
	if(single) then
	  n1=7
	  n2=7
	endif
c
c  source scan is made in the inner loop
c
c  plane, face-on
c  or 
c  plane, Bn=given
c  in the latter case n-axis may not be along the z-direction
c
	if (kindl1.eq.0 .or. kindl1.eq.1) then
	  do 2000 l=1,ns2
	  bb(1)=0.0
	  bb(2)=0.0
	  bb(3)=0.0
	  if(flx2(l).eq.0.0) go to 2000
c
	  rc2=( (xx(1)-xxs2(1,l))**2
     &	     + (xx(2)-xxs2(2,l))**2
     &	     + (xx(3)-xxs2(3,l))**2 )/aa2(l)**2
	  if(.not.single) then
	    if(rc2.lt.rc*rc) then
	      n1=1
	      n2=4
	    else
	      n1=5
	      n2=6
	    endif
	  endif
c
	  do 2090 n=n1,n2
	  xx1(1)=xx(1)-xxs2(1,l) + aa2(l)*dm(n)*direc2(1,l)
	  xx1(2)=xx(2)-xxs2(2,l) + aa2(l)*dm(n)*direc2(2,l)
	  xx1(3)=xx(3)-xxs2(3,l) + aa2(l)*dm(n)*direc2(3,l)
	  r2=xx1(1)**2+xx1(2)**2+xx1(3)**2
	  r=sqrt(r2)
	  r3=r2*r
	  bb(1)=bb(1)+am(n)*xx1(1)/r3
	  bb(2)=bb(2)+am(n)*xx1(2)/r3
	  bb(3)=bb(3)+am(n)*xx1(3)/r3
 2090	  continue
	  b(1)=b(1)+bb(1)*flx2(l)/pi
	  b(2)=b(2)+bb(2)*flx2(l)/pi
	  b(3)=b(3)+bb(3)*flx2(l)/pi
 2000	  continue
c
c  plane, BL=given
c
	else if (kindl1.eq.11) then
	  do 2100 l=1,ns2
	  bb(1)=0.0
	  bb(2)=0.0
	  bb(3)=0.0
	  if(flx2(l).eq.0.0) go to 2100
c
	  rc2=( (xx(1)-xxs2(1,l))**2
     &      + (xx(2)-xxs2(2,l))**2
     &      + (xx(3)-xxs2(3,l))**2 )/aa2(l)**2
	  if(.not.single) then
	    if(rc2.lt.rc*rc) then
	      n1=1
	      n2=4
	    else
	      n1=5
	      n2=6
	    endif
	  endif
c
	  do 2190 n=n1,n2
	  xx1(1)=xx(1)-xxs2(1,l) + aa2(l)*dm(n)*direc2(1,l)
	  xx1(2)=xx(2)-xxs2(2,l) + aa2(l)*dm(n)*direc2(2,l)
	  xx1(3)=xx(3)-xxs2(3,l) + aa2(l)*dm(n)*direc2(3,l)
	  r2=xx1(1)**2+xx1(2)**2+xx1(3)**2
	  r=sqrt(r2)
	  r3=r2*r
	  dr=dlg(1)*xx1(1)+dlg(2)*xx1(2)+dlg(3)*xx1(3)
	  den=r+dr
	  rm=amu(1,l)*xx1(1)+amu(2,l)*xx1(2)+amu(3,l)*xx1(3)
	  bb(1)=bb(1)+am(n)*(-amu(1,l)/(r*den)+rm*dlg(1)/(r*den*den)
     &	       +rm*(2.0*r+dr)*xx1(1)/(r3*den*den)+dotnl(l)*xx1(1)/r3)
	  bb(2)=bb(2)+am(n)*(-amu(2,l)/(r*den)+rm*dlg(2)/(r*den*den)
     &	       +rm*(2.0*r+dr)*xx1(2)/(r3*den*den)+dotnl(l)*xx1(2)/r3)
	  bb(3)=bb(3)+am(n)*(-amu(3,l)/(r*den)+rm*dlg(3)/(r*den*den)
     &	       +rm*(2.0*r+dr)*xx1(3)/(r3*den*den)+dotnl(l)*xx1(3)/r3)
 2190	  continue
	  b(1)=b(1)+bb(1)*flx2(l)/pi
	  b(2)=b(2)+bb(2)*flx2(l)/pi
	  b(3)=b(3)+bb(3)*flx2(l)/pi
 2100	  continue
c
c  spherical, Bn=given
c
	else if (kindl1.eq.2 .or. kindl1.eq.102 .or. kindl1.eq.103) then
	  do 2200 l=1,ns2
	  bb(1)=0.0
	  bb(2)=0.0
	  bb(3)=0.0
	  if(flx2(l).eq.0.0) go to 2200
c
	  rc2=( (xx(1)-xxs2(1,l))**2
     &	      + (xx(2)-xxs2(2,l))**2
     &	      + (xx(3)-xxs2(3,l))**2 )/aa2(l)**2
	  if(.not.single) then
	    if(rc2.lt.rc*rc) then
	      n1=1
	      n2=4
	    else
	      n1=5
	      n2=6
	    endif
	  endif
c
	  xx0(1)=xx(1)-xxsp(1)
	  xx0(2)=xx(2)-xxsp(2)
	  xx0(3)=xx(3)-xxsp(3)
	  r0=sqrt(xx0(1)**2+xx0(2)**2+xx0(3)**2)
	  do 2290 n=n1,n2
	  xx1(1)=xx(1)-xxs2(1,l) + aa2(l)*dm(n)*direc2(1,l)
	  xx1(2)=xx(2)-xxs2(2,l) + aa2(l)*dm(n)*direc2(2,l)
	  xx1(3)=xx(3)-xxs2(3,l) + aa2(l)*dm(n)*direc2(3,l)
	  rn=xx0(1)*direc2(1,l)+xx0(2)*direc2(2,l)+xx0(3)*direc2(3,l)
	  r1=sqrt(xx1(1)**2+xx1(2)**2+xx1(3)**2)
	  if (rn.ge.0.0) then
	    sig = 1.0
	    den0=r0+rn
cx	    den =r1+rn-rsp		changed 00/09/28
	    den =r1+rn-(rsp-aa2(l)*dm(n))
	  else
	    sig =-1.0
	    den0=r0-rn
cx	    den =r1-rn+rsp		changed 00/09/28
	    den =r1-rn+(rsp-aa2(l)*dm(n))
	  endif
	  if(r1.eq.0.0 .or. den.eq.0.0) then
	    write(msg,*) '(subr.field ) error: r1,den=',r1,den
	    errflg=2
	    return
	  endif
	  bb(1)=bb(1)+am(n)*( xx1(1)/r1**3
     &	         +0.5*(sig*xx0(1)/r0+direc2(1,l))/(rsp*den0)
     &	         -0.5*(sig*xx1(1)/r1+direc2(1,l))/(rsp*den ) )
	  bb(2)=bb(2)+am(n)*( xx1(2)/r1**3
     &	         +0.5*(sig*xx0(2)/r0+direc2(2,l))/(rsp*den0)
     &	         -0.5*(sig*xx1(2)/r1+direc2(2,l))/(rsp*den ) )
	  bb(3)=bb(3)+am(n)*( xx1(3)/r1**3
     &	         +0.5*(sig*xx0(3)/r0+direc2(3,l))/(rsp*den0)
     &	         -0.5*(sig*xx1(3)/r1+direc2(3,l))/(rsp*den ) )
 2290	  continue
c
c  inclusion of source surface
c
	  if( (kindl1.eq.102 .or. kindl1.eq.103) .and. rrss.gt.1.0) then
	    xxout(1)=xx0(1)- aout*direc2(1,l)
	    xxout(2)=xx0(2)- aout*direc2(2,l)
	    xxout(3)=xx0(3)- aout*direc2(3,l)
	    xxin (1)=xx0(1)- ain *direc2(1,l)
	    xxin (2)=xx0(2)- ain *direc2(2,l)
	    xxin (3)=xx0(3)- ain *direc2(3,l)
	    rout=sqrt(xxout(1)**2+xxout(2)**2+xxout(3)**2)
	    rin =sqrt(xxin (1)**2+xxin (2)**2+xxin (3)**2)
	    if (rn.ge.0.0) then
	      deni=rin+rn-ain
	    else
	      deni=rin-rn+ain
	    endif
	    if(rin.eq.0.0 .or. deni.eq.0.0) then
	      write(msg,*) '(subr.field ) error: rin,deni=',rin,deni
	      errflg=2
	      return
	    endif
	    bb(1)=bb(1) -amin*xxin(1)/rin**3
     &	   -amout*( xxout(1)/rout**3
     &	   +(sig*xx0 (1)/r0 +direc2(1,l))/(rsp*den0)
     &	   -(sig*xxin(1)/rin+direc2(1,l))/(rsp*deni) )
	    bb(2)=bb(2) -amin*xxin(2)/rin**3
     &	   -amout*( xxout(2)/rout**3
     &	   +(sig*xx0 (2)/r0 +direc2(2,l))/(rsp*den0)
     &	   -(sig*xxin(2)/rin+direc2(2,l))/(rsp*deni) )
	    bb(3)=bb(3) -amin*xxin(3)/rin**3
     &	   -amout*( xxout(3)/rout**3
     &	   +(sig*xx0 (3)/r0 +direc2(3,l))/(rsp*den0)
     &	   -(sig*xxin(3)/rin+direc2(3,l))/(rsp*deni) )
	  endif
c
	  b(1)=b(1)+bb(1)*flx2(l)/pi
	  b(2)=b(2)+bb(2)*flx2(l)/pi
	  b(3)=b(3)+bb(3)*flx2(l)/pi
c
 2200	  continue
c
c  spherical, BL=given
c
	else if (kindl1.eq.12 .or. kindl1.eq.112) then
	  do 2300 l=1,ns2
	  bb(1)=0.0
	  bb(2)=0.0
	  bb(3)=0.0
	  if(flx2(l).eq.0.0) go to 2300
c
	  rc2=( (xx(1)-xxs2(1,l))**2
     &	      + (xx(2)-xxs2(2,l))**2
     &	      + (xx(3)-xxs2(3,l))**2 )/aa2(l)**2
	  if(.not.single) then
	    if(rc2.lt.rc*rc) then
	      n1=1
	      n2=4
	    else
	      n1=5
	      n2=6
	    endif
	  endif
c
	  vn1(1)=direc2(1,l)
	  vn1(2)=direc2(2,l)
	  vn1(3)=direc2(3,l)
	  vn2(1)=vn1(1)-2.0*dotnl(l)*dlg(1)
	  vn2(2)=vn1(2)-2.0*dotnl(l)*dlg(2)
	  vn2(3)=vn1(3)-2.0*dotnl(l)*dlg(3)
	  do 2390 n=n1,n2
	  xx1(1)=xx(1)-xxs2(1,l) + aa2(l)*dm(n)*vn1(1)
	  xx1(2)=xx(2)-xxs2(2,l) + aa2(l)*dm(n)*vn1(2)
	  xx1(3)=xx(3)-xxs2(3,l) + aa2(l)*dm(n)*vn1(3)
	  xx2(1)=xx(1)-xxs2(1,l)+2.0*dotnl(l)*rsp*dlg(1)
     &	        +aa2(l)*dm(n)*vn2(1)
	  xx2(2)=xx(2)-xxs2(2,l)+2.0*dotnl(l)*rsp*dlg(2)
     &	        +aa2(l)*dm(n)*vn2(2)
	  xx2(3)=xx(3)-xxs2(3,l)+2.0*dotnl(l)*rsp*dlg(3)
     &	        +aa2(l)*dm(n)*vn2(3)
	  r1=sqrt(xx1(1)**2+xx1(2)**2+xx1(3)**2)
	  r2=sqrt(xx2(1)**2+xx2(2)**2+xx2(3)**2)
	  rm=amu(1,l)*xx1(1)+amu(2,l)*xx1(2)+amu(3,l)*xx1(3)
	  dr=dlg(1)*(xx(1)-xxsp(1))
     &	    +dlg(2)*(xx(2)-xxsp(2))
     &	    +dlg(3)*(xx(3)-xxsp(3))
	  dr1=dlg(1)*xx1(1)+dlg(2)*xx1(2)+dlg(3)*xx1(3)
	  dr2=dlg(1)*xx2(1)+dlg(2)*xx2(2)+dlg(3)*xx2(3)
	  if (dr.ge.0.0) then
	    sig = 1.0
	    den1=r1+dr1
	    den2=r2+dr2
	  else
	    sig =-1.0
	    den1=r1-dr1
	    den2=r2-dr2
	  endif
	  if(r1.eq.0.0 .or. den1.eq.0.0) then
	    write(msg,*) '(subr.field ) error: r1,den1=',r1,den1
	    errflg=2
	    return
	  endif
        bb(1)=bb(1)+am(n)*(
     &	  dotnl(l)*(xx1(1)/r1**3+xx2(1)/r2**3)
     &	 +rm*sig*(  xx1(1)/r1**3/den1 - xx2(1)/r2**3/den2
     &	           +(xx1(1)/r1+sig*dlg(1))/r1/den1**2
     &	           -(xx2(1)/r2+sig*dlg(1))/r2/den2**2 )
     &       -amu(1,l)*sig*(1.0/(r1*den1)-1.0/(r2*den2))
     &       +( (sig*xx1(1)/r1+dlg(1))/den1
     &	  - (sig*xx2(1)/r2+dlg(1))/den2 ) /(2.0*rsp)
     &	 )
        bb(2)=bb(2)+am(n)*(
     &	  dotnl(l)*(xx1(2)/r1**3+xx2(2)/r2**3)
     &	 +rm*sig*(  xx1(2)/r1**3/den1 - xx2(2)/r2**3/den2
     &	           +(xx1(2)/r1+sig*dlg(2))/r1/den1**2
     &	           -(xx2(2)/r2+sig*dlg(2))/r2/den2**2 )
     &       -amu(2,l)*sig*(1.0/(r1*den1)-1.0/(r2*den2))
     &       +( (sig*xx1(2)/r1+dlg(2))/den1
     &	  - (sig*xx2(2)/r2+dlg(2))/den2 ) /(2.0*rsp)
     &	 )
        bb(3)=bb(3)+am(n)*(
     &	  dotnl(l)*(xx1(3)/r1**3+xx2(3)/r2**3)
     &	 +rm*sig*(  xx1(3)/r1**3/den1 - xx2(3)/r2**3/den2
     &	           +(xx1(3)/r1+sig*dlg(3))/r1/den1**2
     &	           -(xx2(3)/r2+sig*dlg(3))/r2/den2**2 )
     &       -amu(3,l)*sig*(1.0/(r1*den1)-1.0/(r2*den2))
     &       +( (sig*xx1(3)/r1+dlg(3))/den1
     &	  - (sig*xx2(3)/r2+dlg(3))/den2 ) /(2.0*rsp)
     &	 )
 2390	  continue
	  b(1)=b(1)+bb(1)*flx2(l)/pi
	  b(2)=b(2)+bb(2)*flx2(l)/pi
	  b(3)=b(3)+bb(3)*flx2(l)/pi
c
	  if(kindl1.eq.112 .and. rrss.gt.1.0) then
c
	    xx0(1)=xx(1)-xxsp(1)
	    xx0(2)=xx(2)-xxsp(2)
	    xx0(3)=xx(3)-xxsp(3)
	    xxo1(1)=xx0(1)-aout*vn1(1)
	    xxo1(2)=xx0(2)-aout*vn1(2)
	    xxo1(3)=xx0(3)-aout*vn1(3)
	    xxo2(1)=xx0(1)-aout*vn2(1)
	    xxo2(2)=xx0(2)-aout*vn2(2)
	    xxo2(3)=xx0(3)-aout*vn2(3)
	    xxi1(1)=xx0(1)-ain *vn1(1)
	    xxi1(2)=xx0(2)-ain *vn1(2)
	    xxi1(3)=xx0(3)-ain *vn1(3)
	    xxi2(1)=xx0(1)-ain *vn2(1)
	    xxi2(2)=xx0(2)-ain *vn2(2)
	    xxi2(3)=xx0(3)-ain *vn2(3)
c
	    ro1=sqrt(xxo1(1)**2+xxo1(2)**2+xxo1(3)**2)
	    ro2=sqrt(xxo2(1)**2+xxo2(2)**2+xxo2(3)**2)
	    ri1=sqrt(xxi1(1)**2+xxi1(2)**2+xxi1(3)**2)
	    ri2=sqrt(xxi2(1)**2+xxi2(2)**2+xxi2(3)**2)
	    dro1=dlg(1)*xxo1(1)+dlg(2)*xxo1(2)+dlg(3)*xxo1(3)
	    dro2=dlg(1)*xxo2(1)+dlg(2)*xxo2(2)+dlg(3)*xxo2(3)
	    dri1=dlg(1)*xxi1(1)+dlg(2)*xxi1(2)+dlg(3)*xxi1(3)
	    dri2=dlg(1)*xxi2(1)+dlg(2)*xxi2(2)+dlg(3)*xxi2(3)
c
	    if(dr.ge.0.0) then
	      deni1 = ri1+dri1
	      deni2 = ri2+dri2
	    else
	      deni1 = ri1-dri1
	      deni2 = ri2-dri2
	    endif
	    if(ri1.eq.0.0 .or. deni1.eq.0.0) then
	      write(msg,*) '(subr.field ) error: ri1,deni1=',ri1,deni1
	      errflg=2
	      return
	    endif
	    deno1 = ro1-dro1
	    deno2 = ro2+dro2
c
c  sum(am)=0.5, amout=0.5
c
	    amout=0.5
	    amin= -(rsp/aout)*amout
	    bbb(1)= - 0.5*amin/rsp*(
     &	   (sig*xxi1(1)/ri1+dlg(1))/deni1
     &	  -(sig*xxi2(1)/ri2+dlg(1))/deni2 )
     &	            + 0.5*amout/rsp*(
     &	   (xxo1(1)/ro1-dlg(1))/deno1 + (xxo2(1)/ro2+dlg(1))/deno2
     &	                )
	    bbb(2)= - 0.5*amin/rsp*(
     &	   (sig*xxi1(2)/ri1+dlg(2))/deni1
     &	  -(sig*xxi2(2)/ri2+dlg(2))/deni2 )
     &	          + 0.5*amout/rsp*(
     &	   (xxo1(2)/ro1-dlg(2))/deno1 + (xxo2(2)/ro2+dlg(2))/deno2
     &	                )
	    bbb(3)= - 0.5*amin/rsp*(
     &	   (sig*xxi1(3)/ri1+dlg(3))/deni1
     &	  -(sig*xxi2(3)/ri2+dlg(3))/deni2 )
     &	          + 0.5*amout/rsp*(
     &	   (xxo1(3)/ro1-dlg(3))/deno1 + (xxo2(3)/ro2+dlg(3))/deno2
     &	                )
c
	    b(1)=b(1)+bbb(1)*flx2(l+ns2)/pi
	    b(2)=b(2)+bbb(2)*flx2(l+ns2)/pi
	    b(3)=b(3)+bbb(3)*flx2(l+ns2)/pi
	  endif
 2300	  continue
	endif
 2900	continue
c
c  s3-source
c
c  normalized bf: jz roughly gaussian
c  total current=pi
c  radius=1
c
	if(ns3.le.0) go to 3900
	if(isw3.lt.0) go to 3900
c
	do 3000 l=1,ns3
	if(cj3(l).eq.0.0) go to 3000
	if(isw3.eq.0.and.ksw3(l).eq.0) go to 3000
c
	z=direc3(1,l)*(xx(1)-xxs3(1,l))
     &	 +direc3(2,l)*(xx(2)-xxs3(2,l))
     &	 +direc3(3,l)*(xx(3)-xxs3(3,l))
	cu(1)=xx(1)-xxs3(1,l)-z*direc3(1,l)
	cu(2)=xx(2)-xxs3(2,l)-z*direc3(2,l)
	cu(3)=xx(3)-xxs3(3,l)-z*direc3(3,l)
	c=cu(1)**2+cu(2)**2+cu(3)**2
	if (c.ne.0.0) then
	  c=sqrt(c)
	  cu(1)=cu(1)/c
	  cu(2)=cu(2)/c
	  cu(3)=cu(3)/c
	endif
	c=c/aa3(l)
	c2=c*c
	z=abs(z)/aa3(l)
	h=el3(l)/aa3(l)/2.0
	bf=0.0
	if (z.le.h) then
	  if (c.lt.rc) then
	    n1=1
	    n2=4
	  else
	    n1=5
	    n2=6
	  endif
	  if (c.gt.eps) then
	    do 3110 n=n1,n2
 3110	    bf=bf+2.0*am(n)*((h+dm(n)+z)/sqrt(c2+(h+dm(n)+z)**2)
     &	      +(h+dm(n)-z)/sqrt(c2+(h+dm(n)-z)**2)
     &	      -2.0*dm(n)/sqrt(c2+dm(n)**2))
	    bf=pi*bf/c
	  else
	    do 3111 n=n1,n2
 3111	    bf=bf+2.0*am(n)*c
     &	      *(1.0/dm(n)**2-((h+dm(n))**2+z*z)/((h+dm(n))**2-z*z)**2)
	    bf=pi*bf
	  endif
	else
	  if(.not.single) then
	    if(c*c+(z+h)*(z+h).lt.rc*rc) then
	      n1=1
	      n2=4
	    else
	      n1=5
	      n2=6
	    endif
	  endif
	  if(c.gt.eps) then
	    do 3120 n=n1,n2
 3120	    bf=bf+2.0*am(n)*((z+dm(n)+h)/sqrt(c2+(z+dm(n)+h)**2)
     &	      -(z+dm(n)-h)/sqrt(c2+(z+dm(n)-h)**2))
	    bf=pi*bf/c
	  else
	    do 3121 n=n1,n2
 3121	    bf=bf+4.0*am(n)*c*h*(z+dm(n))/((z+dm(n))**2-h*h)**2
	    bf=pi*bf
	  endif
	endif
c  Bf scales as Bf = J/r = (J/a)(a/r), where (a/r) is bf computed here,
c  and J=cj3 is the total current
	bf=bf*(cj3(l)/pi)/aa3(l)
	b(1)=b(1)+bf*(direc3(2,l)*cu(3)-direc3(3,l)*cu(2))
	b(2)=b(2)+bf*(direc3(3,l)*cu(1)-direc3(1,l)*cu(3))
	b(3)=b(3)+bf*(direc3(1,l)*cu(2)-direc3(2,l)*cu(1))
cc if bf is NaN
	if(bf.ne.bf) then
	  write(msg,*) '(subr.field ) error: l,a,z,c,h,cu=',
     &	     l,aa3(l),z,c,h,cu
	  write(msg,*) '       bf=',bf
	  errflg=2
	  return
	endif
cc
c
 3000	continue
 3900	continue
c
	do 7100 m=1,3
 7100	bvectr(m)=b(m)
c
	return
	end
c
	subroutine fields(c0,z0,a0,hh0,bc,bz)
c
c  field of solenoid coil
c  magnetic field (bc,bz) at cylindrical coordinates (c0,z0)
c  hh0 : full length of the coil
c  z0  : height above the top of the coil
c  a0  : radius of the coil
c  total current ( integrated in z ) = 1.0
c  dipole moment 3.14*a0*a0*cj = 1.0  when a0-->0.0
c
	implicit real*8 (d)
	real*4 df
	logical first
	include 'sys.fc'
	dimension cf(10,10),f(20),df(20),fh(10)
	dimension zp(10,10),wp(10,10)
	dimension nsam0(3),zsampt(60),fact(60)
	save first,cf,fh,c1,c2,c3,c4
	data first/.true./
	data pi/3.141592/
c
	data zp/10*0.0,
     2	.57735027,-.57735027, 8*0.0,
     3	.77459667,-.77459667, 8*0.0,
     4	.86113631,-.86113631,.33998104,-.33998104, 6*0.0,
     5	.90617984,-.90617984,.53846931,-.53846931, 6*0.0,
     6	.93246951,-.93246951,.66120939,-.66120939,.23861919,-.23861919,
     &	4*0.0,
     7	.94910791,-.94910791,.74153119,-.74153119,.40584515,-.40584515,
     &	4*0.0,
     8	.96028986,-.96028986,.79666648,-.79666648,.52553241,-.52553241,
     &	.18343464,-.18343464, 2*0.0,
     9	.96816024,-.96816024,.83603111,-.83603111,.61337143,-.61337143,
     &	.32425342,-.32425342, 2*0.0,
     1	.97390653,-.97390653,.86506337,-.86506337,.67940957,-.67940957,
     &	.43339539,-.43339539,.14887434,-.14887434/
	data wp/2.0, 9*0.0,
     2	2*1.0, 8*0.0,
     3	2*.55555556,  .88888889, 7*0.0,
     4	2*.34785485,2*.65214515, 6*0.0,
     5	2*.23692689,2*.47862867,  .56888889, 5*0.0,
     6	2*.17132449,2*.36076157,2*.46791393, 4*0.0,
     7	2*.12948497,2*.27970539,2*.38183005,  .41795918, 3*0.0,
     8	2*.10122854,2*.22238103,2*.31370665,2*.36268378, 2*0.0,
     9	2*.08127439,2*.18064816,2*.26061070,2*.31234708,  .33023936,0.0,
     1	2*.06667134,2*.14945135,2*.21908636,2*.26926672,2*.29552422/
c
	dcelik(d)=dak0+d*(dak1+d*(dak2+d*dak3))
     &	        -(dbk0+d*(dbk1+d*(dbk2+d*dbk3)))*dlog(d)
	dcelie(d)=1.0d0+d*(dae1+d*(dae2+d*dae3))
     &	         -d*(dbe1+d*(dbe2+d*dbe3))*dlog(d)
	data dak0,dak1,dak2,dak3,dbk0,dbk1,dbk2,dbk3/
     1	  1.386294361d0, 0.097932891d0, 0.054544409d0, 0.032024666d0,
     2	  0.500000000d0, 0.124750742d0, 0.060118519d0, 0.010944912d0/,
     3	dae1,dae2,dae3,dbe1,dbe2,dbe3/
     4	  0.444792040d0, 0.085099193d0, 0.040905094d0,
     5	  0.249697949d0, 0.081502240d0, 0.013829990d0/
c
	if (first) then
	  c1=3./4.
	  c2=75./128.
	  c3=245./512.
	  c4=6615./16384.
	  f(1)=1.0
	  do 10 l=1,19
 10	  f(l+1)=f(l)*float(l)
	  df(1)=1.0
	  do 20 l=1,19
 20	  df(l+1)=df(l)*float(2*l+1)
	  cf(1,1)=1.0
	  do 30 ll=2,10
	  l=ll-1
	  do 30 ii=1,ll
	  i=ii-1
	  fct=1.0
	  li1=l-i+1
	  cc=0.0
	  do 40 kk=1,li1
	  k=kk-1
	  cc=cc+fct*df(l+k+1)/(f(2*k+1)*f(li1-k)*f(i+1))
	  fct=-2.0*fct
 40	  continue
	  cf(ii,ll)=cc/float(2*(l-i)+1)
 30	  continue
	  first=.false.
	endif
c
	if(a0.eq.0.0) then
	  if(hh0.eq.0.0) then
c
c  dipole
c
	    r=sqrt(c0*c0+z0*z0)
	    bc= 3.0*z0*c0       /r**5
	    bz=(2.0*z0*z0-c0*c0)/r**5
	  else
c
c  monopole pair
c
	    r=sqrt(c0*c0+z0*z0)
	    bc=c0/r**3
	    bz=z0/r**3
	    r=sqrt(c0*c0+(z0+hh0)**2)
	    bc=(bc-   c0   /r**3)/hh0
	    bz=(bz-(z0+hh0)/r**3)/hh0
	  endif
	  return
	endif
c
	c =c0 /a0
	z =z0 /a0
	hh=hh0/a0
	h=0.5*hh
	r0=(2.2*h*h-h+0.66)/(h*h-0.25*h+0.3)*sqrt(1.0+h*h)
	if((c/r0)**2+((z+h)/(1.1*r0))**2.gt.1.0) then
	  if(h.gt.80.0) then
c
c  monopole pair
c
	    if(msglvl.gt.0) write(lst,*)
     &	      '(subr.fields) warning: too large hh0 (',hh0,
     &	      '), replaced with  monopole pair'
	    r=sqrt(c0*c0+z0*z0)
	    bc=c0/r**3
	    bz=z0/r**3
	    r=sqrt(c0*c0+(z0+hh0)**2)
	    bc=(bc-   c0   /r**3)/hh0
	    bz=(bz-(z0+hh0)/r**3)/hh0
	    bc=bc*a0*a0*pi
	    bz=bz*a0*a0*pi
	    return
	  endif
c
c  distant zone : multipole expansion
c
	  zz=z+h
	  rr=c*c+zz*zz
	  ri=1.0/rr
	  r=sqrt(rr)
	  costh=zz/r
	  sinth=c/r
	  ff=2.0*pi*ri/r
	  h2=h*h
	  fh(1)=1.0
	  pd=1.0
	  p0=1.0
	  p1=costh
	  br=ff*costh
	  bt=0.5*ff*sinth
	  ic=0
c
	  do 1000 l=1,9
	  p2=(float(4*l-1)*costh*p1-float(2*l-1)*p0)/float(2*l)
	  pd=pd+float(4*l+1)*p2
	  ff=-0.5*ff*ri
	  fh(l+1)=fh(l)*h2
	  l1=l+1
	  aux=0.0
	  do 1100 i1=1,l1
 1100	  aux=aux+cf(i1,l1)*(fh(l1-i1+1)*ff)
	  p0=p2
	  p1=(float(4*l+1)*costh*p2-float(2*l)*p1)/float(2*l+1)
	  brd=p1*aux
	  btd=pd*aux*sinth/float(2*l+2)
	  br=br+brd
	  bt=bt+btd
	  if(brd*brd+btd*btd.gt.1.0e-8*(br*br+bt*bt)) then
	    ic=0
	  else
	    if(ic.eq.1) go to 1500
	    ic=1
	  endif
 1000	  continue
	  write(lst,*)
     &	'(subr.fields) warning: multipole expansion not converged'
	  write(lst,*) '  c,z,h=', c,z,h
c
 1500	  continue
	  bc=(br*sinth+bt*costh)/a0
	  bz=(br*costh-bt*sinth)/a0
	  return
	endif
c
c  near zone : gauss integration
c
	a=1.0
	zmin=0.01
	bz=0.0
	bc=0.0
	if(h.lt.1.0e-4) then
	  kk1=1
	  mode=8
	  sig=1.0
	  zsampt(1)=z
	  fact(1)=1.0
	  nsam0(1)=1
	  go to 2350
	endif
	if(z.ge.0.0.or.z.le.-hh) then
	  z1=abs(z+h)-h
	  z2=abs(z+h)+h
	  sig=1.0
	  if(z.ge.0.0) then
	    sig=1.0
	  else
	    sig=-1.0
	    endif
	else
	  z1=0.0
	  z2=z+hh
	  sig=1.0
	endif
c
 2200	continue
	if(c.le.1.0) then
	  za=1.0-c*c
	else
	  za=sqrt(c*c-0.75)-0.5
	endif
	za=amax1(za,zmin)
	zb=sqrt(0.25+c*c)+0.4999 +c*c*0.008
	if(zb.lt.za) zb=za
	if(za.gt.z1) then
	  if(za.gt.z2) then
	    mode=1
	    zu=z2
	  else if (zb.lt.z2) then
	    if(zb.lt.za) then
	      mode=6
	      zu=za
	      zl=za
	    else
	      mode=7
	      zu=za
	      zl=zb
	    endif
	  else
	    mode=4
	    zu=za
	    zl=z2
	  endif
	else if(zb.gt.z1) then
	  if(z2.lt.zb) then
	    mode=2
	    zu=z1
	    zl=z2
	  else
	    mode=5
	    zu=z1
	    zl=zb
	  endif
	else
	  mode=3
	  zl=z1
	endif
c
	kk1=0
	k=0
	if((mode.eq.1.or.mode.eq.4.or.mode.eq.6.or.mode.eq.7)
     &	   .and. zu.ne.z1) then
	  kk1=kk1+1
	  rr=(zu-z1)/(za+zmin)
	  if (rr.lt.0.125) then
	    nn=2
	  else if (rr.lt.0.25) then
	    nn=3
	  else if (rr.lt.0.5) then
	    nn=4
	  else
	    nn=5
	  endif
	  nsam0(kk1)=nn
	  do 2310 n=1,nn
	  k=k+1
	  zsampt(k)=z1+(zu-z1)*(zp(n,nn)+1.0)/2.0
	  fact(k)=(zu-z1)/hh
 2310	  continue
	endif
c
	if((mode.eq.2.or.mode.eq.4.or.mode.eq.5.or.mode.eq.7)
     &	   .and. zl.ne.zu.and.za.ne.zb ) then
	  alzba=alog(zb/za)
	  alzlu=alog(zl/zu)
	  kk1=kk1+1
	  rr=alzlu/alzba
	  if (rr.lt.0.125) then
	    nn=2
	  else if (rr.lt.0.25) then
	    nn=3
	  else if (rr.lt.0.5) then
	    nn=4
	  else
	    nn=5
	  endif
	  nsam0(kk1)=nn
	  do 2320 n=1,nn
	  k=k+1
	  zsampt(k)=zu*exp(alzlu*(zp(n,nn)+1.0)/2.0)
	  fact(k)=alzlu*zsampt(k)/hh
 2320	  continue
	endif
c
	if((mode.eq.3.or.mode.eq.5.or.mode.eq.6.or.mode.eq.7)
     &	  .and. z2.ne.zl) then
	  kk1=kk1+1
	  rr=zb*(z2-zl)/(zl*z2)
	  if (rr.lt.0.125) then
	    nn=2
	  else if (rr.lt.0.25) then
	    nn=3
	  else if (rr.lt.0.5) then
	    nn=4
	  else
	    nn=5
	  endif
	  nsam0(kk1)=nn
	  do 2330 n=1,nn
	  k=k+1
	  zsampt(k)=z2*zl/(zl+(z2-zl)*(zp(n,nn)+1.0)/2.0)
	  fact(k)=(z2-zl)/(zl*z2*hh)*zsampt(k)**2
 2330	  continue
	endif
c
 2350	continue
	k=0
	do 2400 kk=1,kk1
	nn=nsam0(kk)
	do 2400 n=1,nn
	k=k+1
	zz=zsampt(k)
	ak2=4.0*c/((a+c)**2+zz*zz)
c
	if(ak2.gt.0.125) then
	  dc=c
	  dz=zz
	  da=a
	  dk1=((da-dc)**2+dz**2)/((da+dc)**2+dz*dz)
	  dk=dcelik(dk1)
	  de=dcelie(dk1)
	  auxp=-dk+de*(da*da+dc*dc+dz*dz)/((da-dc)**2+dz*dz)
	  auxz= dk+de*(da**2-dc**2-dz*dz)/((da-dc)**2+dz*dz)
	  bc=2.0*zz/c*auxp/sqrt((a+c)**2+zz*zz)
     &	    *wp(n,nn)*fact(k)*sig/2.0+bc
	  bz=2.0*auxz/sqrt((a+c)**2+zz*zz)
     &	    *wp(n,nn)*fact(k)/2.0+bz
c
	else
	  bc=pi*c*zz/sqrt((a+c)**2+zz*zz)**5
     &	    *(3.0+ak2*(5.*c1+ak2*(7.*c2+ak2*(9.*c3+ak2*11.*c4))))
     &	    *wp(n,nn)*fact(k)*sig/2.0+bc
	  bz=pi/sqrt((a+c)**2+zz*zz)**3
     &	    *(2.0+ak2*(3.*c1+ak2*(4.*c2+ak2*(5.*c3+ak2*6.*c4)))
     &	    -(3.0+ak2*(5.*c1+ak2*(7.*c2+ak2*(9.*c3+ak2*11.*c4))))
     &	    *c*(a+c)/((a+c)**2+zz*zz))
     &	    *wp(n,nn)*fact(k)/2.0+bz
	endif
 2400	continue
c
	if(abs(z+h).ge.h .or. sig.eq.-1) then
	  bc=bc/a0
	  bz=bz/a0
	  return
	endif
	sig=-sig
	z2=-z
	go to 2200
c
	end
