c  read fits-format data
c
	subroutine rdfits( iunit )
c
c  input files can be unsigned byte, integer*2, integer*4, or real*4
c
c  speca is a string array, and specf is a comma-separated list
c  of file specification words.
c
c  the parameter given by CTYPE3 keyword is read into specf
c  e.g. CTYPE3='I,BL' --> specf='I,BL', speca(1)='I', speca(2)='BL'
c
c  in order to read foreign fits files, specf should be explicitly
c  specified
c  fits files generated by subr.wtfits has CTYPE3 keywords in the header
c 
c  all the data are read and then written to a file
c  no selective read/write is made
c
	include 'sys.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'mparam.fc'
	include 'string.fc'
	include 'mdata.fc'
c
	parameter (NITEM=28)
	integer iunit
	character line*80, keywd*8, value*20, str*70, image*18,
     &	    origin*18, specf*18, speca*10, buf*80, setto*20,
     &	    trimq*20
	character specf1*18,mfile1*8,tsys1*6,
     &            dateo1*8,stime1*8,etime1*8,
     &            inst1*8,origi1*18,nmlstr*6
	logical simple,eof,isint,alloc,stdate,sttime,stp,stb0,stcl0
	logical iexist,vexist,xexist,yexist,zexist
	integer skylvl,skylv1
	dimension factor(10),zlevel(10),image(10),speca(10),xx(3),
     &	          facto1(10),zleve1(10),
     &	          nmlsw(NITEM),nmlstr(NITEM)
c
	rad(deg)=3.141592/180.0*deg
c
	data specf/' '/, image/10*' '/
	data speca/10*' '/
	data stdate,sttime,stp,stb0,stcl0/5*.false./
	data iexist,vexist,xexist,yexist,zexist/5*.false./
	data pi/3.141592/
        data nmlstr/'nbytmi','naxis','nframi','specf',
     &	            'mfile','factor','zlevel','rsp',
     &		    'nx','ny','xs','ys','dx','dy',
     &		    'tsys','dateo','stime','etime','inst','origin',
     &		    'pdeg','b0deg','cl0deg','aldeg','apdeg',
     &	            'kindmi','skylvl','ncarr'/
c
c  this program accepts BSCALE and BZERO keywords
c  if BSCALE is missing, assume BSCALE=1.0
c  if BZERO is missing, assume BZERO=0.0
c
c  this program accepts IMAGEn and ISCALEn keywords (U.Hawaii B-fits)
c  where n runs from 1 to NAXIS3
c  IMAGEn is a string describing the n-th stacked image
c  if ISCALEn is missing, assume ISCALEn=1.0
c
        do 10 n=1,NSPEC0
 10     kloc(n)=0
        do 20 k=1,MZ
        kmem(k)=0
        lspecs(k)=0
 20     continue
	naxis=2
c
	eof=.false.
	lrec0=80
	nframi=1
	do 30 i=1,10
	factor(i)=1.0
	zlevel(i)=0.0
 30	continue
	rspdef=1.0e20
	rsp=rspdef
	xc=rspdef
	yc=rspref
c  default value of rsp,xc,yc are practically infinity
	apdeg=0.0
	aldeg=0.0
c  set default sky level to be a large negative value
	skylvl=iufl4
c
	kx=0
	ky=0
	ncarr=0
c
	kindmi=0
	mesh=0
c
c  mycode:0=unknown, 1=ascii, 2=ebcdic
c  icode = target code if icode.ne.0
c  assume FITS header is in ASCII code
c  assume FITS data are big endian
c
	if (mycode.eq.2) then
	  icode=mycode
	else
	  icode=0
	endif
	loc=1
	mode=0
c
 100	format(i20)
 200    format(f20.0)
c
c  read the following parameters by namelist input
c	nbytmi,naxis,nframi,specf,
c	mfile,factor,zlevel,rsp,
c	nx,ny,xs,ys,dx,dy,
c	tsys,dateo,stime,etime,inst,origin,
c	pdeg,b0deg,cl0deg,aldeg,apdeg
c	kindmi,skylvl,ncarr
c
        call getnml(nbytmi,naxis,nframi,specf,
     &    mfile,factor,zlevel,rsp,
     &    nx,ny,xs,ys,dx,dy,
     &    tsys,dateo,stime,etime,inst,origin,
     &    pdeg,b0deg,cl0de,aldeg,apdeg,
     &    kindm,skylvl,ncarr, nmlsw)
c
        nbytm1 = nbytmi
        naxis1 = naxis
        nfram1 = nframi
        specf1 = specf
        mfile1 = mfile
        do 40 i=1,10
        facto1(i) = factor(i)
 40     zleve1(i) = zlevel(i)
        rsp1 = rsp
        nx1 = nx
        ny1 = ny
        xs1 = xs
        ys1 = ys
        dx1 = dx
        dy1 = dy
        tsys1 = tsys
        dateo1 = dateo
        stime1 = stime
        etime1 = etime
        inst1 = inst
        origi1 = origin
        pdeg1 = pdeg
        b0deg1 = b0deg
        cl0de1 = cl0deg
        aldeg1 = aldeg
        apdeg1 = apdeg
        kindm1 = kindmi
        skylv1 = skylvl
	ncarr1 = ncarr
c
c  set mode (1,2,3,4,5,6,7) depending on origin
c  other parameters will become effective after keyword search
c
	call upper(origin)
	if(origin.eq.'MAGPACK2') then
	  mode=1
	else if(origin(1:4).eq.'MEES') then
	  mode=2
	else if(origin.eq.'BBSO') then
	  mode=3
	else if(origin(1:8).eq.'KPNO-SYN') then
	  mode=5
	else if(origin(1:4).eq.'KPNO') then
	  mode=4
	else if(origin.eq.'MDI') then
	  mode=6
	else if(origin.eq.'MT. WILSON' .or.
     &	        origin.eq.'MT.WILSON') then
	  mode=7
	endif
c
	if(msglvl.gt.1) write(lst,*) '(subr.rdfits) FITS HEADER'
c
c  top of keyword search loop
c  within the loop, the unit of dx and dy is arcseconds
c  the unit of xs,ys,rsp may be arcseconds or pixels
c
 1	continue
	do 1000 i=1,36
	call ins( iunit, loc, line, lrec0, iostat )
	if( iostat.ne.0) go to 9
	if (icode.ne.0) call cconv(icode, line)
c
	keywd=line(1:8)
	str=line(11:80)
	value=line(11:30)
	setto=' '
c
c  general keywords
c
	if(keywd.eq.'END     ') then
	  eof=.true.
	  go to 1900
	endif
c
	if(keywd.eq.'SIMPLE  ') then
	  read(value,'(L20)') simple
	  if(.not.simple) go to 91
	  go to 1900
	endif
c
	if(keywd.eq.'BITPIX  ') then
	  read(value,100) nbitmi
	  nbytmi=nbitmi/8
	  setto='nbytmi'
	  go to 1900
	endif
c  negative BITPIX indicates ANSI/IEEE-754 floating point data
c
	if(keywd.eq.'NAXIS   ') then
	  read(value,100) naxis
	  go to 1900
	endif
	if(keywd.eq.'NAXIS1  ') then
	  read(value,100) nx
	  setto='nx'
	  go to 1900
	endif
	if(keywd.eq.'NAXIS2  ') then
	  read(value,100) ny
	  setto='ny'
	  go to 1900
	endif
	if(keywd.eq.'NAXIS3  ') then
	  read(value,100) nframi
	  setto='nframi'
	  go to 1900
	endif
c
	if(keywd.eq.'BSCALE  ') then
	  read(value,200) factor(1)
	  do 1100 iframe=1,nframi
 1100	  factor(iframe)=factor(1)
	  setto='factor(*)'
	  go to 1900
	endif
c
	if(keywd.eq.'BZERO   ') then
	  read(value,200) zlevel(1)
	  do 1200 iframe=1,nframi
 1200	  zlevel(iframe)=zlevel(1)
	  setto='zlevel(*)'
	  go to 1900
	endif
c
	if(keywd.eq.'OBJECT  ') then
	  read(str,'(1x,a8,11x)') mfile
	  mfile=trimq(mfile)
	  title=mfile
	  setto='mfile,title'
	  go to 1900
	endif
c
	if(keywd.eq.'CRVAL1  ') then
	  read(value,200) xs
	  setto='xs'
	  go to 1900
	endif
	if(keywd.eq.'CRVAL2  ') then
	  read(value,200) ys
	  setto='ys'
	  go to 1900
	endif
	if(keywd.eq.'CDELT1  ') then
	  read(value,200) dx
	  setto='dx'
	  go to 1900
	endif
	if(keywd.eq.'CDELT2  ') then
	  read(value,200) dy
	  setto='dy'
	  go to 1900
	endif
c
	if(keywd.eq.'CTYPE3  ') then
	  specf=str(2:19)
	  setto='specf'
	  go to 1900
	endif
c
	if(keywd.eq.'DATEOBS ') then
	  read(str,'(1x,a8,11x)') dateo
c                  'yy/mm/dd'
	  setto='dateo'
	  stdate=.true.
	  go to 1900
	endif
	if(keywd.eq.'TIMEOBS ') then
	  read(str,'(1x,a8,1x,a8,2x)') stime,etime
c                  'hh:mm:ss-hh:mm:ss'
	  setto='stime,etime'
	  sttime=.true.
	  go to 1900
	endif
	if(keywd.eq.'INSTRUME') then
	  read(str,'(1x,a8,11x)') buf
	  buf=trimq(buf)
c  set mode=6
	  if(buf(1:3).eq.'MDI') mode=6
	  	  if(lenstr(inst).eq.0) then
	    inst=buf
	  else
	    inst=inst(1:lenstr(inst))//buf
	  endif
	  setto='inst'
	  go to 1900
	endif
	if(keywd.eq.'TELESCOP') then
	  read(str,'(1x,a8,11x)') buf
	  buf=trimq(buf)
	  if(lenstr(inst).eq.0) then
	    inst=buf
	  else
	    inst=inst(1:lenstr(inst))//buf
	  endif
	  setto='inst'
	  go to 1900
	endif
	if(keywd.eq.'ORIGIN  ') then
	  read(str,*) origin
	  setto='origin'
c  if mode is already set by namelist input, keep it intact
	  if(mode.eq.0) then
	    origin=trimq(origin)
	    call upper(origin)
c  set mode (1,2,3,4,7) depending on origin
c  origin not given for MDI
	    if(origin(1:8).eq.'MAGPACK2') then
	      mode=1
	    else if(origin(1:4).eq.'MEES') then
	      mode=2
	    else if(origin.eq.'BBSO') then
	      mode=3
	    else if(origin(1:4).eq.'KPNO') then
	      mode=4
c             could be mode=5(synoptic)
	    else if(origin.eq.'MT. WILSON' .or.
     &	            origin.eq.'MT.WILSON') then
	      mode=7
	    endif
	  endif
	  go to 1900
	endif
c
c  keywords specific to magpack2 package (mode=1)
c
	if(keywd.eq.'KINDM   ') then
	  read(value,100) kindmi
	  setto='kindmi'
	  go to 1900
	endif
	if(keywd.eq.'MESH    ') then
	  read(value,100) mesh
	  setto='mesh'
	  go to 1900
	endif
	if(keywd.eq.'P       ') then
	  read(value,200) pdeg
	  setto='pdeg'
	  stp=.true.
	  go to 1900
	endif
	if(keywd.eq.'B0      ') then
	  read(value,200) b0deg
	  setto='b0deg'
	  stb0=.true.
	  go to 1900
	endif
	if(keywd.eq.'CL0     ') then
	  read(value,200) cl0deg
	  setto='cl0deg'
	  stcl0=.true.
	  go to 1900
	endif
	if(keywd.eq.'RSUN    ') then
	  read(value,200) rsp
	  setto='rsp'
	  go to 1900
	endif
	if(keywd.eq.'YDEG    ') then
	  read(value,200) ydeg
	  setto='ydeg'
	  go to 1900
	endif
	if(keywd.eq.'SYSTIME ') then
	  read(str,'(1x,a6,13x)') tsys
	  setto='tsys'
	  go to 1900
	endif
	if(keywd.eq.'WAVELEN ') then
	  read(value,200) wavel
	  setto='wavel'
	  go to 1900
	endif
	if(keywd(1:6).eq.'FACTOR') then
	  read(keywd(7:7),'(i1)') iframe
	  read(value,200) factor(iframe)
	  setto='factor('//keywd(7:7)//')'
	  go to 1900
	endif
c
c  keywords specific to U.Hawaii magnetograms (mode=2)
c
c  tested on data of 93/08/10 (IVM)
c
	if(keywd(1:5).eq.'IMAGE') then
	  read(keywd(6:6),'(i1)') iframe
	  read(str,*) image(iframe)
	  if(image(iframe).eq.'I_CONT') then
	    image(iframe)='I'
	  else if(image(iframe).eq.'B_LONG') then
	    image(iframe)='BL'
	  else if(image(iframe).eq.'B_TRANS') then
	    image(iframe)='BT'
	    kx=iframe
	  else if(image(iframe).eq.'B_AZIM') then
	    image(iframe)='AZ'
	    ky=iframe
	  else if(image(iframe).eq.'CE') then
	    image(iframe)='VL'
	  else
	    image(iframe)='S1'
	  endif
	  if(lenstr(specf).eq.0) then
	    specf=image(iframe)
	  else
	    specf=specf(1:lenstr(specf))//','//image(iframe)
	  endif
	  setto='image('//keywd(6:6)//')'
c  set mode=2
	  if(mode.eq.0) mode=2
	  go to 1900
	endif
	if(keywd(1:6).eq.'ISCALE') then
	  read(keywd(7:7),100) iframe
	  read(value,200) factor(iframe)
	  if(image(iframe).eq.'AZ') then
	    factor(iframe)=factor(iframe)*3.141592/180.0
c         unit of azimuth is now radian
	  endif
	  setto='factor('//keywd(7:7)//')'
	  go to 1900
	endif
	if(keywd.eq.'T_START ' .and. mode.eq.2) then
	  read(str,'(1x,3a2,1x,3a2,6x)')
c                  'yymmdd.hhmmssss'
     &	  dateo(1:2),dateo(4:5),dateo(7:8),
     &	  stime(1:2),stime(4:5),stime(7:8)
	  setto='dateo,stime'
	  stdate=.true.
	  sttime=.true.
	  go to 1900
	endif
	if(keywd.eq.'T_STOP  ' .and. mode.eq.2) then
	  read(str,'(8x,3a2,6x)') etime(1:2),etime(4:5),etime(7:8)
c                  'yymmdd.hhmmssss'
	  setto='etime'
	  go to 1900
	endif
	if(keywd.eq.'POS-LAT ') then
	  read(value,200) aldeg
	  setto='aldeg'
	  go to 1900
	endif
	if(keywd.eq.'POS-CMD ') then
	  read(value,200) apdeg
	  setto='apdeg'
	  go to 1900
	endif
	if(keywd.eq.'L0      ') then
	  read(value,200) cl0deg
	  setto='cl0deg'
	  stcl0=.true.
	  go to 1900
	endif
	if(keywd.eq.'RADIUS  ') then
	  read(value,200) rsp
	  setto='rsp'
	  go to 1900
	endif
c
c  DATE-OBS, TIME-OBS keywords (BBSO, Mt.Wilson, SOHO/MDI)
c
	if(keywd.eq.'DATE-OBS') then
	  read(str,*) buf
c                  'dd/mm/yy' or 'yyyy/mm/dd' or 'yy/mm/dd'
	  if(isint(buf(1:4),4)) then
c                  yyyy/mm/dd
            read(buf,'(a4,1x,a2,1x,a2)')
     &	      dateo(1:4),dateo(5:6),dateo(7:8)
	  else if(isint(buf(7:8),2)) then
	    read(buf(7:8),*) iyr
	    if(iyr.gt.31) then
c             dd/mm/yy
	      read(buf,'(a2,1x,a2,1x,a2)')
     &	      dateo(7:8),dateo(4:5), dateo(1:2)
	      dateo(3:3)='/'
	      dateo(6:6)='/'
	    else
c             yy/mm/dd
	      read(buf,'(a8)') dateo
	    endif
	  endif
	  setto='dateo'
	  stdate=.true.
	  go to 1900
	endif
c
	if(keywd.eq.'TIME-OBS') then
	  read(str,'(1x,a8,11x)') stime
c                  'hh:mm:ss.ss'
	  setto='stime'
	  sttime=.true.
	  go to 1900
	endif
c
c  BBSO
c
	if(keywd.eq.'WAVELNTH') then
	  read(value,'(1x,f4.0,15x)') wavel
c  WAVELNTH='xxxxA'
	  setto='wavel'
c  set mode=3
	  if(mode.eq.0) mode=3
	  go to 1900
	endif
c
c  keywords specific to KPNO magnetograms (mode=4)
c
	if(keywd.eq.'UTDATE  ' .and. mode.eq.4) then
	  read(str,'(1x,a2,1x,a2,1x,a2,11x)')
     &	  dateo(4:5),dateo(7:8),dateo(1:2)
c	  mm/dd/yy
	  setto='dateo'
	  stdate=.true.
	  go to 1900
	endif
c
	if(keywd.eq.'OBS_DATE' .and. mode.eq.4) then
	  read(str,'(14x,3a2)')
     &	  dateo(4:5),dateo(7:8),dateo(1:2)
c	  mmddyy (integer)
	  setto='dateo'
	  stdate=.true.
	  go to 1900
	endif
c
c  DATEOBS is not given
c  UTDATE='mm/dd/yy' for data of 1996 and later
c  OBS_DATE=mmddyy (integer) for 512ch magnetograph (-1991)
c  IRAFNAME='yymmdd.....' can be used, but sometimes there 
c  appears the second IRAFNAME keyword with other format
c
c  tested on data of: 74/07/01, 91/07/01 (512ch magnetograph)
c                     92/07/01, 93/07/02, 94/07/01, 95/07/01,
c                     96/07/01, 97/07/01, 98/07/01, 99/05/29,
c                     00/01/03 (spectromagnetograph, full res.)
c                     00/01/15 (spectromagnetograph, med. res.)
c 
	if(keywd.eq.'UTSTART ') then
	  read(str,'(1x,a8,11x)') stime
c                  'hh:mm:ss' or hh:mm
	  if(stime(1:2).eq.'  ')
     &	  stime=str(16:20)//':00'
	  setto='stime'
	  sttime=.true.
	  go to 1900
	endif
	if(keywd.eq.'UTSTOP  ') then
	  read(str,'(1x,a8,11x)') etime
c                  'hh:mm:ss'
	  setto='etime'
	  go to 1900
	endif
	if(keywd.eq.'UT_START') then
	  read(str,'(14x,a2,1x,a2,1x)') stime(1:2),stime(4:5)
c                  hh:mm
	  setto='stime'
	  sttime=.true.
	  go to 1900
	endif
	if(keywd.eq.'SCALE   ') then
	  read(value,200) dy
	  dx=dy
	  setto='dx,dy'
	  go to 1900
	endif
	if(keywd.eq.'E_XCEN  ') then
	  read(value,200) xc
	  setto='xc'
	  go to 1900
	endif
	if(keywd.eq.'E_YCEN  ') then
	  read(value,200) yc
	  setto='yc'
	  go to 1900
	endif
	if(keywd.eq.'E_XSMD  ') then
	  read(value,200) rx
	  setto='rx'
	  go to 1900
	endif
	if(keywd.eq.'E_YSMD  ') then
	  read(value,200) rsp
	  dx = dy*rsp/rx
	  setto='rsp, dx=dy*rsp/rx'
	  go to 1900
	endif
	if(keywd.eq.'WAVE    ') then
	  read(value,200) wavel
	  setto='wavel'
	  go to 1900
	endif
	if(keywd.eq.'WV_LNGTH') then
	  read(value,200) wavel
	  setto='wavel'
	  go to 1900
	endif
	if(keywd.eq.'B_ZERO  ') then
	  read(value,200) b0deg
	  setto='b0deg'
	  stb0=.true.
	  go to 1900
	endif
	if(keywd.eq.'L_ZERO  ') then
	  read(value,200) cl0deg
	  setto='cl0deg'
	  stcl0=.true.
	  go to 1900
	endif
	if(keywd.eq.'IRAFNAME') then
	  read(str,'(1x,a8,11x)') mfile
	  mfile=trimq(mfile)
	  title=mfile
	  if(dateo(1:2).eq.'  ' .and. isint(mfile,6)) then
c  assume IRAFNAME includes obsdate
     	    dateo=mfile(1:2)//'/'//mfile(3:4)//'/'//mfile(5:6)
	    setto='mfile,title,dateo'
	    stdate=.true.
c  synoptic data: get Carrington rotation number from IRAFNAME
	  else if(isint(mfile(1:4),4)) then
	    read(mfile(1:4),*) ncarr
	    setto='ncarr'
	  else if(isint(mfile(2:5),4)) then
	    read(mfile(2:5),*) ncarr
	    setto='ncarr'
	  endif
	  go to 1900
	endif
c
c  keywords specific to KPNO synoptic magnetograms (mode=5)
c  in the file containing data(i,j), longitude increases with i
c  (i=1 <==> longitude=0 deg, i=360 <==> longitude=359 deg)
c
c  tested on data of: Carrington rotation 1893 (year 1962)
c
	if(keywd.eq.'AV_BZERO') then
	  read(value,200) b0deg
	  setto='b0deg'
	  stb0=.true.
c  set mode=5
	  if(mode.eq.0) mode=5
	  go to 1900
	endif
	if(keywd.eq.'CAR_ROT') then
	  read(value,100) ncarr
c  set mode=5
	  if(mode.eq.0) mode=5
	  go to 1900
	endif
c
c  keywords specific to SOHO/MDI magnetograms (mode=6)
c
c  1024*1024, 1.98"
c  tested on data of 97/11/06
c
	if(keywd.eq.'IM_SCALE') then
	  read(value,200) dx
	  dy=dx
	  setto='dx,dy'
c  set mode=6
	  if(mode.eq.0) mode=6
	  go to 1900
	endif
	if(keywd.eq.'X0      ') then
	  read(value,200) xs
	  xs=-xs
	  setto='-xs'
	  go to 1900
	endif
	if(keywd.eq.'BLANK ') then
	  read(value,100) skylvl
	  setto='skylvl'
	  go to 1900
	endif
c
c  X0, Y0 also used in Mt.Wilson
	if(keywd.eq.'Y0      ') then
	  read(value,200) ys
	  ys=-ys
	  setto='-ys'
	  go to 1900
	endif
	if(keywd.eq.'R_SUN   ') then
	  read(value,200) rsp
	  setto='rsp'
	  go to 1900
	endif
	if(keywd.eq.'P_ANGLE ') then
	  read(value,200) pdeg
	  setto='pdeg'
	  stp=.true.
	  go to 1900
	endif
	if(keywd.eq.'DTYPE   ') then
	  read(str,*) specf
c  DTYPE=V(Doppler), B(magnetogram), C(continuum), M(modulation)
	  if (specf.eq.'B') specf='BL'
	  setto='specf'
	  go to 1900
	endif
c
c  keywords specific to Mt.Wilson magnetograms (mode=7)
c
c  512*512 pixels, 3.75"
c  tested on data of 95/04/04, 99/07/01
c
	if(keywd.eq.'DXB_IMG ') then
	  read(value,200) dx
	  dy=dx
	  setto='dx,dy'
c  set mode=7
	  if(mode.eq.0) mode=7
	  go to 1900
	endif
	if(keywd.eq.'DYB_IMG ') then
	  read(value,200) dy
	  setto='dy'
	  go to 1900
	endif
	if(keywd.eq.'TAVG-UT') then
	  read(value,200) avgut
	  ih=ifix(avgut)
	  im=ifix(60.0*(avgut-float(ih)))
	  write(stime,'(i2.2,1h:,i2.2,3h:00)') ih,im
	  etime=stime
	  setto='stime,etime'
	  sttime=.true.
	  go to 1900
	endif
	if(keywd.eq.'CENLON') then
	  read(value,200) cl0deg
	  setto='cl0deg'
	  stcl0=.true.
	  go to 1900
	endif
	if(keywd.eq.'R0      ') then
	  read(value,200) rsp
	  setto='rsp'
	  go to 1900
	endif
	if(keywd.eq.'LAMBDA') then
	  read(value,200) wavel
	  setto='wavel'
	  go to 1900
	endif
c
 1900	if(msglvl.gt.1 .and. keywd.ne.' ') then
	  if(msglvl.gt.2 .or. setto.ne.' ')
     &      write(lst,'(1x,a)') line(1:lenstr(line))
	  if(setto.ne.' ')
     &      write(lst,*) 'set to: ',setto
	endif
c
 1000	continue
	if(.not.eof) go to 1
c
c  end of keyword search loop
c
c  calculate solar parameters from date
c
	if(ncarr.ne.0) then
	    call carcmp(ncarr,dateo,stime)
	    stdate=.true.
	    sttime=.true.
	endif
c
	if(stdate.and.sttime) then 
	  call suncal(tsys,dateo,stime,sdist,rspcal,
     &     	        pcal,b0cal,cl0cal,doy,irotno)
	  if(.not.stp) then
	    pdeg=pcal
	    if(msglvl.gt.1) write(msg,*) 'pdeg from ephemeris'
	  endif
	  if(.not.stb0) then
	    b0deg=b0cal
	    if(msglvl.gt.1) write(msg,*) 'b0deg from ephemeris'
	  endif
	  if(.not.stcl0) then
	     cl0deg=cl0cal
	     if(msglvl.gt.1) write(msg,*) 'cl0deg from ephemeris'
	  endif
	  if(rsp.eq.rspdef) then
	    rsp=rspcal
	    if(msglvl.gt.1) write(msg,*) 'rsp from ephemeris'
	  endif
	else
	  if(rsp.eq.rspdef) then
	    rsp=rsun/arcsec
	    rspcal=rsp
c  rsp in arcseconds here
	    if(msglvl.gt.1) write(msg,*) 'rsp set to rsun'
c  if date was not given, set rsp to rsun (in arcsec, at 1 AU)
	  endif
	endif
c
c  Mees
c
c  (xs,ys) is set later by using (apdeg,aldeg)
	if(mode.eq.2) then
	  kindmi=1102
	endif
c
c  BBSO
c
	if(mode.eq.3) then
c
c  tested on data of 93/08/11, 96/05/19
c  512*481, pixel size uncertain
c
	  dx=-0.5
	  dy=0.5
c  to be confirmed
	endif
c
c  KPNO
c
	if(mode.eq.4) then
	  if(xc.eq.rspdef) then
	    xs=-rsp
	    ys=-rsp
c  medium resolution data are 2*2 binned, but dx and dy are those of
c  original pixel in arcseconds. rsp, xs, and ys are in units of dx
	  else
	    rsp=rsp*dy
	    xs=-xc*dx
	    ys=-yc*dy
c  xc and rsp were in pixel unit
	  endif
	  dx=dx*float(2048/nx)
	  dy=dy*float(2048/nx)
c
c  spectromagnetograph 1788*1788 pixels, 1.14"
	  if(inst.eq.'SPECTROM') then
	    if(nx.eq.1788) then
	      skylvl=-10000
	    else if(nx.eq.894) then
	      skylvl=-750
	    endif
	    if(abs(wavel-8688.0).lt.1.0) then
	      factor(1)=factor(1)*1.46
	      zlevel(1)=zlevel(1)*1.46
	    elseif(abs(wavel-8542.0).lt.1.0) then
	      factor(1)=factor(1)*2.16
	      zlevel(1)=zlevel(1)*2.16
	    elseif(abs(wavel-5507.0).lt.1.0) then
	      factor(1)=factor(1)*1.26
	      zlevel(1)=zlevel(1)*1.26
	    endif
	  else
c  512ch magnetograph 2048*2048 pixels, 1"
	    skylvl=-2048
	  endif
	  if(msglvl.gt.0) write(lst,*) 'KPNO data: skylevel, factor,zlevel=',
     &	skylvl,factor(1),zlevel(1)
c
c  data are heliocentric
	  ydeg = pdeg
c
	endif
c
c  KPNO synoptic data
c  x = longitude from 0 deg to 360-eps 
c (the Carrington longitude for each x-value is given in header)
c  y = sin(latitude) from -1 to +1
c  data are 'BR' (BL divived by cosine of angle between LOS and radius vector
c
	if(mode.eq.5) then
	  rsp=rsun/arcsec
	  rspcal=rsp
	  xs=1.0e-4
c  small positive number, so that (xs,ys) lies east of central meridian
c  in the back side of the sun
	  ys=-1.0
	  dx=2.0*pi/float(nx)
c  xe is 359 deg and safely lies west of central meridian
	  dy=2.0/float(ny-1)
	  specf='BR'
	  kindmi=30006
	  mesh=4
	  cl0deg=180.0
c  data are heliocentric
	  ydeg = pdeg
	endif
c
c  MDI
c
	if(mode.eq.6) then
	  xs=xs*dx
	  ys=ys*dy
	  rsp=rsp*dx
c  xs,ys,rsp were in pixel unit
c  data are heliocentric, but p-angle is set to 0 in the header
	  if(stdate.and.sttime) pdeg = pcal
	  ydeg=pdeg
	endif
c
c  Mt.Wilson
c
	if(mode.eq.7) then
	  xs=xs*dx
	  ys=ys*dy
	  rsp=rsp*dx
c  xs,ys,rsp were in pixel unit
	  skylvl=-32768
c  B0 was given in radian in the header
	  b0deg = 180.0*b0deg/3.141592
c  data are geocentric, but p-angle is not given in the header
c  if the date and time were decoded, pdeg is supplied from ephemeris
c
	endif
c
c  change length scale from arcsec to ulen (approx.10^4 km)
c
c  if rsp is not equal to rspcal, change the scale and make rsp=rspcal
c  this makes MDI magnetogram to the scale viewed from earth
c  mod. 02/03/08
c
	if(mode.ne.5) then 
	  dx=dx*arcsec*(rspcal/rsp)
	  dy=dy*arcsec*(rspcal/rsp)
	  xs=xs*arcsec*(rspcal/rsp)
	  ys=ys*arcsec*(rspcal/rsp)
	endif
	rsp=rspcal*arcsec
c
c  assume kindmi=1 (BL) if only one data set is present
	if (nframi.eq.1 .and. 
     &	    (specf.eq.' '.or.specf.eq.'BL') ) then
	  specf='BL'
	  kindmi=1
	endif
c
c  if the following parameters have been specified by namelist input
c  resume those values
c	nbytmi,naxis,nframi,specf,
c	mfile,factor,zlevel,rsp,
c	nx,ny,xs,ys,dx,dy,
c	tsys,dateo,stime,etime,inst,
c	pdeg,b0deg,cl0deg,aldeg,apdeg
c	kindmi,skylvl,ncarr
c
        if(nmlsw(1).eq.1) nbytmi = nbytm1
        if(nmlsw(2).eq.1) naxis = naxis1
        if(nmlsw(3).eq.1) nframi = nfram1
        if(nmlsw(4).eq.1) specf = specf1
        if(nmlsw(5).eq.1) mfile = mfile1
        if(nmlsw(6).eq.1) then
          do 50 i=1,10
 50       factor(i) = facto1(i)
        endif
        if(nmlsw(7).eq.1) then
          do 55 i=1,10
 55       zlevel(i) = zleve1(i)
        endif
        if(nmlsw(8).eq.1) rsp = rsp1
        if(nmlsw(9).eq.1) nx = nx1
        if(nmlsw(10).eq.1) ny = ny1
        if(nmlsw(11).eq.1) xs = xs1
        if(nmlsw(12).eq.1) ys = ys1
        if(nmlsw(13).eq.1) dx = dx1
        if(nmlsw(14).eq.1) dy = dy1
        if(nmlsw(15).eq.1) tsys = tsys1
        if(nmlsw(16).eq.1) dateo = dateo1
        if(nmlsw(17).eq.1) stime = stime1
        if(nmlsw(18).eq.1) etime = etime1
        if(nmlsw(19).eq.1) inst = inst1
        if(nmlsw(20).eq.1) origin = origi1
        if(nmlsw(21).eq.1) pdeg = pdeg1
        if(nmlsw(22).eq.1) b0deg = b0deg1
        if(nmlsw(23).eq.1) cl0deg = cl0de1
        if(nmlsw(24).eq.1) aldeg = aldeg1
        if(nmlsw(25).eq.1) apdeg = apdeg1
        if(nmlsw(25).eq.1) apdeg = apdeg1
        if(nmlsw(26).eq.1) kindmi = kindm1
        if(nmlsw(27).eq.1) skylvl = skylv1
        if(nmlsw(28).eq.1) ncarr = ncarr1
c
	do 60 i=1,28
	if(nmlsw(i).eq.1 .and. msglvl.gt.1) write(msg,*)
     &	    nmlstr(i),' from namelist'
 60	continue
c
	if(rsp.eq.rspdef) then
	  write(msg,*) '(subr.rfits ) warning: rsp undefined'
	endif
c
c  subr.splitf splits specf into items by using comma as a separator
c  and the results are stored in speca
c  (keyword CTYPE3 takes precedence of IMAGEn keywords)
c  the number of items is returned as nspec1
c
	if(specf.ne.' ') call splitf(specf,speca,nspec1)
c
	nspec=0
	do 2000 iframe=1,nframi
	if(speca(iframe).eq.' ') speca(iframe)=image(iframe)
	if(speca(iframe).ne.' ') nspec=nspec+1
 2000	continue
c
	if(nspec.ne.nframi) then
	  write(msg,*)
     &   '(subr.rdfits) warning: nspec.ne.nframi, nspec,nframi=',
     &               nspec,nframi
	endif
c
c  estimate kindmi
c
	if(nframi.gt.1) then 
	  do 2050 iframe=1,nframi
	  if(speca(iframe).eq.'I') iexist=.true.
	  if(speca(iframe).eq.'VL') vexist=.true.
	  if(speca(iframe).eq.'BX') xexist=.true.
	  if(speca(iframe).eq.'BY') yexist=.true.
	  if(speca(iframe).eq.'BL') zexist=.true.
 2050   continue
	  if(zexist) kindmi=1
	  if(xexist.and.yexist.and.zexist) kindmi=2
	  if(vexist) kindmk=kindmi+100
	  if(iexist) kindmi=kindmi+1000
	  if(kindmi.eq.0) then
	    write(msg,*)
     &	'(subr.rdfits) error: kindmi is unknown'
	    errflg=2
	    return
	  endif
	endif
c
	kindm=kindmi
	kindmo=kindmi
c
	ftag=mktag()
	xtod=0.0
	ytod=0.0
	b0rad=rad(b0deg)
	prad=rad(pdeg)
	cl0=rad(cl0deg)
	write(buf,340) title
 340	format(a80)
	xxsp(1)=0.0
	xxsp(2)=0.0
	xxsp(3)=-rsp
	prad=rad(pdeg)
	b0rad=rad(b0deg)
	cl0=rad(cl0deg)
c  set xdu and ydu from ypos
	ypos=rad(ydeg)
c
c  if ydeg=pdeg, the data are heliocentric (solar north up)
c  in this case, in order to avoid coordinate transform,
c  set ypos=0
c  the z-axis of the C-coordinates is then toward solar north
c
      if(ydeg.eq.pdeg) then
        ypos=0.0
        prad=0.0
      endif
	call setdu
c
	if(mesh.eq.3) cl0eff=0.0
	if(mesh.eq.4) cl0eff=cl0
	 call setas
	 call setar

	if(apdeg.ne.0.0 .or. aldeg.ne.0.0) then
	  ap=rad(apdeg)
	  al=rad(aldeg)
	  call rtoc(ap,al,0.0, xx)
	  xs=xx(1)
	  ys=xx(2)
	endif
c
	if(mesh.eq.0) then
	  xtod=xs+0.5*dx*float(nx-1)
	  ytod=ys+0.5*dy*float(ny-1)
	endif
c
	if(msglvl.gt.0) 
     &	  write(lst,*) '(subr.rdfits) kindmi,mesh,nframi=',
     &	  kindmi,mesh,nframi
	if(msglvl.gt.1) then
	  write(lst,*) '  origin=',origin,'   mode=',mode
	  call printm(nbytmi,nx,ny,xs,ys,dx,dy,ydeg,
     &            rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &            tsys,inst,wavel,mfile,dateo,stime,etime,ftag,title)
	endif
c
c  ixs,ixe,iys,iye were read in progmain.f
          nx0=nx
          ny0=ny
          xs0=xs
          ys0=ys
          dx0=dx
          dy0=dy
          if(ixs.eq.0) ixs=1
          if(ixe.eq.0) ixe=nx
          if(iys.eq.0) iys=1
          if(iye.eq.0) iye=ny
c
c  read the data all at once (nx*ny*nframi*nbytmi bytes)
c  check data size
c
	if (nx*ny*nframi*abs(nbytmi).gt.MMX*MMY*4) then
	  write(msg,*) 
     &	  '(subr.rdfits) error: data size is too large'
	  write(msg,*)
     &	  '     input data size (bytes)=',nx*ny*nframi*abs(nbytmi)
	  write(msg,*)
     &	  '     internal buffer size (bytes)=',MMX*MMY*4
	  errflg=2
	  return
	endif
c
        nx1=ixe-ixs+1
        ny1=iye-iys+1
        if(nx1/nbinx.gt.MX .or.
     &     ny1/nbiny.gt.MY) then
          nbinx=(nx1-1)/nxmax +1
          nbiny=(ny1-1)/nymax +1
          if(msglvl.gt.0) then
            write(lst,*)
     &  '(subr.rfits ) warning: nx or ny too large, nx,ny=',nx1,ny1
            write(lst,*)
     &  '      binning will be applied, nbinx,y=',nbinx,nbiny
            write(lst,*)
     &  '      in order to avoid binning, increase MX and MY in'
            write(lst,*)
     &  '      mdata.fc so that MX>=nx and MY>=ny'
          endif
        else if(nx1/nbinx.gt.nxmax .or.
     &          ny1/nbiny.gt.nymax) then
          nbinx=(nx1-1)/nxmax +1
          nbiny=(ny1-1)/nymax +1
          if(msglvl.gt.0) then
            write(lst,*)
     &  '(subr.rfits ) warning: nx or ny too large, nx,ny=',nx1,ny1
            write(lst,*)
     &  '      binning will be applied, nbinx,y=',nbinx,nbiny
            write(lst,*)
     &  '      in order to avoid binning, increase nxmax,nymax in'
            write(lst,*)
     &  '      auxdata.dat so that nxmax>=nx and nymax>=ny'
          endif
        endif
c
c  read data
c
	if (nbytmi.eq.1) then
	  call in1( iunit,loc,idata1,lrec0,nx,ny*nframi,nx,iostat )
	  if(iostat.ne.0) go to 9
c
	else if (nbytmi.eq.2) then
cx	ny=ny-1
	  call in2( iunit,loc,idata2,lrec0,nx,ny*nframi,nx,iostat )
cx	  if(iostat.ne.0) go to 9
	  if (myint.lt.0) call swap2(idata2,nx,ny*nframi,nx)
c
	else if (abs(nbytmi).eq.4) then
c  fdata4 occupies the same physical memory as idata4
c  for nbytmi=-4, the data are read to idata4 and later referenced as fdata4
	  call in4( iunit,loc,idata4,lrec0,nx,ny*nframi,nx,iostat )
	  if( iostat.ne.0) go to 9
	  if (myint.lt.0) call swap4(idata4,nx,ny*nframi,nx)
	endif
c
        nframe=0
	do 2200 iframe=1,nframi
	lspec1=lspec(speca(iframe))
        factm(lspec1)=factor(iframe)
        alloc=.true.
        k=newk(lspec1, alloc)
c  newk increments nframe and set
c       kloc(lspec1)=k
c       kmem(nframe)=k
c       lspecs(k)=lspec1
c
	ijst=1+nx0*ny0*(iframe-1)
	j=(ijst-1)/MMX+1
	i=mod(ijst-1,MMX)+1
c  (i,j) is the address of the first point of iframe-th magnetogram 
c  in array idata1/2/4 when it is dimensioned as (MMX,MMY)
c  nx,ny etc are modified by bin1/2/4 if iframe>1, so that use nx0,ny0
c
	if(nbytmi.eq.1) then
c
c  tag sky datapoints as unfilled (nbytm1=2,4),
c  apply binning if required,
c  and store data into rdata
c
c  nx,ny etc are modified by bin1/2/4
c  the original values are kept as nx0 and ny0
c
	  call bin1(idata1(i,j),nx0,ixs,ixe,iys,iye,
     &              nbinx,nbiny,factor(iframe),zlevel(iframe),
     &              rdata(1,1,k),MX,
     &              xs0,ys0,dx0,dy0,
     &              nx,ny,xs,ys,dx,dy)
c
	else if(nbytmi.eq.2) then
	  if(skylvl.ne.iufl4)
     &	    call skysb2(idata2(i,j),nx0,ny0,nx0,skylvl)
	  call bin2(idata2(i,j),nx0,ixs,ixe,iys,iye,
     &              nbinx,nbiny,factor(iframe),zlevel(iframe),
     &              rdata(1,1,k),MX,
     &              xs0,ys0,dx0,dy0,
     &              nx,ny,xs,ys,dx,dy)
c
	else if(nbytmi.eq.4) then
	  if(skylvl.ne.iufl4)
     &	    call skysb4(idata4(i,j),nx0,ny0,nx0,skylvl)
	  call bin4(idata4(i,j),nx0,ixs,ixe,iys,iye,
     &              nbinx,nbiny,factor(iframe),zlevel(iframe),
     &              rdata(1,1,k),MX,
     &              xs0,ys0,dx0,dy0,
     &              nx,ny,xs,ys,dx,dy)
c
	else if(nbytmi.eq.-4) then
	  call bin4f(fdata4(i,j),nx0,ixs,ixe,iys,iye,
     &              nbinx,nbiny,factor(iframe),zlevel(iframe),
     &              rdata(1,1,k),MX,
     &              xs0,ys0,dx0,dy0,
     &              nx,ny,xs,ys,dx,dy)
	endif
c
 2200	continue
c
	nbytmi=abs(nbytmi)
c
c  Mees: converion from (Bt,AZ) to (BX,NY)
c
	if(mode.eq.2) then
	  do 2300 j=1,ny
	  do 2300 i=1,nx
	  bt=rdata(i,j,kx)
	  az=rdata(i,j,ky)
	  bx=-bt*sin(az)
	  by= bt*cos(az)
	  rdata(i,j,kx)=bx
	  rdata(i,j,ky)=by
 2300	  continue
	  lspecs(kx)=lspec('BX')
	  lspecs(ky)=lspec('BY')
	  kloc(lspec('BX'))=kx
	  kloc(lspec('BY'))=ky
	  kloc(lspec('BT'))=0
	  kloc(lspec('AZ'))=0
          factm(lspec('BY'))=factm(lspec('BX'))
	  if(msglvl.gt.0)
     &	write(lst,*) 'conversion from (bt,az) to (bx,by) done.'
	endif
c
c  KPNO synoptic data: re-gridding from sin(lat) to arcsin(lat)
c
	if(mode.eq.5) then
	  nx0=nx
	  ny0=ny
	  xs0=xs
	  ys0=ys
	  dx0=dx
	  dy0=dy
	  call synop(rdata,MX,nymax,
     &              nx0,ny0,xs0,ys0,dx0,dy0,
     &              nx, ny, xs, ys, dx, dy)
	  if(errflg.gt.1) return
	  if(msglvl.gt.0) 
     &	write(lst,*) 're-gridding of synoptic data done.'
	endif
c
	xe=xs+dx*float(nx-1)
	ye=ys+dy*float(ny-1)
c
	if(msglvl.gt.0) then
	  if(ixs.ne.1 .or. iys.ne.1 .or.
     &	     ixe.ne.nx0 .or. iye.ne.ny0) then
            write(lst,*)
     &    '  sub-area selection: ixs,ixe,iys,iye=',
     &      ixs,ixe,iys,iye
	  endif
	  if(nbinx.ne.1.or.nbiny.ne.1) then
            write(lst,*)
     &    '  binning: nbinx,nbiny=',nbinx,nbiny
	  endif
	  write(lst,*) '  nx,ny=',nx,ny
 	  write(lst,*) '  xs,ys=',xs,ys
	  write(lst,*) '  xe,ye=',xe,ye
	  write(lst,*) '  dx,dy=',dx,dy
	endif
c
	if(mesh.eq.0) then
	  xtod=xs+0.5*dx*float(nx-1)
	  ytod=ys+0.5*dy*float(ny-1)
	  xxtod(1)=xtod
	  xxtod(2)=ytod
	  call projsr(xxtod,rsp)
	  call dtoc(xxtod,xxto)
	else
	  xxtod(1)=xtod
	  xxtod(2)=ytod
	  call projsr(xxtod,rsp)
	  call dtoc(xxtod,xxto)
	endif
	call settu
c
c  for mesh=0
c  clear data outside the solar disk (r> rsp)
c
        if (mesh.eq.0) then
          do 2100 iframe=1,nframi
          do 2100 j=1,ny
          do 2100 i=1,nx
          x= xs + dx*float(i-1)
          y= ys + dy*float(j-1)
          if( (x-xxsp(1))**2+(y-xxsp(2))**2 .gt.
     &      rsp*rsp .or. rdata(i,j,iframe).lt.skylvl ) then
            rdata(i,j,iframe) = ufl
          endif
 2100     continue
        endif
c
	return
c
 9	if(iostat.eq.1) then
	  write(lst,*) '(subr.rdfits) endfile during read'
	else if(iostat.eq.2) then
	  write(lst,*) '(subr.rdfits) read error'
	endif
	errflg=2
	return
c
 91	write(lst,*) '(subr.rdfits) error: simple=',simple
	errflg=2
	return
	end
c
c  write data with fits-format
c  2001/04/07 length unit changed from ulen (approx. 10^4 km) to arcsec
c
	subroutine wtfits( ounit )
c
	include 'sys.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'mparam.fc'
	include 'string.fc'
	include 'mdata.fc'
c
	integer ounit, kolist(MZ)
	integer*2 izero2(40)
	integer*4 izero4(20)
	character hdr1(36)*80, hdr2(36)*80, speca(10)*8, specf*18,
     &	          unitst*12,unita(10)*12
	logical simple
	data izero2/40*0/, izero4/20*0/
c
	if(kindmo.eq.0) kindmo=kindm
	call olist(kindmo,kolist,nframo,NSPEC0)
	if(msglvl.gt.2) then
	  write(lst,900) 'wtfits:nframe_o=',nframo
	  write(lst,900) 'wtfits:kolist(iframe)=',kolist
	  write(lst,900) 'wtfits:kloc(lspec)  =',kloc
	  write(lst,900) 'wtfits:lspecs(k)    =',lspecs
 900	  format(2x, a,(20i3/))
      endif
c
	locbuf=1
	factr0=0.0
	nonmag=0
	mag=0
	do 1000 iframe=1,nframo
	k=kolist(iframe)
	factor=factm(lspecs(k))
	speca(iframe)=specst(lspecs(k))
	unita(iframe)=unitst(lspecs(k))
c  only one factor can be specified in FITS hdr1
c  facter for magnetograms has priority
	if(factr0.eq.0.0) factr0=factor
	if(speca(iframe)(1:1).eq.'B') then
	  factr0=factor
	  mag=1
	else
	  nonmag=1
	endif
c
c  pack data into array idata2/4
c  idata2/4 are passed to cpbuf2/4 as 1-D array addressed by locbuf
c
	if(iabs(nbytem).eq.2) then
 	  call cpbuf2(rdata(1,1,k),factor,idata2,nx,ny,MX,locbuf)
	else if(iabs(nbytem).eq.4) then
 	  call cpbuf4(rdata(1,1,k),factor,idata4,nx,ny,MX,locbuf)
	endif
 1000	continue
c
c  mycode:0=unknown, 1=ascii, 2=ebcdic
c  icode = target code if icode.ne.0
c  FITS hdr1 will be written in ASCII code
c  FITS data will be written in big-endian integers
c
	if (mycode.eq.2) then
	  icode=1
	else
	  icode=0
	endif
c
	simple=.true.
	nbit=8*nbytem
	naxis=3
	zlevel=0.0
	one=1.0
	ftag=mktag()
	call combin(speca,specf,nframo)
c
 100	format(a8,'= ',l20,10x,'/ ',a38)
 200	format(a8,'= ',i20,10x,'/ ',a38)
 300	format(a8,'= ',1pe20.5,10x,'/ ',a38)
 350	format(a8,'= ',f20.2,10x,'/ ',a38)
 400	format(a8,'= ',1h',a18,1h',10x,'/ ',a38)
c
	do 10 i=1,36
	hdr1(i)=' '
 10	hdr2(i)=' '
c
	write(hdr1(1), 100) 'SIMPLE  ',simple,
     &	                    'STANDARD FITS                         '
	write(hdr1(2), 200) 'BITPIX  ',nbit,
     &	                    'NUMBER OF 8-BIT BYTES PER PIXEL       '
	write(hdr1(3), 200) 'NAXIS   ',naxis,
     &	                    'NUMBER OF AXIS                        '
	write(hdr1(4), 200) 'NAXIS1  ',nx,
     &	                    'NUMBER OF PIXELS/ROW(EW)              '
	write(hdr1(5), 200) 'NAXIS2  ',ny,
     &	                    'NUMBER OF ROWS(NS)                    '
	write(hdr1(6), 200) 'NAXIS3  ',nframo,
     &	                    'NUMBER OF FRAMES                      '
	write(hdr1(7), 300) 'BSCALE  ',factr0,
     &	                    'REAL = TAPE*BSCALE+BZERO              '
	write(hdr1(8), 300) 'BZERO   ',zlevel,
     &	                    '                                      '
	if(mag.eq.1.and.nonmag.eq.0)
     &	  write(hdr1(9), 400) 'BUNIT   ','GAUSS             ',
     &	                    '                                      '
	if(mag.eq.1.and.nonmag.eq.1)
     &	  write(hdr1(9), 400) 'BUNIT   ','GAUSS             ',
     &	                    'FOR MAGNETIC FIELDS                   '
	if(mag.eq.0)
     &	  write(hdr1(9), 400) 'BUNIT   ','                  ',
     &	                    '                                      '
	write(hdr1(10),400) 'OBJECT  ',mfile//'          ',
     &	                    'OBJECT OR FILE-ID                     '
	write(hdr1(11),300) 'CRVAL1  ',xs/arcsec,
     &	                    'REF POINT VALUE (ARCSEC)              '
	write(hdr1(12),300) 'CRPIX1  ',one,
     &	                    'REF POINT PIXEL LOCATION              '
	write(hdr1(13),400) 'CTYPE1  ','LL                ',
     &	                    'COORD TYPE:X(CELESTIAL EW),SUNCTR=0   '
	write(hdr1(14),300) 'CDELT1  ',dx/arcsec,
     &	                    'COORD VALUE INCREMENT (ARCSEC)        '
	write(hdr1(15),300) 'CRVAL2  ',ys/arcsec,
     &	                    'REF POINT VALUE (ARCSEC)              '
	write(hdr1(16),300) 'CRPIX2  ',one,
     &	                    'REF POINT PIXEL LOCATION              '
	write(hdr1(17),400) 'CTYPE2  ','MM                 ',
     &	                    'COORD TYPE:Y(CELESTIAL NS),SUNCTR=0   '
	write(hdr1(18),300) 'CDELT2  ',dy/arcsec,
     &	                    'COORD VALUE INCREMENT (ARCSEC)        '
	write(hdr1(19),300) 'CRVAL3  ',one,
     &	                    'REF POINT VALUE                       '
	write(hdr1(20),300) 'CRPIX3  ',one,
     &	                    'REF POINT PIXEL LOCATION              '
	write(hdr1(21),400) 'CTYPE3  ',specf,
     &	                    'COORD TYPE:IMAGE FRAMES               '
	write(hdr1(22),300) 'CDELT3  ',one,
     &	                    'COORD VALUE INCREMENT                 '
	write(hdr1(23),350) 'P       ',pdeg,
     &	                    'SOLAR P-ANGLE (DEG) FROM EPHEMERIS    '
	write(hdr1(24),350) 'B0      ',b0deg,
     &	                    'SOLAR B0-ANGLE (DEG)                  '
	write(hdr1(25),350) 'CL0     ',cl0deg,
     &	                    'CARRINGTON LONGITUDE OF DISK CENTER   '
	write(hdr1(26),350) 'RSUN    ',rsp/arcsec,
     &	                    'SOLAR RADIUS (ARCSEC)                 '
	write(hdr1(27),400) 'INSTRUME',inst//'          ',
     &	                    'INSTRUMENT/TELESCOPE                  '
	write(hdr1(28),400) 'TELESCOP',inst//'          ',
     &	                    'INSTRUMENT/TELESCOPE                  '
	write(hdr1(29),350) 'WAVELEN ',wavel,
     &	                    'WAVELENGTH, ANGSTROM                  '
	write(hdr1(30),400) 'DATEOBS ',dateo//'          ',
     &	                    '                                      '
	write(hdr1(31),400) 'TIMEOBS ',stime//'-'//etime//' ',
     &	                    '                                      '
	write(hdr1(32),400) 'SYSTIME ', tsys//'            ',
     &	                    'TIME ZONE FOR DATEOBS,TIMEOBS         '
	write(hdr1(33),400) 'DATE    ', ftag//'  ',
     &	                    '                                      '
	write(hdr1(34),400) 'ORIGIN  ','MAGPACK2 FITS     ',
     &	                    '                                      '
c  non-standard parametes and comments
 500	format(a10,a)
	write(hdr1(35),500) 'COMMENT   ',title(1:70)
	write(hdr1(36),500) 'COMMENT   ','NON-STANDARD PARAMETERS'
	write(hdr2(1), 200) 'KINDM   ',kindm,
     &	                    'DATA SPECIFIER                        '
	write(hdr2(2), 200) 'MESH    ',mesh,
     &	                    'COORDINATE SYSTEM SPECIFIER           '
	write(hdr2(3), 400) 'MFILE   ',mfile//'          ',
     &	                    'FILE ID                               '
	write(hdr2(4), 350) 'YDEG    ',ydeg,
     &	                    'POSITION ANGLE OF Y-DIRECTION         '
	write(hdr2(5), 300) 'XTOD    ',xtod/arcsec,
     &	                    'X-ORIGIN OF T-COORDINATES (ARCSEC)    '
	write(hdr2(6), 300) 'YTOD    ',ytod/arcsec,
     &	                    'Y-ORIGIN OF T-COORDINATES (ARCSEC)    '
c
	iend=7
	do 2000 iframe=1,nframo
	iend=iend+1
	k=kolist(iframe)
	factor=factm(lspecs(k))
	write(hdr2(6+iframe), 360) 'FACTOR',iframe,factor,
     &	speca(iframe),unita(iframe)
 360	format(a6,i1,1x,'= ',1pe20.5,10x,'/ ',a8,a12)
 2000	continue
c
c  added 2002/05/07
	if(inst.eq.'MTK ft1') then
	  idwl=mpint(1)
	  blfact=mpreal(1)
	  if(idwl.eq.0) idwl=-80
	  if(blfact.eq.0.0) blfact=1.0
	  write(hdr2(6+nframo+1), 200) 'DWL     ',idwl,
     &	                    'PASSBAND POSISION (MILLI-ANGSTROM)    '
	  write(hdr2(6+nframo+2), 300) 'BLFACT  ',blfact,
     &	                    'CALIB.FACTOR MULTIPLIED ON BL         '
	  iend=iend+2
	endif
	hdr2(iend)='END'
c
	if(msglvl.gt.1) then
	  write(lst,*) '(subr.wtfits) FITS HEADER'
	  do 2100 i=1,36
 2100	  write(lst,'(1x,a)') hdr1(i)
	  do 2200 i=1,iend
 2200	  write(lst,'(1x,a)') hdr2(i)
	endif
c
	lrec0=80
	if (icode.ne.0) then
	  call cconv(icode, hdr1)
	  call cconv(icode, hdr2)
	endif
	loc=1
	do 2300 i=1,36
	call outs( ounit, loc, hdr1(i), lrec0, iostat )
	if( iostat.ne.0) go to 9
 2300	continue
	do 2400 i=1,36
	call outs( ounit, loc, hdr2(i), lrec0, iostat )
	if( iostat.ne.0) go to 9
 2400	continue
c
c  write the data all at once (nx*ny*nframo bytes)
c
	if (iabs(nbytem).eq.2) then
	  if (myint .lt.0) call swap2(idata2,nx,nframo*ny,nx) 
	  call out2( ounit, loc, idata2, lrec0, nx, nframo*ny, nx,
     &	       iostat )
	  if(iostat.ne.0) go to 9
c  one fits record = 80*36 bytes
c  pad incomplete record with zero
	  if(mod(loc-1,36).ne.0) then
	    nrec=36-mod(loc-1,36)
	    do 3000 irec=1,nrec
	    call out2( ounit, loc, izero2, lrec0, 40, 1, 40, iostat )
 3000	    continue
	  endif
c
	else if (iabs(nbytem).eq.4) then
	  if (myint .lt.0) call swap4(idata4,nx,nframo*ny,nx)  
	  call out4( ounit, loc, idata4, lrec0, nx, nframo*ny, nx, 
     &	       iostat )
	  if( iostat.ne.0) go to 9
c  pad incomplete record with zero
	  if(mod(loc-1,36).ne.0) then
	    nrec=36-mod(loc-1,36)
	    do 3100 irec=1,nrec
	    call out4( ounit, loc, izero4, lrec0, 20, 1, 20, iostat )
 3100	    continue
	  endif
c
	endif
c
        if(msglvl.gt.0) write(lst,*)
     &   '(subr.wrftis) kindmo,mesh,nframo=',kindmo,mesh,nframo

c
	return
c
 9	write(lst,*) '(subr.wtfits) i/o error during write'
	errflg=2
	return
c
	end
c
	subroutine splitf(specf,speca,n)
	character specf*(*),speca*(*)
	dimension speca(10)
c
	n=0
	l=len(specf)
c  find end of line
	do 10 i=l,1,-1
	if(specf(i:i).ne.' ') go to 20
 10	continue
	return
 20	i2=i
c
	i1=1
	do 30 i=1,i2
c  skip blank
	if(specf(i:i).eq.' ') then
	  i1=i+1
	  go to 30
	endif
c  find one word
	if(specf(i:i).eq.',') then
	  n=n+1
	  speca(n)=specf(i1:i-1)
	  i1=i+1
	else if(i.eq.i2) then
	  n=n+1
	  speca(n)=specf(i1:i)
	endif
 30	continue
	return
	end
c
	subroutine combin(speca,specf,n)
	character specf*(*),speca(10)*(*)
c
	k=1
	do 10 i=1,n
	l=len(speca(i))
	do 20 j=l,1,-1
	if(speca(i)(j:j).ne.' ') go to 30
 20	continue
	j=1
 30	if(i.eq.1) then
	  specf(k:)=speca(i)(1:j)
	  k=k+j
	else
	  specf(k:)=','//speca(i)(1:j)
	  k=k+j+1
	endif
 10	continue
	return
	end
c
 	subroutine cpbuf2(rdata,factor,idata2,nx,ny,ndim,locbuf)
c
	integer*2 idata2
	dimension rdata(ndim,ndim),idata2(1)
c
	do 10 j=1,ny
	do 10 i=1,nx
	idata2(locbuf)=rdata(i,j)/factor
	locbuf=locbuf+1
 10	continue
	return
	end
c
 	subroutine cpbuf4(rdata,factor,idata4,nx,ny,ndim,locbuf)
c
	integer*4 idata4
	dimension rdata(ndim,ndim),idata4(1)
c
	do 10 j=1,ny
	do 10 i=1,nx
	idata4(locbuf)=rdata(i,j)/factor
	locbuf=locbuf+1
 10	continue
	return
	end
c
c  skysb2/4 
c  set data outside the solar disk to be 'undilled datapoints'
c  
	subroutine skysb2(idata2,nx,ny,ndim,skylvl)
c
	include 'sys.fc'
	integer*2 idata2(ndim,ny)
	integer skylvl
c
	do 1000 j=1,ny
	do 1000 i=1,nx
	if (idata2(i,j).le.skylvl) idata2(i,j)=iufl2
 1000	continue
	return
	end
c  
	subroutine skysb4(idata4,nx,ny,ndim,skylvl)
c
	include 'sys.fc'
	integer*4 idata4(ndim,ny)
	integer skylvl
c
	do 1000 j=1,ny
	do 1000 i=1,nx
	if (idata4(i,j).le.skylvl) idata4(i,j)=iufl4
 1000	continue
	return
	end
c
c  mapping from sine(latitude) to arcsin(latitude)
c
	subroutine synop(rdata1,ndim,nymax,
     &              nx0,ny0,xs0,ys0,dx0,dy0,
     &              nx, ny, xs, ys, dx, dy)
c
	include 'sys.fc'
	include 'mdata.fc'
	dimension rdata1(ndim,1),buf(MX)
      data halfpi/1.5707963/
c
	if(ys0.le.-1.0) then 
	  ys=-halfpi
	else if(ys0.ge.1.0) then
	  ys=halfpi
	else
	  ys=yofal(asin(ys0))
	endif
	ye0=ys0+dy0*float(ny0-1)
	if(ye0.le.-1.0) then 
	  ye=-halfpi
	else if(ye0.ge.1.0) then
	  ye=halfpi
	else
	  ye=yofal(asin(ye0))
	endif
	dy=yofal(dy0)
	ny=(ye-ys)/dy+1
	dy=(ye-ys)/float(ny-1)
c
	if(ny.gt.nymax) then
	  write(msg,*) '(subr.synop ) error: new ny gt nymax'
	  write(msg,*) '      newny,nymax=',ny,nymax
	  errflg=2
	  return
	endif
c
	do 1000 i=1,nx
	do 1100 j=1,ny0
 1100	buf(j)=rdata1(i,j)
	do 1000 j=1,ny-1
	y = ys + dy*float(j-1)
	sinl=sin(alofy(y))
c  sinl = ys0 + dy0*float(j-1)
	dj=(sinl-ys0)/dy0 +1.0
	j1 = dj
	dj = dj -float(j1)
	if(j1.eq.0) then
	  j1=1
	  j2=2
	  dj=dj-1.0
	else if(j1.eq.ny0) then
	  j1=j1-1
	  j2=j1+1
	  dj=dj+1.0
	else
	  if(j1.lt.0.or.j1.gt.ny0) then
	    write(msg,*) '(subr.synop ) error: j1,dj=',j1,dj
	    errflg=2
	    return
	  endif
	  j2=j1+1
	endif
	rdata1(i,j)=(1.0-dj)*buf(j1)+dj*buf(j2)
 1000	continue
c
	return
	end
c
c  trim trailing quote
c
	character*20 function trimq(str)
c
	character str*(*)
c
	ll=len(str)
	if (ll.eq.0) go to 20
	do 10 i=1,ll
	if(str(i:i).eq.'''') str(i:i)=' '
 10	continue
 20	trimq=str
	return
	end
