c  assignment of footpoints
c
	subroutine fptflx
c
c  Number of footpoints is proportional to the magnetic flux.
c  For s1-source:
c    footpoints are on concentric circles centered at each elementary
c    source.
c  Array nfd contains the number of circles.
c  Array fd contains:
c    radius of the circle (normalized to the radius of the coil),
c    position angle of the first footpoint on the circle,
c    number of footpoints on the circle.
c
	include 'sys.fc'
	include 'coord.fc'
	include 'fline.fc'
	include 'mdata.fc'
	include 'ss.fc'
	include 's1.fc'
	include 's2.fc'
	include 'mparam.fc'
	include 'lparam.fc'
c
c  hdata are declared in mdata.fc as an array of (MX2,MY2,4)
c
      dimension fdata(MX2,MY2),ndata(MX2,MY2)
      equivalence (fdata(1,1),hdata(1,1,1)),(ndata(1,1),hdata(1,1,2))
c
	character*1 chrp,chrm,chr
	integer*4 kindl1
	dimension xu(3),yu(3),dummy1(3),dummy2(3)
	dimension ni(13),nj(13)
	dimension nfd(61),fd(15,61),fd1(15,19),fd2(15,19),fd3(15,19),
     &	          fd4(15,4)
	equivalence (fd(1,1),fd1(1,1)),
     &	            (fd(1,20),fd2(1,1)),
     &	            (fd(1,39),fd3(1,1)),
     &	            (fd(1,58),fd4(1,1))
c
	data ni/1,2,2,4,4,8,8,16,16,32,32,64,64/,
     &	     nj/1,1,2,2,4,4,8, 8,16,16,32,32,64/
c
	data nfd/3*1,6*2,12*3,18*4,22*5/
	data fd1/ 0.,0.,1.,12*0.,
     2	  .25,0.,2.,12*0.,
     3	  .25,0.,3.,12*0.,
     4	  0.,0.,1.,.5,0.,3.,9*0.,
     5	  0.,0.,1.,.5,0.,4.,9*0.,
     6	  0.,0.,1.,.5,0.,5.,9*0.,
     7	  0.,0.,1.,.5,0.,6.,9*0.,
     8	  .25,0.,2.,.6,90.,6.,9*0.,
     9	  .25,0.,3.,.6,90.,6.,9*0.,
     &	  0.,0.,1.,.3,0.,3.,.7,90.,6.,6*0.,
     1	  0.,0.,1.,.3,0.,3.,.7, 0.,7.,6*0.,
     2	  0.,0.,1.,.3,0.,3.,.7,90.,8.,6*0.,
     3	  0.,0.,1.,.3,0.,4.,.7,0.,8.,6*0.,
     4	  0.,0.,1.,.3,0.,4.,.7,0.,9.,6*0.,
     5	  0.,0.,1.,.3,0.,4.,.7,0.,10.,6*0.,
     6	  0.,0.,1.,.3,0.,5.,.7,0.,10.,6*0.,
     7	  0.,0.,1.,.3,0.,5.,.7,0.,11.,6*0.,
     8	  0.,0.,1.,.3,0.,5.,.7,0.,12.,6*0.,
     9	  0.,0.,1.,.3,0.,6.,.7,0.,12.,6*0./
	data fd2/ .15,90.,2.,.4,0.,6.,.8,0.,12.,6*0.,
     1	  .15, 0.,3.,.4,0.,6.,.8,0.,12.,6*0.,
     2	  0.,0.,1.,.3 , 0.,3.,.6,0.,6.,.9,0.,12.,3*0.,
     3	  0.,0.,1.,.3 , 0.,3.,.6,0.,6.,.9,0.,13.,3*0.,
     4	  0.,0.,1.,.3 , 0.,3.,.6,0.,7.,.9,0.,13.,3*0.,
     5	  0.,0.,1.,.3 , 0.,3.,.6,0.,7.,.9,0.,14.,3*0.,
     6	  0.,0.,1.,.3 , 0.,3.,.6,0.,8.,.9,0.,14.,3*0.,
     7	  0.,0.,1.,.3 ,90.,4.,.6,0.,8.,.9,0.,14.,3*0.,
     8	  0.,0.,1.,.3 ,90.,4.,.6,0.,8.,.9,0.,15.,3*0.,
     9	  0.,0.,1.,.3 ,90.,4.,.6,0.,9.,.9,0.,15.,3*0.,
     &	  0.,0.,1.,.3 ,90.,4.,.6,0.,9.,.9,0.,16.,3*0.,
     1	  0.,0.,1.,.3 ,90.,4.,.6,0.,10.,.9,0.,16.,3*0.,
     2	  0.,0.,1.,.3 , 0.,5.,.6,0.,10.,.9,0.,16.,3*0.,
     3	  0.,0.,1.,.3 , 0.,5.,.6,0.,10.,.9,0.,17.,3*0.,
     4	  0.,0.,1.,.3 , 0.,5.,.6,0.,11.,.9,0.,17.,3*0.,
     5	  0.,0.,1.,.3 , 0.,5.,.6,0.,11.,.9,0.,18.,3*0.,
     6	  0.,0.,1.,.3 , 0.,5.,.6,0.,12.,.9,0.,18.,3*0.,
     7	  0.,0.,1.,.3 ,90.,6.,.6,0.,12.,.9,0.,18.,3*0.,
     8	  .1,0.,2.,.3 ,90.,6.,.6,0.,12.,.9,0.,18.,3*0./
	data fd3/ .1,0.,3.,.3,90.,6.,.6,0.,12.,.9,0.,18.,3*0.,
     &	  0.,0.,1.,.25,0.,3.,.5,90.,6.,.75,0.,12.,1.,0.,18.,
     1	  0.,0.,1.,.25,0.,3.,.5,90.,6.,.75,0.,12.,1.,0.,19.,
     2	  0.,0.,1.,.25,0.,3.,.5,90.,6.,.75,0.,13.,1.,0.,19.,
     3	  0.,0.,1.,.25,0.,3.,.5, 0.,7.,.75,0.,13.,1.,0.,19.,
     4	  0.,0.,1.,.25,0.,3.,.5, 0.,7.,.75,0.,13.,1.,0.,20.,
     5	  0.,0.,1.,.25,0.,3.,.5, 0.,7.,.75,0.,14.,1.,0.,20.,
     6	  0.,0.,1.,.25,0.,3.,.5,90.,8.,.75,0.,14.,1.,0.,20.,
     7	  0.,0.,1.,.25,0.,4.,.5,90.,8.,.75,0.,14.,1.,0.,20.,
     8	  0.,0.,1.,.25,0.,4.,.5,90.,8.,.75,0.,14.,1.,0.,21.,
     9	  0.,0.,1.,.25,0.,4.,.5,90.,8.,.75,0.,15.,1.,0.,21.,
     &	  0.,0.,1.,.25,0.,4.,.5, 0.,9.,.75,0.,15.,1.,0.,21.,
     1	  0.,0.,1.,.25,0.,4.,.5, 0.,9.,.75,0.,15.,1.,0.,22.,
     2	  0.,0.,1.,.25,0.,4.,.5, 0.,9.,.75,0.,16.,1.,0.,22.,
     3	  0.,0.,1.,.25,0.,4.,.5,90.,10.,.75,0.,16.,1.,0.,22.,
     4	  0.,0.,1.,.25,0.,5.,.5,90.,10.,.75,0.,16.,1.,0.,22.,
     5	  0.,0.,1.,.25,0.,5.,.5,90.,10.,.75,0.,16.,1.,0.,23.,
     6	  0.,0.,1.,.25,0.,5.,.5,90.,10.,.75,0.,17.,1.,0.,23.,
     7	  0.,0.,1.,.25,0.,5.,.5, 0.,11.,.75,0.,17.,1.,0.,23./
	data fd4/
     8	  0.,0.,1.,.25,0.,5.,.5, 0.,11.,.75,0.,17.,1.,0.,24.,
     9	  0.,0.,1.,.25,0.,5.,.5, 0.,11.,.75,0.,18.,1.,0.,24.,
     &	  0.,0.,1.,.25,0.,5.,.5, 0.,12.,.75,0.,18.,1.,0.,24.,
     1	  0.,0.,1.,.25,0.,6.,.5, 0.,12.,.75,0.,18.,1.,0.,24./
	data chrp/'+'/, chrm/'-'/
	data pi/3.141592/
c
c  calculation of flux
c
	kindl1=mod(kindl,1000)
	if(nf0.le.0) go to 5000
	nf=nf0
c
	flux1=0.0
	if (ns1.gt.0) then
	  do 1000 l=1,ns1
	  if(aa1(l).gt.0.0) then
	    r=aa1(l)
	  else
	    r=sqrt((xxs1(1,l)-xxc1(1,l))**2
     &	    +(xxs1(2,l)-xxc1(2,l))**2
     &	    +(xxs1(3,l)-xxc1(3,l))**2)
	  endif
	  flux1=flux1+abs(pi*bn1(l)*r**2)**flxpwr
 1000	  continue
	endif
c
	flux2=0.0
	flxmax=0.0
	aa2max=0.0
	if (ns20.gt.0) then
	  do 1200 j=1,ny
	  do 1200 i=1,nx
	  l=nx*(j-1)+i
	  flx=abs(flx20(l))**flxpwr
	  if(abs(flx).gt.flxmax) flxmax=abs(flx)
	  if(aa2(l).gt.aa2max) aa2max=aa2(l)
 1200	  flux2=flux2+flx
	endif
	ratio1=float(nf)/(flux1+flux2)
	ratio2=ratio1
	nf=0
c
c     assign footpoints for s1-sources
c
	if(ns1.eq.0) go to 2900
	if(msglvl.gt.1) write(lst,110)
 110	  format(/1h ,'source no.',5x,'nf',5x,'polarity',10x,'flux')
c
	do 2000 l=1,ns1
	if(aa1(l).gt.0.0) then
	  r=aa1(l)
	else
	  r=sqrt((xxs1(1,l)-xxc1(1,l))**2
     &        +(xxs1(2,l)-xxc1(2,l))**2
     &	  +(xxs1(3,l)-xxc1(3,l))**2)
	endif
	flx1=pi*bn1(l)*r**2
	flux=ratio1*abs(flx1)**flxpwr
	if(flux.lt.1.0) flux=1.0
	if(flux.gt.61.0) flux=61.0
	iflux=flux+0.5
	if(aa1(l).eq.0.0) go to 2000
c
c  dipoles are mostly put at the center of the sphere(s) and used
c  to represent the general field of the sun or stars
c  this situation makes the unit vectors ill-defined
c  further, this routine can anyway generate footpoints near
c  either north or south pole
c  therefore, for dipoles, no footpoints are assigned
c
	nd1=nfd(iflux)
	if(cj1(l).gt.0.0) chr=chrp
	if(cj1(l).lt.0.0) chr=chrm
	r=sqrt((xxs1(1,l)-xxc1(1,l))**2+(xxs1(2,l)-xxc1(2,l))**2
     &	      +(xxs1(3,l)-xxc1(3,l))**2)
	if(aa1(l).gt.r) r=aa1(l)
c
	if( nsp.gt.1) then
	  eps=1.0e-2
	  nsp1=0
	  do 10 n=1,nsp
	  if(highm(n,xxc1(1,l)).gt.eps) go to 10
	  nsp1=n
	  call ctorm(n, xxc1(1,l), apr,alr,h )
	  call rvum(n, apr,alr, xu, dummy1, dummy2 )
 10	  continue
	  if(nsp1.eq.0) then
	    write(msg,*)
     &	  '(subr.fptflx) error: no nearby sphere was found'
	    errflg=2
	    return
	  endif
c
	elseif( kindl1.eq.0) then
	  xu(1)=1.0
	  if(xxc1(1,l).lt.0.0) xu(l)=-1.0
	  xu(2)=0.0
	  xu(3)=0.0
	elseif( mod(kindl1,10).eq.1) then
	  xu(1)=xtu(1)
	  xu(2)=xtu(2)
	  xu(3)=xtu(3)
	elseif( mod(kindl1,10).eq.2 ) then
	  call ctos( xxc1(1,l), ap,al,h )
	  call svu( ap,al, xu, dummy1, dummy2 )
	elseif( kindl1.eq.103 ) then
	  call ctor( xxc1(1,l), apr,alr,h )
	  call rvu( apr,alr, xu, dummy1, dummy2 )
	endif
c
	yu(1)=direc1(2,l)*xu(3)-direc1(3,l)*xu(2)
	yu(2)=direc1(3,l)*xu(1)-direc1(1,l)*xu(3)
	yu(3)=direc1(1,l)*xu(2)-direc1(2,l)*xu(1)
c
	if(msglvl.gt.1) write(lst,100)  l,iflux,chr,flx1
 100	  format(2x, i6,i11,t28,a1,1pe20.5)
c
	do 2100 n=1,nd1
	n1=3*n-2
	n2=3*n-1
	n3=3*n
	nth0=ifix(fd(n3,iflux))
	r1=fd(n1,iflux)
	th0=fd(n2,iflux)
	do 2100 nth=1,nth0
	th=3.141592/180.0*(th0+360.0/float(nth0)*float(nth-1))
	nf=nf+1
	foot(1,nf)=xxc1(1,l)+xu(1)*r*r1*cos(th)+yu(1)*r*r1*sin(th)
	foot(2,nf)=xxc1(2,l)+xu(2)*r*r1*cos(th)+yu(2)*r*r1*sin(th)
	foot(3,nf)=xxc1(3,l)+xu(3)*r*r1*cos(th)+yu(3)*r*r1*sin(th)
c
	if (nsp.gt.1) then
	  call ctorm(nsp1, foot(1,nf),apr,alr,h)
	  call rtocm(nsp1, apr,alr, 0.0, foot(1,nf))
	elseif (mod(kindl1,10).ge.2) then
	  call ctos(foot(1,nf),ap,al,h)
	  call stoc(ap,al,0.0,foot(1,nf))
	endif
 2100	continue
 2000	continue
 2900	continue
	nf1=nf
c
c  assign footpoints for s2-sources
c
	if(nx.le.0.or.ny.le.0) go to 5000
	if(msglvl.gt.1) write(lst,*)
     &	  '(subr.ftpflx) initial ratio2=',ratio2
	if(flxmax*ratio2.lt.1.0) then
	  ratio2=1.5/flxmax
	  if(msglvl.gt.1)
     &	write(lst,*) '(subr.ftpflx) revised ratio2=',ratio2
	endif
	loop=0
 4000	continue
c
	do 3000 j=1,ny
	do 3000 i=1,nx
	l=nx*(j-1)+i
	ndata(i,j)=0
 3000	fdata(i,j)=ratio2*abs(flx20(l))**flxpwr
c
	do 3100 lvl=1,13
	xs1=xs+0.5*float(ni(lvl)-1)*dx
	ys1=ys+0.5*float(nj(lvl)-1)*dy
	nx1=((nx-1)/ni(lvl))*ni(lvl)+1
	ny1=((ny-1)/nj(lvl))*nj(lvl)+1
c
	do 3400 j1=1,ny1,nj(lvl)
	do 3400 i1=1,nx1,ni(lvl)
	f=0.0
	fx=0.0
	fy=0.0
	area=0.0
	do 3300 j2=1,nj(lvl)
	do 3300 i2=1,ni(lvl)
	l=nx*(j1+j2-2)+i1+i2-1
	f=f+fdata(i1+i2-1,j1+j2-1)
	fx=fx+float(i2-1)*fdata(i1+i2-1,j1+j2-1)
	fy=fy+float(j2-1)*fdata(i1+i2-1,j1+j2-1)
	area=area+aa2(l)**2
 3300	continue
	aa2avr=sqrt(area)
	if(aa2avr.gt.4.0*aa2max) go to 3400
c  since element size is smaller near the poles, size of the combined
c  elements is allowed to be up to aa2max
c  aa2max is the largest radius of elements (near the equator)
	if(f.ne.0.0) then
	  fx=fx/f
	  fy=fy/f
c  calculate center of gravity
	endif
c
cx	n=f
	if(f.lt.1.0) go to 3400
	i=( xs1+dx*(float(i1-1)+fx)-xs )/dx+1.5
	j=( ys1+dy*(float(j1-1)+fy)-ys )/dy+1.5
	do 3350 j2=1,nj(lvl)
	do 3350 i2=1,ni(lvl)
 3350	fdata(i1+i2-1,j1+j2-1)=(f-1.0)/f*fdata(i1+i2-1,j1+j2-1)
c  sum of fdata is reduced from f to f-1
cx	fdata(i,j)=fdata(i,j)-float(n)
	if(ndata(i,j).eq.0) then
	  nf=nf+1
	  if(nf.gt.NFMAX) then
	    nf=NFMAX
	    nf2=nf-nf1
	    if(msglvl.gt.0)
     &	write(lst,*) '(subr.fptflx) warning: nf=nfmax'
	    go to 3200
	  endif
c
	  call gridpt(i,j,foot(1,nf),xs,ys,dx,dy,mesh)
	  ndata(i,j)=(2+lvl)/2
	endif
 3400	continue
 3100	continue
 3200	continue
c
	if(msglvl.gt.1) write(lst,*)
     &	'(subr.fptflx) loop=',loop,', nf,nf0,ratio2=',nf,nf0,ratio2
	if( loop.lt.30 .and.
     &	 (nf-nf1.lt.int(0.9*float(nf0-nf1)) .or. 
     &	  nf-nf1.gt.int(1.1*float(nf0-nf1)) ) ) then
	  ratio2=ratio2*
     &	  (0.5+0.5*sqrt(abs(float(nf0-nf1)/float(nf-nf1+1))))
	  loop=loop+1
	  nf=nf1
	  go to 4000
	endif
c
	nf2=nf-nf1
	if(msglvl.gt.1) write(lst,*)
     &	  '(subr.fptflx) footpoints for s2: nf2=',nf2 
 3600	continue
c
	if(msglvl.gt.2) then
	  do 3500 j=1,ny
	  jj=ny+1-j
 3500	  write(lst,350) jj,(ndata(i,j),i=1,nx)
 350	  format(2x, i3,2x,10(10i1,1x),(/7x,10(10i1,1x)))
	endif
c
 5000	continue
	if(msglvl.gt.0) write(lst,*)
     &	  '(subr.fptflx) generated footpoints: nf=',nf ,
     &        ', flxpwr=',flxpwr
	return
	end
c
c  read field line file and set reference footpoints
c
	subroutine fptref( iunit )
c
	include 'sys.fc'
	include 'coord.fc'
	include 'fline.fc'
	include 'fileio.fc'
	include 'lparam.fc'
	integer iunit
	integer*4 kindl1
	logical update
c
	if( iunit.eq.0 ) return
c
	update=.false.
	call readlh(iunit,update)
	kindl1=mod(kindli,1000)
	nf=0
c
 1	continue
	call readl(iunit,np,xyzp)
	if( np.eq.0 ) go to 9
	if(irefpt.eq.1.or.irefpt.eq.3) then
	  nf=nf+1
	  do 10 m=1,3
 10	  foot(m,nf)=xyzp(m,1)
	  if(mod(kindl1,10).eq.1) then
	    call projt(foot(1,nf),xt,yt)
	  else if(mod(kindl1,10).eq.2) then
	    call projs(foot(1,nf),ap,al)
	  else if(kindl1.eq.103) then
	    call projr(foot(1,nf),ap,al)
	  endif
	endif
c
	if(irefpt.eq.2.or.irefpt.eq.3) then
	  nf=nf+1
	  do 20 m=1,3
 20	  foot(m,nf)=xyzp(m,np)
	  if(mod(kindl1,10).eq.1) then
	    call projt(foot(1,nf),xt,yt)
	  else if(mod(kindl1,10).eq.2) then
	    call projs(foot(1,nf),ap,al)
	  else if(kindl1.eq.103) then
	    call projr(foot(1,nf),ap,al)
	  endif
	endif
	go to 1
c
 9	if(msglvl.gt.0) write(lst,*)
     &	  '(subr.fptref) footpoints from file: nf=',nf,
     &	  ', irefpt=',irefpt
	kindl=10000 + kindl
  	return
	end
c
c  gridpoint at the (i,j)-th s2-source
c  return value xx is in cartesian
c  the current grid system is specified by xs1,ys1,dx1,dy1,mesh1
c
	subroutine gridpt(i,j,xx,xs1,ys1,dx1,dy1,mesh1)
c
	include 'sys.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'mparam.fc'
c
	dimension xx(3),xx1(3)
c
	fx = i
	fy = j
	go to 1
c
c  entry gridfp is for fractional values of footpoint indices (fi,fj)
c
	entry gridfp(fi,fj,xx,xs1,ys1,dx1,dy1,mesh1)
c
	fx = fi
	fy = fj
 1	continue
c
	xx1(1)=xs1+dx1*(fx - 1.0)
	xx1(2)=ys1+dy1*(fy - 1.0)
	xx1(3)=0.0
	xx(1)=xx1(1)
	xx(2)=xx1(2)
	xx(3)=xx1(3)
c
	if( mesh1.eq.0 ) then
	  call dtoc(xx1,xx)
	elseif( mesh1.eq.1) then
	  call ttoc(xx1,xx)
	elseif( mesh1.eq.2 ) then
	  ap=xx1(1)
	  al=alofy(xx1(2))
	  call stoc(ap,al,0.0, xx)
	elseif( mesh1.ge.3 ) then
	  apr=xx1(1)
	  alr=alofy(xx1(2))
	  call rtoc(apr,alr,0.0, xx)
	elseif( mesh1.eq.-1 ) then
	  call projt(xx,xt,yt)
	elseif( mesh1.eq.-2 ) then
	  call projs(xx,ap,al)
	endif
c
	return
	end

