c  generate a simulated magnetogram made of a delta function 
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	integer uin,uout
	character*80 fname1,fname2,chr
	logical alloc
	rad(deg1)=3.141592*deg1/180.0
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	chr='0'
        if(myargc().eq.1) call myargv(1,chr)
        if(chr.eq.'1') then
          msglvl=1
        else if(chr.eq.'2') then
          msglvl=2
        else if(chr.eq.'3') then
          msglvl=3
        else
          msglvl=0
        endif
c
	include 'sysconf.cfg'
	call initfc
c
	if(mycode.eq.0 .or. myint.eq.0) stop
	nbytem=sign(2,myint)
c
	lrec0=80
	uout=97
	uin=98
c
	xtod=0.0
	ytod=0.0
	kindm=1
	mesh=0
	rsp=70.0
c
	call getfn('DELTA',fname1)
	call openfl(other1,'DELTA',uin,fname1,text,rdo,0)
	read(uin,'(a)') fname2
	read(uin,*) kindm,mesh,xtod,ytod
c  if mesh=1, xtod and ytod should be given
	read(uin,*) nx,ny,xs,ys,dx,dy,rsp
	if(mesh.ge.2) then
	  xs=rad(xs)
	  ys=rad(ys)
	  dx=rad(dx)
	  dy=rad(dy)
	endif
c
	call openfl(other2,'GMGRAM',uout,fname2,export,wrt,lrec0)
c
	ypos=0.0
	pdeg=0.0
	b0deg=0.0
	cl0deg=0.0
	xxsp(1)=0.0
	xxsp(2)=0.0
	xxsp(3)=-rsp
	call setdu
	tsys='GMT+09'
	inst='DUMMY'
	wavel=5250.0
	mfile='DELTA '
	dateo=' '
	stime=' '
	etime=' '
	ftag=' '
	kindmo=kindm
c
	alloc=.true.
	call umake(kindm,m5,m4,m3,m2,m1)
	if(m5.eq.2) then
	  kx=newk(lspec('BPH'),alloc)
	  ky=newk(lspec('BTH'),alloc)
	  kz=newk(lspec('BR'),alloc)
	else
	  kx=newk(lspec('BX'),alloc)
	  ky=newk(lspec('BY'),alloc)
	  kz=newk(lspec('BL'), alloc)
	endif
c
	if(kx.eq.0.or.ky.eq.0.or.kz.eq.0) then
	  write(msg,*) '(proc.gendlt) error: kx,ky,kz=',kx,ky,kz
	  stop
	endif
c
	do 10 j=1,ny
	do 10 i=1,nx
	rdata(i,j,kx)=0.0
	rdata(i,j,ky)=0.0
	rdata(i,j,kz)=0.0
 10	continue
	factm(lspecs(kx))=0.2
	factm(lspecs(ky))=0.2
	factm(lspecs(kz))=0.2
c
	write(lst,*) 'delta function source(s):'
	write(lst,*) '  kindm,mesh=',kindm,mesh
	write(lst,*) '  nx,ny=',nx,ny
	write(lst,*) '  xs,ys=',xs,ys
	write(lst,*) '  dx,dy=',dx,dy
c
	ns=0
 20	read(uin,*) i0,j0,b
	if(i0.gt.0) then
	  ns=ns+1
	  rdata(i0,j0,kz)=b
	  write(lst,*) '  location (i,j)=',i0,j0,', b=',b
	  go to 20
	endif
c
	write(title,100) ns
 100	format(i2,' DELTA FUNCTION SOURCE(S)')
c
	call writem (uout)
c
	stop
	end
