c  generate a simulated magnetogram based on a dipole field
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	include 'auxparam.fc'
	integer uin,uout
	dimension xx(3),bb1(3),bb2(3),dir(3),xxs(3)
	character*80 fname1,fname2,chr
	logical alloc
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	chr='0'
        if(myargc().eq.1) call myargv(1,chr)
        if(chr.eq.'1') then
          msglvl=1
        else if(chr.eq.'2') then
          msglvl=2
        else if(chr.eq.'3') then
          msglvl=3
        else
          msglvl=0
        endif
c
	include 'sysconf.cfg'
	call initfc
c
	if(mycode.eq.0 .or. myint.eq.0) stop
	nbytem=sign(2,myint)
c
	uin=98
	uout=97
	lrec0=80
c
	mesh=0
	rsp=70.0
c  the following are not set in readdp because solar.fc is not included there
	ypos=0.0
	pdeg=0.0
	b0deg=0.0
	cl0deg=0.0
c
	call getfn('DIPOLE',fname1)
	call openfl(other1,'DIPOLE',uin,fname1,text,rdo,0)
	call readdp(uin,iproj,kindm,nx,ny,xs,ys,dx,dy,rsp)
	read(uin,'(a)') fname2
	close (uin)
c
c  kindm =2 - pseudo-vector
c        =3 - real vector
c  bx,by,bz are evaluated on the following meshes
c  iproj=0: plane, face-on
c        1: plane, oblique
c        2: sphere, with mirror source (bl=0 at the plane of the sky)
c        3: sphere, no mirror source
c          (assume p=b0=0, which is different from mesh=3)
c
	do 10 i=1,3
	xxs(i)=xxsaux(i)
	dir(i)=diraux(i)
 10	continue
c 
c  source location xxsaux, diraux, and
c  mirror source xxsm and dirm have been set by readpp and 
c  passed through auxparam.fc
c
	call openfl(other2,'GMGRAM',uout,fname2,export,wrt,lrec0)
c
	tsys='GMT+09'
	inst='DUMMY'
	wavel=5250.0
	mfile='DIPOLE'
	dateo=' '
	stime=' '
	etime=' '
	ftag=' '
	write(title,100) iproj,xxs,dir 
 100	format('DIPOLE',i2,1p6e12.3)
c
	alloc=.true.
	kz=newk(lspec('BL'), alloc)
	kx=newk(lspec('BX'), alloc)
	ky=newk(lspec('BY'), alloc)
	if(kx.eq.0.0 .or. ky.eq.0 .or. kz.eq.0) then
	  write(msg,*) '(prog.gendpl) error kx,ky,kz=',kx,ky,kz
	  stop
	endif
	factm(lspecs(kx))=0.2
	factm(lspecs(ky))=0.2
	factm(lspecs(kz))=0.2
c
c  set depth and dv for energy calculation
c
      if(iproj.ge.1) then
        call ctot(xxs,xx)
        depth=-xx(3)
        dv=ztu(1)*dir(1)+ztu(2)*dir(2)+ztu(3)*dir(3)
      else
        depth=-xxs(3)
        dv=zdu(1)*dir(1)+zdu(2)*dir(2)+zdu(3)*dir(3)
      endif
      dh=sqrt(abs(1.0-dv**2))
c
c  generate magnetogram
c
        bb2(1)=0.0
        bb2(2)=0.0
        bb2(3)=0.0
	do 20 j=1,ny
	do 20 i=1,nx
	xx(1)=xs+dx*float(i-1)
	xx(2)=ys+dy*float(j-1)
	xx(3)=0.0
	if(iproj.eq.1) then
	  call projt(xx,xt,yt)
	else if(iproj.eq.2) then
	  call projsr(xx,rsp)
	  call dipole(xx,bb2,psi,xxsm,dirm,dmom)
	else if(iproj.eq.3) then
	  call projsr(xx,rsp)
	endif
c
	call dipole(xx,bb1,psi,xxs,dir,dmom)
c
	rdata(i,j,kx)=bb1(1)+bb2(1)
	rdata(i,j,ky)=bb1(2)+bb2(2)
	rdata(i,j,kz)=bb1(3)+bb2(3)
 20	continue
c
	kindmo = kindm
	call writem (uout)
c
c  energy of dipole at xxs
c  (mirror dipole at xxsm is not taken into account)
c
	ulen=1.0e9
	engy=dmom**2*(dh**2+2.0*dv**2)/(32.0*depth**3)*ulen**3
	write(lst,*) 'dipole:'
	write(lst,*) '  location=',xxs
	write(lst,*) '  depth=',depth
	write(lst,*) '  moment=',dmom
	write(lst,*) '  direction=',dir
	write(lst,*) '  dv,dh=',dv,dh
	if(iproj.eq.1) 
     &write(lst,*) '  xtod,ytod=',xtod,ytod
	write(lst,*) '  nx,ny=',nx,ny
	write(lst,*) '  xs,ys=',xs,ys,'  rsp=',rsp
	write(lst,*) '  dx,dy=',dx,dy
	write(lst,*) '  data projection: iproj=',iproj
	write(lst,*) '  kindmo=',kindmo
	write(lst,*) '  energy=',engy,' erg (for plane boundary)'
c
	write(6,*) 'atmat=',atmat
	write(6,*) 'xxto=',xxto
	write(6,*) 'xxtod=',xxtod
	stop
	end
