c  generate a simulated magnetogram based on a non-force-free field
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	include 'auxparam.fc'
	integer uin,uout
	dimension xx(3),bb(3),aj(3),xxs(3),vn(3)
	character*80 fname1,fname2,chr
	logical alloc
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	chr='0'
        if(myargc().eq.1) call myargv(1,chr)
        if(chr.eq.'1') then
          msglvl=1
        else if(chr.eq.'2') then
          msglvl=2
        else if(chr.eq.'3') then
          msglvl=3
        else
          msglvl=0
        endif
c
	include 'sysconf.cfg'
	call initfc
c
	if(mycode.eq.0 .or. myint.eq.0) stop
	nbytem=sign(2,myint)
c
	uin=98
	lrec0=80
	uout=97
c
	mesh=0
	rsp=70.0
c  the following are not set in readnf because solar.fc is not included there
	ypos=0.0
	pdeg=0.0
	b0deg=0.0
	cl0deg=0.0
c
	call getfn('NONFFF',fname1)
	call openfl(other1,'NONFFF',uin,'nonfff.dat',text,rdo,0)
	call readnf(uin,iproj,kindm,nx,ny,xs,ys,dx,dy,rsp)
	read(uin,'(a)') fname2
	close (uin)
c
c  kindm =2 - pseudo-vector
c        =3 - real vector
c  bx,by,bz are evaluated on the following meshes
c  iproj=0: plane, face-on
c        1: plane, oblique
c      2,3: sphere
c
c  readnf sets kindm etc.
c  xxs and vn passed through auxparam.fc
	do 10 i=1,3
	xxs(i)=xxsaux(i)
	vn(i)=diraux(i)
 10	continue
c
	a0=a0nff
	ax=axnff
	ay=aynff
	akz=akznff
c
	call openfl(other2,'GMGRAM',uout,fname2,export,wrt,lrec0)
	tsys='GMT+09'
	inst='DUMMY'
	wavel=5250.0
	mfile='NONFFF'
	dateo='  /  /  '
	stime='  :  :  '
	etime='  :  :  '
	ftag ='  /  /    :  :  '
	write(title,100) iproj,xxs,ax,ay,akz
 100	format('NONFFF',i2,1p6e12.3)
c
	alloc=.true.
	kz=newk(lspec('BL'), alloc)
	kx=newk(lspec('BX'), alloc)
	ky=newk(lspec('BY'), alloc)
	if(iproj.eq.0) then
	  kindm=10+mod(kindm,10)
	  kj=newk(lspec('JL'), alloc)
	else if(iproj.eq.1) then
	  kindm=20+mod(kindm,10)
	  kj=newk(lspec('JN'), alloc)
	else if(iproj.eq.2) then
	  kindm=30+mod(kindm,10)
	  kj=newk(lspec('JR'), alloc)
	endif
	kindmo=kindm
c
	if(kx.eq.0.0 .or. ky.eq.0 .or. kz.eq.0 .or. kj.eq.0) then
	  write(msg,*)
     &	'(prog.gennff) error kx,ky,kz,kj=',kx,ky,kz,kj
	  stop
	endif
	factm(lspecs(kx))=0.2
	factm(lspecs(ky))=0.2
	factm(lspecs(kz))=0.2
	factm(lspecs(kj))=1.0
c
	do 30 j=1,ny
	do 30 i=1,nx
	xx(1)=xs+dx*float(i-1)
	xx(2)=ys+dy*float(j-1)
	xx(3)=0.0
	if(iproj.eq.1) then
	  call projt(xx,xt,yt)
	else if(iproj.ge.2) then
	  call projs(xx,ap,al)
	  do 32 m=1,3
 32	  vn(m)=(xx(m)-xxsp(m))/rsp
	endif
	call nonfff(xx,bb,aj,xxs,a0,ax,ay,akz)
	ajn=aj(1)*vn(1)+aj(2)*vn(2)+aj(3)*vn(3)
c
	rdata(i,j,kx)=bb(1)
	rdata(i,j,ky)=bb(2)
	rdata(i,j,kz)=bb(3)
	rdata(i,j,kj)=ajn
 30	continue
c
	call writem (uout)
c
	write(lst,*) 'nonfff:'
	write(lst,*) '  location=',xxs
	write(lst,*) '  a0=',a0
	write(lst,*) '  ax,ay,akz=',ax,ay,akz
	write(lst,*) '  data projection: iproj=',iproj
c
	stop
	end
