c  graphics-related subroutines 
c  (without direct access to graphics library)
c
c  apply 3x3 filter 'w' to rdata(*,*)
c  results are returned as bs(*,*)
c
	subroutine flt3x3(rdata,nx,ny,ndim,bs, w)
c
	dimension rdata(ndim,ndim),bs(ndim,ndim)
	dimension w(3,3)
c
	sum=0.0
	do 10 jj=1,3
	do 10 ii=1,3
 10	sum=sum+w(ii,jj)
c
	do 20 j=2,ny-1
	do 20 i=2,nx-1
	bs(i,j)= w(1,1)*rdata(i-1,j-1)
     &	      +w(1,2)*rdata(i-1,j  )
     &	      +w(1,3)*rdata(i-1,j+1)
     &	      +w(2,1)*rdata(i  ,j-1)
     &	      +w(2,2)*rdata(i  ,j  )
     &	      +w(2,3)*rdata(i  ,j+1)
     &	      +w(3,1)*rdata(i+1,j-1)
     &	      +w(3,2)*rdata(i+1,j  )
     &	      +w(3,3)*rdata(i+1,j+1)
	bs(i,j)=bs(i,j)/sum
 20	continue
c
	do 30 i=2,nx-1
	j=1
	bs(i,j)=     w(1,2)*rdata(i-1,j  )
     &	      +w(1,3)*rdata(i-1,j+1)
     &	      +w(2,2)*rdata(i  ,j  )
     &	      +w(2,3)*rdata(i  ,j+1)
     &	      +w(3,2)*rdata(i+1,j  )
     &	      +w(3,3)*rdata(i+1,j+1)
	bs(i,j)=bs(i,j)/(w(1,2)+w(1,3)+w(2,2)+w(2,3)+w(3,2)+w(3,3))
	j=ny
	bs(i,j)=     w(1,1)*rdata(i-1,j-1)
     &	      +w(1,2)*rdata(i-1,j  )
     &	      +w(2,1)*rdata(i  ,j-1)
     &	      +w(2,2)*rdata(i  ,j  )
     &	      +w(3,1)*rdata(i+1,j-1)
     &	      +w(3,2)*rdata(i+1,j  )
	bs(i,j)=bs(i,j)/(w(1,1)+w(1,2)+w(2,1)+w(2,2)+w(3,1)+w(3,2))
 30	continue
c
	do 40 j=2,ny-1
	i=1
	bs(i,j)=     w(2,1)*rdata(i  ,j-1)
     &	      +w(2,2)*rdata(i  ,j  )
     &	      +w(2,3)*rdata(i  ,j+1)
     &	      +w(3,1)*rdata(i+1,j-1)
     &	      +w(3,2)*rdata(i+1,j  )
     &	      +w(3,3)*rdata(i+1,j+1)
	bs(i,j)=bs(i,j)/(w(2,1)+w(2,2)+w(2,3)+w(3,1)+w(3,2)+w(3,3))
	i=nx
	bs(i,j)=     w(1,1)*rdata(i-1,j-1)
     &	      +w(1,2)*rdata(i-1,j  )
     &	      +w(1,3)*rdata(i-1,j+1)
     &	      +w(2,1)*rdata(i  ,j-1)
     &	      +w(2,2)*rdata(i  ,j  )
     &	      +w(2,3)*rdata(i  ,j+1)
	bs(i,j)=bs(i,j)/(w(1,1)+w(1,2)+w(1,3)+w(2,1)+w(2,2)+w(2,3))
 40	continue
c
	bs(1, 1 )=rdata(1,1)
	bs(nx,1 )=rdata(nx,1)
	bs(1, ny)=rdata(1,ny)
	bs(nx,ny)=rdata(nx,ny)
c
	return
	end
c
c  apply 5x5 filter 'w' to rdata(*,*)
c  results are returned as bs(*,*)
c  edge points are not taken care of
c
      subroutine flt5x5(rdata,nx,ny,ndim,bs, w)
c
      dimension rdata(ndim,ndim),bs(ndim,ndim)
      dimension w(5,5)
c
      sum=0.0
      do 10 jj=1,3
      do 10 ii=1,3
 10   sum=sum+w(ii,jj)
c
      do 20 j=1,ny
      do 20 i=1,nx
 20   bs(i,j)=0.0
c
      do 30 j=3,ny-2
      do 30 i=3,nx-2
c
	aux=0.0
	do 40 jj=1,5
	do 40 ii=1,5
 40	aux=aux+w(ii,jj)*rdata(i+ii-3,j+jj-3)
      bs(i,j)=aux/sum
c
 30   continue
      return
      end
c
c  find maximum value of rdata
c
	function frmax( rdata, nx, ny, ndim )
	dimension rdata(ndim,ndim)
c
	frmax=0.0
	do 10 j=1,ny
	do 10 i=1,nx
	if(rdata(i,j).gt.frmax) frmax=rdata(i,j)
 10	continue
	return
	end
c
c  find minimum value of rdata
c
	function frmin( rdata, nx, ny, ndim )
	include 'sys.fc'
	dimension rdata(ndim,ndim)
c
	frmin=0.0
	do 10 j=1,ny
	do 10 i=1,nx
	if(rdata(i,j).lt.frmin) frmin=rdata(i,j)
 10	continue
	return
	end
c
c  find maximum value of abs(rdata)
c
	function framax( rdata, nx, ny, ndim )
	dimension rdata(ndim,ndim)
c
	framax=0.0
	do 10 j=1,ny
	do 10 i=1,nx
	if(abs(rdata(i,j)).gt.framax) framax=abs(rdata(i,j))
 10	continue
	return
	end
c
c  find minimum value of abs(rdata)
c
	function framin( rdata, nx, ny, ndim )
	dimension rdata(ndim,ndim)
c
	framin=0.0
	do 10 j=1,ny
	do 10 i=1,nx
	if(abs(rdata(i,j)).lt.framin) framin=abs(rdata(i,j))
 10	continue
	return
	end
c
c  find mean value of rdata
c
	function frmean( rdata, nx, ny, ndim )
c
	include 'sys.fc'
c
	dimension rdata(ndim,ndim)
c
	frmean=0.0
	count=0.0
	do 10 j=1,ny
	do 10 i=1,nx
	if(rdata(i,j).eq.ufl) go to 10
	frmean=frmean+rdata(i,j)
	count=count+1.0
 10	continue
	if(count.ne.0.0) frmean=frmean/count
	return
	end
c
	real function loglvl(bval,bmin,bmax)
c
c  bval=bmin --> return loglvl=0.0
c  bval=bmax --> return loglvl=1.0
c
	include 'sys.fc'
c
	loglvl=0.0
	if(bval.eq.0.0 .or. bval.eq.ufl) return
	if(bmin.le.0.0 .or. bmax.le.0.0) then
	  write(msg,*) '(func.loglbl) error: bmin,bmax=',bmin,bmax
	  errflg=2
	  return
	endif
	bval0=alog(abs(bval)/bmin)/alog(bmax/bmin)
	if(bval0.lt.0.0) bval0=0.0
	if(bval0.gt.1.0) bval0=1.0
	loglvl=sign(bval0,bval)
	return
	end
c
c  adjust contour levels
c  abs(nlevel) : number of contour levels
c  plevel : positive contour levels, plevel(1)=min, plevel(abs(nlevel))=max
c  mlevel = -plevel : negative contour levels
c  adjustment is done if
c     nlevel<0 and
c     max(rdata) gt 10*max(plevel) or max(rdata) lt min(plevel)
c  plevel and mlevels may be updated by this routine
c  final plevel is converted to a packed string
c (like str='1,2,5,10,20,50,100')
c
c  obsolete: use lvl125
c
	subroutine lvladj(nx,ny,ndim,rdata,nlevel,plevel,mlevel,str)
	real mlevel
	dimension rdata(ndim,ndim),plevel(20),mlevel(20)
	character str*(*),buf*10
c
	n=iabs(nlevel)
	if(nlevel.gt.0) go to 1
	valmax=frmax(rdata,nx,ny,ndim)
	if(valmax.eq.0.0 .or. plevel(n).le.0.0) go to 1
c
	f=log10(valmax/plevel(n))  
	if(f.gt.1.0) then
	  f=10.0**int(f)
	  do 20 i=1,n
	  plevel(i)=f*plevel(i)
	  mlevel(i)=f*mlevel(i)
 20	  continue
	  go to 1
	endif
c
	if(plevel(1).eq.0.0) go to 1
	f=log10(plevel(1)/valmax)
	if(f.gt.1.0) then
	  f=10.0**(int(f)+1)
	  do 30 i=1,n
	  plevel(i)=plevel(i)/f
	  mlevel(i)=mlevel(i)/f
 30	  continue
	  go to 1
	endif
c
 1	continue
	ip=1
	str=' '
	do 40 i=1,n
c  levels greater than 10 are in integers (e.g. 10,20,50,,,,)
	if(plevel(i).ge.10.0) then
	  ii=plevel(i)+0.1
	  write(buf,'(i10)') ii
	  do 50 j=1,10
	  if(buf(j:j).ne.' ') go to 51
 50	  continue
	  j=10
 51	  str(ip:)=buf(j:10)//','
	  ip=ip+(12-j)
c  levels between 1 and 10 are in f3.1 (e.g. 1.0, 2.5,,,,)
	else if(plevel(i).ge.1.0) then
	  cl=plevel(i)+0.01
	  write(buf,'(f3.1)') cl
	  str(ip:)=buf(1:3)//','
	  ip=ip+4
	else
C  levels smaller than 1.0 have two digits (e.g. 0.011, 0.02,,,,)
	  cl = plevel(i)*1.000001
	  write(buf,'(f9.7)') cl
	  do 60 j=3,7
	  if(buf(j:j).ne.'0') go to 61
 60	  continue
	  j=7
 61	  do 62 jj=j,j+2
	  if(buf(jj:jj).eq.'0') go to 63
 62	  continue
	  jj=j+3
 63	  str(ip:)=buf(1:jj-1)//','
	  ip=ip+jj
	endif
 40	continue
	str(ip-1:ip-1)=' '
	return
	end
c
c  generate contour levels
c  if nlevel<0, contour levels which are multiples of 1,2,5 are
c  generated
c  abs(nlevel) : number of contour levels
c  plevel : positive contour levels, plevel(1)=min,
c           plevel(abs(nlevel))=max
c  mlevel = -plevel : negative contour levels
c  plevel and mleves may be updated by this routine
c  final plevel is converted to a packed string
c (like str='1,2,5,10,20,50,100')
c
c  if nlevel>0, this routine only generates str.
c
	subroutine lvl125(nx,ny,ndim,rdata,nlevel,plevel,mlevel,str)
	real mlevel
	dimension rdata(ndim,ndim),plevel(1),mlevel(1),clevel(3)
	character str*(*),buf*10
	data clevel/1.0,2.0,5.0/
c
	n=iabs(nlevel)
	if(nlevel.gt.0) go to 1
	valmax=framax(rdata,nx,ny,ndim)
	if(valmax.eq.0.0) go to 1
c
	f=log10(valmax)
	dex=10.0**int(f)
	f=valmax/dex
	if(f.gt.clevel(3)) then
	  ist=2
	elseif(f.gt.clevel(2)) then
	  ist=1
	else
	  ist=0
	endif
c
	do 10 i=n,1,-1
	plevel(i)=clevel(mod(3*n+ist+i-n,3)+1)*dex
	mlevel(i)=-plevel(i)
	if(mod(3*n+ist+i-n,3).eq.0) dex=dex/10.0
 10	continue
c
 1	continue
	ip=1
	str=' '
	do 20 i=1,n
c  levels greater than 10 are in integers (e.g. 10,20,50,,,,)
	if(plevel(i).ge.10.0) then
	  ii=plevel(i)+0.1
	  write(buf,'(i10)') ii
	  do 30 j=1,10
	  if(buf(j:j).ne.' ') go to 31
 30	  continue
	  j=10
 31	  str(ip:)=buf(j:10)//','
	  ip=ip+(12-j)
c  levels between 1 and 10 are in f3.1 (e.g. 1.0, 2.5,,,,)
	else if(plevel(i).ge.1.0) then
	  write(buf,'(f3.1)') plevel(i)
	  str(ip:)=buf(1:3)//','
	  ip=ip+4
	else
	  cl = plevel(i)*1.000001
	  write(buf,'(f9.7)') cl
	  do 40 j=3,7
	  if(buf(j:j).ne.'0') go to 41
 40	  continue
	  j=7
 41	  do 42 jj=j,j+2
	  if(buf(jj:jj).eq.'0') go to 43
 42	  continue
	  jj=j+3
 43	  str(ip:)=buf(1:jj-1)//','
	  ip=ip+jj
	endif
 20	continue
	str(ip-1:ip-1)=' '
	return
	end
c
c  1-d spline fit y=y(x)
c  dy=dy/dx
c
	subroutine splin1(n,dx,y,dy,a,b,c)
	dimension y(n),dy(n),a(n),b(n),c(n)
c
	a(1)=0.0
	b(1)=2.0
	c(1)=1.0
	dy(1)=3.0*(y(1+1)-y(1))/dx
	a(n)=1.0
	b(n)=2.0
	c(n)=0.0
	dy(n)=3.0*(y(n)-y(n-1))/dx
	dxm=dx
	do 10 i=2,n-1
	a(i)=1.0
	b(i)=2.0*(1.0+dxm/dx)
	c(i)=dxm/dx
	dy(i)=3.0*(dxm/dx**2*(y(i+1)-y(i))
     &	    +(y(i)-y(i-1))/dxm)
 10	continue
c
	call tdms(1,n,n,a,b,c, dy)
	return
	end
c
c  solve tri-diagonal matrix
c  updated 95/09/09
c
	subroutine tdms(id,nd,n,a,b,c,y)
c
c  matrix / b(1),c(1), 0  ,                             ` * x = y
c         | a(2),b(2),c(2), 0  ,                        |
c         |  0  ,a(3),b(3),c(3),                        |
c         |                                             |
c         |                       ,a(n-1),b(n-1),c(n-1) |
c         `                         0   , a(n) , b(n)  /
c
c  nd=number of data points, should be n or larger
c  id=number of dimensions
c  solution is returned in y
c  contents of arrays are descroyed
c
	include 'sys.fc'
	dimension a(nd),b(nd),c(nd),y(nd,id)
c
	if(n.eq.1) go to 1
	if(n.eq.2) go to 2
	if(n.lt.1) go to 9
	c(1)=c(1)/b(1)
	do 10 j=1,id
 10	y(1,j)=y(1,j)/b(1)
c
	do 20 i=2,n-1
	c(i)=c(i)/(b(i)-a(i)*c(i-1))
	do 21 j=1,id
 21	y(i,j)=(y(i,j)-a(i)*y(i-1,j))/(b(i)-a(i)*c(i-1))
 20	continue
c
	do 30 j=1,id
 30	y(n,j)=(y(n,j)-a(n)*y(n-1,j))/(b(n)-a(n)*c(n-1))
c
	do 40 i=n-1,1,-1
	do 41 j=1,id
 41	y(i,j)=y(i,j)-c(i)*y(i+1,j)
 40	continue
	return
c
 1	do 50 j=1,id
 50	y(1,j)=y(1,j)/b(1)
	return
c
 2	det=b(1)*b(2)-a(2)*c(1)
	do 60 j=1,id
	y1=(b(2)*y(1,j)-c(1)*y(2,j))/det
	y2=(-a(2)*y(1,j)+b(1)*y(2,j))/det
	y(1,j)=y1
	y(2,j)=y2
 60	continue
	return
c
 9	write(msg,*) '(subr.tdms  ) error: n=',n
	errflg=2
	return
	end
c
c  solve periodic tri-diagonal matrix
c  updated 95/09/09
c
	subroutine ptdms(id,nd,n,a,b,c,y)
c
c     matrix / b(1),c(1), 0  ,           , 0    ,a(1)   ` * x = y
c            | a(2),b(2),c(2), 0  ,      , 0    , 0     |
c            |  0  ,a(3),b(3),c(3),      , 0    , 0     |
c            |                                          |
c            |  0  , 0  ,         ,a(n-1),b(n-1),c(n-1) |
c            ` c(n), 0  ,            0   , a(n) , b(n)  /
c
c  nd=number of data points, should be n or larger
c  id=number of dimensions
c  solution is returned in y
c  contents of arrays are descroyed
c
	include 'sys.fc'
	dimension a(nd),b(nd),c(nd),y(nd,id)
c
	if(n.eq.1) go to 1
	if(n.eq.2) go to 2
	if(n.lt.1) go to 9
c
	c(1)=c(1)/b(1)
	do 10 j=1,id
 10	y(1,j)=y(1,j)/b(1)
	a(1)=a(1)/b(1)
c
	do 20 i=2,n-1
	c(i)=c(i)/(b(i)-a(i)*c(i-1))
	do 21 j=1,id
 21	y(i,j)=(y(i,j)-a(i)*y(i-1,j))/(b(i)-a(i)*c(i-1))
	a(i)=-a(i)*a(i-1)/(b(i)-a(i)*c(i-1))
	if(abs(a(i)).lt.1.0e-20) a(i)=0.0
c  this is to avoid underflow messages
c  maybe only necessary for SunOs
 20	continue
c
	do 30 j=1,id
 30	y(n,j)=(y(n,j)-a(n)*y(n-1,j))/(b(n)-a(n)*(c(n-1)+a(n-1)))
	c(n)=c(n)/(b(n)-a(n)*(c(n-1)+a(n-1)))
c
	do 40 i=1,n-1
	do 41 j=1,id
 41	y(n,j)=(y(n,j)-c(n)*y(i,j))/(1.0-c(n)*a(i))
	c(n)=-c(n)*c(i)/(1.0-c(n)*a(i))
	if(abs(c(n)*a(i)).lt.1.0e-20) c(n)=0.0
c  this is to avoid underflow messages
c  maybe only necessary for SunOs
 40	continue
c
	do 50 j=1,id
 50	y(n,j)=y(n,j)/(1.0+c(n))
	do 60 i=n-1,1,-1
	do 61 j=1,id
 61	y(i,j)=y(i,j)-a(i)*y(n,j)-c(i)*y(i+1,j)
 60	continue
	return
c
 1	do 70 j=1,id
 70	y(1,j)=y(1,j)/b(1)
	return
c
 2	det=b(1)*b(2)-a(2)*c(1)
	do 80 j=1,id
	y1=(b(2)*y(1,j)-c(1)*y(2,j))/det
	y2=(-a(2)*y(1,j)+b(1)*y(2,j))/det
	y(1,j)=y1
	y(2,j)=y2
 80	continue
	return
c
 9	write(msg,*) '(subr.ptdms ) error n=',n
	errflg=2
	return
	end
c
	subroutine spline(id,nd,n,iarcl,s,x,a0,a1,a2,a3,a,b,c)
c
c  id-dimensional spline curve
c  arc-length=s, data point=x, s is calculated from x if iarcl.ne.0
c  x is appriximated by a0+a1*t+a2*t*t+a3*t*t*t (0<t<1)
c  working area a(n),b(n),c(n)
c
c  rev. 92/05 closed contour
c
	include 'sys.fc'
	dimension s(nd),x(id,nd),a(nd),b(nd),c(nd),
     &	          a0(nd,id),a1(nd,id),a2(nd,id),a3(nd,id)
c
	if(.not.(id.ge.1.and.nd.ge.n.and.n.ge.2)) go to 1
	if(iarcl.eq.0) go to 3
	s(1)=0.0
	do 11 i=2,n
	ds=0.0
	do 12 m=1,id
 12	ds=ds+(x(m,i)-x(m,i-1))**2
	s(i)=s(i-1)+sqrt(ds)
	if(s(i).eq.s(i-1)) then
	  write(msg,*) 
     &	  '(subr.spline) error: zero denominator at i=',i
	  errflg=2
	  return
	endif
 11	continue
 3	if(n.eq.2) go to 2
c
	ret=0.0
	iret=0
	do 13 m=1,id
 13	ret=ret+abs(x(m,n)-x(m,1))
	if(ret.lt.1.0e-4) iret=1
c  iret=0 -- open contour, iret=1 -- closed contour
c
	if(iret.eq.1) then
	  dsp=s(3)-s(2)
	  ds =s(2)-s(1)
	  dsm=s(n)-s(n-1)
	  a(1)=1.0
	  b(1)=2.0*(dsm/ds)*(1.0+dsm/ds)
	  c(1)=ds*dsm/(dsp*dsp)
	  do 21 m=1,id
 21	  a2(1,m)=3.0*(dsm/ds*(x(m,2)-x(m,1))-(x(m,n)-x(m,n-1)))
	else
	  a(1)=0.0
	  b(1)=1.0
	  c(1)=0.0
	  do 22 m=1,id
 22	  a2(1,m)=0.0
	endif
c
	do 10 i=2,n-1
	if(i.lt.n-1) dsp=s(i+2)-s(i+1)
	ds =s(i+1)-s(i)
	dsm=s(i)-s(i-1)
	a(i)=1.0
	b(i)=2.0*(dsm/ds)*(1.0+dsm/ds)
	if(i.lt.n-1) c(i)=ds*dsm/(dsp*dsp)
	do 20 m=1,id
 20	a2(i,m)=3.0*(dsm/ds*(x(m,i+1)-x(m,i))-(x(m,i)-x(m,i-1)))
 10	continue
c
	if(iret.eq.1) then
	  dsp=s(2)  -s(1)
	  ds =s(n)  -s(n-1)
	  dsm=s(n-1)-s(n-2)
	  c(n-1)=ds*dsm/(dsp*dsp)
	else
	  c(n-1)=0.0
	endif
c
	if(iret.eq.1) then
	  call ptdms(id,nd,n-1,a,b,c,a2)
	else
	  call tdms(id,nd,n-1,a,b,c,a2)
	endif
c
	do 40 m=1,id
c
	do 30 i=2,n-1
	dsm=s(i)  -s(i-1)
	ds =s(i+1)-s(i)
	a3(i-1,m)=0.3333333*(dsm*dsm/(ds*ds)*a2(i,m)-a2(i-1,m))
 30	continue
c
	if(iret.eq.1) then
	  dsm=s(n)-s(n-1)
	  ds =s(2)-s(1)
	  a3(n-1,m)=0.3333333*(dsm*dsm/(ds*ds)*a2(1,m)-a2(n-1,m))
	else
	  a3(n-1,m)=-0.3333333*a2(n-1,m)
	endif
c
	do 32 i=2,n
	a1(i-1,m)=x(m,i)-x(m,i-1)-a3(i-1,m)-a2(i-1,m)
	a0(i-1,m)=x(m,i-1)
 32	continue
 40	continue
	return
c
 1	write(msg,*) 
     &	  '(subr.spline) error: id,nd,n=',id,nd,n
	errflg=2
	return
 2	continue
	do 50 m=1,id
	a0(1,m)=x(m,1)
	a1(1,m)=x(m,2)-x(m,1)
	a2(1,m)=0.0
	a3(1,m)=0.0
 50	continue
	return
	end
