c  initialize constants concerning file handling
c  this routine should be called before subr.assign or subr.openfl
c
	subroutine initfc
c
	include 'fcntl.fc'
	include 'fileio.fc'
	include 'procs.fc'
	include 'mdata.fc'
	include 'sys.fc'
c
c  constants in common/sys/
c	keyin  = 5
c	stdin  = 10
c	lst    = 6
c	msg    = 0
c	errflg = 0
c	msglvl = 1
c  these are given in mains
c
c  indicators of unfilled points
	ufl=1.0e-15
	iufl2= -32000
	iufl4= -2 140 000 000
c  maximum values of 2- and 4-byte integers
	maxi2= 32767
	maxi4= 2 147 483 647
c
c  constants in common/fcntl/
c
c  inuse should be initialized to 0 before calling assign and initc
	do 10 i=0,99
 10	inuse(i+1)=0
	inuse(keyin +1)=kbrd
	inuse(stdin +1)=cntrol
	inuse(lst   +1)=list
	inuse(msg   +1)=msgs
c
	undef=-1
	rdo=1
	wrto=2
	wrt=3
	rdwt=4
	text=0
	local=1
	export=2
	fprint=3
	nomax=80
c
c  logical file numbers
c
	kbrd   =1
	msgs   =2
	list   =3
	cntrol =4
c  this order from 1 to 4 should not be changed
	rawdat =5
	poldeg =6
	rmgram =7
	imap   =8
	dgram  =9
	vmgram =10
	smgram =11
	tmgram =12
	mgram  =13
	gmgram =14
	fitsi  =15
	fitso  =16
	s123   =17
	inilof =18
	itrlof =19
	ffbase =20
	falpha =21
	xvect1 =22
	xvect2 =23
	potlof =24
	fflof  =25
	reflof =26
	pltlof =27
	s1data =28
	auxdat =29
	psetup =30
	footpt =31
	evalpt =32
	logfl  =33
	other1 =34
	other2 =35
	other3 =36
	nfile  =36
c
c  logical file names
c
	lname(kbrd  ) ='KEYIN'
	lname(msgs  ) ='MESSAGE'
	lname(list  ) ='LIST'
	lname(cntrol) ='CONTROL'
	lname(rawdat) ='RAWDATA'
	lname(poldeg) ='POLDEG'
	lname(rmgram) ='RMGRAM'
	lname(imap)   ='IMAP'
	lname(dgram)  ='DGRAM'
	lname(vmgram) ='VMGRAM'
	lname(smgram) ='SMGRAM'
	lname(tmgram) ='TMGRAM'
	lname(mgram)  ='MGRAM'
	lname(gmgram) ='GMGRAM'
	lname(fitsi)  ='FITSIN'
	lname(fitso)  ='FITSOUT'
	lname(s123)   ='S123'
	lname(inilof) ='INILOF'
	lname(itrlof) ='ITRLOF'
	lname(ffbase) ='FFBASE'
	lname(falpha) ='ALPHA'
	lname(xvect1) ='XVECTOR1'
	lname(xvect2) ='XVECTOR2'
	lname(potlof) ='POTLOF'
	lname(fflof)  ='FFLOF'
	lname(reflof) ='REFLOF'
	lname(pltlof) ='PLOTLOF'
	lname(s1data) ='S1DATA'
	lname(auxdat) ='AUXDATA'
	lname(psetup) ='PSETUP'
	lname(footpt) ='FOOTPT'
	lname(evalpt) ='EVALPT'
	lname(logfl ) ='LOGFILE'
c
c  constants in common/fileio/
c
	ocode=0
c  output character code = native  
c
c  constants in common/procs/
c
c  logical process names
c
	init   =1
	obs2p  =2
	pol2b  =3
	obs2b  =4
	rfits  =5
	vector =6
	virial =7
	trans  =8
	ffinit =9
	ffitr  =10
	integp =11
	integf =12
	energy =13
	eval   =14
	wfits  =15
	plot   =16
	disp   =17
	databk =18
	test   =19
	nproc  =19
c
	lproc(init  ) ='INIT'
	lproc(obs2p)  ='OBSTOPOL'
	lproc(rfits)  ='RFITS'
	lproc(pol2b)  ='POLTOB'
	lproc(obs2b)  ='OBSTOB'
	lproc(vector) ='VECTOR'
	lproc(virial) ='VIRIAL'
	lproc(trans)  ='TRANS'
	lproc(ffinit) ='FFINIT'
	lproc(ffitr)  ='FFITR'
	lproc(integp) ='INTEGP'
	lproc(integf) ='INTEGF'
	lproc(energy) ='ENERGY'
	lproc(eval)   ='EVAL'
	lproc(wfits)  ='WFITS'
	lproc(plot)   ='PLOT'
	lproc(disp)   ='DISP'
	lproc(databk) ='DATABOOK'
	lproc(test)   ='TEST'
c
c  constants in common/mdata/
c
	nframe=0
	do 11 i=1,NSPEC0
 11	kloc(i)=0
	do 12 k=1,MZ
	kmem(k)=0
 12	lspecs(k)=0
	do 13 i=1,MD
 13	owner(i)=' '
c
	return
	end
c
c  initialize common variables
c
	subroutine initc( unit )
c
	integer unit
	include 'coord.fc'
	include 'ff0.fc'
	include 'fcntl.fc'
	include 'fileio.fc'
	include 'lparam.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'ss.fc'
	include 'solar.fc'
	include 'string.fc'
	include 'sys.fc'
	include 'auxparam.fc'
	include 'graph.fc'
c
	character strid*8
	dimension filtr0(3,3),filtr1(3,3)
	data filtr1/0.5, 1.0, 0.5, 1.0, 4.0, 1.0, 0.5, 1.0, 0.5/
	data filtr0/0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0/
c
c***  common/string/  ***
c
	tsys ='GMT   '
	inst ='        '
	mfile='        '
	lfile='        '
	dateo='  /  /  '
	stime='  :  :  '
	etime='  :  :  '
	ftag= '  /  /    :  :  '
	mtag= '  /  /    :  :  '
	ltag= '  /  /    :  :  '
	title=' '
c
c***  common/solar/  ***
c
	ulen=1.0e9
	rsun=69.6
	arcsec=0.07
c  one arcsecond on the sun at 1AU is 0.0725 x 10e9 cm
c  arcsec=0.07 is not the real arcsecond on the sun.
c  rather, it defines the scale of rsp
	pdeg=0.0
	b0deg=0.0
	cl0deg=0.0
	ydeg=0.0
c
c***  common/fcntl/  ***
c  lrecu and mmatch are taken from sysconf.cfg
c
	ovwrt=0
c  output files are not overwritten if they already exist
c
c  other scalar constants and inuse are initialized by subr.initfc
c  arrays fstat, funit, fmode, fmulti, fname, lname, lproc are set
c  by subr.assign 
c
c***  common/fileio/  ***
c
	kindmi=0
	kindmo=0
	nbytmi=0
	nbytem=0
	nframi=0
	nframo=0
	mesho=0
	kindli=0
	nbytli=0
	nbytel=0
	ncompi=0
	ncomp=8
c  iabs(nbytel)=2: factx=0.02, factb=0.2
c  (32767*0.02=650, which is larger than 2*3.14*rsp(=70))
c  iabs(nbytel)=4: factx=0.01*1.0e-4, factb=0.1 *1.0e-4
c  factx and factb are set after nbytel is set
	irefpt =0
	rdfpt  = .false.
	rdlof  = .false.
	rdvmag = .false.
	rdmag  = .true.
	rds1   = .false.
	rds2   = .true.
	rds123 = .false.
	mkimap = .false.
	mkdmap = .false.
	mkmmap = .false.
	rdimap = .false.
	rddmap = .false.
c
c***  common/mparam/  ***
c
	kindm=0
	btlim=0.0
	rcutof=0.95
	cfmax=5.0
	bmin1=0.0
	bmin2=0.0
	nx=0
	ny=0
	xs=0.0
	ys=0.0
	dx=1.0
	dy=1.0
	nx0=0
	ny0=0
	xs0=0.0
	ys0=0.0
	dx0=0.0
	dy0=0.0
	nxmax=MX
	nymax=MY
	nbinx=1
	nbiny=1
	ixs=0
	ixe=0
	iys=0
	iye=0
	wavel=0.0
	do 20 i=1,10
	mpstr(i)=' '
	mpint(i)=0
	mpreal(i)=0.0
 20	continue
c
c***  common/mdata/  ***
c
	do 21 i=1,NSPEC0
 21	factm(i)=1.0
c
c***  common/ss/  ***
	ns1=0
	ns2=0
	ns20=0
	ns3=0
	chksum=0
	calib=.true.
c
c***  common/lparam/  ***
c
	kindl=0
	cancel=.true.
	wfile=.true.
	modelf=0
	x1lim=0.0
	x2lim=0.0
	y1lim=0.0
	y2lim=0.0
	z1lim=0.0
	z2lim=0.0
	nf0=0
	nf=0
	ds0=0.0
	flxpwr=1.0
	rrss=0.0
	rotsrc=0.0
	dlg(1)=0.0
	dlg(2)=0.0
	dlg(3)=1.0
c  rss,aout,ain,amout,amin are set by subr.sets12
c  but in order to avoid zero division when do loops are optimized,
c  the following default values are set
	aout=rsun
	ain=rsun
c
c***  common/coord/  ***
c
	xdu(1)=1.0
	xdu(2)=0.0
	xdu(3)=0.0
	ydu(1)=0.0
	ydu(2)=1.0
	ydu(3)=0.0
	zdu(1)=0.0
	zdu(2)=0.0
	zdu(3)=1.0
	ypos=0.0
	rsp=rsun
	xxsp(1)=0.0
	xxsp(2)=0.0
	xxsp(3)=-rsp
	prad=0.0
	b0rad=0.0
	cl0=0.0
	cl0eff=0.0
	mesh=0
	xtod=0.0
	ytod=0.0
	sinals=0.0
	cosals=1.0
	sinaps=0.0
	cosaps=1.0
	do 30 i=1,3
	xxto(i)=0.0
	xxtod(i)=0.0
	xtu(i)=xdu(i)
	ytu(i)=ydu(i)
	ztu(i)=zdu(i)
	ypu(i)=ydu(i)
	do 40 j=1,3
	armat(i,j)=0.0
	atmat(i,j)=0.0
	asmat(i,j)=0.0
 40	continue
	armat(i,i)=1.0
	atmat(i,i)=1.0
	asmat(i,i)=1.0
 30	continue
c
	dset=.false.
	tset=.false.
	sset=.false.
	rset=.false.
c
	nsp=1
	do 35 n=1,5
	rsetm(n)=.false.
	rspm(n)=0.0
	pradm(n)=0.0
	b0radm(n)=0.0
	do 35 j=1,3
	xxspm(j,n)=0.0
	do 36 i=1,3
 36	armatm(i,j,n)=0.0
 35	armatm(j,j,n)=1.0
c
c***  common/aux/  ***
c
	iform=1
	ifiltr=2
c  method in subr.vectr1
	apint(1)=1
c  nitrv in subr.vectr1
	apint(2)=1
c  nsize in subr.vectr1
	apint(3)=5
c  apot in subr.vectr1
	apreal(1)=1.0
c  wuns in in subr.vectr1
	apreal(2)=1.0
c  wflp in in subr.vectr1
	apreal(3)=1.0
c
	do 50 j=1,3
	do 50 i=1,3
	filter(i,j,1)=filtr0(i,j)
	filter(i,j,2)=filtr1(i,j)
 50	continue
	ns2min=100
	ns2max=2500
	x1lim0=0.0
	x2lim0=0.0
	y1lim0=0.0
	y2lim0=0.0
	z1lim0=0.0
	z2lim0=0.0
	x1del=0.0
	x2del=0.0
	y1del=0.0
	y2del=0.0
	z1del=0.0
	z2del=0.0
	swall  = .true.
	mansel = .false.
	single = .false.
	rezone = .false.
c  other parameters are for debugging/evaluation purposes and not
c  initialized here
c
c***  common/ff0/  ***
c
	nff=0
	region=0
	minjz=0.0
	minbz=0.0
	elmax=1.0e10
	aratio=2.0
	elminr=2.0
	elmaxr=30.0
	facta=1.0
	factda=0.5
	modeff=1
	bdc(1)=0.0
	bdc(2)=0.0
	bdc(3)=0.0
	lmax=0
	nvar=0
	iser=-1
	itrmax=0
	nitr=0
	nrezon=0
	nloop=0
	errfff=0
	step0=1.0
	epsfff=1.0e-3
	delta=0.01
c
c***  common/graph/  ***
c
	gmode = 0
	meshl=2
	devcmn=1.0
	vmicm=0.6
	chrcm=0.25
	xsize=16.0
	ysize=24.0
	xfl=0.0
	yfl=0.0
	xfr=16.0
	yfr=16.0
	xfc=0.5*(xfl+xfr)
	yfc=0.5*(yfl+yfr)
	gxc=0.0
	gyc=0.0
	gfact=1.0
	rotang=0.0
	xang=0.0
	zang=0.0
	eyed=0.0
	do 60 j=1,3
	do 65 i=1,3
	rotr(i,j)=0.0
	rotv(i,j)=0.0
	rotx(i,j)=0.0
	rotz(i,j)=0.0
 65	continue
	rotr(j,j)=1.0
	rotv(j,j)=1.0
	rotx(j,j)=1.0
	rotz(j,j)=1.0
 60	continue
c
	lpdev='/dev/lp'
	lpname='lp'
c
c  read data if default values need to be changed
c
c  current version number of auxdat file
	iver0 =3
c  version 2->3: z2del is replaced by z2lim
	read(unit,*) strid,iver1
	call upper(strid)
	if(strid.ne.'AUXDATA') then
	  write(msg,*) 'error: this is not the auxdata file'
	  errflg=2
	  return
	endif
	if(iver1.ne.iver0) then
	  write(msg,*)
     &	  '(subr.initc ) error: version of auxdata should be',
     &	  iver0
	  errflg=2
	  return
	endif
c
c  solar
	read(unit,*) ulen,rsun,arcsec
c  fcntl
	read(unit,*) ovwrt
c  fileio
	read(unit,*) ocode
c  mparam
	read(unit,*) btlim
	read(unit,*) bmin1,bmin2 
	read(unit,*) nxmax,nymax 
	nxmax=min(nxmax,MX)
	nymax=min(nymax,MY)
c  lparam
	read(unit,*) rrss,rotsrc
	read(unit,*) modelf,single
	read(unit,*) x1del,x2del,y1del,y2del,z1lim,z2lim,z2del
	read(unit,*) nbytem,nbytel,ncomp
c  fileio,mdata
        if(iabs(nbytel).eq.2) then
          factx=0.02
          factb=0.2
        else
          factx=0.01*1.0e-4
          factb=0.1 *1.0e-4
        endif
	read(unit,*) factx,factb,factm
c  aux
	read(unit,*) iform
	read(unit,*) rcutof,cfmax
	read(unit,*) swall,ifiltr
	read(unit,*) ((filter(i,j,2),i=1,3),j=1,3)
	read(unit,*) apint(1),apint(3)
	read(unit,*) (apreal(i),i=1,3)
	read(unit,*) ns2min,ns2max 
c  ff0
	read(unit,*) aratio,elminr,elmaxr,factda
	read(unit,*) rezone
	read(unit,*) epsfff,step0,delta
c
	return 
	end
