c  merge two magnetograms
c
	program mergem
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	logical update
	integer ium1,ium2,oum,kdest(NSPEC0)
	character*80 fname1,fname2,fnameo,chr
	character*10 spec,spec2
c
	data pi/3.141592/
	rad(deg)=3.141592*deg/180.0
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	chr='0'
	if(myargc().eq.1) call myargv(1,chr)
	if(chr.eq.'0') then
	  msglvl=0
	else if(chr.eq.'1') then
	  msglvl=1
	else if(chr.eq.'2') then
	  msglvl=2
	else if(chr.eq.'3') then
	  msglvl=3
	else
	  msglvl=1
	endif
c
	include 'sysconf.cfg'
c
	call initfc
	lst = lstini()
c
c  these are not initialized in initfc
	nxmax=MX
	nymax=MY
c
	if(mycode.eq.0 .or. myint.eq.0) stop
c
	lrec0=80
	ium1=98
	ium2=97
	oum=96
c
	write(msg,*)
     &	'(prog.mergem) enter primary magnetogram file  for input'
	write(msg,*)
     &      '   grid size of these data becomes the final grid size'
	read(keyin,'(a)') fname1
	call openfl(smgram,'SMGRAM',ium1,fname1,export,rdo,lrec0)
	if(errflg.gt.1) stop
c
	write(msg,*)
     &	'(prog.mergem) enter secondary magnetogram file for input'
	read(keyin,'(a)') fname2
	call openfl(mgram,'MGRAM',ium2,fname2,export,rdo,lrec0)
	if(errflg.gt.1) stop
c
	write(msg,*)
     &	'(prog.mergem) enter magnetogram file name for output'
	read(keyin,'(a)') fnameo
	call openfl(tmgram,'TMGRAM',oum,fnameo,export,wrt,lrec0)
	if(errflg.gt.1) stop
c
	update=.true.
	do 10 n=1,NSPEC0
 10	kloc(n)=0
	do 20 k=1,MZ
	kmem(k)=0
	lspecs(k)=0
 20	continue
	nframe=0
	nbinx=1
	nbiny=1
c
	call inmh(ium2,update)
	if(errflg.gt.1) stop
	write(lst,*)
     &	  '(prog.mergem) secondary file:'
	if(nframi.gt.1) then
	  write(lst,*) 'nframe gt 1'
	  stop
	endif
c
	write(lst,*) 
     &	  '    kindm,mesh,nframe=',kindmi,mesh,nframi
	call printm(nbytmi,nx,ny,xs,ys,dx,dy,ydeg,
     &	rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	tsys,inst,wavel,mfile,dateo,stime,etime,ftag,title)
c
c  read data to rdata(*,*,2)
	do 30 lspec1=1,NSPEC0
 30	kdest(lspec1)=2
	call inm(ium2,kdest)
	spec2=specst(lspecs(2))
	write(lst,*) 'secondary data=',spec2, ', factor=',factm(lspecs(2))
c  save parameters
	nx2=nx
	ny2=ny
	xs2=xs
	ys2=ys
	dx2=dx
	dy2=dy
	mesh2=mesh
	pdeg2=pdeg
	rsp2=rsp
	cl2deg=cl0deg
	cl2 = rad(cl2deg)
	xe2=xs2+dx2*float(nx2-1)
	ixs=0
	ixe=0
	iys=0
	iye=0
c
	call inmh(ium1,update)
	if(errflg.gt.1) stop
	write(lst,*)
     &	  '(prog.mergem) primary file:'
	if(nframi.gt.1) then
	  write(lst,*) 'nframe gt 1'
	  stop
	endif
c
	write(lst,*) 
     &	  '    kindm,mesh,nframe=',kindmi,mesh,nframi
	call printm(nbytmi,nx,ny,xs,ys,dx,dy,ydeg,
     &	rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	tsys,inst,wavel,mfile,dateo,stime,etime,ftag,title)
c
	if(mesh.ne.mesh2) then
	  write(lst,*) 'mesh parameter mismatch',mesh,mesh2
	  stop
	endif
c
	cl0 = rad(cl0deg)
	xe=xs+dx*float(nx-1)
c  when the data area does not cover the back side of the sun,
c  extend the array to make space for the data of the back side 
	if(xe-xs.lt.1.1*pi) then
	  xe = xs + 2.0*pi
	  nx = (xe-xs)/dx
	endif
c
c  read data to rdata(*,*,1)
	do 40 lspec1=1,NSPEC0
 40	kdest(lspec1)=1
	call inm(ium1,kdest)
	spec = specst(lspecs(1))
	write(lst,*) 'primary data=',spec, ', factor=',factm(lspecs(1))
c
	if(spec.ne.spec2) then
	  write(lst,*) 'spec parameter mismatch',spec,spec2
	  stop
	endif
c
c  ufl=1.0e-15 (indicator of unfilled data) is defined
c  by initfc.f
c
c  calculate ratios of two data sets on common pixels near the pole
c
	if(mesh.gt.1) then
	  sum1n=0.0
	  sum2n=0.0
	  sum1s=0.0
	  sum2s=0.0
	  do 1000 j=1,ny
	  do 1000 i=1,nx
	  if(rdata(i,j,1).eq.ufl) go to 1000
	  x1=xs+dx*float(i-1)
	  y1=ys+dy*float(j-1)
	  if(mesh.eq.4) x1=x1 -cl0 +cl2
	  if(x1.lt.xs2) x1=x1+2.0*pi
	  if(x1.gt.xe2) x1=x1-2.0*pi
	  al=alofy(y1)
	  if(abs(al).lt.pi/3.0) go to 1000 
c  get the mesh number in data#2
	  call getij(nx2,ny2,xs2,ys2,dx2,dy2,x1,y1,i2,j2,xr,yr)
	  if(i2.ge.1.and.i2.le.nx2-1.and.j2.ge.1.and.j2.le.ny2-1) then
	    b1=rdata(i2,  j2,  2)
	    b2=rdata(i2+1,j2,  2)
	    b3=rdata(i2+1,j2+1,2)
	    b4=rdata(i2,  j2+1,2)
c  perform bilinear interpolation
	    if(b1.ne.ufl.and. b2.ne.ufl.and. b3.ne.ufl.and. b4.ne.ufl) then
     	      b= b1+(b2-b1)*xr+(b4-b1)*yr+(b3-b4-b2+b1)*xr*yr
	      if(al.gt.0.0) then
	        sum1n=sum1n+abs(rdata(i,j,1))
	        sum2n=sum2n+abs(b)
	      else
	        sum1s=sum1s+abs(rdata(i,j,1))
	        sum2s=sum2s+abs(b)
	      endif
	    endif
	  endif
 1000	continue
	  if(sum1n.ne.0.0 .and. sum2n.ne.0.0) then
	    ration=sum1n/sum2n
	    write(lst,*) 'north pole: ratio of data #1/#2=',ration
	  else
	    ration=1.0
	  endif
	  if(sum1s.ne.0.0 .and. sum2s.ne.0.0) then
	    ratios=sum1s/sum2s
	    write(lst,*) 'south pole: ratio of data #1/#2=',ratios
	  else
	    ratios=1.0
	  endif
	endif
c
	do 2000 j=1,ny
	do 2000 i=1,nx
c  if the data in rdata(*,*,1) is valid, copy them to rdata(*,*,3)
	if(rdata(i,j,1).ne.ufl) then
	  rdata(i,j,3) = rdata(i,j,1)
	  go to 2000
	endif
	x1=xs+dx*float(i-1)
	y1=ys+dy*float(j-1)
	fact=1.0
	if(mesh.eq.4) x1=x1 -cl0 +cl2
	if(mesh.gt.1) then
	  if(x1.lt.xs2) x1=x1+2.0*pi
	  if(x1.gt.xe2) x1=x1-2.0*pi
	  al=alofy(y1)
	  w=pi/8.0
	  if(al.gt.pi/3.0) then
	    fact=1.0+(ration-1.0)*exp(-((al-0.5*pi)/w)**2)
	  else if(al.lt.-pi/3.0) then
	    fact=1.0+(ratios-1.0)*exp(-((al+0.5*pi)/w)**2)
	  endif
	endif
c  get the mesh number in data#2
	call getij(nx2,ny2,xs2,ys2,dx2,dy2,x1,y1,i2,j2,xr,yr)
	if(i2.ge.1.and.i2.le.nx2-1.and.j2.ge.1.and.j2.le.ny2-1) then
	  b1=rdata(i2,  j2,  2)
	  b2=rdata(i2+1,j2,  2)
	  b3=rdata(i2+1,j2+1,2)
	  b4=rdata(i2,  j2+1,2)
c  perform bilinear interpolation
	  if(b1.ne.ufl.and. b2.ne.ufl.and. b3.ne.ufl.and. b4.ne.ufl)
     &	  rdata(i,j,3)=fact*(
     &	  b1+(b2-b1)*xr+(b4-b1)*yr+(b3-b4-b2+b1)*xr*yr)
 	endif 
 2000	continue
c
c  set output parameters
	kindmo=kindmi
	nframo=1
	nbytem=nbytmi
	factm(lspecs(3))=factm(lspecs(1))
	lspecs(3)=lspecs(1)
      ftag=mktag()
c
c  write header to file
	call outmh(oum)
c  write rdata(*,*,3) to file
	call outm(oum,3)
c
	write(lst,*) 
     &	  '(proc.mergem) output:'
	write(lst,*)
     &	  '    kindm,mesh,nframe=',kindmo,mesh,nframo
	call printm(nbytem,nx,ny,xs,ys,dx,dy,ydeg,
     &	rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	tsys,inst,wavel,mfile,dateo,stime,etime,ftag,title)
c
	stop
	end

