c  system-dependent programs : mips fortran
c
c  open files
c
	subroutine openfl( ln, lname1,
     &	                   funit1, fname1, fmode1, fstat1, lrec0 )
c
	include 'sys.fc'
	include 'fcntl.fc'
	integer funit1, fmode1, fstat1
	character lname1*(*),fname1*(*),
     &	           access*10, form*12, status*10, other*30, fname2*80
c
c  fmode1 = text   : formatted sequential
c           local  : unformatted sequential
c           export : formatted direct-access (mmatch.eq.0)
c                  : unformatted direct-access (mmatch.ne.0)
c           fprint : same as text, with fortran print control
c
c  fstat1=  rdo    : read only, file should exist
c           wrto   : write only, file should not exist
c           wrt    : write, file is created if non-existent
c           rdwrt  : read/write, file is created if non-existent
c  constants text, local, etc. are set by subr.initfc, and these values
c  are passed through common/fcntl/ defined in 'fcntl.fc'. 
c
	if(fmode1.eq.export .and.
     &  mod(lrec0,lrecu).ne.0 .and. mmatch.ne.0) then
	  write(lst,*)
     &	    '(subr.openfl) this system cannot handle lrec=',lrec0
	  errflg=2
	  return
	endif
c
	lrec=lrec0/lrecu
	ln2=ln
	fname2=fname1
c
	if(fmode1.eq.text) then
	  form='formatted'
	  access='sequential'
	  other=' '
	  if(fstat1.eq.rdo) then
	    status='old'
	    other='readonly'
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, readonly,
     &	            status=status, err=91 )
	    else
	      open( unit=funit1, readonly, status=status, err=91 )
	    endif
	  else if(fstat1.eq.wrto) then
	    status='new'
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, status=status, err=91 )
	    else
	      open( unit=funit1, status=status, err=91 )
	    endif
	  else if(fstat1.eq.rdwrt .or. fstat1.eq.wrt) then
	    status='unknown'
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, err=91 ) 
	    else
	      open( unit=funit1, err=91 )
	    endif
	  else
	    write(msg,*) '(subr.openfl) error: fstat1=',fstat1
	    errflg=2
	    return
	  endif
c
c  (fprint is only for output)
c
      else if(fmode1.eq.fprint) then
	form='formatted'
        access='sequential'
	other='carriagecontrol=fortran'
c
        if(fstat1.eq.wrto) then
          status='new'
          if(fname2.ne.' '.and.fname2.ne.'-') then
            open( unit=funit1, file=fname2, form=form,
     &	          carriagecontrol='fortran', status=status, err=91 )
          else
            open( unit=funit1, form=form,
     &	          carriagecontrol='fortran', status=status, err=91 )
          endif
c
        else if(fstat1.eq.rdwrt .or. fstat1.eq.wrt) then
          status='unknown'
          if(fname2.ne.' '.and.fname2.ne.'-') then
            open( unit=funit1, file=fname2, form=form,
     *	          carriagecontrol='fortran',  err=91 )
          else
            open( unit=funit1, form=form,
     *	          carriagecontrol='fortran',  err=91 )
          endif
c
        else
          if(fstat1.eq.rdo) then
            write(msg,*)
     &      '(subr.openfl) error: fmode1=fprint and fstat1=readonly'
          else
            write(msg,*) '(subr.openfl) error: fstat1=',fstat1
          endif
          errflg=2
          return
        endif
c
c
	else if(fmode1.eq.local) then
	  form='unformatted'
	  access='sequential'
	  other=' '
	  if(fstat1.eq.rdo) then
	    status='old'
	    other='readonly'
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form, 
     &	            readonly, status=status, err=91 )
	    else
	      open( unit=funit1, form=form, 
     &	            readonly, status=status, err=91 )
	    endif
	  else if(fstat1.eq.wrto) then
	    status='new'
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form, 
     &	            status=status, err=91 )
	    else
	      open( unit=funit1, form=form,
     &	            status=status, err=91 )
	    endif
	  else if(fstat1.eq.rdwrt .or. fstat1.eq.wrt) then
	    status='unknown'
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form, err=91 ) 
	    else
	      open( unit=funit1, form=form, err=91 )
	    endif
	  else
	    write(msg,*) '(subr.openfl) error: fstat1=',fstat1
	    errflg=2
	    return
	  endif
c
	else if(fmode1.eq.export .and. mmatch.ne.0) then
	  form='unformatted'
	  access='direct'
	  other=' '
	  if(fstat1.eq.rdo) then
	    status='old'
	    other='readonly'
	    if(instr(fname1,':').gt.0) then
	      fname2='RGET-'//lname1
	      call rcp(fname1,fname2)
	      if(errflg.gt.1) return
	    endif
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form, readonly,
     &	            status=status, access=access, recl=lrec, err=91 )   
	    else
	      open( unit=funit1, form=form, readonly,
     &	            status=status, access=access, recl=lrec, err=91 )
	    endif
	  else if(fstat1.eq.wrto) then
	    status='new'
	    if(instr(fname1,':').gt.0) then
	      fname2='RPUT-'//lname1
	      status='unknown'
	      ln2=-ln
	    endif
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form,
     &	            status=status, access=access, recl=lrec, err=91 )   
	    else
	      open( unit=funit1, form=form,
     &	            status=status, access=access, recl=lrec, err=91 )   
	    endif
	  else if(fstat1.eq.rdwrt) then
	    status='unknown'
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form,
     &	              access=access, recl=lrec, err=91 )   
	    else
	      open( unit=funit1, form=form, 
     &	            access=access, recl=lrec, err=91 )
	    endif
	  else if(fstat1.eq.wrt) then
	    status='unknown'
c  for direct-access files, overwriting does not initially clear
c  the files.  therefore, here a file is deleted and then created
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, err=71 )
 71	      close(unit=funit1, status='delete' )
	      open( unit=funit1, file=fname2, form=form,
     &	              status='new',access=access, recl=lrec, err=91 )   
	    else
	      open( unit=funit1, file=fname2, err=72 )
 72	      close(unit=funit1, status='delete' )
	      open( unit=funit1, form=form, 
     &	            status='new',access=access, recl=lrec, err=91 )
	    endif
	  else
	    write(msg,*) '(subr.openfl) error: fstat1=',fstat1
	    errflg=2
	    return
	  endif
c
	else if(fmode1.eq.export .and. mmatch.eq.0) then
	  form='formatted'
	  access='direct'
	  other=' '
	  lrec=lrec0
	  fname2=fname1
	  if(fstat1.eq.rdo) then
	    status='old'
	    other='readonly'
	    if(instr(fname1,':').gt.0) then
	      fname2='RGET-'//lname1
	      call rcp(fname1,fname2)
	      if(errflg.gt.1) return
	    endif
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form, readonly,
     &	            status=status, access=access, recl=lrec, err=91 )   
	    else
	      open( unit=funit1, form=form, readonly,
     &	            status=status, access=access, recl=lrec, err=91 )
	    endif
	  else if(fstat1.eq.wrto) then
	    status='new'
	    if(instr(fname1,':').gt.0) then
	      fname2='RPUT-'//lname1
	      status='unknown'
	      ln2=-ln
	    endif
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form,
     &	            status=status, access=access, recl=lrec, err=91 )   
	    else
	      open( unit=funit1, form=form,
     &	            status=status, access=access, recl=lrec, err=91 )
	    endif
	  else if(fstat1.eq.rdwrt) then
	    status='unknown'
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, form=form,
     &	            access=access, recl=lrec, err=91 )   
	    else
	      open( unit=funit1, form=form,
     &	            access=access, recl=lrec, err=91 )
	    endif
	  else if(fstat1.eq.wrt) then
	    status='unknown'
c  for direct-access files, overwriting does not initially clear
c  the files.  therefore, here a file is deleted and then created
	    if(fname2.ne.' '.and.fname2.ne.'-') then
	      open( unit=funit1, file=fname2, err=81 )
 81	      close(unit=funit1, status='delete' )
	      open( unit=funit1, file=fname2, form=form,
     &	            status='new', access=access, recl=lrec, err=91 )   
	    else
	      open( unit=funit1, err=82 )
 82	      close(unit=funit1, status='delete' )
	      open( unit=funit1, form=form,
     &	            status='new', access=access, recl=lrec, err=91 )
	    endif
	  else
	    write(msg,*) '(subr.openfl) error: fstat1=',fstat1
	    errflg=2
	    return
	  endif
c
	else
	  write(msg,*) '(subr.openfl) paramater error'
	  errflg=2
	endif

c
	inuse(funit1 +1)=ln2
c  negative ln2 means remote output files
c
	if(msglvl.gt.0)
     &	      call opened(lname1,funit1,fname2,access,form,
     &	                  status,other,lrec)
	return
 91	errflg=2
	call opnerr(lname1,funit1,fname2,access,form,status,other,lrec)
	return
	end
c
c  initial value of msg
c
	integer function msgini()
	msgini=6
	return
	end
c
c  open list file
c
	integer function lstini()
c
	include 'fcntl.fc'
c
	lst = 6
	call openfl(list,lname(list),lst,' ',fprint,wrt,0)
	lstini = lst
	return
	end
c
c
c  close a file
c
        subroutine clsfl(lno)
c
        include 'fcntl.fc'
        include 'sys.fc'
	character fname2*80
c
        if(lno.lt.1) then
          write(msg,*)
     &	  '(subr.clsfl ) invalid logical file number, lno=',
     &    lno
          errflg=2
          return
        endif
c
        if(funit(lno).ge.0) then
          close (funit(lno))
	  fname2='RPUT-'//lname(lno)
	  if(inuse(funit(lno)+1).lt.0) then
	    call rcp(fname2,fname(lno))
	  endif
          inuse(funit(lno)+1)=0
          funit(lno)=undef
	endif
        return
        end
c
c  find a character in a string 
c
	function instr(str,chr)
	character str*(*),chr*1
c
	l=len(str)
	do 10 i=1,l
 10	if(str(i:i).eq.chr) go to 20
	instr=0
	return
 20	instr=i
	return
	end
c
c  execute remote copy
c
	subroutine rcp(file1,file2)
c
	character file1*(*),file2*(*)
	character*80 filei,fileo
	include 'sys.fc'
c
	len1=max(1,lenstr(file1))
	len2=max(1,lenstr(file2))
	filei=file1
	fileo=file2
	ierr= system('rcp '//filei(1:len1)//' '//fileo(1:len2) )
	if(ierr.ne.0) then
	  write(msg,*) '(subr.rcp   ) error'
	  write(msg,*) '           input  file='//filei(1:len1)
	  write(msg,*) '           output file='//fileo(1:len2)
	  errflg=2
	endif
	if(msglvl.gt.0) then
     	  write(lst,*) '(subr.rcp   ) remote copy'
	  write(lst,*) '           input  file='//filei(1:len1)
	  write(lst,*) '           output file='//fileo(1:len2)
	endif
	return
	end
c
c  unix file i/o for MAGPACK2 transportable files
c  direct access (un)formatted read/write
c  record length = lrec0 bytes (lrec0 <= 256 )
c  (\n is converted to blank in formatted read of some systems,
c  e.g.SunOS)
c  (sequential write inserts \n at the end of each record)
c
c  byte string
c
	subroutine ins( iunit, loc, buf, nbyte, iostat )
	include 'fcntl.fc'
	integer iunit
	character magic*2,buf*(*)
c
	magic='TS'
	buf(1:2)=magic
	iostat=0
	if(mmatch.eq.0) then
	  read( iunit, '(a)', rec=loc, err=8 ) buf(1:nbyte)
	else
	  read( iunit,        rec=loc, err=8 ) buf(1:nbyte)
	endif
	if(buf(1:2).eq.magic) go to 9
	loc=loc+1
	return
 8	iostat=1
	return
 9	iostat=2
	return
	end
c
c  2-d byte array
c
	subroutine in1( iunit,loc,idata1,lrec0,nx,ny,ndim,iostat )
c
	parameter (MAXBUF=256)
	include 'sys.fc'
	include 'fileio.fc'
	integer iunit
	character*1 ibuf1(MAXBUF),idata1(ndim,1)
	character fmt*10
c
	if(lrec0.gt.MAXBUF) then
	  write(lst,*)
     &	'(subr.in1   ) lrec0 is larger than buffer size (',
     &	MAXBUF,')'
	  errflg=2
	  return
	endif
c
	iostat=0
	nrec=(nx*ny+lrec0-1)/lrec0
	nrec1=lrec0
	write(fmt,100) nrec1
 100	format('(',i3,'a1)')
c
	ij=1
	if(mmatch.eq.0) then
	  do 10 n=1,nrec
	  read(iunit,fmt,rec=loc,err=9) (ibuf1(m),m=1,nrec1)
	  loc=loc+1
	  do 10 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  if(j.gt.ny) go to 30
	  idata1(i,j)=ibuf1(m)
	  ij=ij+1
 10	  continue
	else
	  do 20 n=1,nrec
	  read(iunit,         rec=loc,err=9) (ibuf1(m),m=1,nrec1)
	  loc=loc+1
	  do 20 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  if(j.gt.ny) go to 30
	  idata1(i,j)=ibuf1(m)
	  ij=ij+1
 20	  continue
	endif
c
 30	return
 9	iostat=2
	return
	end
c
c  integer*2 2-d array
c
	subroutine in2( iunit,loc,idata2,lrec0,nx,ny,ndim,iostat )
c
	parameter (MAXBUF=256/2)
	include 'sys.fc'
	include 'fcntl.fc'
	integer iunit
	integer*2 ibuf2(MAXBUF),idata2(ndim,1)
	character fmt*10
c
	if(lrec0.gt.2*MAXBUF) then
	  write(lst,*)
     &	'(subr.in2   ) lrec0 is larger than buffer size (',
     &	MAXBUF,')'
	  errflg=2
	  return
	endif
c
	iostat=0
	nrec=(2*nx*ny+lrec0-1)/lrec0
	nrec1=lrec0/2
	write(fmt,100) nrec1
 100	format('(',i3,'a2)')
c
	ij=1
	if(mmatch.eq.0) then
	  do 10 n=1,nrec
	  read(iunit,fmt,rec=loc,err=9) (ibuf2(m),m=1,nrec1)
	  loc=loc+1
	  do 10 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  if(j.gt.ny) go to 30
	  idata2(i,j)=ibuf2(m)
	  ij=ij+1
 10	  continue
	else
	  do 20 n=1,nrec
	  read(iunit,         rec=loc,err=9) (ibuf2(m),m=1,nrec1)
	  loc=loc+1
	  do 20 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  if(j.gt.ny) go to 30
	  idata2(i,j)=ibuf2(m)
	  ij=ij+1
 20	  continue
	endif
c
 30	return
 9	iostat=2
	return
	end
c
c  integer*4 2-d array
c
	subroutine in4( iunit,loc,idata4,lrec0,nx,ny,ndim,iostat )
	parameter (MAXBUF=256/4)
	include 'sys.fc'
	include 'fcntl.fc'
	integer iunit
	integer*4 ibuf4(MAXBUF),idata4(ndim,1)
	character fmt*10
c
	if(lrec0.gt.4*MAXBUF) then
	  write(lst,*)
     &	'(subr.in4   ) lrec0 is larger than buffer size (',
     &	MAXBUF,')'
	  errflg=2
	  return
	endif
c
	iostat=0
	nrec=(4*nx*ny+lrec0-1)/lrec0
	nrec1=lrec0/4
	write(fmt,100) nrec1
 100	format('(',i3,'a4)')
c
	ij=1
	if(mmatch.eq.0) then
	  do 10 n=1,nrec
	  read(iunit,fmt,rec=loc,err=9) (ibuf4(m),m=1,nrec1)
	  loc=loc+1
	  do 10 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  if(j.gt.ny) go to 30
	  idata4(i,j)=ibuf4(m)
	  ij=ij+1
 10	  continue
	else
	  do 20 n=1,nrec
	  read(iunit,         rec=loc,err=9) (ibuf4(m),m=1,nrec1)
	  loc=loc+1
	  do 20 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  if(j.gt.ny) go to 30
	  idata4(i,j)=ibuf4(m)
	  ij=ij+1
 20	  continue
	endif
c
 30	return
 9	iostat=2
	return
	end
c
c  direct access (un)formatted write
c
c  byte string
c
	subroutine outs( ounit, loc, buf, nbyte )
	include 'fcntl.fc'
	integer ounit
	character buf*(*)
c
	if(mmatch.eq.0) then
	  write( ounit, '(a)',rec=loc ) buf(1:nbyte)
	else
	  write( ounit,       rec=loc ) buf(1:nbyte)
	endif
	loc=loc+1
	return
	end
c
c  2-d byte array
c
	subroutine out1( ounit, loc, idata1, lrec0, nx, ny, ndim )
	parameter (MAXBUF=256)
	include 'sys.fc'
	include 'fcntl.fc'
	integer ounit
	character*1 ibuf1(MAXBUF),idata1(ndim,1)
	character fmt*10
c
	if(lrec0.gt.MAXBUF) then
	  write(lst,*)
     &	'(subr.out1  ) lrec0 is larger than buffer size (',
     &	MAXBUF,')'
	  errflg=2
	  return
	endif
c
	nrec=(nx*ny+lrec0-1)/lrec0
	nrec1=lrec0
      write(fmt,100) nrec1
 100	format('(',i3,'a1)')
c
	ij=1
	if(mmatch.eq.0) then
	  do 10 n=1,nrec
	  do 11 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  ibuf1(m)=char(0)
	  if(j.gt.ny) go to 12
	  ibuf1(m)=idata1(i,j)
 11	  ij=ij+1
 12	  write(ounit,fmt,rec=loc) (ibuf1(m),m=1,nrec1)
	  loc=loc+1
 10	  continue
	else
	  do 20 n=1,nrec
	  do 21 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  ibuf1(m)=char(0)
	  if(j.gt.ny) go to 22
	  ibuf1(m)=idata1(i,j)
 21	  ij=ij+1
 22	  write(ounit,         rec=loc) (ibuf1(m),m=1,nrec1)
	  loc=loc+1
 20	  continue
	endif
	return
	end
c
c  integer*2 2-d array
c
	subroutine out2( ounit, loc, idata2, lrec0, nx, ny, ndim )
	parameter (MAXBUF=256/2)
	include 'sys.fc'
	include 'fcntl.fc'
	integer ounit
	integer*2 ibuf2(MAXBUF),idata2(ndim,1)
	character fmt*10
c
	if(lrec0.gt.2*MAXBUF) then
	  write(lst,*)
     &	'(subr.out2  ) lrec0 is larger than buffer size (',
     &	MAXBUF,')'
	  errflg=2
	  return
	endif
c
	nrec=(2*nx*ny+lrec0-1)/lrec0
	nrec1=lrec0/2
      write(fmt,100) nrec1
 100	format('(',i3,'a2)')
c
	ij=1
	if(mmatch.eq.0) then
	  do 10 n=1,nrec
	  do 11 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  ibuf2(m)=0
	  if(j.gt.ny) go to 12
	  ibuf2(m)=idata2(i,j)
 11	  ij=ij+1
 12	  write(ounit,fmt,rec=loc) (ibuf2(m),m=1,nrec1)
	  loc=loc+1
 10	  continue
	else
	  do 20 n=1,nrec
	  do 21 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  ibuf2(m)=0
	  if(j.gt.ny) go to 22
	  ibuf2(m)=idata2(i,j)
 21	  ij=ij+1
 22	  write(ounit,         rec=loc) (ibuf2(m),m=1,nrec1)
	  loc=loc+1
 20	  continue
	endif
	return
	end
c
c   integer*4 2-d array
c
	subroutine out4( ounit, loc, idata4, lrec0, nx, ny, ndim )
	parameter (MAXBUF=256/4)
	include 'sys.fc'
	include 'fcntl.fc'
	integer ounit
	integer*4 ibuf4(MAXBUF),idata4(ndim,1)
	character fmt*10
c
	if(lrec0.gt.4*MAXBUF) then
	  write(lst,*)
     &	'(subr.out4  ) lrec0 is larger than buffer size (',
     &	MAXBUF,')'
	  errflg=2
	  return
	endif
c
	nrec=(4*nx*ny+lrec0-1)/lrec0
	nrec1=lrec0/4
      write(fmt,100) nrec1
 100	format('(',i3,'a4)')
c
	ij=1
	if(mmatch.eq.0) then
	  do 10 n=1,nrec
	  do 11 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  ibuf4(m)=0
	  if(j.gt.ny) go to 12
	  ibuf4(m)=idata4(i,j)
 11	  ij=ij+1
 12	  write(ounit,fmt,rec=loc) (ibuf4(m),m=1,nrec1)
	  loc=loc+1
 10	  continue
	else
	  do 20 n=1,nrec
	  do 21 m=1,nrec1
	  j=(ij-1)/nx+1
	  i=ij-nx*(j-1)
	  ibuf4(m)=0
	  if(j.gt.ny) go to 22
	  ibuf4(m)=idata4(i,j)
 21	  ij=ij+1
 22	  write(ounit,         rec=loc) (ibuf4(m),m=1,nrec1)
	  loc=loc+1
 20	  continue
	endif
	return
	end
c
c  namelist input
c
        subroutine getnml(nbytm1,naxis1,nfram1,specf1,
     &    mfile1,facto1,zleve1,rsp1,
     &    nx1,ny1,xs1,ys1,dx1,dy1,
     &    tsys1,dateo1,stime1,etime1,inst1,origi1,
     &    pdeg1,b0deg1,cl0de1,aldeg1,apdeg1,
     &    kindm1,skylv1,ncarr1,nmlsw)
c
        include 'sys.fc'
c
        parameter (NITEM=28)
c
        character specf*18,specf1*18,mfile*8,mfile1*8,tsys*6,tsys1*6,
     &            dateo*8,dateo1*8,stime*8,stime1*8,etime*8,etime1*8,
     &            inst*8,inst1*8,origin*18,origi1*18
        integer skylvl,skylv1
        dimension factor(10),facto1(10),zlevel(10),zleve1(10)
        dimension nmlsw(NITEM)
c
        namelist/fits/nbytmi,naxis,nframi,specf,
     &                mfile,factor,zlevel,rsp,
     &                nx,ny,xs,ys,dx,dy,
     &                tsys,dateo,stime,etime,inst,origin,
     &                pdeg,b0deg,cl0deg,aldeg,apdeg,
     &                kindmi,skylvl,ncarr
c
        nbytmi = nbytm1
        naxis = naxis1
        nframi = nfram1
        specf = specf1
        mfile = mfile1
        do 10 i=1,10
        factor(i) = facto1(i)
 10     zlevel(i) = zleve1(i)
        rsp = rsp1
        nx = nx1
        ny = ny1
        xs = xs1
        ys = ys1
        dx = dx1
        dy = dy1
        tsys = tsys1
        dateo = dateo1
        stime = stime1
        etime = etime1
        inst = inst1
        origin = origi1
        pdeg = pdeg1
        b0deg = b0deg1
        cl0deg = cl0de1
        aldeg = aldeg1
        apdeg = apdeg1
        kindmi = kindm1
        skylvl = skylv1
        ncarr = ncarr1
c
        do 20 i=1,NITEM
 20     nmlsw(i)=0
c
        if(nbytm1.ne.nbytmi) nmlsw(1)=1
        if(naxis1.ne.naxis) nmlsw(2)=1
        if(nfram1.ne.nframi) nmlsw(3)=1
        if(specf1.ne.specf) nmlsw(4)=1
        if(mfile.ne.mfile1) nmlsw(5)=1
        do 30 i=1,10
        if(facto1(i).ne.factor(i)) nmlsw(6)=1
        if(zleve1(i).ne.zlevel(i)) nmlsw(7)=1
 30     continue
        if(rsp1.ne.rsp) nmlsw(8)=1
        if(nx1.ne.nx) nmlsw(9)=1
        if(ny1.ne.ny) nmlsw(10)=1
        if(xs1.ne.xs) nmlsw(11)=1
        if(ys1.ne.ys) nmlsw(12)=1
        if(dx1.ne.dx) nmlsw(13)=1
        if(dy1.ne.dy) nmlsw(14)=1
        if(tsys1.ne.tsys) nmlsw(15)=1
        if(dateo1.ne.dateo) nmlsw(16)=1
        if(stime1.ne.stime) nmlsw(17)=1
        if(etime1.ne.etime) nmlsw(18)=1
        if(inst1.ne.inst) nmlsw(19)=1
        if(origi1.ne.origin) nmlsw(20)=1
        if(pdeg1.ne.pdeg) nmlsw(21)=1
        if(b0deg1.ne.b0deg) nmlsw(22)=1
        if(cl0de1.ne.cl0deg) nmlsw(23)=1
        if(aldeg1.ne.aldeg) nmlsw(24)=1
        if(apdeg1.ne.apdeg) nmlsw(25)=1
        if(kindm1.ne.kindmi) nmlsw(26)=1
        if(skylv1.ne.skylvl) nmlsw(27)=1
        if(ncarr1.ne.ncarr) nmlsw(28)=1
c
        nbytm1 = nbytmi
        naxis1 = naxis
        nfram1 = nframi
        specf1 = specf
        mfile1 = mfile
        do 40 i=1,10
        facto1(i) = factor(i)
 40     zleve1(i) = zlevel(i)
        rsp1 = rsp
        nx1 = nx
        ny1 = ny
        xs1 = xs
        ys1 = ys
        dx1 = dx
        dy1 = dy
        tsys1 = tsys
        dateo1 = dateo
        stime1 = stime
        etime1 = etime
        inst1 = inst
        origi1 = origin
        pdeg1 = pdeg
        b0deg1 = b0deg
        cl0de1 = cl0deg
        aldeg1 = aldeg
        apdeg1 = apdeg
        kindm1 = kindmi
        skylv1 = skylvl
        ncarr1 = ncarr
c
	return
	end	
