c  plot magnetogram and field lines
c  graphics interface : calcomp subroutines
c
	subroutine plotm( iunitp, iunitl, mfname, lfname )
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'mparam.fc'
	include 'string.fc'
	include 'fileio.fc'
	include 'fline.fc'
	include 'graph.fc'
c
	parameter (NLVL=20)
	integer iunit, iunitp, iunitl
	dimension xf(5),yf(5),xxc4(3,4),xxc40(3,4)
	dimension dlp(NLVL),dlm(NLVL),blp(NLVL),blm(NLVL),
     &	          flp(NLVL),flm(NLVL),alp(NLVL),alm(NLVL),
     &	          slp(NLVL),slm(NLVL),dummy(NLVL)
	real intlvl(NLVL),jlp(NLVL),jlm(NLVL)
	dimension iovr(4)
	dimension xp(ML),yp(ML),zp(ML),hp(ML)
	equivalence (xp(1),xyzr(1,1))
	equivalence (yp(1),xyzr(1,2))
	equivalence (zp(1),xyzr(1,3))
	equivalence (hp(1),xyzr(1,4))
c
	character goff*1, cls*3, strid*8, lpbuf*50,
     &	chrc*1, dumstr*8, comma*1, str*50, commnt*80,
     &	title1*80, title2*80, title3*80, title4*80,
     &	files*80, mfname*(*),lfname*(*)
c
	character*5 strx,stry,strz
	dimension kxlist(MZ),kylist(MZ),kzlist(MZ),
     &	          strx(MZ),stry(MZ),strz(MZ)
c
	logical update
	logical ask,arrow,lonlat,limb,clip,first
c
	xconv(x)=gfact*(x-gxc) +xfc
	yconv(y)=gfact*(y-gyc) +yfc
	rad(deg)=3.141592/180.0*deg
c
      data kxlist/MZ*0/, kylist/MZ*0/, kzlist/MZ*0/
      data strx/MZ*'     '/, stry/MZ*'     '/, strz/MZ*'     '/
c
c  Tektronix terminal control
c  graphic mode on  = 0x1d = 29
c  graphic mode off = 0x1f = 31
c  screen clear = esc + 0x0c = 27, 12
	goff=char(31)
	cls=goff//char(27)//char(12)
c
	ask= stdin.eq.keyin
	first=.true.
	comma=','
c
c  abs(lpout) : 1=portrait
	lpout=0
	if(ask) write(msg,*) 
     &	       'output mode? 0=graphics, 1=graphics+LBP, -1=LBP'
	read(stdin,*) lpout
	if(ask) write(msg,*) cls
c
c  gmode=0 : fixed view angle
c        1 : arbitrary view angle and scaling
c  (gmode=2 is also used internally)
c
	gmode=0
	if(ask) write(msg,*)
     &	'enable coordinate transform? 0=no, 1=yes'
	read(stdin,*) gmode
c
	do 20 i=1,3
 20	iovr(i)=0
	iovr(4)=2
c  default is to reset cl0deg unless mesh=4
c
	if(ask) write(msg,*)
     &      'calculate rsp,p,b0,cl0 from calendar? 0=no, 1=yes'
	read(stdin,*) iovr
	if(tsys.ne.' '.and.dateo.ne.' '.and.stime.ne.' ') then
	  call suncal(tsys,dateo,stime,sdist,rspc,pc,b0c,cl0c,
     &	              doy,irotno)
	  if(iovr(1).eq.1) rsp=arcsec*rspc
        if(iovr(2).eq.1 .and. pdeg.eq.ydeg) then
          pdeg=pc
          ydeg=pdeg
          call setdu
        endif
	  if(iovr(3).eq.1) b0deg=b0c
	  if(iovr(4).eq.1) cl0deg=cl0c
	  if(iovr(1).eq.2) rsp=arcsec*rsun
        if(iovr(2).eq.2 .and. pdeg.eq.ydeg) then
          pdeg=0.0
          ydeg=0.0
          call setdu
        endif
	  if(iovr(3).eq.2) b0deg=0.0
	  if(iovr(4).eq.2 .and. mesh.ne.4) cl0deg=0.0
        cl0=rad(cl0deg)
        if(mesh.eq.4) then
          cl0eff=cl0
        else
          cl0eff=0.0
        endif
	endif
c
c  sizecm=x-width of screen in cm
c  default sizecm = 16cm
c  scale is the scaling factor, cm / unit length(=10^4 km)
c  if scale =0, observed region is scaled to fill the display window
c
	sizecm=16.0
	scale=0.0
	if(ask) write(msg,*) 'enter display size (cm) and scale factor'
	read(stdin,*) sizecm,scale
c
c  meshl specifies initial projection mode
c  default value of meshl = 2 (by subr.initc)
c  if fieldline file is avaiable, meshl is overridden by kindli
c
c  current version number of input file
	iver0 = 2
c  check version number
        read(iunitp,*) strid,iver1
	call upper(strid)
        if(strid.ne.'PSETUP') then
          write(msg,*)
     &    '(subr.plotm ) error: this is not the psetup file'
          errflg=2
          return
        endif
	if(iver1.ne.iver0) then
	  write(msg,*)
     &	  '(subr.plotm ) error: version of psetup should be',
     &	  iver0
	  errflg=2
	  return
	endif
c
c  y-offset in cm = yoffcm
c  line separation in cm = vmicm
c  character size in cm = chrcm
c  eye distance = eyed
c  mesh separation in cm in plotting arrows = asepcm
c
	yoffcm=4.0
	chrcm=0.25
	clip=.false.	
	asepcm=0.4
c  order of input changed on 2000/10/09 to lpname,lpdev
        read(iunitp,*) lpname, lpdev
c  take care for old format 
        if(lpname(1:1).eq.'/') then
          lpbuf=lpname
          lpname=lpdev
          lpdev=lpbuf
        endif
	read(iunitp,*) meshl, yoffcm, vmicm, chrcm
	read(iunitp,*) eyed, clip
	read(iunitp,*) asepcm
	devcm=1.0
	xsize = devcm*sizecm
	yoff = yoffcm*devcm
	ysize=xsize + yoff
	yfsize=xsize
	vmi=vmicm*devcm
	chrsiz=chrcm*devcm
	arrsep=asepcm*devcm
c
      write(title1,400) inst,dateo,stime,etime,tsys,mfile
 400  format(a8,2x,a8,1x,a8,' - ',a8,'(',a6,')',2x,a8,24x)
c
c  read parameters for plotting from iunitp
c  contour levels should be from the smallest to the largest values in
c  order to detect level over(under)flows
c  if number of levels are <0, automatic level adjustment will be made
c
	rblmin=0.01
	nbl=-5
	read(iunitp,*) rblmin,nbl,blp
	do 30 i=1,NLVL
 30	blm(i)=-blp(i)
	rdmin=0.01
	ndl=-5
	read(iunitp,*) rdmin,ndl,dlp
	do 31 i=1,NLVL
 31	dlm(i)=-dlp(i)
	rimin=0.3
	nint=-5
	read(iunitp,*) rimin,nint,intlvl
c  intensity is normalized to nearly 1
	rjlmin=0.01
	njl=-5
	read(iunitp,*) rjmin,njl,jlp
	do 32 i=1,NLVL
 32	jlm(i)=-jlp(i)
	rflmin=0.01
	nfl=-5
	read(iunitp,*) rfmin,nfl,flp
	do 33 i=1,NLVL
 33	flm(i)=-flp(i)
	ralmin=0.01
	nal=-5
	read(iunitp,*) ramin,nal,alp
	do 34 i=1,NLVL
 34	alm(i)=-alp(i)
	rslmin=0.01
	nsl=-5
	read(iunitp,*) rsmin,nsl,slp
	do 35 i=1,NLVL
 35	slm(i)=-slp(i)
	btmax0=1000.0
	rbtmin=0.1
	read(iunitp,*) btmax0,rbtmin
	btmin0=btmax0*abs(rbtmin)
c
c  if rbtmin<0, bars displayed will be for btmin<bt<btmax
c  where btmax(min) are max(min) values of the data bt
c  if rbtmin>0, bars displayed are for btmin0<bt<btmax0
c
c  number of gray levels: not used in plotm
	graylvl=64
	cuelvl=16
	fwidth=1.0
	read(iunitp,*) graylvl,cuelvl,fwidth
c  parameters for depth cuing of field lines: not used in plotm
	hmax0=20.0
	rcue=0.5
	read(iunitp,*) hmax0,rcue
c
c  obtain data list
c  nxy=number of vector data
c  nz =number of scalar data
c
	call mklist(nxy,nz,kxlist,kylist,kzlist,strx,stry,strz)
	if(msglvl.gt.2) then
	  write(lst,*) '(subr.plotm ) mklist:'
	  write(lst,*) '  nxy,nz=',nxy,nz
	  write(lst,*) '  kxlist=',kxlist
	  write(lst,*) '  kylist=',kylist
	  write(lst,*) '  kylist=',kylist
	  write(lst,*) '  strx=',strx
	  write(lst,*) '  stry=',stry
	  write(lst,*) '  strz=',strz
	  read(keyin,'(a)') dumstr
	endif
c
	mlof0=0
	if(iunitl.gt.0) then
	  mlof0=1
	  update=.true.
          chksm1=chksum
c  chksm1 is the check sum of s1data which has been read
c  in the main program
        call readlh(iunitl,update)
        meshl=mod(kindli,10)
	  if(ftag.ne.mtag) then
	    write(lst,*) '(subr.plotm ) warning: ftag .ne. mtag'
	    write(lst,*) '  ftag=',ftag
	    write(lst,*) '  mtag=',mtag
	  endif
          if(ns1.gt.0 .and. (chksum.ne.chksm1)) then
            write(lst,*)
     &   '(subr.dispm ) warning: mismatch in checksum of s1data'
          endif
c
	else
	  mlof0=0
	endif
c
	mesho=0
	if(mesh.eq.-1) mesh=0
        if(gmode.eq.0) then
          if(mesh.ge.1.and.mesh.le.4 .and.
     &       meshl.ge.0.and.meshl.le.4) then
            call transm(kindm,mesh, kindm,mesho)
            if(msglvl.gt.1) write(lst,*)
     &                   '(subr.plotm ) subr.transm called'
          endif
c  if meshl<0, transm is not called.
c  this feature can be used to plot contours of data
c  as if they were in 2-D cartesian
c  since meshl is overwritten by kindl, meshl<0 can result
c  only when field line file is not read
c
        else
          if(mesh.eq.1.and.meshl.gt.1 .or.
     &       mesh.gt.1.and.(meshl.eq.0.or.meshl.eq.1)) then
            call transm(kindm,mesh, kindm,meshl)
            if(msglvl.gt.1) write(lst,*)
     &                   '(subr.plotm ) subr.transm called'
          else if(meshl.lt.0) then
            write(msg,*) 'error: gmode=1 and meshl<0',meshl
            errflg=2
            return
          endif
        endif
c
	rotdeg=0.0
	xeg=0.0
	zdeg=0.0
	dxc1=0.0
	dyc1=0.0
c
        dx0=dx
        dy0=dy
c  dx0 and dy0 are physical lengths, while dx and dy may be
c  spherical coordinates
c
	if(nx.eq.0.and.ny.eq.0) then
cc  reads1 sets dx=xe-xs, dy=ye-ys in cartesian coord.
	  dxy=min(dx,dy)/100
          dxy0=dxy
	else
          if(mesh.le.1 .or. meshl.lt.0) then
            dxy=min(abs(dx),abs(dy))
            dxy0=dxy
          else if(mesh.ge.2.and.meshl.ge.0) then
            dx0=dx*rsp
            dy0=alofy(dy)*rsp
            dxy0=min(abs(dx0),abs(dy0))
            dxy=min(abs(dx),abs(alofy(dy)))
          endif
          dxy0=max(1.0,float(min(nx,ny))/50.0)*dxy0/3.0
          dxy =max(1.0,float(min(nx,ny))/50.0)*dxy/3.0
	endif
c
c  four corners of observed region
c
	xf(1)=xs
	yf(1)=ys
	xf(2)=xs+dx*float(max(1,nx-1))
	yf(2)=yf(1)
	xf(3)=xf(2)
	yf(3)=ys+dy*float(max(1,ny-1))
	xf(4)=xf(1)
	yf(4)=yf(3)
	xf(5)=xf(1)
	yf(5)=yf(1)
c  xf and yf are in D-coordinates
c
        if(meshl.lt.0) then
	  do 50 n=1,4
          xxc4(1,n)=xf(n)
          xxc4(2,n)=yf(n)
          xxc4(3,n)=0.0
 50	  continue
        else if(mesh.eq.0) then
	  do 51 n=1,4
          call dtoc2(xf(n),yf(n), xxc4(1,n),xxc4(2,n))
          call projsr(xxc4(1,n), rsp)
 51	  continue
        else if(mesh.eq.1) then
	  do 52 n=1,4
          xxc4(1,n)=xf(n)
          xxc4(2,n)=yf(n)
          xxc4(3,n)=0.0
          call ttoc(xxc4(1,n),xxc4(1,n))
 52	  continue
        else if(mesh.ge.3.and.meshl.ge.0) then
          call transf(mesh,mesho,
     &                nx, ny, xs, ys, dx, dy,
     &                nx1,ny1,xs1,ys1,dx1,dy1,xe1,ye1)
          xxc4(1,1)=xs1
          xxc4(2,1)=ys1
          xxc4(1,2)=xe1
          xxc4(2,2)=xxc4(2,1)
          xxc4(1,3)=xxc4(1,2)
          xxc4(2,3)=ye1
          xxc4(1,4)=xxc4(1,1)
          xxc4(2,4)=xxc4(2,3)
          do 53 n=1,4
          call dtoc2(xxc4(1,n),xxc4(2,n), xxc4(1,n),xxc4(2,n))
          call projsr(xxc4(1,n), rsp)
 53       continue
        endif
	do 54 n=1,4
	do 54 i=1,3
 54	xxc40(i,n)=xxc4(i,n)
c
c  xxc4 are in C-coordinates
c
c  drawable area
c  (xfl,xfr) = lower left corner
c  (yfl,yfr) = upper right corner
c  (xfc,yfc) = center of window
c
c  clipping window
c  (xclipl,yclipb) = lower left corner
c  (xclipr,yclipt) = upper right corner
c
	xfl=0.0
	xfr=xsize
	yfl=0.0
	yfr=yfsize
	xfc=0.5*(xfl+xfr)
	yfc=0.5*(yfl+yfr)
	gxc = 0.25*(xxc4(1,1)+xxc4(1,2)+xxc4(1,3)+xxc4(1,4))
	gyc = 0.25*(xxc4(2,1)+xxc4(2,2)+xxc4(2,3)+xxc4(2,4))
c
	if(scale.gt.0.0) then
	  gfact=devcm*scale
	  scale1=scale
	else
	  gfact = min( xsize / (abs(xxc4(1,2)-xxc4(1,1))
     &                       + abs(xxc4(1,4)-xxc4(1,1)) ),
     &               yfsize / (abs(xxc4(2,2)-xxc4(2,1))
     &                       + abs(xxc4(2,4)-xxc4(2,1)) ) )
	  if(scale.lt.0.0) gfact=gfact*abs(scale)
	  scale1=gfact/devcm
	endif
c
	xclipl = gfact*(min(xxc4(1,1),xxc4(1,4)) -gxc) +xfc
	xclipr = gfact*(max(xxc4(1,2),xxc4(1,3)) -gxc) +xfc
	yclipb = gfact*(min(xxc4(2,1),xxc4(2,2)) -gyc) +yfc
	yclipt = gfact*(max(xxc4(2,3),xxc4(2,4)) -gyc) +yfc
c
	mauto=0
	if(ask) then
	  write(msg,100)
     &'select 0(manual), 1(standard-sequence), or 2(local-sequence) : '
 100	  format(2x, a,$)
	endif
c  output to msg and to lst may be asynchronous
c  therefore text output should also be directed to lst, rather
c  than to msg
c
	read(stdin,*) mauto
	if(mauto.eq.1) then
	  iunit=iunitp
	  ask=.false.
	elseif(mauto.eq.2) then
	  iunit=stdin
	  ask=.false.
	else
	  iunit=keyin
	  ask=.true.
	endif
c
	if(lpout.ge.0) then
	  write(msg,*) 'output to Tektronix terminal : hit CR '
	  read(keyin,'(a)') dumstr
	endif
c
	call plots(0.5*devcm,1.0*devcm,lpout)
c  shift 1.0cm up to make space for message
c
 1	continue
	mlof=0
	mregn=0
	mfram=0
	mglobe=0
	mi=0
	kc=0
	kx=0
	ky=0
	title2=' '
	title3=' '
	title4=' '
	isp=1
c
c  rotation angle and view angles
c
	if(gmode.eq.1) then
	  write(msg,100) 
     &	  cls//'enter rotation and view angles (rotr,rotz,rotx) '
	endif
	if(gmode.eq.1 .or. .not.ask)
     &	  read(iunit,*,end=97) rotdeg, zdeg,xdeg
	if(gmode.eq.1 .and. .not.ask)
     &      write(msg,*) rotdeg,zdeg,xdeg
c  if eof, try keyin
	if(gmode.eq.1) then
c  the unit of dxc1 and dyc1 is ulen (=10^4 km)
	  write(msg,100)
     &	  cls//'enter scale factor(=0.0 for reset), offset (dx,dy) '
	endif
	if(gmode.eq.1 .or. .not.ask)
     &	  read(iunit,*,end=99) scale,dxc1,dyc1
	if(gmode.eq.1 .and. .not.ask)
     &      write(msg,*) scale,dxc1,dyc1
c
	if(gmode.eq.1) then
	  if(rotdeg.ne.0.0 .or. zdeg.ne.0.0 .or.
     &	    xdeg.ne.0.0 .or. scale.ne.0.0) then
	    clip=.false.
	  else
cx          clip=.true.
	    clip=clip
	  endif
c
	  call setmat(rotdeg, zdeg,xdeg)
	  do 55 n=1,3
 55	  call rotpt(xxc40(1,n),xxc4(1,n))
	  gxc = 0.25*(xxc4(1,1)+xxc4(1,2)+xxc4(1,3)+xxc4(1,4))
     &	      -dxc1
	  gyc = 0.25*(xxc4(2,1)+xxc4(2,2)+xxc4(2,3)+xxc4(2,4))
     &	      -dyc1
c
	  if(scale.gt.0.0) then
	    gfact=devcm*scale
	    scale1=scale
	  else
            gfact = min( xsize / (abs(xxc4(1,2)-xxc4(1,1))
     &                        + abs(xxc4(1,4)-xxc4(1,1)) ),
     &                 yfsize / (abs(xxc4(2,2)-xxc4(2,1))
     &                        + abs(xxc4(2,4)-xxc4(2,1)) ) )
	    scale1=gfact/devcm
	  endif
	endif
c
	if(gmode.eq.0) then
	  write(title4,300) scale1
	else
	  write(title4,310) rotdeg,zdeg,xdeg,scale1
	endif
 300	format('SCALE FACTOR=',f8.4)
 310	format('ROTR=',f6.1,4x,'(ROTZ,ROTX)=',2f6.1,4x,
     &	  'SCALE FACTOR=',f8.4)
c
	ki=kiloc()
	if(meshl.ge.0) then
	  write(msg,100)
     &	  cls//'location of observed area : 0=skip, 1=plot '
	endif
c
	read(iunit,*,end=99) mregn
	if(.not.ask .and. meshl.ge.0) write(msg,*) mregn
	if(meshl.ge.0) then
	  if(mregn.eq.1) then
	    call plotr(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	         title1,rsp,pdeg-ydeg,b0deg,cl0deg,
     &	         ki,xxc4,
     &	         white,yellow)
c  the index ki rather than the data array rdata(*,*,ki) is passed to
c  plotr because ki might be 0
c
	    call symbol(xfl,ysize-5.0*vmi, chrsiz,title4, 0.0, 40)
c  print title4(1:40), which does not include scale factor
	    go to 9100
	  endif
	endif
c
	if(nz.gt.0)
     &	write(msg,110) cls//'contour map : 0=skip',
     &	(comma,n,strz(n),n=1,nz)
 110	format(2x, a, 5(a1,i2,'=',a5, $))
c
	nc=0
	chrc=' '
	if(.not.ask .or. nz.gt.0) read(iunit,*,end=99) nc
	if(nz.eq.0) nc=0
	if(.not.ask .and. nz.gt.0) write(msg,*) nc
	if(nc.gt.0 .and. nc.le.nz) then
	  kc=kzlist(nc)
	  chrc=strz(nc)(1:1)
	endif
c
	if(nxy.gt.0) write(msg,120)
     &	 cls//'vector map : 0=skip ',
     &	(comma,n,strx(n),stry(n),n=1,nxy)
 120	format(2x, a, 5(a1,i2,'=(',a5, ',',a5,') ' ,$))
c
	nv=0
	arrow=.true.
	if(.not.ask .or. nxy.gt.0) read(iunit,*,end=99) nv
	if(nxy.eq.0) nv=0
	if(.not.ask .and. nxy.gt.0) write(msg,*) nv
	if(nv.lt.0) then
	  nv=-nv
	  arrow=.false.
	endif
	if(nv.gt.0 .and. nv.le.nxy) then
	  kx=kxlist(nv)
	  ky=kylist(nv)
	endif
c
	if(ki.gt.0) write(msg,100)
     &	  cls//'intensity in dots: 0=skip, 1=plot '
	if(.not.ask .or. ki.gt.0) read(iunit,*,end=99) mi
	if(ki.le.0) mi=0
	if(.not.ask .and. ki.gt.0) write(msg,*) mi
c
	if(meshl.ge.0) write(msg,100)
     &	  cls//'longitude/latitude circles: 0=skip, 1=plot '
	if(.not.ask .or. meshl.ge.0) read(iunit,*,end=99) mglobe
	if(meshl.lt.0) mglobe=0
	if(.not.ask .and. meshl.ge.0) write(msg,*) mglobe
c
	write(msg,100)
     &	  cls//'border of observed region: 0=skip, 1=plot '
	read(iunit,*,end=99) mfram
	if(.not.ask) write(msg,*) mfram
c
	if(mlof0.eq.1) then
	  write(msg,100)
     &	  cls//'field lines : 0=skip, 1=plot all, 2=closed, 3=open '
	endif
	if(.not.ask .or. mlof0.gt.0) read(iunit,*,end=99) mlof
	if(mlof0.eq.0) mlof=0
	if(.not.ask .and. mlof0.gt.0) write(msg,*) mlof
c
c  scale indicator (longer than 3mm, shorter than 30mm)
c
	if(meshl.lt.0) go to 3000
	xp1=xfr-2.0*devcm
	yp1=yfr+0.5*devcm
	gauge=gfact*(rsp*1.0e9)/(rsun*ulen)
	if(gauge.lt.0.3) then
	  gauge=gauge*10.0
	  call symbol(xp1,yp1, chrsiz,'10**5 KM', 0.0, 8)
	else if (gauge.gt.3.0) then
	  gauge=gauge/10.0
	  call symbol(xp1,yp1, chrsiz,'10**3 KM', 0.0, 8)
	else
	  call symbol(xp1,yp1, chrsiz,'10**4 KM', 0.0, 8)
	endif
	call newpen(thick+white)
	xp1=xp1-0.2*devcm
	call plot(xp1,yp1-0.1*devcm, 3)
	call plot(xp1,yp1+0.1*devcm, 2)
	call plot(xp1,yp1, 3)
	xp1=xp1-gauge
	call plot(xp1,yp1, 2)
	call plot(xp1,yp1-0.1*devcm, 2)
	call plot(xp1,yp1, 2)
	call plot(xp1,yp1+0.1*devcm, 2)
	call newpen(white)
c
c  intensity in dots
c
 3000 if(mi.ne.1.or.ki.le.0) go to 3500
	call newpen(yellow)
	call pltdot(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	     MX,rdata(1,1,ki),intlvl)
c
c  solar limb and longitude/latitude circles
c
 3500	if(mglobe.eq.1) then
	  lonlat=.true.
	else
	  lonlat=.false.
	endif
	limb=meshl.ne.0
	call newpen(yellow)
	call sphere(xxsp,rsp,cl0eff,xxc4,dxy0,lonlat,limb,clip)
c  if limb=T, solar limb is drawn
c  if clip=T, long./lat. circles are only drawn inside the 
c  observed region
c
c  contour plot
c
 4000	if(kc.eq.0) go to 5000
	mkdot=1
	nodot=0
	if(chrc.eq.'I') then
	  call newpen(yellow)
	  call lvl125(nx,ny,MX,rdata(1,1,kc),nint,intlvl,dummy,str)
	  nlevel=iabs(nint)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	            nlevel,intlvl,nodot,dxy,idata4)
c
	else if(chrc.eq.'V') then
	  call newpen(blue)
	  call lvl125(nx,ny,MX,rdata(1,1,kc),ndl,dlp,dlm,str)
	  nlevel=iabs(ndl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,dlp,nodot,dxy,idata4)
	  call newpen(red)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,dlm,mkdot,dxy,idata4)
c
	else if(chrc.eq.'B') then
	  call newpen(red)
	  call lvl125(nx,ny,MX,rdata(1,1,kc),nbl,blp,blm,str)
	  nlevel=iabs(nbl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,blp,nodot,dxy,idata4)
	  call newpen(blue)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,blm,mkdot,dxy,idata4)
c
	else if(chrc.eq.'J' .or. chrc.eq.'1') then
	  call newpen(red)
	  call lvl125(nx,ny,MX,rdata(1,1,kc),njl,jlp,jlm,str)
	  nlevel=iabs(njl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,jlp,nodot,dxy,idata4)
	  call newpen(blue)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,jlm,mkdot,dxy,idata4)
c
	else if(chrc.eq.'F') then
	  call newpen(red)
	  call lvl125(nx,ny,MX,rdata(1,1,kc),nfl,flp,flm,str)
	  nlevel=iabs(nfl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,flp,nodot,dxy,idata4)
	  call newpen(blue)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,flm,mkdot,dxy,idata4)
c
	else if(chrc.eq.'A') then
	  call newpen(red)
	  call lvl125(nx,ny,MX,rdata(1,1,kc),nal,alp,alm,str)
	  nlevel=iabs(nal)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,alp,nodot,dxy,idata4)
	  call newpen(blue)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,alm,mkdot,dxy,idata4)
c
	else
	  call newpen(yellow)
	  call lvl125(nx,ny,MX,rdata(1,1,kc),nsl,slp,dummy,str)
	  nlevel=iabs(nsl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc),
     &	       nlevel,slp,nodot,dxy,idata4)
c
	endif
	write(title2,200) strz(nc)
 200  format('CONTOURS:', a5, '  LEVELS=')
	title2(25:)=str
c
c  transverse field -- line segments
c
 5000	if(kx.eq.0.or.ky.eq.0) go to 6000
	if(rbtmin.gt.0.0) then
	  btmax=btmax0
	  btmin=btmin0
	else
	  btmax=0.0
	  do 5100 i=1,nx
	  do 5100 j=1,ny
	  bt=sqrt(rdata(i,j,kx)**2+rdata(i,j,ky)**2)
	  if(bt.gt.btmax) btmax=bt
 5100	  continue
	  btmin=btmax*abs(rbtmin)
	endif
c  set arrow=true for vectorized data
	arrow=arrow.and.mod(kindm,10).gt.2
	if(.not.arrow) call newpen(thick+white)
	if(mod(kindm,10).eq.6 .and. kx.ne.kxploc()) arrow=.false.
	call pltbar(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	     MX,rdata(1,1,kx),rdata(1,1,ky),
     &	     btmin,btmax,arrow,arrsep)
	write(title3(isp:),210) strx(nv),stry(nv),btmax,btmin
 210	format('VECTORS:',2a5,'MAX,MIN=',2f5.0)
	isp=isp+40
c
c  frame
c
c  arguments of pline2 should be D-coordinates
 6000	if(mfram.ne.1) go to 6500
	call newpen(white)
	if(gmode.eq.0) then
	  call pline2(5, xf,yf)
	else
	  do 6100 n=1,4
	  alen=sqrt( (xf(n+1)-xf(n))**2
     &	           + (yf(n+1)-yf(n))**2 )
	  np=min(int(alen/dxy),ML)
	  do 6200 ip=1,np
	  xp(ip)=xf(n)+(xf(n+1)-xf(n))*float(ip-1)/float(np-1)
	  yp(ip)=yf(n)+(yf(n+1)-yf(n))*float(ip-1)/float(np-1)
 6200	  continue
 6100	  call pline2(np, xp,yp)
	endif
c
c  title
c
 6500	continue
	call newpen(white)
	ipos=lenstr(mfname)
	if(iunitl.gt.0) then
	  files='FILES='//mfname(1:ipos+1)//lfname
	else
	  files='FILES='//mfname(1:ipos+1)
	endif
	call symbol(xfl,ysize-1.0*vmi, chrsiz,files , 0.0, 80)
	call symbol(xfl,ysize-2.0*vmi, chrsiz,title1, 0.0, 80)
	call symbol(xfl,ysize-3.0*vmi, chrsiz,title2, 0.0, 80)
	call symbol(xfl,ysize-4.0*vmi, chrsiz,title3, 0.0, 80)
	call symbol(xfl,ysize-5.0*vmi, chrsiz,title4, 0.0, 80)
c
c  field lines
c
	msav=msglvl
	if(.not.first) msglvl=0
	if(mlof0.eq.0 .or. mlof.eq.0) go to 9000
	call newpen(thick+green)
	update=.false.
	call readlh(iunitl,update)
	first=.false.
c
 1100	continue
	call readl(iunitl,np,xyzp)
	if(np.eq.0) go to 9000
c
	eps=0.005*rsp
	do 1200 n=1,np
	xp(n)=xyzp(1,n)
	yp(n)=xyzp(2,n)
	zp(n)=xyzp(3,n)
	hp(n)=height(xyzp(1,n),meshl)
 1200	continue
c
	if(mlof.eq.2 .and. (hp(1).gt.eps .or. hp(np).gt.eps) )
     &      go to 1100
	if(mlof.eq.3 .and. hp(1).lt.eps .and. hp(np).lt.eps)
     &      go to 1100
c
	call pline3(np,xp,yp,zp)
c  arguments of pline3 should be C-coordinates
	go to 1100
c
 9000	continue
	msglvl=msav
c
 9100	call plot(0.0*devcm,-0.7*devcm,3)
	if(lpout.eq.0) then
	  write(msg,100) goff//'enter 1=restart, 9=end : '
	else
	  write(msg,100) goff//'enter 1=restart, 2=hardcopy, 9=end : '
	endif
	read(iunit,*,end=98) mode1
	if(.not.ask)  write(msg,*) mode1
c
c  erase screen and restart
	if(mode1.eq.1) then
cx	  call plot(0.0,0.0, 1000)
cx	  call sleep(1)
c  this caused trouble of erasing the next text output
c  since cls is inserted at every message line, screen is not erased here
	  go to 1
c  hardcopy
	else if(lpout.ne.0 .and. mode1.eq.2) then
        if(ask) then
          write(msg,*) 'enter comment : '
          read(iunit,'(a)') commnt
	    call symbol(xfl,ysize-6.0*vmi, chrsiz,commnt, 0.0, 80)
        endif
	  call plot(0.0,0.0, 999)
	  call sleep(1)
	  go to 9100
c  end of plot
	else if(mode1.eq.9) then
	  go to 99
	else
	  iunit=keyin
	  ask=.true.
	  mauto=0
	  go to 9100
	endif
c
 97	if(iunit.eq.keyin) go to 99
	iunit=keyin
	ask=.true.
	mauto=0
	go to 1
c
 98	if(iunit.eq.keyin) go to 99
	iunit=keyin
	ask=.true.
	mauto=0
	go to 9100
c
 99	call plote()
	if(mfname.ne.' ')
     &      write(lst,*) 'magnetogram id=',mfile,
     &      ', filename=',mfname(1:lenstr(mfname))
	if(iunitl.gt.0.and.lfname.ne.' ')
     &      write(lst,*) 'field lines id=',lfile,
     &      ', filename=',lfname(1:lenstr(lfname))
	return
c
	end
c
c  interface to calcomp subroutines
c  gmode=0 : fixed view angle
c        1 : arbitrary view angle and scaling
c        2 : draw solar limb (pline3, use pers instead of rotpt)
c
	subroutine pline2(np,xp,yp)
c
c  this subroutine is for contour plot
c  (xp,yp) are given in D-coordinates
c
	include 'graph.fc'
        include 'fline.fc'
        include 'coord.fc'
c
	dimension xp(np),yp(np),zp(np),xx(3)
	logical l1,l2,visibl
c
	xconv(x)=gfact*(x-gxc) +xfc
	yconv(y)=gfact*(y-gyc) +yfc
c
	if(np.le.1) return
	l1=.false.
	delta1=0.05*devcm
c
	do 10 n=1,np
c
        if(gmode.eq.0) then
            call dtoc2(xp(n),yp(n), xx(1),xx(2))
	else if(gmode.eq.1) then
          if(mesh.eq.0) then
            call dtoc2(xp(n),yp(n), xx(1),xx(2))
            call proj(xx,meshl)
c
c  mesh=1 and meshl=1
          else if(mesh.eq.1) then
            xx(1)=xp(n)
            xx(2)=yp(n)
            xx(3)=0.0
            call ttoc(xx,xx)
c
c  mesh=2 and meshl=2,3,4
          else if(mesh.eq.2) then
            call stoc(xp(n),alofy(yp(n)),0.0, xx)
c
c  mesh=3,4 and meshl=2,3,4
          else if(mesh.eq.3.or.mesh.eq.4) then
            call rtoc(xp(n),alofy(yp(n)),0.0, xx)
          endif
          call rotpt(xx,xx)
        endif
c
	rxp=xconv(xx(1))
	ryp=yconv(xx(2))
	l2=   rxp.ge.xfl-delta1 .and. rxp.le.xfr+delta1
     &	.and. ryp.ge.yfl-delta1 .and. ryp.le.yfr+delta1
	if(gmode.eq.1) l2=l2.and.visibl(xx)
	if(l2) then
	  if(l1) then
	    call plot(rxp,ryp,2)
	  else
	    call plot(rxp,ryp,3)
	  endif
	endif
	l1=l2
 10	continue
	return
c
	entry pline3(np,xp,yp,zp)
c
c  this subroutine is for field line plot and for spherical grid
c  (xp,yp,zp) are in C-coordinates
c
	if(np.le.1) return
	l1=.false.
	delta1=0.05*devcm
c
	do 30 n=1,np
	xx(1)=xp(n)
	xx(2)=yp(n)
	xx(3)=zp(n)
	if(gmode.eq.1) call rotpt(xx,xx)
	if(gmode.eq.2) call pers(xx,xx)
	rxp=xconv(xx(1))
	ryp=yconv(xx(2))
	l2=   rxp.ge.xfl-delta1 .and. rxp.le.xfr+delta1
     &	.and. ryp.ge.yfl-delta1 .and. ryp.le.yfr+delta1
     &	.and. visibl(xx)
	if(l2) then
	  if(l1) then
	    call plot(rxp,ryp,2)
	  else
	    call plot(rxp,ryp,3)
	  endif
	endif
	l1=l2
 30	continue
	return
c
c  this subroutine is for N,S,E,W marks
c  (xp,yp,zp) are in C-coordinates
c
	entry pline5(np,xp,yp,zp,xp1,yp1)

	l1=.false.
	delta1=0.05*devcm
c
	do 40 n=1,np
	xx(1)=xp(n)
	xx(2)=yp(n)
	xx(3)=zp(n)
	if(gmode.eq.1) call rotptv(xx,xx)
	rxp=xconv(xx(1))
	ryp=yconv(xx(2))
	l2=   rxp.ge.xfl-delta1 .and. rxp.le.xfr+delta1
     &	.and. ryp.ge.yfl-delta1 .and. ryp.le.yfr+delta1
	if(l2) then
	  if(l1) then
	    call plot(rxp,ryp,2)
	  else
	    call plot(rxp,ryp,3)
	  endif
	endif
	if(n.eq.1) then
	  xp1=rxp
	  yp1=ryp
	endif
	l1=l2
 40	continue
	return
	end
c
c  intensity map with dots
c  intlvl(1) < intensity             -- no dots
c  intlvl(2) < intensity < intlvl(1) -- one dot in 5x5 area
c  intlvl(3) < intensity < intlvl(2) -- 4  dots in 5x5 area
c  intlvl(4) < intensity < intlvl(3) -- 13 dots in 5x5 area
c              intensity < intlvl(4) -- ignore (maybe beyond the limb)
c
	subroutine pltdot(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	           ndim,rdata,
     &	           intlvl)
c
	include 'sys.fc'
	include 'graph.fc'
	dimension rdata(ndim,ndim),idot(5,5,3),xp(2),yp(2)
	real intlvl(4)
c
	data idot/12*0,1,12*0,
     &	           5*0,0,1,0,1,0,5*0,0,1,0,1,0,5*0,
     &	           1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1/
	idd0=5
	valmax=frmean(rdata,nx,ny,ndim)
c
c  assume 2mm is the size of elementary dot patterns
	ndx=max(1.0,dx0/(0.2*devcm/gfact) +0.51)
	ndy=max(1.0,dy0/(0.2*devcm/gfact) +0.51)
	ddx=dx/float(ndx)
	ddy=dy/float(ndy)
c
	do 1000 i=2,nx
	do 1000 j=2,ny
	do 1000 ii=1,ndx
	do 1000 jj=1,ndy
	ex=(float(ii)-0.5)/float(ndx)
	ey=(float(jj)-0.5)/float(ndy)
	a00=rdata(i-1,j-1)
	a10=rdata(i  ,j-1)
	a01=rdata(i-1,j  )
	a11=rdata(i  ,j  )
	val=a00+(a10-a00)*ex+(a01-a00)*ey+(a00+a11-a10-a10)*ex*ey
	val=val/valmax
c  val=intensity normalized by max.intensity
	xp0 = xs + dx*float(i-2) + ddx*float(ii-1)
	yp0 = ys + dy*float(j-2) + ddy*float(jj-1)
	if(val.gt.intlvl(1)) go to 1000
	if(val.lt.intlvl(4)) go to 1000
	if(val.gt.intlvl(2)) then
	  lvl=1
	else if(val.gt.intlvl(3)) then
	  lvl=2
	else
	  lvl=3
	endif
c
	do 1100 iii=1,idd0
	do 1100 jjj=1,idd0
	if(idot(iii,jjj,lvl).eq.0) go to 1100
	  xp(1) = xp0 + ddx*float(iii-1)/float(idd0)
	  yp(1) = yp0 + ddy*float(jjj-1)/float(idd0)
	  xp(2)=xp(1)
	  yp(2)=yp(1)
	  call pline2(2,xp,yp)
 1100 continue
 1000 continue
c  arguments of pline2 should be D-coordinates
	return
	end
c
c  plot bars
c
	subroutine pltbar(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	           ndim,xdata,ydata,
     &	           btmin,btmax,arrow,arrsep)
c
	include 'sys.fc'
	include 'graph.fc'
c
	dimension xdata(ndim,ndim),ydata(ndim,ndim),xp(2),yp(2)
	real loglvl
	logical arrow
c
c  arrsep is minimum arrow separation
c  grid size of arrow plotting is dx*ndxar, dy*ndyar
        ndxar=arrsep/(dx0*gfact)
        ndyar=arrsep/(dy0*gfact)
        if (ndxar.lt.1) ndxar=1
        if (ndyar.lt.1) ndyar=1
c
c  arrow size = 1mm
	asize=0.1*devcm/gfact*(dx/dx0)
	f=0.4
c  minimum length of bars = 0.5mm
	ww=0.05*devcm/gfact
	dx1=dx*float(ndxar)
	dy1=dy*float(ndyar)
	dbmax=sqrt(dx1**2+dy1**2)
c
	do 1000 i=2,nx-1,ndxar
	do 1000 j=2,ny-1,ndyar
	bt=sqrt(xdata(i,j)**2+ydata(i,j)**2)
	db=dbmax*loglvl(bt,btmin,btmax)
	if(db.lt.ww) go to 1000
	ux=xdata(i,j)/bt
	uy=ydata(i,j)/bt
	dxx=ux*db
	dyy=uy*db
	xp(1) = xs + dx*float(i-1) + 0.5*dxx
	xp(2) = xs + dx*float(i-1) - 0.5*dxx
	yp(1) = ys + dy*float(j-1) + 0.5*dyy
	yp(2) = ys + dy*float(j-1) - 0.5*dyy
	call pline2(2,xp,yp)
c  arguments of pline2 should be D-coordinates
	if(.not.arrow) go to 1000
	if(db.lt.asize) go to 1000
c
	vx=-uy
	vy= ux
c  (ux,uy) and (vx,vy) are orthogonal
	xp(2) = xp(1) - (asize*ux+f*asize*vx)
	yp(2) = yp(1) - (asize*uy+f*asize*vy)
	call pline2(2,xp,yp)
	xp(2) = xp(1) - (asize*ux-f*asize*vx)
	yp(2) = yp(1) - (asize*uy-f*asize*vy)
	call pline2(2,xp,yp)
 1000 continue
	return
	end
