c  plotmain.f
c
	program plotp
c
	include 'sys.fc'
	include 'fileio.fc'
	include 'string.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'mdata.fc'
	include 'fcntl.fc'
	include 'procs.fc'
c
	character chr*1,cfile*80,specf(10)*8,
     &	          line*80,line1*80,line2*80
	dimension multi(20)
	data specf/10*' '/, multi/20*0/
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	msglvl = 1
c
c  character code should either be ASCII or EBCDIC
c  binary integer should either be big endian or
c  full-byte-swap little endian
        include 'sysconf.cfg'
c
        if(mycode.eq.0 .or. myint.eq.0) stop
        if(errflg.gt.0) stop
c
c  initialize commons /fcntl/ and /procs/
        call initfc
c
c  open list file
	lst = lstini()
c
c  print version number
	call vsn
c
c  common variables should be static
        call static(ist)
        if(ist.gt.1) stop
c  algorithm for byte swap should be correct
        call swap(iswap)
        if(iswap.gt.0) stop
c
      if(myargc().eq.1) then
        call myargv(1,cfile)
      else
        cfile=' '
        write(msg,*,err=2)
     &	'enter control file name (default=pcontrol.dat)'
        go to 3
 2      msg=lst
        write(msg,*) 'enter control file name (default=pcontrol.dat)'
 3      read(keyin,'(a)',end=4) cfile
 4      if(cfile.eq.' ') cfile='pcontrol.dat'
      endif
c
        call openfl(cntrol,lname(cntrol),stdin,cfile,text,rdo,0)
	write(lst,*) '(proc.plot  ) start'
c
c  the first column of the first line gives the global msglvl
	read(stdin,'(a1,a)') chr,line
	if(chr.eq.'0') then
	  msglvl=0
	else if(chr.eq.'1') then
	  msglvl=1
	else if(chr.eq.'2') then
	  msglvl=2
	else if(chr.eq.'3') then
	  msglvl=3
	endif
c
c  current version number of control file
        iver0=1
c  check the version number
        call split(line,'=',line1,line2,len1,len2)
        if(len2.eq.0) then
          iver1=0
        else
          read(line2,*) iver1
        endif
        if(iver1.ne.iver0.and.
     &	  .not.(iver0.eq.1.and.iver1.eq.0)) then
          write(msg,*) 'error: version of control file should be',
     &    iver0
          errflg=2
          stop
        endif
c
c  initialize common variables and read auxdata
	multi1=0
	call assign( init,multi1 )
	if(errflg.gt.0) stop
	call initc( funit(auxdat) )
	call clsfl (auxdat)
c
        if(nbytem.ne.0) then
          nbytem=sign(nbytem,myint)
        else
          nbytem=myint
        endif
        if(nbytel.ne.0) then
          nbytel=sign(nbytel,myint)
        else
          nbytel=myint
        endif
c
c  reset modelf to 0
	modelf =0
c
 1000	continue
	errflg=0
	ms=0
c
c
c  proc.rfits
c  read a magnetogram data file with the FITS format and create
c  a raw magnetogram (rmgram) in the MAGPACK2 standard format
c  subr.writem is not called: integer data in FITS file are
c  written as they are to rmgram
c
c  subr.assign reads msglvl
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( rfits,multi(ms) )
	if(errflg.gt.1) go to 1001
	if(multi(ms).lt.0) stop
c
c  in version-1,
c  format of control file changed for fits file handling
        if(iver0.eq.1.and.iver1.eq.0) then
          write(msg,*) 'error: version of control file should be',
     &    iver0
          errflg=2
          stop
        endif
c
	if(errflg.eq.0) then
          nbinx=1
          nbiny=1
          ixs=0
          ixe=0
          iys=0
          iye=0
          read(stdin,*) nbinx,nbiny,ixs,ixe,iys,iye
c  binning factors may be altered by subr.rfits
c  subr.rdfits reads namelist &fits
          call rdfits( funit(fitsi) )
          if(errflg.gt.1) go to 1001
          dxnew=dx
          dynew=dy
          read(stdin,*) dxnew,dynew
          call rebin(dxnew,dynew)
c  dx and dy are altered in subr.rebin
          if(errflg.gt.1) go to 1001
          call writem(funit(rmgram))
          if(errflg.gt.1) go to 1001
c
        endif
c
 1001	continue
	if(errflg.ne.1) then
	  call clsfl (fitsi)
	  call clsfl (rmgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.plot
c  plot magnetogram and field lines
c
c	subr.assign reads msglvl,rdlof,rdimap,rddmap,rds2
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( plot,multi(ms) )
 	if(errflg.gt.1) go to 1002
	if(multi(ms).lt.0) stop
c
 	if(errflg.eq.0) then
	  kindm=0
 	  read(stdin,*) kindm,mesho
 	  if (rdimap) then
 	    call readiv( lspec('I'), funit(imap) )
	    if(errflg.gt.1) go to 1002
 	  endif
c
 	  if (rddmap) then
 	    call readiv( lspec('VL'), funit(dgram) )
	    if(errflg.gt.1) go to 1002
 	  endif
c  read s1 source if necessary
	  if(rds1) then
	    call reads1( funit(s1data) )
	    if(errflg.gt.1) go to 1002
	  endif
c
c  read magnetogram
c
	  call load(mgram)
	  if(errflg.gt.1) go to 1002
c
    	  call plotm ( funit(psetup), funit(pltlof),
     &	         fname(mgram), fname(pltlof) )
	  if(errflg.gt.1) go to 1002
c
 	endif
c
 1002	continue
	if(errflg.ne.1) then
 	  if (rdimap) call clsfl (imap)
 	  if (rddmap) call clsfl (dgram)
	  if(rds1) call clsfl (s1data)
	  if(rds2) call clsfl (mgram)
 	  if(rdlof) call clsfl (pltlof)
 	  call clsfl (psetup)
	endif
	if(errflg.gt.1) go to 1900
c
 1900	continue
        do 1100 i=1,20
        if(multi(i).ne.0) then
          if(errflg.le.1) go to 1000
        endif
 1100   continue
c  it is better stop the job here if errflg=2, because the correspondence
c  between the input and output files may become non-synchronous
c
	write(lst,*) '(proc.plot  ) end'
	stop
	end
