c  location of observed region
c
	subroutine plotr(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	           title,rsp1,pdeg,b0deg,cl0deg,
     &	           ki,xxc4,
     &	           color1,color2)
c
	include 'graph.fc'
	include 'coord.fc'
	include 'fline.fc'
	include 'mdata.fc'
cx	character buf*80, title*(*)
	character buf*80, title*80
	integer color1,color2
	logical lonlat,globe,clip
c  ML is defined in fline.fc
	dimension xp(ML),yp(ML),xf(5),yf(5)
	dimension xpn(3),xps(3),xpe(3),xpw(3),
     &          ypn(3),yps(3),ype(3),ypw(3),
     &          zpn(3),zps(3),zpe(3),zpw(3)
	equivalence (xp(1),xyzr(1,1))
	equivalence (yp(1),xyzr(1,2))
c
c  data description
c
	vmi=vmicm*devcm
	xloc=xfl
	yloc=ysize-2.0*vmi
	angle=0.0
	call newpen(color1)
	call symbol(xloc,yloc,chrsiz,title, angle,80)
	write(buf,100) pdeg,b0deg,cl0deg,rsp1
 100    format('P=',f5.1,4x,'B0=',f4.1,4x,'CL0=',f6.1,4x,
     &         'RSP=',f6.2)
	yloc=ysize-3.0*vmi
	call symbol(xloc,yloc,chrsiz,buf, angle,46)
	write(buf,110) nx,ny,xs,ys,dx,dy
 110    format('(NX,NY)=',i3,2x,i3,4x,'(XS,YS)=',f6.2,2x,f6.2,4x,
     &         '(DX,DY)=',f6.2,2x,f6.2)
	yloc=ysize-4.0*vmi
	call symbol(xloc,yloc,chrsiz,buf, angle,68)
c
c  save and change scaling parameters
c
	fsav=gfact
	gxcsav=gxc
	gycsav=gyc
	xfcsav=xfc
	yfcsav=yfc
	xfrsav=xfr
	yfrsav=yfr
c
	gxc=0.0
	gyc=0.0
	xfc=0.5*xsize
	yfc=0.5*xsize
	xfr=xsize
	yfr=xsize
c
c  markers
c
	rad=0.75*(0.5*xsize)
	gfact=rad/rsp1
	call setar
	d =0.2*devcm/gfact
	d1=0.3*devcm/gfact
	d2=0.6*devcm/gfact
c
      do 10 i=1,3
      xpn(i)=xxsp(1)
      xps(i)=xxsp(1)
      xpe(i)=xxsp(1)
      xpw(i)=xxsp(1)
      ypn(i)=xxsp(2)
      yps(i)=xxsp(2)
      ype(i)=xxsp(2)
      ypw(i)=xxsp(2)
      zpn(i)=xxsp(3)
      zps(i)=xxsp(3)
      zpe(i)=xxsp(3)
      zpw(i)=xxsp(3)
 10   continue
c  N
      ypn(1)=xxsp(2)+rsp1+d2
      ypn(2)=ypn(1)-d1
      xpn(3)=xxsp(1)-d
      ypn(3)=xxsp(2)+rsp1+d2+d
      call pline5(2,xpn,ypn,zpn,xp1,yp1)
      call pline5(1,xpn(3),ypn(3),zpn(3),xp1,yp1)
	call symbol(xp1,yp1, chrsiz,'N', angle,1)
c  S
      yps(1)=xxsp(2)-rsp1-d2
      yps(2)=yps(1)+d1
      xps(3)=xxsp(1)-d
      yps(3)=xxsp(2)-rsp1-d2-4.0*d
      call pline5(2,xps,yps,zps,xp1,yp1)
      call pline5(1,xps(3),yps(3),zps(3),xp1,yp1)
	call symbol(xp1,yp1,chrsiz,'S', angle,1)
c  E
      xpe(1)=xxsp(1)-rsp1-d2
      xpe(2)=xpe(1)+d1
      xpe(3)=xxsp(1)-rsp1-d2-3.0*d
      ype(3)=xxsp(2)-d
      call pline5(2,xpe,ype,zpe,xp1,yp1)
      call pline5(1,xpe(3),ype(3),zpe(3),xp1,yp1)
	call symbol(xp1,yp1,chrsiz,'E', angle,1)
c  W
      xpw(1)=xxsp(1)+rsp1+d2
      xpw(2)=xpw(1)-d1
      xpw(3)=xxsp(1)+rsp1+d2+d
      ypw(3)=xxsp(2)-d
      call pline5(2,xpw,ypw,zpw,xp1,yp1)
      call pline5(1,xpw(3),ypw(3),zpw(3),xp1,yp1)
	call symbol(xp1,yp1,chrsiz, 'W', angle,1)
c
c  sphere
c
	call newpen(color2)
	lonlat=.true.
	globe=.true.
	clip=.false.
	dl=0.02*rsp1
	call sphere(xxsp,rsp1,cl0eff,xxc4,dl, lonlat,globe,clip)
c
c  observed area
c
	call newpen(color1)
	xf(1)=xs
	yf(1)=ys
	xf(2)=xs+dx*float(max(1,nx-1))
	yf(2)=ys
	xf(3)=xs+dx*float(max(1,nx-1))
	yf(3)=ys+dy*float(max(1,ny-1))
	xf(4)=xs
	yf(4)=ys+dy*float(max(1,ny-1))
	xf(5)=xf(1)
	yf(5)=yf(1)
c  arguments of pline2 should be D-coordinates
c
	if(gmode.eq.0) then
	  call pline2(5, xf,yf)
	else
	  do 20 n=1,4
	  alen=sqrt( (xf(n+1)-xf(n))**2
     &	           + (yf(n+1)-yf(n))**2 )
	  np=min(int(alen/(dl*(dx/dx0))),ML)
	  do 30 ip=1,np
	  xp(ip)=xf(n)+(xf(n+1)-xf(n))*float(ip-1)/float(np-1)
	  yp(ip)=yf(n)+(yf(n+1)-yf(n))*float(ip-1)/float(np-1)
 30	  continue
 20	  call pline2(np, xp,yp)
	endif
c
c  intensity map
c
	if(ki.gt.0) then
	  aimin=0.7
	  ww=0.02*devcm
	  do 40 j=1,ny
	  do 40 i=1,nx
	  if (rdata(i,j,ki).gt.aimin) go to 40
	  xp(1)=xs+dx*float(i-1)
	  yp(1)=ys+dy*float(j-1)
	  xp(2)=xp(1)
	  yp(2)=yp(1)
	  call pline2(2,xp,yp)
c  arguments of pline2 should be D-coordinates
 40	  continue
	endif
c
c  restore normal scaling
c
      gfact=fsav
      gxc=gxcsav
      gyc=gycsav
      xfc=xfcsav
      yfc=yfcsav
      xfr=xfrsav
      yfr=yfrsav
c
	return
	end
