c  MAGPACK2 main program
c
	program prog
c
	include 'sys.fc'
	include 'fileio.fc'
	include 'string.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'mdata.fc'
	include 'fcntl.fc'
	include 'procs.fc'
	include 'auxparam.fc'
c
	character chr*1,cfile*80,line*80,line1*80,line2*80
	dimension multi(20)
	data multi/20*0/
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	msglvl = 1
c
c  character code should either be ASCII or EBCDIC
c  binary integer should either be big endian or 
c  full-byte-swap little endian
	include 'sysconf.cfg'
c
	if(mycode.eq.0 .or. myint.eq.0) stop
	if(errflg.gt.0) stop
c
c  initialize commons /fcntl/ and /procs/
	call initfc
c
c  open list file
	lst = lstini()
c
c  print version number
	call vsn
c
c  common variables should be static
	call static(ist)
	if(ist.gt.1) stop
c  algorithm for byte swap should be correct
        call swap(iswap)
        if(iswap.gt.0) stop
c
      if(myargc().eq.1) then
	call myargv(1,cfile)
      else
	cfile=' '
	write(msg,*,err=2)
     &	'enter control file name (default=control.dat)'
	  go to 3
 2	  msg=lst
	  write(msg,*) 'enter control file name (default=control.dat)'
 3	  read(keyin,'(a)',end=4) cfile
 4	  if(cfile.eq.' ') cfile='control.dat'
	endif
c
        call openfl(cntrol,lname(cntrol),stdin,cfile,text,rdo,0)
	write(lst,*) '(proc.prog  ) start'
c
c  the first column of the first line gives the global msglvl
	read(stdin,'(a1,a)') chr,line
	if (chr.eq.'0') then
	  msglvl=0
	else if(chr.eq.'1') then
	  msglvl=1
	else if(chr.eq.'2') then
	  msglvl=2
	else if(chr.eq.'3') then
	  msglvl=3
	endif
c  current version number of control file
	iver0=1
c  check the version number
	call split(line,'=',line1,line2,len1,len2)
	if(len2.eq.0) then
	  iver1=0
	else
	  read(line2,*) iver1
	endif
	if(iver1.ne.iver0.and.
     &	  .not.(iver0.eq.1.and.iver1.eq.0)) then
	  write(msg,*) 'error: version of control file should be',
     &	  iver0
	  errflg=2
	  stop
	endif
c
c  initialize common variables and read auxdata
	multi1=0
	call assign( init,multi1 )
	if(errflg.gt.0) stop
	if(multi1.ne.0) stop
	call initc( funit(auxdat) )
	call clsfl(auxdat)
c
	if(nbytem.ne.0) then
	  nbytem=sign(nbytem,myint)
	else
	  nbytem=myint
	endif
	if(nbytel.ne.0) then
	  nbytel=sign(nbytel,myint)
	else
	  nbytel=myint
	endif
c
 1000	continue
	errflg=0
	ms=0
c
c  procedure control conventions:
c
c  by call assign(proc,multi);
c     errflg=0 if assign detects *proc in the control file
c            1 if assign did not find *proc in the control file
c            2 if assign encountered fatal errors
c     multi= 1 if multi-file processing started
c           -1 if multi-file processing ended
c
c  proc.obs2p
c  conversion from observed raw data taken with the vector magnetograph of
c  the Okayama Astrophysical Observatory to polarization degrees.
c  for other instruments a similar program might be prepared. 
c  'rawdat' file is opened in 'obstop', not in 'assign', 
c  because the data format depends on the instruments.
c
c  subr.assign reads msglvl
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( obs2p,multi(ms) )
	if(errflg.gt.1) go to 1001
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  kindm=0
	  kindmo=0
	  nbinx=1
	  nbiny=1
	  ixs=0
	  ixe=0
	  iys=0
	  iye=0
        read(stdin,*) kindm, kindmo
	  read(stdin,*) nbinx,nbiny,ixs,ixe,iys,iye
c  this read is dummy; binning is not applied in obstop for oao data
	  call obstop( funit(rawdat), fname(rawdat) )
        if(errflg.gt.1) go to 1001
c
	  dxnew=dx
	  dynew=dy
	  read(stdin,*) dxnew,dynew
	  call rebin(dxnew,dynew)
	  if(errflg.gt.1) go to 1001
	  if(kindmi.lt.0) call poltob
c
        call writem( funit(poldeg) )
        if(errflg.gt.1) go to 1001
c
c  separate intensity map
	  if (mkimap) then
	    call writiv( lspec('I'), funit(imap) )
	    if(errflg.gt.1) go to 1001
	  endif
c
c  separate Doppler map
	  if (mkdmap) then
	    call writiv( lspec('VL'), funit(dgram) )
	    if(errflg.gt.1) go to 1001
	  endif
	endif
c
 1001	continue
	if(errflg.ne.1) then
	  call clsfl (rawdat)
	  call clsfl (poldeg)
	  if (mkimap) call clsfl (imap)
	  if (mkdmap) call clsfl (dgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.obs2b
c  conversion from observed raw data taken with the vector
c  magnetograph of the Solar Flare Telescope at Mitaka to the
c  magnetic field vectors.
c  for other instruments a similar program might be prepared. 
c  'rawdat' file is opened in 'obstob', not in 'assign', 
c  because the data format depends on the instruments.
c
c  subr.assign reads msglvl
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( obs2b,multi(ms) )
	if(errflg.gt.1) go to 1002
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  kindm=0
	  kindmo=0
	  nbinx=1
	  nbiny=1
	  ixs=0
	  ixe=0
	  iys=0
	  iye=0
        read(stdin,*) kindm, kindmo
	  read(stdin,*) nbinx,nbiny,ixs,ixe,iys,iye
c
	  call obstob( funit(rawdat), fname(rawdat) )
	  if(errflg.gt.1) go to 1002
c
	  dxnew=dx
	  dynew=dy
	  read(stdin,*) dxnew,dynew
	  call rebin(dxnew,dynew)
        call writem( funit(rmgram) )
        if(errflg.gt.1) go to 1002
c
c  separate intensity map
	  if (mkimap) then
	    call writiv( lspec('I'), funit(imap) )
	    if(errflg.gt.1) go to 1900
	  endif
c
c  separate Doppler map
	  if (mkdmap) then
	    call writiv( lspec('VL'), funit(dgram) )
	    if(errflg.gt.1) go to 1900
	  endif
	endif
c
 1002	continue
	if(errflg.ne.1) then
	  call clsfl (rawdat)
	  call clsfl (rmgram)
	  if (mkimap) call clsfl (imap)
	  if (mkdmap) call clsfl (dgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.rfits
c  read a magnetogram data file with the FITS format and create
c  a raw magnetogram (rmgram) in the MAGPACK2 standard format
c  subr.writem is not called: integer data in FITS file are
c  written as they are to rmgram
c
c  subr.assign reads msglvl
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( rfits,multi(ms) )
	if(errflg.gt.1) go to 1003
	if(multi(ms).lt.0) stop
c
c  in version-1,
c  format of control file changed for fits file handling
        if(iver0.eq.1.and.iver1.eq.0) then
          write(msg,*) 'error: version of control file should be',
     &    iver0
          errflg=2
          stop
        endif
c
	if(errflg.eq.0) then
c
	  nbinx=1
	  nbiny=1
	  ixs=0
	  ixe=0
 	  iys=0
	  iye=0
	  read(stdin,*) nbinx,nbiny,ixs,ixe,iys,iye
c  binning factors may be altered by subr.rfits
c  subr.rdfits reads namelist &fits
	  call rdfits( funit(fitsi) )
	  if(errflg.gt.1) go to 1003
	  dxnew=dx
	  dynew=dy
	  read(stdin,*) dxnew,dynew
	  call rebin(dxnew,dynew)
c  dx and dy are altered in subr.rebin
	  if(errflg.gt.1) go to 1003
	  call writem(funit(rmgram))
	  if(errflg.gt.1) go to 1003
c
	endif
 1003	continue
	if(errflg.ne.1) then
	  call clsfl (fitsi)
	  call clsfl (rmgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.pol2b
c  conversion from polarization degrees (poldeg) to 
c  a raw magnetogram (rmgram)
c  for the vector magnetograph at Okayama
c
c  subr.assign reads msglvl,mkimap,mkdmap
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( pol2b,multi(ms) )
	if(errflg.gt.1) go to 1004
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  kindm=0
	  kindmo=0
	  read(stdin,*) kindm, kindmo
	  call loadp(poldeg)
	  if(errflg.gt.1) go to 1004
c
	  call poltob
	  call writem( funit(rmgram) )
	  if(errflg.gt.1) go to 1004
c
c  separate intensity map
	  if (mkimap) then
	    call writiv( lspec('I'), funit(imap) )
	    if(errflg.gt.1) go to 1004
	  endif
c
c  separate Doppler map
	  if (mkdmap) then
	    call writiv( lspec('VL'), funit(dgram) )
	    if(errflg.gt.1) go to 1004
	  endif
	endif
c
 1004	continue
	if(errflg.ne.1) then
	  call clsfl (poldeg)
	  call clsfl (rmgram)
	  if (mkimap) call clsfl (imap)
	  if (mkdmap) call clsfl (dgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.vector
c  read a raw magnetogram (rmgram) and make
c  a vector magnetogram (vmgram)
c
c  subr.assign reads msglvl
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( vector,multi(ms) )
	if(errflg.gt.1) go to 1005
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  kindm=0
	  kindmo=0
	  mesho=0
c	  kindmo and mesho should be explicitly given
	  read(stdin,*) kindm,kindmo,mesho
	  call load(rmgram)
	  if(errflg.gt.1) go to 1005
c
c  mesho should be either 0 or -1
c  modev=1: use current-free field
c  modev=2: use linear force-free field and determine calpha
c  modev=3: use linear force-free field with given calpha
	  modev=1
	  read(stdin,*) modev,calpha,apint(2)
c  apint(2)=nitrv
	  call vectr1(modev)
	  call writem( funit(vmgram) )
	  if(errflg.gt.1) go to 1005
	endif
c
 1005	continue
	if(errflg.ne.1) then
	  call clsfl (rmgram)
	  call clsfl (vmgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.virial
c  examine force-balance and virial relations
c
c  subr.assign reads msglvl,rdvmag
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( virial,multi(ms) )
	if(errflg.gt.1) go to 1006
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
c  'virial' can use the results of 'vector'
c  vmgram is read from a file as an option  
        if (rdvmag) then
	    call load(vmgram)
	    if(errflg.gt.1) go to 1006
	  endif
	  call vrl1
cx	  if(mesh.eq.-1) then
cx	    mesh=-2
cx	    call vrl2
cx	    mesh=-1
cx	  endif
cx	  vrl2 is still incomplete
	  if(errflg.gt.1) go to 1006
	endif
c
 1006	continue
	if(errflg.ne.1) then
	  if (rdvmag) call clsfl (vmgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.trans
c  coordinate transform of vector magnetogram
c  smgram = source magnetogram
c  tmgram = target magnetogram
c
c  subr.assign reads msglvl
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( trans,multi(ms) )
	if(errflg.gt.1) go to 1007
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  kindm=0
	  kindmo=0
	  mesho=0
c  kindmo and mesho should be explicitly given
	  read(stdin,*) kindm,kindmo,mesho
	  dday=0.0
	  irot=0
	  novect=0
c  dday = time difference in days
c  irot = 0(Carrington), 1(Newton-Nunn), 2(Snodgrass)
c  novect=0 requires vector transform
c  novect=1 indicates pseudo-scalar transform, ignoring vector properties
c  (xtod,ytod) can be specified if mesho=1
	  read(stdin,*) dday,irot,novect,xtod,ytod
	  call load(smgram)
	  if(errflg.gt.1) go to 1007
c
c  transform from (kindm,mesh) to (kindmo,mesho)
	  if(dday.ne.0.0) then
	    call rotm(kindm,mesh,kindmo,mesho,dday,irot,novect)
	  else
	    call transm(kindm,mesh,kindmo,mesho)
	  endif
c
	  call writem( funit(tmgram) )
	  if(errflg.gt.1) go to 1900
	endif
c
 1007	continue
	if(errflg.ne.1) then
	  call clsfl (smgram)
	  call clsfl (tmgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.integp
c  integrate potential field lines
c
c  subr.assign reads msglvl,rdfpt,irefpt,rds1,rds2
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( integp,multi(ms) )
	if(errflg.gt.1) go to 1008
	if(multi(ms).lt.0) stop
c
	if(errflg.eq.0) then
	  kindm=0
	  kindl=0
	  read(stdin,*) kindm,kindl
	  call load(mgram)
	  if(errflg.gt.1) go to 1008
c
	  call sets12( rds1, funit(s1data) )
	  if(errflg.gt.1) go to 1008
c
c  irefpt gt 0  : footpoints are taken from reflof-file
c       =.false.: footpoints will be distributed proportional to
c                 magnetic flux
c
	  kindl=mod(kindl,1000)
	  read(stdin,*) nf0,cancel,flxpwr,ds0
	  nf=nf0
c  nf is updated by ftpflx and integ
	  if (irefpt.gt.0 .and. irefpt.le.3) then
	    call fptref( funit(reflof) )
	    if(errflg.gt.1) go to 1008
	  else 
	    call fptflx
	    if(errflg.gt.1) go to 1008
	  endif
	  if (rdfpt) then
	    call readfp( funit(footpt) )
	    if(errflg.gt.1) go to 1008
	  endif
c
	  call integ( funit(potlof) )
	  if(errflg.gt.1) go to 1008
	endif
	rds1=.false.
	rds2=.true.
c
 1008	continue
	if(errflg.ne.1) then
	  if(rds2) call clsfl (mgram)
	  if(rds1) call clsfl (s1data)
	  if (irefpt.gt.0 .and. irefpt.le.3) call clsfl (reflof)
	  if (rdfpt) call clsfl (footpt)
	  call clsfl (potlof)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.energy
c  calculate magnetic energy
c
c  subr.assign reads msglvl,rdmag,rds1,rds2,rds123
c  rds123 should be F for potential field models
      if(errflg.gt.1) go to 1900
	rds123=.false.
	ms=ms+1
	call assign( energy,multi(ms) )
	if(errflg.gt.1) go to 1009
	if(multi(ms).lt.0) stop
c
      if(errflg.eq.0) then
        kindm=0
        read(stdin,*) kindm
c  'egergy' is primarily for solenoid coil models
c  mgram can be read from a file as an option
	  if(rdmag ) then
          call load(mgram)
	    if(errflg.gt.1) go to 1009
	  endif
        call sets12( rds1, funit(s1data) )
        call engy
        if(errflg.gt.1) go to 1009
      endif
	rds1=.false.
	rds2=.true.
	rds123=.false.
c
 1009	continue
	if(errflg.ne.1) then
	  if(rdmag ) call clsfl (mgram)
	  if(rds1) call clsfl (s1data)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.eval
c  evaluate magnetic fields at specified points
c
c  subr.assign reads msglvl,rds1,rds2,rds123,mkmmap
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( eval,multi(ms) )
 	if(errflg.gt.1) go to 1010
	if(multi(ms).lt.0) stop
c
 	if(errflg.eq.0) then
	  kindm=0
	  kindl=0
	  read(stdin,*) kindm,kindl
	  call load(mgram)
	  if(errflg.gt.1) go to 1010
c
	  call sets12( rds1, funit(s1data) )
	  if(errflg.gt.1) go to 1010
c
	  call evalb( funit(evalpt), funit(gmgram) )
	  if(errflg.gt.1) go to 1010
	endif
	rds1=.false.
	rds2=.true.
	rds123=.false.
c
 1010	continue
	if(errflg.ne.1) then
	  if(rds2) call clsfl (mgram)
	  if(rds1) call clsfl (s1data)
	  call clsfl (evalpt)
	  if(mkmmap) call clsfl (gmgram)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.wfits
c  write data with FITS format
c
c	subr.assign reads msglvl
	if(errflg.gt.1) go to 1900
	ms=ms+1
	call assign( wfits,multi(ms) )
 	if(errflg.gt.1) go to 1011
	if(multi(ms).lt.0) stop
c
 	if(errflg.eq.0) then
	  kindm=0
	  kindmo=0
	  mesho=0
        read(stdin,*) kindm,kindmo,mesho
        call load(mgram)
        if(errflg.gt.1) go to 1011
c
	  call wtfits( funit(fitso) )
	  if(errflg.gt.1) go to 1011
	endif
c
 1011	continue
	if(errflg.ne.1) then
	  call clsfl (mgram)
	  call clsfl (fitso)
	endif
	if(errflg.gt.1) go to 1900
c
c  proc.test
c
c  subr.assign reads msglvl,rds1,rds2,rds123
c  rds123 should be F for potential field models
	if(errflg.gt.1) go to 1900
	rds123=.false.
	ms=ms+1
 	call assign( test,multi(ms) )
 	if(errflg.gt.1) go to 1012
c
 	if(errflg.eq.0) then
	  read(stdin,*) itest
	  read(stdin,*) kindm,kindl
	  if(kindm.ge.0) then
          call load(mgram)
	    if(errflg.gt.1) go to 1012
	    if(kindmi.lt.0) then
	      call poltob
	      if(errflg.gt.1) go to 1012
	    endif
	    if(modelf.le.0) then
	      call sets12( rds1, funit(s1data) )
	      if(errflg.gt.1) go to 1012
	    endif
	  endif
c
	  call tests(itest)
	  if(errflg.gt.1) go to 1012
	endif
	rds1=.false.
	rds2=.true.
	rds123=.false.
c
 1012	continue
	if(errflg.ne.1) then
	  if(rds2.and.kindm.ge.0) call clsfl (mgram)
	  if(modelf.le.0.and.rds1) call clsfl (s1data)
	endif
	if(errflg.gt.1) go to 1900
c
 1900	continue
        do 1100 i=1,20
        if(multi(i).ne.0) then
          if(errflg.le.1) go to 1000
        endif
 1100   continue
c  it is better stop the job here if errflg=2, because the correspondence
c  between the input and output files may become non-synchronous
c
	write(lst,*) '(proc.prog  ) end'
	stop
	end
c
	subroutine tests(itest)
c
c  test1: create magnetogram by using subr.field
	if(itest.eq.1) call test1
c  test2: cross check with dipole field
	if(itest.eq.2) call test2
c  test3: cross check with nonlinear force-free field
	if(itest.eq.3) call test3
c  test4: energy routine
	if(itest.eq.4) call test4
c
	return
	end
