c  read fieldline file
c
c  read header
c
	subroutine readlh(iunit,update)
c
	include 'sys.fc'
	include 'coord.fc'
	include 'fileio.fc'
	include 'string.fc'
	include 'fline.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'ss.fc'
c
c
	integer iunit
	integer*4 chksm1
	logical update
	character buf*80
	dimension facts(8)
	dimension xyz(8,ML)
c  ML is defined in fline.fc
c  necessary dimensions: xyz(8,np), ixyz4(8,np), ixyz2(8,np)
	save facts,icode,nlof,loc
c
	loc=1
	lrec0=80
	icode = 0
	nlof=0
c
	call ins( iunit, loc, buf, lrec0, iostat )
	if(iostat.eq.1) go to 1009
	if(iostat.eq.2) go to 1019
	if(iostat.eq.3) go to 1010
	if(mycode.ne.0) then
	  if(buf(13:14).eq.blank(3-mycode)) icode=mycode
	endif
  	if(icode.ne.0) call cconv(icode, buf)
	read(buf,210, err=1029) np1
	if(np1.ne.1) go to 1049
c
	if(update) then
	  read(buf,210, err=1029) np1,nex,
     &    nf,ns1,ns2,ns3,bmin1,bmin2,flxpwr
	else
	  read(buf,210, err=1029) np1,nex,
     &    nf1,ns1f,ns2f,ns3f,bmin1f,bmin2f,pwrf
	endif
 210  format(i8,i4,2x,i4,3i8,3f12.5,2x)
c
c  np = 1: control record
c
	call ins( iunit, loc, buf, lrec0, iostat )
	if(iostat.eq.1) go to 1009
	if(iostat.eq.2) go to 1019
	if(iostat.eq.3) go to 1010
c
  	if(icode.ne.0) call cconv(icode, buf)
	read(buf,220, err=1039) kindli,nbytli,ncompi,factx,factb,
     &	                      lfile,mtag,ltag
 220	format(i8,2i4,2e12.5,a8,2a16)
c
	do 20 m=1,4
 20	facts(m)=factx
	do 30 m=5,8
 30	facts(m)=factb
c
	if(nex.eq.1) then
	  call ins( iunit, loc, buf, lrec0, iostat)
	  if(iostat.eq.1) go to 1009
	  if(iostat.eq.2) go to 1019
	  if(iostat.eq.3) go to 1010
  	  if(icode.ne.0) call cconv(icode, buf)
	  if(update) then
	    read(buf,230, err=1039) rrss,chksum
	  else
	    read(buf,230, err=1039) rrss1,chksm1
	  endif
 230	  format(f12.5,i12,54x)
	endif
c
	if(msglvl.gt.1 .and. update) then
	  write(lst,*) '(subr.readlh)'
	  write(lst,*) '  kindli,nbyte,ncomp=',kindli,nbytli,ncompi
	  write(lst,*) '  factx,factb=',factx,factb
	  write(lst,*) '  fileid=',lfile
	  write(lst,*) '  mtag=',mtag
	  write(lst,*) '  ltag=',ltag
	  write(lst,*) '  rrss=',rrss
	  write(lst,*) '  initial nf=',nf
	  write(lst,*) '  ns1,ns2,ns3=',ns1,ns2,ns3
	  write(lst,*) '  bmin1,bmin2=',bmin1,bmin2
	  write(lst,*) '  flxpwr     =',flxpwr
	endif
	return
c
 1009	continue
	if(msglvl.gt.0) 
     &	  write(msg,*) '(subr.readlh) error: EOF encountered, nrec=',loc
	errflg=2
	return
c
 1010	if(msglvl.gt.0) write(msg,*)
     &	  '(subr.readlh) error: read pointer stalled at loc=',loc
	errflg=2
	return
c
 1019	continue
	write(msg,*)
     &	  '(subr.readlh) read error, loc=',loc
	errflg=2
	return
c
 1029	continue
	write(msg,*)
     &    '(subr.readlh) error in formatted internal read (np),',
     &    'loc=',loc
	errflg=2
	return
c
 1039	continue
     	write(msg,*)
     &	'(subr.readlh) error in formatted internal read (cntl),',
     &      'loc=',loc
	errflg=2
	return
c
 1049	continue
	write(msg,*)
     &      '(subr.readlh) error: invalid header record, np=',np1
	errflg=2
	return
c
c  read one field-line data
c
	entry readl(iunit,np,xyz)
c
	lrec0=80
c
 1	call ins( iunit, loc, buf, lrec0, iostat )
	np=0
	if(iostat.eq.1) go to  9
	if(iostat.eq.2) go to 19
	if(iostat.eq.3) go to 10
	if(mycode.ne.0) then
	  if(buf(13:14).eq.blank(3-mycode)) icode=mycode
	endif
  	if(icode.ne.0) call cconv(icode, buf)
	read(buf,210, err=29) np,nex
	if(np.le.0) go to 8
	if(np.eq.1) then
	  if(nex.eq.1) then
	    call ins( iunit, loc, buf, lrec0, iostat)
	    if(iostat.ne.0) go to 19
	  endif 
	  go to 1
	endif
c
c  np > 1 : field line records
c
	if (iabs(nbytli) .eq. 2) then
	  call in2( iunit, loc, ixyz2, lrec0, ncompi, np, 8, iostat )
	  if(iostat.ne.0) go to 19
	  if ( nbytli*myint .lt. 0) call swap2(ixyz2, ncompi, np, 8)
      	  do 1000 i=1,np
	  do 1000 m=1,ncompi
 1000	  xyz(m,i)=float(ixyz2(m,i))*facts(m)
c
	elseif (iabs(nbytli) .eq. 4) then
	  call in4( iunit, loc, ixyz4, lrec0, ncompi, np, 8, iostat )
	  if(iostat.ne.0) go to 19
	  if ( nbytli*myint .lt. 0) call swap4(ixyz4, ncompi, np, 8)
	  do 1100 i=1,np
	  do 1100 m=1,ncompi
 1100	  xyz(m,i)=float(ixyz4(m,i))*facts(m)
	  endif
c
	nlof=nlof+1
	if(msglvl.gt.2) 
     &	  write(lst,*) 'nlof,np,nextrec,xyz=',
     &	                nlof,np,loc,(xyz(m,1),m=1,3)
	return
c
 8	continue
	if(msglvl.gt.2) 
     &	  write(lst,*) 'EOF by np=0, nlof, nrec=',nlof,loc
	if(np.eq.0.and.msglvl.gt.0)
     &  write(lst,*) '(subr.readl ) end, number of field lines=',nlof
	return
c
 9	continue
	if(msglvl.gt.2) 
     &	  write(lst,*) 'EOF encountered, nlof, nrec=',nlof,loc
	if(np.eq.0.and.msglvl.gt.0)
     &  write(lst,*) '(subr.readl ) end, number of field lines=',nlof
	return
c
 10	if(msglvl.gt.0) write(msg,*)
     &	  '(subr.readl ) error: read pointer stalled at loc=',loc
	errflg=2
	return
c
 19	continue
	write(msg,*)
     &	  '(subr.readl ) read error, nlof, loc=',nlof,loc
	errflg=2
	return
c
 29	continue
	write(msg,*)
     &    '(subr.readl ) error in formatted internal read (np),',
     &    'nlof,loc=',nlof,loc
	errflg=2
	return
c
 39	continue
     	write(msg,*)
     &	'(subr.readl ) error in formatted internal read (cntl),',
     &      'nlof,loc=',nlof,loc
	errflg=2
	return
c
 49	continue
	write(msg,*)
     &      '(subr.readl ) error: invalid header record, np=',np
	errflg=2
	return
	end
