c
c  read s1(solenoid coil) data
c
c  this subroutine is called from subr.sets12 and from the main programs.
c  in order for commons s1-s3 to be separated from graphic programs,
c  this subroutine should not be included in sets12, because sets12
c  calls subr.field, which includes s1-s3.
c
	subroutine reads1( iunit1 )
c
	include 'sys.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'auxparam.fc'
	include 'ss.fc'
	include 's1.fc'
	integer iunit1
	integer*4 kindl1
	character*1 buf(100)
c
	rad(deg1)=3.141592*deg1/180.0
c
	kindl1=mod(kindl,1000)
	if( iunit1.eq.0 ) then
	  write(msg,*) '(subr.reads1) error: iunit1=',iunit1
	  errflg=2
	  return
	endif
c
c  coordinate system for s1-source
c  ns1 : number of s1-source
c  if mesh1=0, data will be given in D-coordinates
c    fact1 : scale factor
c  if mesh1=3 or 4, data will be given in R-coordinates
c    apo1 : offset in ap
c
	fact1=1.0
	fz=0.3
	fl=5.0
	xo1=0.0
	yo1=0.0
	apo1=0.0
c
	if (nsp.lt.2) then
	  read(iunit1,*) ns1,mesh1,calib
	else
	  read(iunit1,*) nsp,ns1,calib
	  mesh1=0
	endif
c
	if(nsp.lt.2) nsp=1
	if(ns1.le.0) then
	  write(msg,*) '(subr.reads1) error: ns1=',ns1
	  errflg=2
	  return
	endif
      if(msglvl.gt.0) write(lst,*)
     &          '(subr.reads1) nsp,ns1,mesh1=',nsp,ns1,mesh1
c
	do 2000 n=1,nsp
c
	if(nsp.lt.2) then
	  read(iunit1,*) rsp
	  xxsp(1)=0.0
	  xxsp(2)=0.0
	  xxsp(3)=-rsp
          if(msglvl.gt.0) write(lst,*)
     &              '(subr.reads1) rsp=',rsp
c
	else
	  pdeg1=0.0
	  b0deg1=0.0
	  read(iunit1,*) rspm(n),xxspm(1,n),xxspm(2,n),xxspm(3,n),
     &	                 pdeg1,b0deg1
	  pradm(n)=rad(pdeg1)
	  b0radm(n)=rad(b0deg1)
	  if(n.eq.1) then
	    ydeg=0.0
	    call setdu
	    mesh1=3
	    rsp=rspm(1)
	    xxsp(1)=0.0
	    xxsp(2)=0.0
	    xxsp(3)=0.0
	    pdeg=0.0
	    b0deg=0.0
cx	    call setar
cx	    prad=pradm(1)
cx	    b0rad=b0radm(1)
	    prad=0.0
	    b0rad=0.0
	    call setas
	  endif
	  call setarm(n)
	endif
 2000	continue
c
c  set integration limits if no magnetograms are available
c  x&y limits are compulsory
	read(iunit1,*) x1lim0,x2lim0,y1lim0,y2lim0,z1lim0,z2lim0
c  for binary star model, xlim and ylim are regarded as cartisian limits
c  (namely, box size)
	if(nsp.gt.1) then
	  xs=x1lim0
	  ys=y1lim0
	  dx=x2lim0-x1lim0
	  dy=y2lim0-y1lim0
	  do 2100 n=1,nsp
 2100	  z2lim0 = max(z2lim0, rspm(n))
	  ds0=0.02*z2lim0
	  if(msglvl.gt.1) write(lst,*)
     &	'(subr.reads1) xs,ys,dx,dy=',xs,ys,dx,dy
c
	else if(nx.eq.0.and.ny.eq.0) then
	  if( iabs(mesh1).le.1) then
	    z2lim0=0.5*sqrt((x2lim0-x1lim0)**2+(y2lim0-y1lim0)**2)
	    xs=x1lim0
	    ys=y1lim0
	    dx=x2lim0-x1lim0
	    dy=y2lim0-y1lim0
	    ds0=0.01*z2lim0
	  else
	    x1lim0=rad(x1lim0)
	    x2lim0=rad(x2lim0)
	    ys=rad(y1lim0)
	    ye=rad(y2lim0)
	    y1lim0=alofy(ys)
	    y2lim0=alofy(ye)
	    xs=x1lim0
	    dx=x2lim0-x1lim0
	    dy=ye-ys
	    if(rrss.lt.1.0) then
	      z2lim0=rsp*0.5*
     &               sqrt((x2lim0-x1lim0)**2+(y2lim0-y1lim0)**2)
	    else
	      z2lim0=rsp*rrss -rsp
	    endif
	  endif
cx  moved to integ.f
cx	  x1lim=x1lim0+x1del
cx	  x2lim=x2lim0+x2del
cx	  y1lim=y1lim0+y1del
cx	  y2lim=y2lim0+y2del
cx	  if(z1lim.eq.0.0) z1lim=z1lim0
cx	  if(z2lim.eq.0.0) z2lim=z2lim0+z2del
	  ds0=0.01*z2lim0
	  if(msglvl.gt.1) write(lst,*)
     &	'(subr.reads1) xs,ys,dx,dy=',xs,ys,dx,dy
	endif
c
c  rsp and ydeg may be overridden later by s2-data
c
	if( nsp.gt.1 ) go to 1900
c
	if( mesh1.eq.0 ) then
	  read(iunit1,*) xo1,yo1,fact1,ydeg
	  read(iunit1,*) 
	  read(iunit1,*) 
	  read(iunit1,*) 
	  call setdu
	  if(msglvl.gt.0) write(lst,*)
     &	    '  xo1,yo1,fact1,ydeg=',xo1,yo1,fact1,ydeg
	else if( mesh1.eq.1 ) then
	  read(iunit1,*) 
	  read(iunit1,*) xtod,ytod,fact1,ydeg
	  read(iunit1,*) 
	  read(iunit1,*) 
	  ypos=rad(ydeg)
	  call setdu
	  xxtod(1)=xtod
	  xxtod(2)=ytod
	  call projsr(xxtod,rsp)
	  call dtoc(xxtod,xxto)
	  call settu
	  if(msglvl.gt.0) write(lst,*)
     &	    '  xtod,ytod,fact1,ydeg=',xtod,ytod,fact1,ydeg
c
      elseif( mesh1.eq.2 ) then
        read(iunit1,*)
        read(iunit1,*)
        read(iunit1,*) ydeg
        read(iunit1,*)
        call setdu
        call setas
        if(msglvl.gt.0) write(lst,*)
     &          '  ydeg=',ydeg
c
	elseif( mesh1.ge.3 ) then
	  read(iunit1,*) 
	  read(iunit1,*) 
	  read(iunit1,*) 
	  read(iunit1,*) apo1,pdeg,b0deg,cl0deg
	  prad=rad(pdeg)
	  b0rad=rad(b0deg)
	  cl0=rad(cl0deg)
	  if(mesh1.eq.3) cl0eff=0.0
	  if(Mesh1.eq.4) cl0eff=cl0
	  call setdu
	  call setar
	  if(msglvl.gt.0) write(lst,*)
     &	    '  ap-offset,rsp,pdeg,b0deg,cl0deg=',
     &	       apo1,rsp,pdeg,b0deg,cl0deg
c
	else
	  write(msg,*)
     &	'(subr.reads1) error: illegal value of mesh1:',mesh1
	  errflg=2
	  return
	endif
c
 1900	continue
c
	if(msglvl.gt.1) write(lst,100) 
 100	format(/'   no.',
     &	       t12,'a',t24,'b',t36,'x',t48,'y',t60,'d',t72,'l')
c
	do 1000 l=1,ns1
	z=-1.0
	el=-1.0
	if(nsp.lt.2) then
	  read(iunit1,*) aa1(l),bn1(l),xd1,yd1,z,el
	else
	  read(iunit1,*) n,aa1(l),bn1(l),xd1,yd1,z,el
	endif
c
	if( nsp.gt.1) then
	  xd=xd1
	  yd=yd1
	  apr=rad(xd)
	  alr=rad(yd)
	  call rtocm( n, apr,alr, 0.0, xxc1(1,l))
c
	else if( mesh1.eq.0) then
	  call dtoc2(xd1,yd1,xxc1(1,l),xxc1(2,l))
	  xxc1(1,l)=xxc1(1,l)*fact1+xo1
	  xxc1(2,l)=xxc1(2,l)*fact1+yo1
	  xxc1(3,l)=0.0
	  xd=xxc1(1,l)
	  yd=xxc1(2,l)
c
	elseif( mesh1.eq.1 ) then
	  call dtoc2(xd1,yd1,xxc1(1,l),xxc1(2,l))
	  xxc1(1,l)=xxc1(1,l)*fact1
	  xxc1(2,l)=xxc1(2,l)*fact1
	  xxc1(3,l)=0.0
	  call projt( xxc1(1,l), xt,yt )
	  xd=xxc1(1,l)
	  yd=xxc1(2,l)
c
	elseif( mesh1.eq.2 ) then
	  xd=xd1
	  yd=yd1
	  ap=rad(xd)
	  al=rad(yd)
	  call stoc( ap,al, 0.0, xxc1(1,l))
c
	elseif( mesh1.ge.3 ) then
	  xd=xd1+apo1
	  yd=yd1
	  apr=rad(xd)
	  alr=rad(yd)
	  call rtoc( apr,alr, 0.0, xxc1(1,l))
c
	endif
c
	aa1(l)=aa1(l)*fact1
	if(z.lt.0.0) z=aa1(l)*fz
	if(el.lt.0.0) then
	  el1(l)=aa1(l)*fl
	else
	  el1(l)=el
	endif
	if(msglvl.gt.1) 
     &	  write(lst,200) l,aa1(l),bn1(l),xd,yd,z,el1(l)
 200	  format(2x,i3,6f12.3)
c
	if( nsp.gt.1 ) then
	  do 1400 m=1,3
 1400	  direc1(m,l)=(xxc1(m,l)-xxspm(m,n))/rspm(n)
c
	else if(kindl1.eq.0) then
	  direc1(1,l)=0.0
	  direc1(2,l)=0.0
	  direc1(3,l)=1.0
c
	elseif( mod(kindl1,10).eq.1 ) then
	  do 1100 m=1,3
 1100	  direc1(m,l)=ztu(m)
c
	elseif( mod(kindl1,10).eq.2 ) then
	  do 1200 m=1,3
 1200	  direc1(m,l)=(xxc1(m,l)-xxsp(m))/rsp
	  call ctos(xxc1(1,l),ap,al,h)
c
	  if(msglvl.gt.1) write(lst,210) ap,al
 210	    format(2x, 23x,'ap =',2f12.3,'=al ')
	elseif( kindl1.eq.103 ) then
	  do 1300 m=1,3
 1300	  direc1(m,l)=(xxc1(m,l)-xxsp(m))/rsp
	  call ctor(xxc1(1,l),apr,alr,h)
c
	  if(msglvl.gt.1) write(lst,220) apr,alr
 220	    format(2x, 23x,'apr=',2f12.3,'=alr')
	endif
c
	do 1500 m=1,3
 1500	xxs1(m,l)=xxc1(m,l)-z*direc1(m,l)
cc
cc	write(lst,*) 'xxc1=',(xxc1(m,l),m=1,3)
cc	write(lst,*) 'xxs1=',(xxs1(m,l),m=1,3)
cc	write(lst,*) 'direc1=',(direc1(m,l),m=1,3)
cc
 1000	continue
c
c  calculate checksum
c
	chksum=0
	rewind (iunit1)
 3000	read(iunit1,'(100a1)',end=3900) buf
	do 3100 ip=1,100
	if(buf(ip).eq.'/') go to 3200
 3100	continue
	ip=100
 3200	continue
	if(ip.le.1) go to 3400
	do 3300 i=1,ip-1
 3300 chksum=chksum+ichar(buf(i))-32
 3400	continue
	go to 3000
 3900	continue
	if(msglvl.gt.1) write(lst,*) '(subr.reads1) check sum=',chksum
c
	return
	end
