c  rotation of magnetograms around the polar axis
c  novect=0 requires vector transform
c  novect=1 indicates pseudo-scalar transform, ignoring vector properties
c
	subroutine rotm(kindm1,mesh1,kindm2,mesh2,dday,irot,novect)
c
	include 'sys.fc'
	include 'fileio.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'auxparam.fc'
	include 'mparam.fc'
	include 'mdata.fc'
c
	external modulo
c
	dimension apold(6),apnew(6),almesh(6)
c
c  at first, transform into R-coordinates
c
	call umake(kindm2, m5,m4,m3,m2,m1)
	if(novect.eq.0) m5=3
	kindm3 = make( m5, m4,m3,m2,m1)
	mesh3=3
	call transm(kindm1,mesh1,kindm3,mesh3)
c  kindm1 and mesh1 are updated by transm: kindm1=kindm3, mesh1=mesh3
	if(errflg.gt.1) return
c
c  apply differential rotation
c
	apold(1)=xs
	almesh(1)=alofy(ys)
	apold(2)=apold(1)+dx*float(nx-1)
	almesh(2)=almesh(1)
	apold(3)=apold(2)
	almesh(3)=alofy(ys+dy*float(ny-1))
	apold(4)=apold(1)
	almesh(4)=almesh(3)
	apold(5)=apold(1)
	apold(6)=apold(2)
	if( almesh(1)*almesh(4) .lt. 0.0 ) then
	  almesh(5)=0.0
	else
	  almesh(5)=almesh(1)
	endif
	if( almesh(2)*almesh(3) .lt. 0.0 ) then
	  almesh(6)=0.0
	else
	  almesh(6)=almesh(2)
	endif
c
	do 10 n=1,6
	call difrot(dday,almesh(n),irot,rangle)
	apnew(n)=apold(n)+rangle
 10	continue
c
	shift=apnew(1)
	call modulo(apnew,mesh3,6)
	shift=apnew(1)-shift
	xsnew=amin1(apnew(1),apnew(2),apnew(3),apnew(4),
     &	  apnew(5),apnew(6) )
	xenew=amax1(apnew(1),apnew(2),apnew(3),apnew(4),
     &	  apnew(5),apnew(6) )
	dxnew=abs(dx)
	nxnew = ( xenew - xsnew )/dxnew + 1.5
c
	if( nxnew.gt.MX ) then
	  write(msg,*)
     &	  '(subr.rotm) error: mesh size too large, new nx=',
     &	  nxnew
	  errflg=2
	  return
	endif
c
	do 1000 iframe=1,nframe
	k=kmem(iframe)
	do 2000 jnew=1,ny
	do 2000 inew=1,nxnew
	y=ys+dy*float(jnew-1)
	al=alofy(y)
	call difrot(dday,al,irot,rangle)
	ap=xsnew +dxnew*float(inew-1) -rangle -shift
	wdata(inew,jnew)=ufl
	call getij(nx,ny,xs,ys,dx,dy,ap,y,i,j,xr,yr)
	if(i.ge.1.and.i.le.nx-1.and.j.ge.1.and.j.le.ny-1) then
	  b1=rdata(i,  j,  k)
	  b2=rdata(i+1,j,  k)
	  b3=rdata(i+1,j+1,k)
	  b4=rdata(i,  j+1,k)
	  if(b1.ne.ufl .and. b2.ne.ufl .and. b3.ne.ufl .and. b4.ne.ufl)
     &	  wdata(inew,jnew)=
     &	  b1+(b2-b1)*xr+(b4-b1)*yr+(b3-b4-b2+b1)*xr*yr
	endif
 2000	continue
c
 1000   continue
c
	xs=xsnew
	nx=nxnew
	dx=dxnew
	x1lim0=xs
	x2lim0=xs+dx*float(nx-1)
	if(rrss.lt.1.0) then
	  z2lim0=rsp*0.5*sqrt((x2lim0-x1lim0)**2+(y2lim0-y1lim0)**2)
	else
	  z2lim0=rsp*rrss -rsp
	endif
c
	call projr(xxto, apr,alr)
	call difrot(dday,alr,irot,rangle)
	apr=apr+rangle
	call rtoc(apr,alr,0.0, xxto)
	call ctod(xxto,xxtod)
	xtod=xxtod(1)
	ytod=xxtod(2)
	call settu
c
c  finally, transform from R-coordinates to the coordinates specified
c  by mesh2
	call transm(kindm1,mesh1, kindm2,mesh2)
c  kindm1 and mesh1 are updated by transm to final values
c
	if(msglvl.gt.0) write(lst,*) 
     &	'(subr.rotm  ) dday,irot,novect=',dday,irot,novect
	return
	end
c
c  solar differential rotation
c
	subroutine difrot(dday,al,model,rangle)
c
c  dday = time difference in day
c  al   =latitude in radian
c  model=0: Carrington rotation
c        1: Newton and Nunn
c        2: Snodgrass
c  rangle=synodic rotation angle in radian
c
c  first calculate sidereal rotation speed rotdeg (deg/day)
c
	if (model.eq.1) then
	  rotdeg= 14.368 - 2.69*sin(al)**2
	else if (model.eq.2) then
	  rotdeg= 14.049 - 1.492*sin(al)**2 - 2.605*sin(al)**4
	else
	  rotdeg= 14.18
	endif
c
c  then calculate synodic rotation angle rangle (rad/day)
c
	rangle=3.141592*(rotdeg-0.9856)*dday/180.0
	return
	end
