c  How to read a standard-format magnetogram: a sample program
c
c  This sample program describes how to read a magnetogram in
c  the standard format of the MAGPACK2 package. You may also 
c  look up at dumpm.f, which prints out all or part of a
c  magnetogram data.
c
	program sampl2
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	logical update
	integer ium,kdest(NSPEC0)
	character*80 fname1
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	msglvl=1
	include 'sysconf.cfg'
	call initfc
	lst = lstini()
	nxmax=MX
	nymax=MY
	if(mycode.eq.0 .or. myint.eq.0) stop
	lrec0=80
	ium=98
	update=.true.
	do 10 n=1,NSPEC0
 10	kloc(n)=0
	do 20 k=1,MZ
	kmem(k)=0
	lspecs(k)=0
 20	continue
	nframe=0
	nbinx=1
	nbiny=1
	do 30 lspec1=1,NSPEC0
 30	kdest(lspec1)=1
c
c   ***************************************************
c   * You may customize the program below this line.  *
c   ***************************************************
c
c  First, specify the name of the data file from the keyboard.
c
	write(lst,*) 'enter input file name '
	read(keyin,'(a)') fname1
c
	call openfl(mgram,'MGRAM',ium,fname1,export,rdo,lrec0)
	if(errflg.gt.1) stop
c
c  Open the file and read the header
c
	call inmh(ium,update)
	if(errflg.gt.1) stop
c
c  Print the contents of the header if you wish
c
	write(lst,*) 'kindm,nframe=',kindmi,nframi
	call printm(nbytmi,nx,ny,xs,ys,dx,dy,ydeg,
     &	mesh,rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	tsys,inst,wavel,mfile,dateo,stime,etime,ftag,title)
c
c  The number of magnetogram frames contained in the file is 'nframi'.
c  Now, read the frame one by one.
c
	do 1000 iframe=1,nframi
	call inm(ium,kdest)
c
c  The data are now stored in an array:
c     rdata(i,j,k), i=1--nx, j=1--ny, k=1
c
	write(lst,*) 'data(25,*)=',(rdata(25,j,1),j=1,ny)
c
 1000	continue
c
	stop
	end
