c  How to read a standard-format field line file: a sample program
c
c  This sample program describes how to read a field-line file
c  in the standard format of the MAGPACK2 package. You may also
c  look up at dumpl.f, which prints out all or part of a
c  field-line data.
c
	program sampl3
c
	include 'sys.fc'
	include 'coord.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	include 'fline.fc'
	include 'lparam.fc'
	integer iul
	character*80 fname1
	logical update
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	msglvl=1
	include 'sysconf.cfg'
	call initfc
	lst = lstini()
	if(mycode.eq.0 .or. myint.eq.0) stop
	lrec0=80
	iul=98
	update=.true.
c
c
c   ***************************************************
c   * You may customize the program below this line.  *
c   ***************************************************
c
c  First, specify the name of the data file from the keyboard.
c
	write(lst,*) 'enter fieldline file name for input '
	read(keyin,'(a)') fname1
	call openfl(other1,'DUMPL',iul,fname1,export,rdo,lrec0)
	if(errflg.gt.1) stop
c
c  Open the file and read the header
c
	call readlh(iul,update)
	if(errflg.gt.1) stop
	nbytel=sign(nbytli,myint)
	ncomp=ncompi
c
c  Read the field line data one by one. The end of data is
c  indicated by np=0
c
 1	call readl(iul,np,xyzp)
	if(np.le.1) go to 9
c
c  The field line has 'np' data points along its length.
c  If abs(ncomp)=3, the array xyzp contains the following data.
c     xyzp(1,*): x-coordinate  
c     xyzp(2,*): y-coordinate
c     xyzp(3,*): z-coordinate  
c  Here * means 1--np.
c  If abs(ncomp)=8, the array further contains the following data.
c     xyzp(4,*): arc-length along the field line
c     xyzp(5,*): Bx
c     xyzp(6,*): By
c     xyzp(7,*): Bz
c     xyzp(8,*): B(field strength)
c
c  Print the data if you wish.
c
	do 10 j=1,np
 10	write(lst,*) (xyzp(i,j),i=1,iabs(ncomp))
c
c  Repeat the same procedure until all the field lines are read.
	go to 1
c
 9	stop
	end
