c  select field lines for force-free field computation
c
	subroutine select( iounit )
c
	include 'sys.fc'
	include 'coord.fc'
	include 'mparam.fc'
	include 'lparam.fc'
	include 'fline.fc'
	include 'ff0.fc'
	include 'fff.fc'
	include 'mdata.fc'
	include 'fileio.fc'
	include 'auxparam.fc'
c
	logical elim
	integer iounit
	integer*4 kindl1
	dimension selz(NFF0,2),ajz(NFF0,2),ljz(NFF0,2),nbr(NFF0,2),
     &	    nmax(2),idispx(2),idispy(2),iavx(2),iavy(2),disp(2)
c
	dimension wk(MX),awk(MX),bwk(MX),cwk(MX),dwk(MX)
	dimension bxs(MX,MY),bys(MX,MY),bzs(MX,MY)
	equivalence (bxs(1,1),qdata(1,1,1)),(bys(1,1),qdata(1,1,2)),
     &	            (bzs(1,1),qdata(1,1,3)),
     &	            (wk(1),qdata(1,1,4)),(awk(1),qdata(1,2,4)),
     &	            (bwk(1),qdata(1,3,4)),(cwk(1),qdata(1,4,4)),
     &	            (dwk(1),qdata(1,5,4))
c
c  nff= number of current-carrying field lines
c  region= 1: footpoints are selected from positive flux region
c  region=-1: footpoints are selected from negative flux region
c  region= 0: footpoints are selected from the region with smaller
c             dispersion of footpoint locations
c  region= 2: footpoints are selected regardless of magnetic polarities
c
	call allocm(1,4,'select')
	if(errflg.gt.1) then
	  write(lst,*) '(subr.select) error'
	  return
	endif
c
	kindl1=mod(kindl,1000)
	if(msglvl.gt.2) write(lst,*) '(subr.select) start',iounit
c
	kx=kxloc()
	ky=kyloc()
	kz=kzloc()
	kj=kjloc()
	kxp=kxploc()
	kyp=kyploc()
	if(kx.eq.0 .or. ky.eq.0 .or. kz.eq.0 ) then
	  write(lst,*) '(subr.select) error: kx,ky,kz=',kx,ky,kz
	  errflg=2
	  return
	endif
	if(kj.eq.0) then
	  write(lst,*) '(subr.select) error: kj=',kj
	  errflg=2
	  return
	endif
	if( kxp.eq.0 .or. kyp.eq.0 ) then
	  write(lst,*) '(subr.select) error: kxp,kyp=',kxp,kyp
	  errflg=2
	  return
	endif
	if(nff.gt.NFF0) then
	  write(lst,*) '(subr.select) error: nff too large, nff=',nff
	  errflg=2
	  return
	endif
c
c  specified boundary values should be Bn
c
	if(.not.(kindl1.eq.0 .or. kindl1.eq.1 .or.
     &         kindl1.eq.2 .or. kindl1.eq.102 ) ) then
	  write(lst,*) '(subr.select) error: kindl=',kindl
	  errflg=2
	  return
	endif
c
	mesho =  mod(kindl1,10)
	if(mesho.gt.2) mesho=2
c
	call mkindm(kindl1,kindm,kindmo)
	if( mesho.ne.mesh .or. kindm.ne.kindmo ) then
	  if(msglvl.gt.0) then
	    write(lst,*) '(subr.select) calling subr.transm'
	    write(lst,*) '  target mesho and kindmo=',mesho,kindmo
	  endif
	  call transm(kindm,mesh,kindmo,mesho)
	endif
c
c  set bxs=smoothed d(bn)/dx,
	call flt3x3(rdata(1,1,kz),nx,ny,MX, bxs,filter(1,1,ifiltr))
c
	do 4000 j=1,ny
	do 4100 i=1,nx
	bys(i,j)=bxs(i,j)
 4100	wk(i)= bxs(i,j)
	call splin1(nx,dx,wk,dwk,awk,bwk,cwk)
	do 4200 i=1,nx
 4200	bxs(i,j)=dwk(i)
 4000	continue
c  bxs=d(Bz)/dx
c
	do 4300 i=1,nx
	do 4400 j=1,ny
 4400	wk(j)= bys(i,j)
	call splin1(ny,dy,wk,dwk,awk,bwk,cwk)
	do 4500 j=1,ny
 4500	bys(i,j)=dwk(j)
 4300	continue
c  bys=d(Bz)/dy
c
c  reset parameters for iterative process
c
	nitr=0
	nrezon=0
	nffmax=nff
c
	if( mansel ) then
	  nff=0
	  do 10 n=1,nffmax
	  read(iounit,*,end=19) i,j,rotb0(n)
	  nff=nff+1
	  call gridpt(i,j,foot(1,n),xs,ys,dx,dy,mesh)
	  bn0(n)=rdata(i,j,kz)
	  bngx0(n)=bxs(i,j)
	  bngy0(n)=bys(i,j)
	  rotbb0(n)=bngx0(n)*(rdata(i,j,ky)-rdata(i,j,kyp))
     &            -bngy0(n)*(rdata(i,j,kx)-rdata(i,j,kxp))
     &            +bn0(n)*rotb0(n)
	  if(mesh.le.1) then
	    ss0(n)=abs(dx*dy)
	  else
	    ap=xs+dx*float(i-1)
	    y =ys+dy*float(j-1)
	    al=alofy(y)
	    ss0(n)=abs(dx*cos(al)*rsp)*abs(dalofy(y)*dy*rsp)
	  endif
 10	  continue
 19	  continue
	  if(msglvl.gt.0) write(lst,*) 
     &	'(subr.select) nff=',nff,' manual select=',mansel
	  return
	endif
c
	nmax(1)=0
	nmax(2)=0
	do 20 l=1,nffmax
	ajz(l,1)=0.0
	ajz(l,2)=0.0
	selz(l,1)=0.0
	selz(l,2)=0.0
	nbr(l,1)=0
	nbr(l,2)=0
 20	continue
c
c  sort in order of descending jz for positive/negative polarities
c  if minjz.lt.0.0, sort in order of descending bz, instead
c
	if(minjz.lt.0.0) then
	  ksort=kz
	else
	  ksort=kj
	endif
c
	do 1000 j=1,ny
	do 1000 i=1,nx
	if( minjz.ge.0.0 .and. abs(rdata(i,j,kj)).lt.minjz ) go to 1000
	if( abs(rdata(i,j,kz)).lt.minbz ) go to 1000
	if( rdata(i,j,kz).gt.0.0 ) then
	  m=2
	elseif( rdata(i,j,kz).lt.0.0 ) then
	  m=1
	else
	  go to 1000
	endif
c
	if(nmax(m).gt.0) then
c  already there are registered points
	  do 1120 n=1,nmax(m)
	  if(abs(rdata(i,j,ksort)).gt.abs(selz(n,m))) then
	    do 1130 nn=nmax(m),n,-1
	    if(nn+1.gt.nffmax) go to 1130
	    selz(nn+1,m)=selz(nn,m)
	    ajz (nn+1,m)=ajz (nn,m)
	    ljz (nn+1,m)=ljz (nn,m)
 1130	    continue
	    selz(n,m)=rdata(i,j,ksort)
	    ajz(n,m) =rdata(i,j,kj)
	    l=i+(j-1)*nx
	    ljz(n,m)=l
	    nmax(m)=min(nmax(m)+1,nffmax)
	    go to 1000
	  endif
 1120	  continue
c
	  if(nmax(m).lt.nffmax) then
	    selz(nmax(m)+1,m)=rdata(i,j,ksort)
	    ajz (nmax(m)+1,m)=rdata(i,j,kj)
	    l=i+(j-1)*nx
	    ljz(nmax(m)+1,m)=l
	    nmax(m)=nmax(m)+1
	  endif
c
c  the first point to be registered
	else
	  nmax(m)=1
	  selz(nmax(m),m)=rdata(i,j,ksort)
	  ajz (nmax(m),m)=rdata(i,j,kj)
	  l=i+(j-1)*nx
	  ljz(nmax(m),m)=l
	endif
 1000	continue
c
c  search neighboring footpoints
c
	do 2500 m=1,2
c
	do 2000 n=1,nmax(m)
	l=ljz(n,m)
	j=(l-1)/nx+1
	i=l-(j-1)*nx
	do 2100 nn=1,nmax(m)
	if(nn.eq.n) go to 2100
	ll=ljz(nn,m)
	jj=(ll-1)/nx+1
	ii=ll-(jj-1)*nx
	id=(jj-j)**2+(ii-i)**2
	if(id.le.2) nbr(n,m)=nbr(n,m)+1
 2100	continue
 2000	continue
c
c  eliminate isolated field lines? presently, no
	elim=.false.
c  calculate dispersion
c
	idispx(m)=0.0
	idispy(m)=0.0
	iavx(m)=0.0
	iavy(m)=0.0
	nm=nmax(m)
c
	do 2200 n=1,nm
	if(elim .and. nbr(n,m).eq.0) then
	  nmax(m)=nmax(m)-1
	  if(n.lt.nm) then
	    do 2400 nn=n+1,nm
	    selz(nn-1,m)=selz(nn,m)
	    ajz(nn-1,m) =ajz(nn,m)
	    nbr(nn-1,m) =nbr(nn,m)
	    ljz(nn-1,m) =ljz(nn,m)
 2400	    continue
	  endif
c
	  selz(nmax(m)+1,m)=0.0
	  ajz (nmax(m)+1,m)=0.0
	  nbr (nmax(m)+1,m)=0
	  ljz (nmax(m)+1,m)=0
	else
c
	  l=ljz(n,m)
	  j=(l-1)/nx+1
	  i=l-(j-1)*nx
	  idispx(m)=idispx(m)+i**2
	  idispy(m)=idispy(m)+j**2
	  iavx(m)=iavx(m)+i
	  iavy(m)=iavy(m)+j
	endif
 2200	continue
	if(nmax(m).gt.0) then
	  disp(m)=float(idispx(m))/float(nmax(m))
     &	         +float(idispy(m))/float(nmax(m))
     &	         -(float(iavx(m))/float(nmax(m)))**2
     &	         -(float(iavy(m))/float(nmax(m)))**2
	else
	  disp(m)=1.0e30
	endif
 2500	continue
c
	if(nmax(1).eq.0 .and. nmax(2).eq.0) then
	  write(lst,*) '(subr.select) error: no field lines were found'
	  errflg=2
	  return
	endif
c
	if(msglvl.gt.1) then
	  if(ksort.eq.kj) then
          write(lst,100) 'curlbh','curlbh'
	  else
          write(lst,100) 'bz','bz'
	  endif
	endif
 100	  format(/2x, t3,'no.',t12,'negative polarity',
     &	         t42,'positive polarity'/
     &	         2x, t14, a,t24,'(i,j)',t32,'nbr',
     &	         t44, a,t54,'(i,j)',t62,'nbr')
	nm=max(nmax(1),nmax(2))
c
	if(msglvl.gt.1) then
	  do 3000 n=1,nm
	  l1=ljz(n,1)
	  j1=(l1-1)/nx+1
	  i1=l1-(j1-1)*nx
	  l2=ljz(n,2)
	  j2=(l2-1)/nx+1
	  i2=l2-(j2-1)*nx
	  if(n.le.nmax(1) .and. n.le.nmax(2)) then
	    write(lst,110) n,selz(n,1),i1,j1,nbr(n,1),
     &	             selz(n,2),i2,j2,nbr(n,2)
	  else if (n.gt.nmax(2)) then
	    write(lst,120) n,selz(n,1),i1,j1,nbr(n,1)
	  else
	    write(lst,130) n,selz(n,2),i2,j2,nbr(n,2)
 110	  format(2x, i5,1pe12.3,3i5,3x,e12.3,3i5)
 120	  format(2x, i5,1pe12.3,3i5)
 130	  format(2x, i5,12x,15x,3x,1pe12.3,3i5)
	  endif
 3000	  continue
	endif
c
c  set footpoints
c
	factor=1.0
	if(region.eq.2) factor=0.5
c
	if( region.eq.-1 .or.
     &	  (region.eq.0.and.disp(1).le.disp(2))
     &	  .or. region.eq.2 ) then
	  if(nmax(1).eq.0) then
	    write(lst,*) '(subr.select) error: nmax(negative)=0'
	    errflg=2
	    return
	  endif
	  if(msglvl.gt.1) then
	    write(lst,200) 'negative'
 200	  format(/1x,'(subr.select) currents on ',a,' flux'/
     &	         2x, t5,'no.',t9,'ix',t13,'iy',t17,'curlbh',
     &	         t25,'curl[bn(bh-bhp)]',t42,'bz',t52,'alpha')
	  endif
c
	  nff=nmax(1)
	  do 3100 n=1,nff
	  l=ljz(n,1)
	  j=(l-1)/nx+1
	  i=l-(j-1)*nx
	  call gridpt(i,j,foot(1,n),xs,ys,dx,dy,mesh)
	  rotb0(n)=factor*rdata(i,j,kj)
	  alpha0(n)=rotb0(n)/rdata(i,j,kz)
	  alpha(n)=0.0
	  bn0(n)=rdata(i,j,kz)
	  bngx0(n)=bxs(i,j)
	  bngy0(n)=bys(i,j)
	  rotbb0(n)=bngx0(n)*(rdata(i,j,ky)-rdata(i,j,kyp))
     &            -bngy0(n)*(rdata(i,j,kx)-rdata(i,j,kxp))
     &            +bn0(n)*rotb0(n)
	  if(mesh.le.1) then
	    ss0(n)=abs(dx*dy)
	  else
	    ap=xs+dx*float(i-1)
	    y =ys+dy*float(j-1)
	    al=alofy(y)
	    ss0(n)=abs(dx*cos(al)*rsp)*abs(dalofy(y)*dy*rsp)
	  endif
c
	  write(iounit,*) i,j,rotb0(n)
	  if(msglvl.gt.1) write(lst,300)
     &	    n,i,j,rotb0(n),rotbb0(n),bn0(n),alpha0(n)
 300	    format(2x, 3i4,1p4e11.3)
 3100	  continue
c
	elseif( region.eq.1 .or.
     &	  (region.eq.0.and.disp(2).lt.disp(1))
     &	  .or. region.eq.2 ) then
	  if(nmax(2).eq.0) then
	    write(lst,*) '(subr.select) error: nmax(positive)=0'
	    errflg=2
	    return
	  endif
	  if(msglvl.gt.1) then
	    write(lst,200) 'positive'
	  endif
c
	  nff=nmax(2)
	  do 3200 n=1,nff
	  l=ljz(n,2)
	  j=(l-1)/nx+1
	  i=l-(j-1)*nx
	  call gridpt(i,j,foot(1,n),xs,ys,dx,dy,mesh)
	  rotb0(n)=factor*rdata(i,j,kj)
	  bn0(n)=rdata(i,j,kz)
	  alpha0(n)=rotb0(n)/bn0(n)
	  bn0(n)=rdata(i,j,kz)
	  bngx0(n)=bxs(i,j)
	  bngy0(n)=bys(i,j)
	  rotbb0(n)=bngx0(n)*(rdata(i,j,ky)-rdata(i,j,kyp))
     &            -bngy0(n)*(rdata(i,j,kx)-rdata(i,j,kxp))
     &            +bn0(n)*rotb0(n)
	  if(mesh.le.1) then
	    ss0(n)=abs(dx*dy)
	  else
	    ap=xs+dx*float(i-1)
	    y =ys+dy*float(j-1)
	    al=alofy(y)
	    ss0(n)=abs(dx*cos(al)*rsp)*abs(dalofy(y)*dy*rsp)
	  endif
c
	  write(iounit,*) i,j,rotb0(n)
	  if(msglvl.gt.1) write(lst,300)
     &	    n,i,j,rotb0(n),rotbb0(n),bn0(n),alpha0(n)
 3200	  continue
	endif
c
	ajzpbp=0.0
	ajzmbp=0.0
	ajzpbm=0.0
	ajzmbm=0.0
	ajzpbp0=0.0
	ajzmbp0=0.0
	ajzpbm0=0.0
	ajzmbm0=0.0
c
	do 3300 n=1,nff
	if(bn0(n).ge.0.0) then
	  if(rotb0(n).gt.0.0) then
	    ajzpbp=ajzpbp+rotb0(n)*ss0(n)
	  else
	    ajzmbp=ajzmbp-rotb0(n)*ss0(n)
	  endif
	else
	  if(rotb0(n).gt.0.0) then
	    ajzpbm=ajzpbm+rotb0(n)*ss0(n)
	  else
	    ajzmbm=ajzmbm-rotb0(n)*ss0(n)
	  endif
	endif
 3300	continue
c
	do 3400 j=1,ny
	do 3400 i=1,nx
	if(mesh.le.1) then
	  aa=abs(dx*dy)
	else
	  ap=xs+dx*float(i-1)
	  y =ys+dy*float(j-1)
	  al=alofy(y)
	  aa=abs(dx*cos(al)*rsp)*abs(dalofy(y)*dy*rsp)
	endif
	if(rdata(i,j,kz).ge.0.0) then
	  if(rdata(i,j,kj).gt.0.0) then
	    ajzpbp0=ajzpbp0+rdata(i,j,kj)*aa
	  else
	    ajzmbp0=ajzmbp0-rdata(i,j,kj)*aa
	  endif
	else
	  if(rdata(i,j,kj).gt.0.0) then
	    ajzpbm0=ajzpbm0+rdata(i,j,kj)*aa
	  else
	    ajzmbm0=ajzmbm0-rdata(i,j,kj)*aa
	  endif
	endif
 3400	continue
c
	if(msglvl.gt.0) then
	  write(lst,*) '(subr.select) manual select=',mansel
	  write(lst,*) '   positive flux region'
	  write(lst,*) '   area*curlbh (positive,negative): total   =',
     &	               ajzpbp0,ajzmbp0
	  write(lst,*) '   area*curlbh (positive,negative): selected=',
     &	               ajzpbp,ajzmbp
	  write(lst,*) '   negative flux region'
	  write(lst,*) '   area*curlbh (positive,negative): total   =',
     &	               ajzpbm0,ajzmbm0
	  write(lst,*) '   area*curlbh (positive,negative): selected=',
     &	               ajzpbm,ajzmbm
	endif
c
	call freem(1,4)
	return
	end
