c  set s1(solenoid coil) and s2(Green's function monopole) sources
c
	subroutine sets12( rds1a, iunit1 )
c
	include 'sys.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'auxparam.fc'
	include 'fileio.fc'
	include 'mdata.fc'
	include 'ss.fc'
	include 's1.fc'
	include 's2.fc'
	integer iunit1
	integer*4 kindl1
	logical rds1a
c
	kindl1=mod(kindl,1000)
	kz=kzloc()
	if( rds1a .and. iunit1.gt.0 ) call reads1(iunit1)
c
c  correction for mutual interference among s1-sources
c  and set currents
	call s1cal(kz)
c
	ns20=nx*ny
	if(ns20.eq.0) go to 3
c
c  make kindmo 
c
	if(kz.eq.0) then
	  write(msg,*) '(subr.sets12) error: kz=0'
	  errflg=2
	  return
	endif
c
	mesho =  mod(kindl1,10)
	if(mesho.eq.3 .and. mesh.eq.4) mesho=mesh
	call mkindm(kindl1,kindm,kindmo)
	if( mesho.ne.mesh .or. kindm.ne.kindmo ) then
	  if(msglvl.gt.0) then
	    write(lst,*) '(subr.sets12) calling subr.transm'
	    write(lst,*) '  current kind and mesh=',kindm,mesh
	  endif
	  call transm(kindm,mesh,kindmo,mesho)
	  if(errflg.gt.1) return
	endif
c  subr.transm may have updated nx and ny, so that recalculate ns20 
	ns20=nx*ny
c
c  set s2-source data
c
c  ufl=1.0e-15
c  ufl is in sys.fc and defined by initfc.f
c
	if(ns20.gt.NSIZE2) then
	  write(msg,*)
     &	'(subr.sets12) error: insufficient space for s2 sources'
	  write(msg,*)
     &	  '              NSIZE2 in s2.fc should be larger than ',ns20
	  errflg=2
	  return
	endif
c
	do 10 m=1,3
 10	dlg(m)=zdu(m)
c
	if(kindl1.eq.0) then
	  do 2000 j=1,ny
	  do 2000 i=1,nx
	  l=i+(j-1)*nx
	  xxs2(1,l)=xs+dx*float(i-1)
	  xxs2(2,l)=ys+dy*float(j-1)
	  xxs2(3,l)=0.0
	  call dtoc(xxs2(1,l),xxs2(1,l))
	  direc2(1,l)=0.0
	  direc2(2,l)=0.0
	  direc2(3,l)=1.0
	  ss2(l)=abs(dx*dy)
	  flx20(l)=rdata(i,j,kz)*ss2(l)
 2000	  continue
c
	elseif( mod(kindl1,10).eq.1 ) then
	  do 2100 j=1,ny
	  do 2100 i=1,nx
	  l=i+(j-1)*nx
	  xxs2(1,l)=xs+dx*float(i-1)
	  xxs2(2,l)=ys+dy*float(j-1)
	  xxs2(3,l)=0.0
	  call ttoc(xxs2(1,l),xxs2(1,l))
	  do 2110 m=1,3
 2110	  direc2(m,l)=ztu(m)
	  dotnl(l)=dlg(1)*direc2(1,l)+dlg(2)*direc2(2,l)
     &	          +dlg(3)*direc2(3,l)
	  do 2120 m=1,3
 2120	  amu(m,l)=direc2(m,l)-dotnl(l)*dlg(m)
	  ss2(l)=abs(dx*dy)
	  flx20(l)=rdata(i,j,kz)*ss2(l)
 2100	  continue
c
	elseif( mod(kindl1,10).eq.2 ) then
c  rotate source if necessary
	  aprot=0.0
	  if(rotsrc.ne.0.0) then
	    if(msglvl.gt.0)
     &	    write(lst,*) '(subr.sets12) s2 sources rotated by',
     &	                 rotsrc,' deg'
	    aprot=rotsrc*3.141592/180.0
	    do 2210 m=1,3
 2210	    dlg(m)=dlg(m)*rsp+xxsp(m)
	    call ctor(dlg,ap,al,h)
	    ap=ap+aprot
	    call rtoc(ap,al,h,dlg)
	    do 2220 m=1,3
	    dlg(m)=dlg(m)-xxsp(m)
 2220	    dlg(m)=dlg(m)/rsp
	    x1lim0=x1lim0+aprot
	    x2lim0=x2lim0+aprot
	    x1lim=x1lim+aprot
	    x2lim=x2lim+aprot
	  endif
c
	  do 2200 j=1,ny
	  do 2200 i=1,nx
	  l=i+(j-1)*nx
	  ap=xs+dx*float(i-1) + aprot
	  y =ys+dy*float(j-1)
	  al=alofy(y)
	  call stoc(ap,al,0.0, xxs2(1,l))
	  ss2(l)=abs(dx*cos(al)*rsp)*abs(dalofy(y)*dy*rsp)
	  flx20(l)=rdata(i,j,kz)*ss2(l)
c
c  if y=pi/2 or -pi/2, dalofy(y)=0 and no contribution to flux from 
c  the poles
c  there are nx pixels at y=pi/2-dy or y=-pi/2+dy which have flux similar
c  to the poles, so that the error in ignoring the poles is of the order 
c  of 1/nx
c 
 2200	  continue
c
	elseif( kindl1.eq.103 ) then
	  do 2300 j=1,ny
	  do 2300 i=1,nx
	  l=i+(j-1)*nx
	  apr=xs+dx*float(i-1)
	  y  =ys+dy*float(j-1)
	  alr=alofy(y)
	  call rtoc(apr,alr,0.0, xxs2(1,l))
	  ss2(l)=abs(dx*cos(alr)*rsp)*abs(dalofy(y)*dy*rsp)
	  flx20(l)=rdata(i,j,kz)*ss2(l)
 2300	  continue
	endif
c
c max./min. field strengths
c
	bpmax=0.0
	bmmax=0.0
	nozero=0
	do 2500 j=1,ny
	do 2500 i=1,nx
	if(rdata(i,j,kz).gt. bpmax) bpmax= rdata(i,j,kz)
	if(rdata(i,j,kz).lt.-bmmax) bmmax=-rdata(i,j,kz)
	if(rdata(i,j,kz).ne.0.0 .and. rdata(i,j,kz).ne.ufl)
     &  nozero=nozero+1
 2500	continue
c
c  s2-data with b<abs(bmin1) is set to zero
c  if bmin1<0 and the number of s2 sources (ns2) is too small 
c  (ns2 < ns2min), bmin1 is decreased in order to increase ns2
c
	bmin10=bmin1
	bmin20=bmin2
c
 3900	continue
	flxp=0.0
	flxm=0.0
	ns2=0
	do 3000 l=1,ns20
	if(flx20(l).gt.0.0) flxp=flxp+flx20(l)
	if(flx20(l).lt.0.0) flxm=flxm-flx20(l)
	if(abs(flx20(l)).lt.ss2(l)*abs(bmin1) ) then
	  flx2(l)=0.0
	else
	  flx2(l)=flx20(l)
	  ns2=ns2+1
	endif
 3000	continue
c
	if(bmin1.lt.0.0 .and. ns2.lt.ns2min .and.
     &   nozero.gt.ns2min ) then
	   if(msglvl.gt.1)
     &	write(lst,*)
     &	'(subr.sets12) bmin1 is reduced. bmin1,ns2=',
     &	abs(bmin1),ns2
	  bmin1=bmin1/2.0
	  bmin2=bmin2/2.0
	  go to 3900
	endif
c
	if(bmin1.ne.bmin10 .and. ns2.lt.2*ns2min) then
	  bmin2=0.0
	  if(msglvl.gt.1) write(lst,*)
     &	'(subr.sets12) warning: bmin2 is set to 0'
	endif
	call bpack(bmin2,ns2max)
c
c  s2-data with b<bmin2 are now packed
c  flx2 is packed, flx20 remains intact 
c  subr.bpack also defines ns2
c
	do 3100 l=1,ns2
 3100	aa2(l)=sqrt(abs(ss2(l))/3.141592)
c  conversion from area ss2 to radius aa2
c  actually ss2 and aa2 occupy the same memory area
c
	flx=flxp-flxm
      if(msglvl.gt.1) then
        write(lst,*) '(subr.sets12) s2 sources'
        write(lst,*) '  positive max.field, flux =',bpmax,flxp
        write(lst,*) '  negative max.field, flux =',bmmax,flxm
        write(lst,*) '  total flux =',flx
      endif
c
c  calculate direc2,dotnl,amu for spherical models
c
	if(mod(kindl1,10).ge.2) then
	  do 3200 l=1,ns2
	  do 3300 m=1,3
 3300	  direc2(m,l)=(xxs2(m,l)-xxsp(m))/rsp
	  dotnl(l)=dlg(1)*direc2(1,l)+dlg(2)*direc2(2,l)
     &	          +dlg(3)*direc2(3,l)
	  do 3400 m=1,3
 3400	  amu(m,l)=direc2(m,l)-dotnl(l)*dlg(m)
 3200	  continue
c
	  if(rrss.gt.1.0 .and. kindl1/100.gt.0 ) then
	    call setrss
	  endif
c
	endif
c
 3	continue
c
	if(ns1.le.0.and.ns2.le.0.and.modelf.eq.0) then
	  write(msg,*) '(subr.sets12) error: ns1,ns2=',ns1,ns2
	  errflg=2
	  return
	endif
c
	if(msglvl.gt.0) write(lst,*)
     &	 '(subr.sets12) ns1,ns2=',ns1,ns2,
     &	 '  bmin1,bmin2=',abs(bmin1),abs(bmin2)
	return
	end
c
c  calibrate s1-source and set currents
c
	subroutine s1cal(kz)
c
c  after this routine:
c   bn1 is corrected if ns1>0
c   cj1 is the strength of currnt
c
	include 'sys.fc'
	include 'coord.fc'
	include 'mparam.fc'
	include 'lparam.fc'
	include 'ss.fc'
	include 's1.fc'
	include 's2.fc'
	include 'mdata.fc'
	integer*4 kindl1
	dimension bn(NSIZE1),icalib(NSIZE1),
     &	          a(NSIZE1,NSIZE1),nans(NSIZE1)
	dimension bb(3),xx(3)
c
c  contribution of s2 to s1
c
	if(ns1.eq.0) return
	kindl1=mod(kindl,1000)
	if(ns2.eq.0) go to 1100
c
	if(msglvl.gt.1) write(lst,100)
 100	  format(1h0,t5,'no.',t10,'contribution from s2',t40,
     &	         'b(corrected)'/)
c
	do 1000 l=1,ns1
	if( kindl1.eq.0 ) then
	  call ctod(xxc1(1,l),xx)
	  i=(xx(1)-xs)/dx+1.0
	  j=(xx(2)-ys)/dy+1.0
	  xr=(xx(1)-xs)/dx-float(i-1)
	  yr=(xx(2)-ys)/dy-float(j-1)
c
	elseif( mod(kindl1,10).eq.1 ) then
	  call ctot(xxc1(1,l),xx)
	  i=(xx(1)-xs)/dx+1.0
	  j=(xx(2)-ys)/dy+1.0
	  xr=(xx(1)-xs)/dx-float(i-1)
	  yr=(xx(2)-ys)/dy-float(j-1)
c
	elseif( mod(kindl1,10).eq.2 ) then
	  call ctos(xxc1(1,l), ap,al,h)
	  i=(ap-xs)/dx+1.0
c al=halfpi*sin(ys+dy*(j-1))
	  j=(yofal(al)-ys)/dy+1.0
	  xr=(ap-xs)/dx-float(i-1)
	  yr=(yofal(al)-ys)/dy-float(j-1)
c
	elseif( kindl1.eq.103 ) then
	  call ctor(xxc1(1,l), apr,alr,h)
	  i=(apr-xs)/dx+1.0
	  j=(yofal(alr)-ys)/dy+1.0
	  xr=(apr-xs)/dx-float(i-1)
	  yr=(yofal(alr)-ys)/dy-float(j-1)
	endif
c
	if(i.lt.1.or.i.gt.nx-1.or.j.lt.1.or.j.gt.ny-1) go to 1000
c
	base=rdata(i,j,kz)
     &	   +(rdata(i+1,j,  kz)-rdata(i,  j,kz))*xr
     &	   +(rdata(i,  j+1,kz)-rdata(i,  j,kz))*yr
     &	   +(rdata(i+1,j+1,kz)-rdata(i+1,j,kz)
     &	    -rdata(i,  j+1,kz)+rdata(i,  j,kz))*xr*yr
	bn1(l)=bn1(l)-base
	if(msglvl.gt.1) write(lst,110) l,base,bn1(l)
 110	  format(2x, i5,15x,f10.3,10x,f10.3)
 1000	continue
c
c  set s1-sources
c
 1100	continue
	do 1200 l=1,ns1
	ksw1(l)=0
	depth=sqrt((xxc1(1,l)-xxs1(1,l))**2+(xxc1(2,l)-xxs1(2,l))**2
     &	          +(xxc1(3,l)-xxs1(3,l))**2)
c
	if( aa1(l).eq. 0.0) then
	  if(el1(l).eq. 0.0) then
c
	    cj1(l)=bn1(l)*0.5*depth**3
c
	  else
	    cj1(l)=bn1(l)*(depth*(el1(l)+depth))**2
     &	          /(el1(l)+2.0*depth)
	  endif
c
	else
	  if(el1(l).eq. 0.0) then
c
	    cj1(l)=bn1(l)/2.0/3.141592*aa1(l)
     &	          *sqrt(1.0+(depth/aa1(l))**2)**3
	  else
c
	    aux=(el1(l)+depth)/sqrt((el1(l)+depth)**2+aa1(l)**2)
     &	   -depth/sqrt(depth**2+aa1(l)**2)
	    cj1(l)=bn1(l)*el1(l)/(2.0*3.141592*aux)
	  endif
	endif
 1200	continue
	if(.not.calib) return
	if(kindl1.eq.103) return
c
c  correction for mutual inteference among s1-sources
c
	m=0
	do 10 l=1,ns1
	call field(xxc1(1,l),bb,1,-1,-1)
	icalib(l)=0
	if( kindl1.eq.0 .or. kindl1.eq.1 .or.
     &    kindl1.eq.2 .or. kindl1.eq.102 ) then
	  bcal=bb(3)
	elseif( kindl1.eq.11 .or. kindl1.eq.12 .or. kindl1.eq.112 ) then
	  bcal=bb(1)*direc1(1,l)+bb(2)*direc1(2,l)+bb(3)*direc1(3,l)
	endif 
	if(abs(bn1(l)-bcal).gt.0.99*abs(bn1(l))) then
	  if(msglvl.gt.1) write(lst,*) '(subr.s1cal ) skip source no.',l
	  go to 10
	endif
	m=m+1
	icalib(l)=m
	bn(m)=bn1(l)
 10	continue
	nm=m
c
	do 20 m=1,ns1
	mm=icalib(m)
	if(mm.eq.0) go to 20
	ksw1(m)=1
c
	do 21 l=1,ns1
	ll=icalib(l)
	if(ll.eq.0) go to 21
	call field(xxc1(1,l),bb,0,-1,-1)
	if( kindl1.eq.0 .or. kindl1.eq.1 .or.
     &    kindl1.eq.2 .or. kindl1.eq.102 ) then
	  bcal=bb(3)
	elseif( kindl1.eq.11 .or. kindl1.eq.12 .or. kindl1.eq.112 ) then
	  bcal=bb(1)*direc1(1,l)+bb(2)*direc1(2,l)+bb(3)*direc1(3,l)
	endif 
 21	a(ll,mm)=bcal/cj1(m)
c
	ksw1(m)=0
 20	continue
c
	nstop=1
	if(nm.gt.0) call lins2(a,nm,NSIZE1,bn,nans,nstop,1.e-5)
	if(nstop.ne.1) then
	  write(msg,*) '(subr.s1cal ) error: matrix is singular'
	  errflg=2
	  return
	endif
c
	do 30 l=1,ns1
	ll=icalib(l)
	if(ll.eq.0) go to 30
	cj1(l)=bn(ll)
 30	continue
c
	if(msglvl.gt.0) 
     &	  write(lst,*) '(subr.s1cal )', nm,'-sources calibrated'
c
	return
	end
c
c  pack s2-source
c
	subroutine bpack(bmin,nsmax)
c
c  subr.sets12 sets:
c	ss2 = area of s2 source
c	flx20 = flux of s2 source
c	flx2 = flx20 for Bn>abs(bmin1), otherwise flx2=0
c  this routine makes 2x2 mesh points with bn<bmin combined to one
c  1-d packed magnetic fluxes are stored in flx2
c  if bmin<0 and the number of s2 sources after packing is too large
c  (ns2 > ns2max), bmin is increased in order to reduce ns2
c
	include 'sys.fc'
	include 'coord.fc'
	include 'ss.fc'
	include 's1.fc'
	include 's2.fc'
	include 'mparam.fc'
	include 'lparam.fc'
	include 'mdata.fc'
	integer*4 kindl1
	dimension line(MX)
c
	kindl1=mod(kindl,1000)
	if(bmin.ge.0.0) then
	  nrep=1
	else
	  nrep=10
	endif
c
	do 3000 loop=1,nrep
	ns2=0
	nobin=0
c
	do 1000 j1=2,ny,2
	do 1000 i1=2,nx,2
	i=i1-1
	j=j1-1
	l=i+(j-1)*nx
	a1=ss2(l)
	a2=ss2(l+1)
	a3=ss2(l+nx)
	a4=ss2(l+1+nx)
	f1=flx20(l)
	f2=flx20(l+1)
	f3=flx20(l+nx)
	f4=flx20(l+1+nx)
c  flx2=0 if Bn<bmin1 in subr.sets12
c  or flx2=0 if the sources are packed in this routine
      if(flx2(l)     .eq.0.0) f1=0.0
      if(flx2(l+1)   .eq.0.0) f2=0.0
      if(flx2(l+nx)  .eq.0.0) f3=0.0
      if(flx2(l+1+nx).eq.0.0) f4=0.0
c
	if( a2*a3*a4.ne.0 .and. 
     &	(abs(f1).gt.a1*abs(bmin) .or. abs(f2).gt.a2*abs(bmin) .or.
     &	 abs(f3).gt.a3*abs(bmin) .or. abs(f4).gt.a4*abs(bmin) ) ) then
	  nobin=nobin+4
        if(f1.ne.0.0) ns2=ns2+1
        if(f2.ne.0.0) ns2=ns2+1
        if(f3.ne.0.0) ns2=ns2+1
        if(f4.ne.0.0) ns2=ns2+1
	  go to 1000
	else
        if(f1+f2+f3+f4.ne.0.0) ns2=ns2+1
c
        if(a2*a3*a4.ne.0.0) then
c  after the sources are packed, a2=a3=a4=0 and the following statements
c  will not be executed any more
	    flx2(l)     =f1+f2+f3+f4
	    flx2(l+1)   =0.0
	    flx2(l+nx)  =0.0
	    flx2(l+1+nx)=0.0
	    ss2(l)      =a1+a2+a3+a4
	    ss2(l+1)    =0.0
	    ss2(l+nx)   =0.0
 	    ss2(l+1+nx) =0.0
c
	    if( kindl1.eq.0) then
	      xxs2(1,l)=xxs2(1,l)+0.5*dx
	      xxs2(2,l)=xxs2(2,l)+0.5*dy
c
	    elseif( mod(kindl1,10).eq.1 )then
	      xxs2(1,l)=xs+dx*(float(i-1)+0.5)
	      xxs2(2,l)=ys+dy*(float(j-1)+0.5)
	      xxs2(3,l)=0.0
	      call ttoc(xxs2(1,l),xxs2(1,l))
c
	    elseif( mod(kindl1,10).eq.2 ) then
	      ap=xs+dx*(float(i-1)+0.5)
	      al=alofy(ys+dy*(float(j-1)+0.5))
	      call stoc(ap,al,0.0, xxs2(1,l))
	    elseif( kindl1.eq.103 ) then
	      apr=xs+dx*(float(i-1)+0.5)
	      alr=alofy(ys+dy*(float(j-1)+0.5))
	      call rtoc(apr,alr,0.0, xxs2(1,l))
	    endif
	  endif
	endif
 1000	continue
c
	if(loop.eq.nrep .or. nobin.eq.0 .or.
     &   ns2.lt.nsmax .or.
     &   abs(bmin).gt.2000.0) go to 3900
c
      if(msglvl.gt.1) write(lst,*)
     &  '(subr.bpack ) bmin2 is increased. bmin2,ns2=',abs(bmin),ns2
      bmin=2.0*bmin
 3000	continue
 3900	continue
c
	ll=0
	nx2=nx/2*2
	ny2=ny/2*2
	do 2000 j=1,ny2
	do 2100 i=1,nx2
	l=i+(j-1)*nx
	line(i)=0
	if(flx2(l).ne.0.0) then
	  line(i)=1
	  if(flx2(l).ne.flx20(l)) line(i)=2
	  ll=ll+1
	  ss2(ll)=ss2(l)
	  flx2(ll)=flx2(l)
	  do 2200 m=1,3
 2200	  xxs2(m,ll)=xxs2(m,l)
	endif
 2100	continue
c
	if(msglvl.gt.2) write(lst,200) j,(line(i),i=1,nx2)
 200	  format(2x, i3,2x,10(10i1,1x)/2x, 5x,10(10i1,1x))
 2000	continue
c
	ns2=ll
	if(msglvl.gt.0)
     &	  write(lst,*) '(subr.bpack ) ns2 after pack=',ns2
	return
	end
c
c  set source surface radius
c
	subroutine setrss
c
	include 'sys.fc'
	include 'coord.fc'
	include 'lparam.fc'
	include 'ss.fc'
	include 's2.fc'
	parameter (NTABLE=11)
c
	integer*4 kindl1
	dimension tbln(3,NTABLE),rsstbl(NTABLE),
     &	    amtbl(NTABLE),aoutbl(NTABLE),
     &	    tbll(2,NTABLE),coeff(9,NTABLE),
     &	    coeff1(9,5),coeff2(9,5)
	equivalence (coeff(1,1),coeff1(1,1)),(coeff(1,6),coeff2(1,1))
c
c  source surface model when bn is specified
c
c  rsstbl is a table of relative source surface radii rrss = rss/rsp 
c  amtbl = am/rrss, am=monopole strength
c  aotbl = ao/rrss**2, ao=normalized outer radius of monopole
c  aout  = ao*rsp, ain=rsp**2/aout
c
	data tbln/
c    1/rrss  am/rrss   ao/rrss**2
     1 0.10, 1.210556, 0.898693,
     2 0.20, 1.189272, 0.892683,
     3 0.30, 1.139110, 0.878500,
     4 0.40, 1.052349, 0.853382,
     5 0.50, 0.941330, 0.822118,
     6 0.60, 0.855617, 0.808789,
     7 0.70, 0.834568, 0.837233,
     8 0.80, 0.855196, 0.877156,
     9 0.85, 0.881043, 0.906698,
     a 0.90, 0.930295, 1.006620,
     b 0.95, 0.982045, 1.121181/
c
c  source surface model when bl is specified
c
c  data for source surface model generated by rssl.f + convrssl.f
c  am*rrss = sum(j=1 to 9) [ coeff(j)*cos(float(2*j-1)*th) ]
c
	data tbll/
c    1/rrss   ao/rrss**2
     1 0.10,  0.75,
     2 0.20,  0.75,
     3 0.30,  0.75,
     4 0.40,  0.75,
     5 0.50,  0.75,
     6 0.60,  0.75,
     7 0.70,  0.75,
     8 0.80,  0.8576,
     9 0.85,  0.91035,
     a 0.90,  0.9639,
     b 0.90,  0.9639 /
	data coeff1/
     1    -5.550643,   0.291150,   0.776798,   0.495543,   0.409210,
     1     0.301419,   0.250631,   0.208004,   0.192339,
     2    -4.534327,   0.421385,   0.676358,   0.336765,   0.214059,
     2     0.112404,   0.071672,   0.042096,   0.032918,
     3    -3.778797,   0.271335,   0.478262,   0.205486,   0.110049,
     3     0.044792,   0.024544,   0.010270,   0.007143,
     4    -3.185766,   0.040860,   0.294018,   0.125474,   0.062106,
     4     0.022042,   0.011302,   0.003822,   0.002599,
     5    -2.660593,  -0.193669,   0.121586,   0.065620,   0.035254,
     5     0.012771,   0.006413,   0.002090,   0.001373/
	data coeff2/
     6    -2.152467,  -0.363366,  -0.041561,  -0.004744,   0.004063,
     6     0.000965,   0.000632,  -0.000576,  -0.000607,
     7    -1.653699,  -0.393237,  -0.145229,  -0.074905,  -0.041447,
     7    -0.027110,  -0.018801,  -0.014990,  -0.013131,
     8    -1.372272,  -0.393443,  -0.201454,  -0.121272,  -0.076077,
     8    -0.053910,  -0.041693,  -0.035459,  -0.032552,
     9    -0.976871,  -0.596509,  -0.203784,  -0.071028,  -0.104964,
     9    -0.093301,  -0.023562,  -0.013447,  -0.061295,
     a    -0.522680,  -0.468979,  -0.375856,  -0.266501,  -0.164615,
     a    -0.086640,  -0.037829,  -0.013556,  -0.004792  /
c
	if(rrss.eq.0.0) return
	kindl1=mod(kindl,1000)
	ntab=NTABLE
	rssinv=1.0/rrss
c
c  source surface model when bn is specified
c
	if( kindl1.eq.102 .or. kindl1.eq.103 ) then
	  do 10 n=1,ntab 
	  rsstbl(n)=tbln(1,n)
	  amtbl (n)=tbln(2,n)
	  aoutbl(n)=tbln(3,n)
 10	  continue
c
c  source surface model when bl is specified
c
	else if( kindl1.eq.112 ) then
	  if(2*ns2.gt.NSIZE4) then
	    write(msg,*)
     &    '(subr.setrss) error: insufficient space in flx2'
	    write(msg,*)
     &	  '              NSIZE4 in s2.fc should be larger than ',2*ns2
	    errflg=2
	    return
	  endif
	  do 20 n=1,ntab 
	  rsstbl(n)=tbll(1,n)
 20	  aoutbl(n)=tbll(2,n)
	else
	  write(msg,*) '(subr.setrss) error: kindl=',kindl
	  errflg=2
	  return
	endif
c
      if(rssinv.lt.rsstbl(1)) then
        write(lst,*)
     &  '(subr.setrss) warning: rrss is too large: set rrss=infinity'
        rrss=0.0
        return
      endif
      if(rssinv.gt.rsstbl(ntab)) then
        write(msg,*) '(subr.setrss) error: rrss too small',rrss
        errflg=2
        return
      endif
c
	rss=rsp*rrss
c
c  source surface model when bn is specified
c
	if( kindl1.eq.102 .or. kindl1.eq.103 ) then
	  do 1000 n=2,ntab
	  if(rssinv.lt.rsstbl(n)) go to 1100
 1000	  continue
 1100	  continue
c
	  f=(rssinv-rsstbl(n-1))/(rsstbl(n)-rsstbl(n-1))
	  ao=aoutbl(n-1)+f*(aoutbl(n)-aoutbl(n-1))
	  ao=ao*rrss**2
	  if(ao.le.rrss) then
          write(msg,*) '(subr.setrss) error: rrss too small',rrss
          errflg=2
          return
        endif
c
	  aout=ao*rsp
	  ain=rsp**2/aout
	  amout=amtbl(n-1)+f*(amtbl(n)-amtbl(n-1))
	  amout=amout*rrss/4.0
c  amtbl was calculated for the source am=2 on the solar surface.
c  to make emergent flux=pi, am should be am=0.5.
c  therefore amout is divided by 4.
	  amin=amout*rsp/aout
c
	if(msglvl.gt.1) then
	  write(lst,*) '(subr.setrss) rrss=',rrss
	  write(lst,*) '  ao,aout,ain=',ao,aout,ain
	  write(lst,*) '  amout,amin=',amout,amin
	endif
c
c  source surface model when bl is specified
c
	else
c
	  do 2000 l=1,ns2
	  do 2100 n=2,ntab
	  if(rssinv.lt.rsstbl(n)) go to 2200
 2100	  continue
 2200	  continue
c
	  f=(rssinv-rsstbl(n-1))/(rsstbl(n)-rsstbl(n-1))
	  ao=aoutbl(n-1)+f*(aoutbl(n)-aoutbl(n-1))
	  ao=ao*rrss**2
	  aout=ao*rsp
	  ain=rsp**2/aout
	  r=sqrt( (xxs2(1,l)-xxsp(1))**2
     &         +(xxs2(2,l)-xxsp(2))**2
     &         +(xxs2(3,l)-xxsp(3))**2 )
	  rl=dlg(1)*(xxs2(1,l)-xxsp(1))
     &    +dlg(2)*(xxs2(2,l)-xxsp(2))
     &    +dlg(3)*(xxs2(3,l)-xxsp(3))
	  th = acos(rl/r)
	  amout1=0.0 
	  do 2300 m=1,9
 2300	  amout1=amout1 + 
     &    ( coeff(m,n-1)+f*(coeff(m,n)-coeff(m,n-1)) )
     &    *cos(float(2*m-1)*th)
	  amout1=amout1/rrss
	  flx2(l+ns2)=flx2(l)*amout1
c
c  coeff was calculated for the source am=1 on the solar surface.
c  to make emergent flux=pi, am should be am=0.5.
c  therefore in subr.field, a vector bbb is calculated for amout=0.5
c  and then bbb*flx2(l+ns2) is added to b-vector.
c
 2000   continue
	endif
c
	return
	end
