c  set file specification string
	character*8 function  specst(lspec1)
c
	include 'mdata.fc'
c
	character specs(NSPEC0)*8
	data specs/ 'I',  'BT',  'AZ',
     &	      'V',  'Q',   'U',   'V/I','Q/I','U/I',
     &	      'W',  '*',   '*',   'W/I','*',  '*',
     &	      'BLP','BXP', 'BYP', 'BNP','BHXP','BHYP',
     &	      'BRP','BPHP','BTHP', 
     &	      'BL', 'BX',  'BY',  'BN', 'BHX', 'BHY',
     &	      'BR', 'BPH', 'BTH',
     &	      'VL', 'VX',  'VY',  'VN', 'VHX', 'VHY',
     &	      'VR', 'VPH', 'VTH',
     &	      'JL','*','*', 'JN','*','*', 'JR','*','*',
     &	      'FL','*','*', 'FN','*','*', 'FR','*','*',
     &	      'ALPHA','*','*',
     &	      'DIVB','*','*',
     &	      '1S', '1X', '1Y', '2S', '2X','2Y',
     &	      '3S', '3X', '3Y', '4S', '4X','4Y'/
c
c  lspec1      specst
c  1,2,3       I,BT,AZ
c  4,5,6       V,Q,U
c  7,8,9       V/I,Q/I,U/I
c  10          W
c  13          W/I
c  16,17,18    BLP,BXP,BYP
c  19,20,21    BNP,BHXP,BHYP
c  22,23,24    BRP,BPHP,BTHP
c  25,26,27    BL,BX,BY
c  28,29,30    BN,BHX,BHY
c  31,32,33    BR,BPH,BTH
c  34,35,36    VL,VX,VY
c  37,38,39    VN,VHX,VHY
c  40,41,42    VR,VPH,VTH
c  43          JL
c  46          JN
c  49          JR
c  52          FL
c  55          FN
c  58          FR
c  61          ALPHA
c  64          DIVB
c  67,68,69    1S,1X,1Y
c  70,71,72    2S,2X,2Y
c  73,74,75    3S,3X,3Y
c  76,77,78    4S,4X,4Y
c
c  larger lspec1 values indicate higher priorities
c  mod(lspec1,3)=1   : scalar data
c  mod(lspec1,3)=2,3 : 2-d vector data
c
	if(lspec1.ge.1.and.lspec1.le.NSPEC0) then
	  specst=specs(lspec1)
	else
	  specst='UNKNOWN'
	endif
	return
	end
c
c  set unit specification string
	character*12 function  unitst(lspec1)
c
	include 'mdata.fc'
c
	character units(NSPEC0)*12
	data units/ 'ADU',  'GAUSS',  'DEG',
     &	      'ADU',  'ADU',   'ADU',   ' ',' ',' ',
     &	      'ADU',  ' ',   ' ',   ' ',' ',  ' ',
     &	      'GAUSS','GAUSS','GAUSS', 'GAUSS','GAUSS','GAUSS',
     &	      'GAUSS','GAUSS','GAUSS', 
     &	      'GAUSS','GAUSS','GAUSS', 'GAUSS','GAUSS','GAUSS',
     &	      'GAUSS','GAUSS','GAUSS', 
     &	      'M/S', 'M/S', 'M/S',  'M/S', 'M/S', 'M/S',
     &	      'M/S', 'M/S', 'M/S',
     &	      'G/10**4KM',' ',' ', 'G/10**4KM',' ',' ',
     &	      'G/10**4KM',' ',' ',
     &	      'G**2/10**4KM',' ',' ', 'G**2/10**4KM',' ',' ',
     &	      'G**2/10**4KM',' ',' ',
     &	      '/10**4KM',' ',' ',
     &	      'G/10**4KM',' ',' ',
     &	      ' ', ' ', ' ', ' ', ' ',' ',
     &	      ' ', ' ', ' ', ' ', ' ',' '/
c
c  lspec1      specst            unitst
c  1,2,3       I,BT,AZ           ADU,GAUSS,DEG
c  4,5,6       V,Q,U             ADU,ADU,ADU
c  7,8,9       V/I,Q/I,U/I      (NONDIM)
c  10          W                 ADU
c  13          W/I              (NONDIM)
c  16,17,18    BLP,BXP,BYP       GAUSS
c  19,20,21    BNP,BHXP,BHYP     GAUSS
c  22,23,24    BRP,BPHP,BTHP     GAUSS
c  25,26,27    BL,BX,BY          GAUSS
c  28,29,30    BN,BHX,BHY        GAUSS
c  31,32,33    BR,BPH,BTH        GAUSS
c  34,35,36    VL,VX,VY          KM/S
c  37,38,39    VN,VHX,VHY        KM/S
c  40,41,42    VR,VPH,VTH        KM/S
c  43          JL                G/10**4KM
c  46          JN                G/10**4KM
c  49          JR                G/10**4KM
c  52          FL                G**2/10**4KM
c  55          FN                G**2/10**4KM
c  58          FR                G**2/10**4KM
c  61          ALPHA             /10**4KM
c  64          DIVB              G/10**4KM
c  67,68,69    1S,1X,1Y         (NONE)
c  70,71,72    2S,2X,2Y         (NONE)
c  73,74,75    3S,3X,3Y         (NONE)
c  76,77,78    4S,4X,4Y         (NONE)
c
c  larger lspec1 values indicate higher priorities
c  mod(lspec1,3)=1   : scalar data
c  mod(lspec1,3)=2,3 : 2-d vector data
c
	if(lspec1.ge.1.and.lspec1.le.NSPEC0) then
	  unitst=units(lspec1)
	else
	  unitst='       '
	endif
	return
	end
c
c  search file specification string
c  spec=file specification string
c  lspec=logical specification number
c
	integer function lspec(spec)
c
	include 'mdata.fc'
c
	character spec*(*),buf*8,specst*8
c
c  BL and BZ are regarded identical
	buf=spec
	if (buf(2:2).eq.'Z' .and. buf.ne.'AZ') buf(2:2)='L'
	do 10 lspec=1,NSPEC0
	if (buf.eq.specst(lspec)) go to 20
 10	continue
	lspec  = 0
 20	return
	end
c
c  set nframe and kmem
c  kmem(1-nframe) : effective k-values
c    if rdata(*,*,k) has valid data, kmem(k)=k
c    otherwise, kmem(k)=0
c  lspecs(k) : logical specification number
c  kloc(lspec) : memory location of data specified by lspec
c
	subroutine kpack
c
	include 'fileio.fc'
	include 'mdata.fc'
c
	nframe=0
	do 10 k=1,MZ
	lspec1=lspecs(k)
	if(lspec1.eq.0) go to 10
	nframe=nframe+1
	kloc(lspec1)=k
	kmem(nframe)=k
 10	continue
	return
	end
c
c  find space for lspec=lspec1 on memory and return the k-value
c
	function newk(lspec1,alloc)
	include 'sys.fc'
	include 'mdata.fc'
	logical alloc
c
	newk=0
c
	do 10 k=1,MZ
	if( lspecs(k).ne.0 ) go to 10
	newk=k
	if(alloc) then
	  nframe=nframe+1
	  kloc(lspec1)=k
	  kmem(nframe)=k
	  lspecs(k)=lspec1
	endif
	return
 10	continue
	write(msg,*)
     &	'(func.newk  ) error: nframe exceeded limit (',MZ,')'
	newk=0
	errflg=2
	return
	end
c
c
c  kxloc, kyloc, and kzloc give the k-values for:
c      BT,BXP,BHXP,BPHP,BX,BHX,BPH 
c      AZ,BYP,BHYP,BTHP,BY,BHY,BTH
c         BLP,BNP, BRP, BL,BN, BR
c     (lowest              highest priority)
c     (lowest              highest lspec-value)
c  if they exist on memory 
c
	function kxloc()
c
	include 'fileio.fc'
	include 'mdata.fc'
	character spec*8
c  specst is declared as charactere*8 in fileio.fc
c
	kxloc=0
	lspec1=0
	do 10 iframe=1,nframe
	lspecx=lspecs(kmem(iframe))
	if(lspecx.eq.0) go to 10
	spec=specst(lspecx)
	if((spec(1:2).eq.'BX' .or. spec(1:3).eq.'BHX'
     &	.or. spec(1:3).eq.'BPH'
     &	.or. spec.eq.'BT')
     &	.and. lspecx.gt.lspec1) then
	  lspec1=lspecx
	  kxloc=kloc(lspecx)
	endif
 10	continue
	return
c
	entry kyloc()
c
	kyloc=0
	lspec1=0
	do 20 iframe=1,nframe
	lspecy=lspecs(kmem(iframe))
	if(lspecy.eq.0) go to 20
	spec=specst(lspecy)
	if((spec(1:2).eq.'BY' .or. spec(1:3).eq.'BHY'
     &	.or. spec(1:3).eq.'BTH'
     &	.or. spec.eq.'AZ')
     &	.and. lspecy.gt.lspec1) then
	  lspec1=lspecy
	  kyloc=kloc(lspecy)
	endif
 20	continue
	return
c
	entry kzloc()
c
	kzloc=0
	lspec1=0
	do 30 iframe=1,nframe
	lspecz=lspecs(kmem(iframe))
	if(lspecz.eq.0) go to 30
	spec=specst(lspecz)
	if((spec(1:2).eq.'BL' .or. spec(1:2).eq.'BN'
     &	.or. spec(1:2).eq.'BR')
     &	.and. lspecz.gt.lspec1) then
	  lspec1=lspecz
	  kzloc=kloc(lspecz)
	endif
 30	continue
	return
c
c  kxploc, kyploc, and kzploc give the k-values for:
c      BXP,BHXP,BPHP
c      BYP,BHYP,BTHP
c      BLP,BNP, BRP
c     (lowest   highest priority)
c     (lowest   highest lspec-value)
c  if they exist on memory
c  if several candidates exist, the one with the largest lspec value
c  is taken
c
	entry kxploc()
c
	kxploc=0
	lspec1=0
	do 15 iframe=1,nframe
	lspecx=lspecs(kmem(iframe))
	if(lspecx.eq.0) go to 15
	spec=specst(lspecx)
	if((spec.eq.'BXP' .or. spec.eq.'BHXP'
     &	.or. spec.eq.'BPHP')
     &	.and. lspecx.gt.lspec1) then
	  lspec1=lspecx
	  kxploc=kloc(lspecx)
	endif
 15	continue
	return
c
	entry kyploc()
c
	kyploc=0
	lspec1=0
	do 25 iframe=1,nframe
	lspecy=lspecs(kmem(iframe))
	if(lspecy.eq.0) go to 25
	spec=specst(lspecy)
	if((spec.eq.'BYP' .or. spec.eq.'BHYP'
     &	.or. spec.eq.'BTHP')
     &	.and. lspecy.gt.lspec1) then
	  lspec1=lspecy
	  kyploc=kloc(lspecy)
	endif
 25	continue
	return
c
	entry kzploc()
c
	kzploc=0
	lspec1=0
	do 35 iframe=1,nframe
	lspecz=lspecs(kmem(iframe))
	if(lspecz.eq.0) go to 35
	spec=specst(lspecz)
	if((spec.eq.'BLP' .or. spec.eq.'BNP'
     &	.or. spec.eq.'BRP')
     &	.and. lspecz.gt.lspec1) then
	  lspec1=lspecz
	  kzploc=kloc(lspecz)
	endif
 35	continue
	return
c
c  kiloc returns the k-value for intensity
c
	entry kiloc()
c
	kiloc=0
	do 40 iframe=1,nframe
	lspeci=lspecs(kmem(iframe))
	if(lspeci.eq.0) go to 40
	spec=specst(lspeci)
	if(spec.eq.'I')
     &	kiloc=kloc(lspeci)
 40	continue
	return
c
c  kdloc return the k-value for the Doppler velocity VL, VN, or VR
c
	entry kdloc()
c
	kdloc=0
	lspec1=0
	do 50 iframe=1,nframe
	lspecd=lspecs(kmem(iframe))
	if(lspecd.eq.0) go to 50
	spec=specst(lspecd)
	if((spec.eq.'VL' .or. spec.eq.'VN' .or. spec.eq.'VR')
     &	.and. lspecd.gt.lspec1) then
	  lspec1=lspecd
	  kdloc=kloc(lspecd)
	endif
 50	continue
	return
c
c  kjloc returns the k-value for
c     JL: 2-d curl of (BX,BY),
c     JN=curl(BHX,BHY), or
c     JR=curl(BTH,BPH)
c
	entry kjloc()
c
	kjloc=0
	lspec1=0
	do 60 iframe=1,nframe
	lspecj=lspecs(kmem(iframe))
	if(lspecj.eq.0) go to 60
	spec=specst(lspecj)
	if((spec.eq.'JL' .or. spec.eq.'JN' .or. spec.eq.'JR')
     &	.and. lspecj.gt.lspec1) then
	  lspec1=lspecj
	  kjloc=kloc(lspecj)
	endif
 60	continue
	return
c
c  kfloc returns the k-value for 
c     FL: 2-d curl of (BL*BX,BL*BY),
c     FN=curl(BN*BHX,BN*BHY), or
c     FR=curl(BR*BTH,BR*BPH)
c
	entry kfloc()
c
	kfloc=0
	lspec1=0
	do 65 iframe=1,nframe
	lspecf=lspecs(kmem(iframe))
	if(lspecf.eq.0) go to 65
	spec=specst(lspecf)
	if((spec.eq.'FL' .or. spec.eq.'FN' .or. spec.eq.'FR')
     &	.and. lspecf.gt.lspec1) then
	  lspec1=lspecf
	  kfloc=kloc(lspecf)
	endif
 65	continue
	return
c
c  kaloc returns the k-value for force-free parameter alpha
c
	entry kaloc()
c
	kaloc=0
	do 70 iframe=1,nframe
	lspeca=lspecs(kmem(iframe))
	if(lspeca.eq.0) go to 70
	spec=specst(lspeca)
	if(spec.eq.'ALPHA') 
     &	kaloc=kloc(lspeca)
 70	continue
	return
c
c  kqloc, kuloc, and kvloc return the k-values 
c  for Stokes q,u,v
c
	entry kqloc()
c
	kqloc=0
	lspec1=0
	do 80 iframe=1,nframe
	lspecq=lspecs(kmem(iframe))
	if(lspecq.eq.0) go to 80
	spec=specst(lspecq)
	if((spec.eq.'Q' .or. spec.eq.'Q/I')
     &	.and. lspecq.gt.lspec1) then
	  lspec1=lspecq
	  kqloc=kloc(lspecq)
	endif
 80	continue
	return
c
	entry kuloc()
c
	kuloc=0
	lspec1=0
	do 85 iframe=1,nframe
	lspecu=lspecs(kmem(iframe))
	if(lspecu.eq.0) go to 85
	spec=specst(lspecu)
	if((spec.eq.'U' .or. spec.eq.'U/I')
     &	.and. lspecu.gt.lspec1) then
	  lspec1=lspecu
	  kuloc=kloc(lspecu)
	endif
 85	continue
	return

	entry kvloc()
c
	kvloc=0
	lspec1=0
	do 90 iframe=1,nframe
	lspecv=lspecs(kmem(iframe))
	if(lspecv.eq.0) go to 90
	spec=specst(lspecv)
	if((spec.eq.'V' .or. spec.eq.'V/I')
     &	.and. lspecv.gt.lspec1) then
	  lspec1=lspecv
	  kvloc=kloc(lspecv)
	endif
 90	continue
	return
c
c  kwloc returns the k-value for wing intensity difference
c  (namely, uncalibrated Doppler signal)
c
	entry kwloc()
c
	kwloc=0
	lspec1=0
	do 95 iframe=1,nframe
	lspecw=lspecs(kmem(iframe))
	if(lspecw.eq.0) go to 95
	spec=specst(lspecw)
	if((spec.eq.'W' .or. spec.eq.'W/I')
     &	.and. lspecw.gt.lspec1) then
	  lspec1=lspecw
	  kwloc=kloc(lspecw)
	endif
 95	continue
	return
c
	end
c
c  determine kdest from the value of kindm1
c  'readm' routine reads the data into rdata(*,*,k) if k is in kdest-list.
c  subr.readm calls ilist with unique=false
c  sunr.olist calls ilist with unique=true 
c
	subroutine ilist(kindm1,kdest,kmax,nspec,unique)
c
	include 'sys.fc'
	include 'fileio.fc'
c
	integer kdest(nspec)
	logical unique
c
	if(msglvl.gt.2) write(lst,*) 'ilist: kindm1=',kindm1
c
c  if kindm1=0, all the data will be stored in rdata
c
	if(kindm1.eq.0) then
	  do 10 lspec1=1,nspec
 10	  kdest(lspec1)=0
	  return
	endif
c
	do 20 lspec1=1,nspec
 20	kdest(lspec1)=-1
	k=0
c
c  kindm1<0 : polarization data
c
	if(kindm1.lt.0) then
	  call umake(-kindm1, m5,m4,m3,m2,m1)
	  if(m1.ne.0) then
	    k=k+1
	    kdest(lspec('V'))=k
	    if(.not.unique) then
	      kdest(lspec('V/I'))=k
	      kdest(lspec('BL'))=k
	    endif
	  endif
	  if(m2.ne.0) then
	    k=k+1
	    kdest(lspec('Q'))=k
	    if(.not.unique) then
	      kdest(lspec('Q/I'))=k
	      kdest(lspec('BT'))=k
	      kdest(lspec('BX'))=k
	    endif
	    k=k+1
	    kdest(lspec('U'))=k
	    if(.not.unique) then
	      kdest(lspec('U/I'))=k
	      kdest(lspec('AZ'))=k
	      kdest(lspec('BY'))=k
	    endif
	  endif
	  if(m3.ne.0) then
	    k=k+1
	    kdest(lspec('VL'))=k
	    if(.not.unique) then
	      kdest(lspec('W'))=k
	      kdest(lspec('W/I'))=k
	    endif
	  endif
	  if(m4.ne.0) then
	    k=k+1
	    kdest(lspec('I'))=k
	  endif
	  return
	endif
c
	call umake(kindm1, m5,m4,m3,m2,m1)
c
	go to (30,31,32,33),m5+1
	go to 39
c
c  magnetogram: (longitudinal,transverse)
c
 30	continue
	if(m1.ne.0) then
	  k=k+1
	  kdest(lspec('BL'))=k
	  if(.not.unique) then
	    kdest(lspec('BLP'))=k
	    kdest(lspec('V'))=k
	    kdest(lspec('V/I'))=k
	  endif
	endif
	if(m1.ge.2 .and. m1.ne.5) then
	  k=k+1
	  kdest(lspec('BX'))=k
	  if(.not.unique) then
	    kdest(lspec('BT'))=k
	    kdest(lspec('BXP'))=k
	    kdest(lspec('Q'))=k
	    kdest(lspec('Q/I'))=k
	  endif
	  k=k+1
	  kdest(lspec('BY'))=k
	  if(.not.unique) then
	    kdest(lspec('AZ'))=k
	    kdest(lspec('BYP'))=k
	    kdest(lspec('U'))=k
	    kdest(lspec('U/I'))=k
	  endif
	endif
	if(m1.eq.7 .or. m1.eq.8) then
	  k=k+1
	  kdest(lspec('BLP'))=k
	endif
	if(m1.eq.5 .or. m1.eq.6 .or. m1.eq.7. .or. m1.eq.8) then
	  k=k+1
	  kdest(lspec('BXP'))=k
	  k=k+1
	  kdest(lspec('BYP'))=k
	endif
	go to 39
c
c  magnetogram:(normal,horizontal)
c
 31	continue
	if(m1.ne.0 .and. m1.ne.5) then
	  k=k+1
	  kdest(lspec('BN'))=k
	  if(.not.unique) kdest(lspec('BNP'))=k
	endif
	if(m1.eq.3 .or. m1.eq.4 .or. m1.eq.7 .or. m1.eq.8 .or.
     &	  m1.eq.9) then
	  k=k+1
	  kdest(lspec('BHX'))=k
	  if(.not.unique) kdest(lspec('BHXP'))=k
	  k=k+1
	  kdest(lspec('BHY'))=k
	  if(.not.unique) kdest(lspec('BHYP'))=k
	endif
	if(m1.eq.5 .or. m1.eq.7 .or. m1.eq.8) then
	  k=k+1
	  kdest(lspec('BNP'))=k
	endif
	if(m1.eq.5 .or. m1.eq.7. .or. m1.eq.8) then
	  k=k+1
	  kdest(lspec('BHXP'))=k
	  k=k+1
	  kdest(lspec('BHYP'))=k
	endif
	go to 39
c
c  magnetogram: spherical polar
c
 32	continue
 33	continue
	if(m1.ne.0 .and. m1.ne.5) then
	  k=k+1
	  kdest(lspec('BR'))=k
	  if(.not.unique) kdest(lspec('BRP'))=k
	endif
	if(m1.eq.3 .or. m1.eq.4 .or. m1.eq.7 .or. m1.eq.8 .or.
     &	  m1.eq.9) then
	  k=k+1
	  kdest(lspec('BTH'))=k
	  if(.not.unique) kdest(lspec('BTHP'))=k
	  k=k+1
	  kdest(lspec('BPH'))=k
	  if(.not.unique) kdest(lspec('BPHP'))=k
	endif
	if(m1.eq.5 .or. m1.eq.7 .or. m1.eq.8) then
	  k=k+1
	  kdest(lspec('BRP'))=k
	endif
	if(m1.eq.5 .or. m1.eq.7. .or. m1.eq.8) then
	  k=k+1
	  kdest(lspec('BTHP'))=k
	  k=k+1
	  kdest(lspec('BPHP'))=k
	endif
 39	continue
c
c  electric currents
c
	if(m2.eq.1 .or. m2.eq.4) then
	  k=k+1
	  kdest(lspec('JL'))=k
	else if(m2.eq.2 .or. m2.eq.5) then
	  k=k+1
	  kdest(lspec('JN'))=k
	else if(m2.eq.3 .or. m2.eq.6) then
	  k=k+1
	  kdest(lspec('JR'))=k
	endif
c
	if(m2.eq.4) then
	  k=k+1
	  kdest(lspec('FL'))=k
	else if(m2.eq.5) then
	  k=k+1
	  kdest(lspec('FN'))=k
	else if(m2.eq.6) then
	  k=k+1
	  kdest(lspec('FR'))=k
	endif
c
c  velocity
c
	if(m3.ge.1) then
	  k=k+1
	  kdest(lspec('VL'))=k
	else if(m3.eq.2) then
	  k=k+1
	  kdest(lspec('VN'))=k
	else if(m3.eq.3) then
	  k=k+1
	  kdest(lspec('VR'))=k
	endif
c
c  intensity
c
	if(m4.eq.1 .or. m4.eq.3 .or. m4.eq.5 .or. m4.eq.7) then
	  k=k+1
	  kdest(lspec('I'))=k
	endif
c
c  force-free alpha
c
	if(m4.eq.2 .or. m4.eq.3 .or. m4.eq.6 .or. m4.eq.7) then
	  k=k+1
	  kdest(lspec('ALPHA'))=k
	endif
c
c  degree of misfit and unsmoothness
c
	if(m4.eq.4 .or. m4.eq.5 .or. m4.eq.6 .or. m4.eq.7) then
	  k=k+1
	  kdest(lspec('1S'))=k
	  k=k+1
	  kdest(lspec('2S'))=k
	  k=k+1
	  kdest(lspec('3S'))=k
	endif
c
	kmax=k
	return
	end
c
c  determine kolist from the value of kindm1
c  'writem' routine writes rdata(*,*,k) to a file if k is in kolist.
c  the actual argument corresponding to kindm1 will be kindmo
c
	subroutine olist(kindm1,kolist,kmax,nspec)
c
	include 'fileio.fc'
	include 'mdata.fc'
	include 'sys.fc'
c
	integer kolist(MZ),kdest(NSPEC0)
	logical unique
c  specst is declared as character*8 in fileio.fc
c
c  subr.ilist gives kdest for a given value of kindm1
c
	unique=.true.
	call ilist(kindm1,kdest,kmax,nspec,unique)
	if(msglvl.gt.2) then
	  write(lst,100) 'olist:kdest(lspec) from ilist=',
     &	               (kdest(lspec1),lspec1=1,nspec)
 100	  format(2x, a,10i3/(2x,30x,10i3))
	endif
c
c  data with k-values listed in kdest should be written to a file
c
	do 20 k=1,MZ
 20	kolist(k)=0
c
	nframo=0
	do 30 lspec1=1,nspec
	if(kdest(lspec1).gt.0) then
	  k=kloc(lspec1) 
	  if(k.gt.0) then
	    nframo=nframo+1
	    kolist(nframo)=k
	  else
	    write(lst,*)
     &    '(subr.olist ) requested data are not in rdata : ',
     &	    specst(lspec1)
	  endif
	endif
 30	continue
c
	do 40 iframe=1,nframe
	  do 50 iframo=1,nframo
	  if( kmem(iframe) .eq. kolist(iframo) ) go to 60
 50	  continue
	  write(lst,*)
     &  '(subr.olist ) data are not written to a file : ',
     &	   specst(lspecs(kmem(iframe)))
 60	  continue
 40	continue
c
	return
	end
c
c  check whether kindm is compatible with kindl
c  if not, a standard value of kindm is returned as kindmo
c
	subroutine mkindm(kindl0,kindm1,kindm2)
c
	integer*4 kindl0,kindl1,kindm1,kindm2
c
	kindl1=mod(kindl0,1000)
	call umake(kindl0, l5,l4,l3,l2,mesh1)
	kindm2=kindm1
	call umake(kindm1, m5,m4,m3,m2,m1)
c
	if( kindl1.eq.0 ) then
c  magnetogram should be planar
	  if( m5.gt.1 ) kindm2=make(0,m4,m3,m2,m1)
c
	elseif( kindl1.eq.1) then
c  magnetogram should be in (Bn,Bh) or should be convertible to such
	  if( .not.(m5.eq.1 .and. m1.ge.3))
     &	    kindm2=make(1,m4,m3,m2,m1)
c
	elseif( kindl1.eq.2 .or. kindl1.eq.102) then
c  magnetogram should be in (Br,Btheta,Bphi) or should be
c  convertible to such
	  if( .not.(m5.eq.2 .and. m1.ge.3))
     &	    kindm2=make(2,m4,m3,m2,m1)
c
	elseif( kindl1.eq.103 ) then
c  magnetogram should be in (Br,Btheta,Bphi) or should be
c  convertible to such
c  data should be in R-coordinates (synoptic maps)
	  if( .not.(m5.eq.3 .and. m1.ge.3))
     &	    kindm2=make(3,m4,m3,m2,m1)
c
	elseif( kindl1.eq.11 ) then
c  magnetgram should be given in data plane
	  if( m5.ne.0 ) kindm2=make(0,m4,m3,m2,m1)
c
	elseif( kindl1.eq.12 .or. kindl1.eq.112 ) then
c  magnetgram should be given in data plane
	  if( m5.ne.0 ) kindm2=make(0,m4,m3,m2,m1)
	endif
c
	return 
	end
c
c  split kindm into digits
c  kindm = 10000*m5 + 1000*m4 + 100*m3 + 10*m2 + m1
c
	subroutine umake(kindm1, m5,m4,m3,m2,m1)
	m1=mod(kindm1,10)
	m2=mod(kindm1/10,10)
	m3=mod(kindm1/100,10)
	m4=mod(kindm1/1000,10)
	m5=mod(kindm1/10000,10)
	return
	end
c
	integer function make(m5,m4,m3,m2,m1)
	make=10000*m5+1000*m4+100*m3+10*m2+m1
	return
	end
c
c  make a list of scalar and vector data that are on memory
c
c  nv=number of vector data
c  nz=number of scalar data
c  kxlist, kylist, kzlist = list of k-values 
c  strx,stry,strz = list of spec-strings
c
	subroutine mklist(nv,nz,
     &	kxlist,kylist,kzlist,
     &	strx,stry,strz)
c
	include 'fileio.fc'
	include 'mdata.fc'
	dimension kxlist(MZ),kylist(MZ),kzlist(MZ)
	character*(*) strx(MZ),stry(MZ),strz(MZ)
c  specst is declared as charactere*8 in fileio.fc
c
	nz=0
	nv=0
	nspec=NSPEC0
c
	do 10 lspecz=1,nspec,3
	kz=kloc(lspecz)
	lspecx=lspecz+1
	lspecy=lspecz+2
	kx=kloc(lspecx)
	ky=kloc(lspecy)
c
	if(kz.gt.0) then
	  nz=nz+1
	  kzlist(nz)=kz
	  strz(nz)=specst(lspecz)
	endif
	if(kx.gt.0.and.ky.gt.0) then
	  nv=nv+1
	  kxlist(nv)=kx
	  kylist(nv)=ky
	  strx(nv)=specst(lspecx)
	  stry(nv)=specst(lspecy)
	endif
 10	continue
	return
	end
