c  plot a sphere of radius rsp1 centered at xxsp1 in C-coodrinates
c  if limb=.true., solar limb is drawn
c  if lonlat=.true., longitude/latitude circles are also drawn
c  clipping limits are given by rectangle spanned by four corner
c  points xx4
c
	subroutine sphere(xxsp1,rsp1,cl0ef1,xx4,dl,
     &	                  lonlat,limb,clip)
c
	logical l1,l2,lonlat,limb,clip,inside
	include 'graph.fc'
	include 'coord.fc'
	include 'fline.fc'
	dimension xp(ML),yp(ML),zp(ML), xx4(3,4), xxsp1(3)
	integer gsave
	equivalence (xp(1),xyzr(1,1))
	equivalence (yp(1),xyzr(1,2))
	equivalence (zp(1),xyzr(1,3))
	data pi/3.141593/
c
	call setar
c  set matrix armat
c
	eps=-1.0e-2
	nc=min(int(2.0*pi*rsp1/dl),ML)
c
c  draw circle of radius rsp1 (solar limb)
c  bypass rotpt
c
	if(.not.limb) go to 1 
	gsave=gmode
	if(gmode.eq.1) gmode=2
c
	l1=.false.
	if(eyed.gt.0.0) then
	  zl=rsp1*rsp1/(eyed+rsp1)
	else
	  zl=0.0
	endif
	rsplim=sqrt(abs(rsp1**2-zl**2))
c
	do 10 i=1,nc
	xp(i)=rsplim*cos(2.0*pi*float(i-1)/float(nc-1))+xxsp1(1)
	yp(i)=rsplim*sin(2.0*pi*float(i-1)/float(nc-1))+xxsp1(2)
	zp(i)=zl +xxsp1(3)
	l2=(.not.clip) .or. inside(xp(i),yp(i),xx4)
	if(l1.and.l2) call pline3(2,xp(i-1),yp(i-1),zp(i-1))
	l1=l2
 10	continue
	gmode=gsave
c
c  plot latitude circles
c
 1	if(.not.lonlat) return
c
	do 2000 i=1,17
	th=10.0/180.0*pi*float(i)
	ux2=rsp1*cos(th)
	np=float(nc)*sin(th)
	if(np.lt.6) np=6
	l1=.false.
	do 2100 j=1,np
	ph=2.0*pi*float(j-1)/float(np-1)
	ux1=rsp1*sin(th)*sin(ph)
	ux3=rsp1*sin(th)*cos(ph)
	xp(j)=armat(1,1)*ux1+armat(1,2)*ux2+armat(1,3)*ux3 +xxsp1(1)
	yp(j)=armat(2,1)*ux1+armat(2,2)*ux2+armat(2,3)*ux3 +xxsp1(2)
	zp(j)=armat(3,1)*ux1+armat(3,2)*ux2+armat(3,3)*ux3 +xxsp1(3)
	l2=(.not.clip).or.inside(xp(j),yp(j), xx4)
	if(l1.and.l2) call pline3(2,xp(j-1),yp(j-1),zp(j-1))
	l1=l2
 2100	continue
 2000	continue
c
c  plot longitude circles
c
	do 3000 i=1,36
	ph=10.0/180.0*pi*float(i-1) -cl0ef1
	dth=1.0
	if(mod(i-1,9).eq.0) dth=0.0
	wth=18.0-2.0*dth
	nt=nc/2
	l1=.false.
	do 3100 j=1,nt
	th=pi*(wth*float(j-1)/float(nt-1)+dth)/18.0
	ux1=rsp1*sin(th)*sin(ph)
	ux2=rsp1*cos(th)
	ux3=rsp1*sin(th)*cos(ph)
	xp(j)=armat(1,1)*ux1+armat(1,2)*ux2+armat(1,3)*ux3 +xxsp1(1)
	yp(j)=armat(2,1)*ux1+armat(2,2)*ux2+armat(2,3)*ux3 +xxsp1(2)
	zp(j)=armat(3,1)*ux1+armat(3,2)*ux2+armat(3,3)*ux3 +xxsp1(3)
	l2=(.not.clip).or.inside(xp(j),yp(j), xx4)
	if(l1.and.l2) call pline3(2,xp(j-1),yp(j-1),zp(j-1))
 	l1=l2
 3100	continue
 3000	continue
c
	return
	end
c
c  determine whether a point (x,y) is inside a rectangle whose four corners
c  are xxc4, as viewed from the z-axis
c
	logical function inside( x,y, xxc4)
c
	dimension xx(3),xxc4(3,4),xcxc(3),xxxc(3)
c
	xx(1)=x
	xx(2)=y
c
	inside=.true.
	do 10 n=1,4
	do 20 i=1,2
	xcxc(i)=xxc4(i,mod(n,4)+1)-xxc4(i,n)
	xxxc(i)=xx(i)-xxc4(i,n)
 20	continue
	area=xcxc(1)*xxxc(2)-xcxc(2)*xxxc(1)
	inside=inside.and.(area.gt.0.0)
 10	continue
	return
	end
c
c  set matrix for rotation and view angle transform
c
	subroutine setmat(rotdeg,zdeg,xdeg)
c
	include 'graph.fc'
	include 'coord.fc'
	include 'sys.fc'
	dimension roty(3,3),arinv(3,3)
c
	rad(deg)=3.141592*deg/180.0
c
	rotang=rad(rotdeg)
	xang=rad(xdeg)
	zang=rad(zdeg)
c
	do 10 i=1,3
	do 10 j=1,3
 10	arinv(i,j)=armat(j,i)
c
	roty(1,1)=cos(rotang)
	roty(1,2)=0.0
	roty(1,3)=sin(rotang)
	roty(2,1)=0.0
	roty(2,2)=1.0
	roty(2,3)=0.0
	roty(3,1)=-sin(rotang)
	roty(3,2)=0.0
	roty(3,3)=cos(rotang)
c
	rotx(1,1)=1.0
	rotx(1,2)=0.0
	rotx(1,3)=0.0
	rotx(2,1)=0.0
	rotx(2,2)=cos(xang)
	rotx(2,3)=-sin(xang)
	rotx(3,1)=0.0
	rotx(3,2)=sin(xang)
	rotx(3,3)=cos(xang)
c
	rotz(1,1)=cos(zang)
	rotz(1,2)=-sin(zang)
	rotz(1,3)=0.0
	rotz(2,1)=sin(zang)
	rotz(2,2)=cos(zang)
	rotz(2,3)=0.0
	rotz(3,1)=0.0
	rotz(3,2)=0.0
	rotz(3,3)=1.0
c
c  rotr = armat*roty*arinv
c
	call mult(rotr, armat, roty)
	call mult(rotr, rotr, arinv)
c
c  rotv = rotx*rotz
	call mult(rotv, rotx,rotz)
c
	return
	end
c
c  a = b*c
c  b or c may occupy the same area as a
c
	subroutine mult( a,b,c )
	dimension a(3,3),b(3,3),c(3,3),d(3,3)
c
	do 10 j=1,3
	do 10 i=1,3
	aux=0.0
	do 20 k=1,3
 20	aux=aux+b(i,k)*c(k,j)
	d(i,j)=aux
 10	continue
	do 30 j=1,3
	do 30 i=1,3
 30	a(i,j)=d(i,j)
c
	return
	end
c
c  rotation around the polar axis and view angle transform
c
	subroutine rotpt(xx,xxr)
	dimension xx(3),xxr(3),xx0(3),xx1(3)
c
	include 'graph.fc'
	include 'coord.fc'
c
c  rotation around the polar axis
c
	xx0(1)=xx(1)-xxsp(1)
	xx0(2)=xx(2)-xxsp(2)
	xx0(3)=xx(3)-xxsp(3)
	xx1(1)=rotr(1,1)*xx0(1)+rotr(1,2)*xx0(2)+rotr(1,3)*xx0(3)
	xx1(2)=rotr(2,1)*xx0(1)+rotr(2,2)*xx0(2)+rotr(2,3)*xx0(3)
	xx1(3)=rotr(3,1)*xx0(1)+rotr(3,2)*xx0(2)+rotr(3,3)*xx0(3)
c
c  view angle transform
c
	xxr(1)=rotv(1,1)*xx1(1)+rotv(1,2)*xx1(2)+rotv(1,3)*xx1(3)
	xxr(2)=rotv(2,1)*xx1(1)+rotv(2,2)*xx1(2)+rotv(2,3)*xx1(3)
	xxr(3)=rotv(3,1)*xx1(1)+rotv(3,2)*xx1(2)+rotv(3,3)*xx1(3)
c
	go to 1
c
c  this entry only applies the rotion around the z-axis
c  (for N,S,E,W markers)
c
	entry rotptv(xx,xxr)
c
	xx1(1)=xx(1)-xxsp(1)
	xx1(2)=xx(2)-xxsp(2)
	xx1(3)=xx(3)-xxsp(3)
	xxr(1)=rotz(1,1)*xx1(1)+rotz(1,2)*xx1(2)+rotz(1,3)*xx1(3)
	xxr(2)=rotz(2,1)*xx1(1)+rotz(2,2)*xx1(2)+rotz(2,3)*xx1(3)
	xxr(3)=rotz(3,1)*xx1(1)+rotz(3,2)*xx1(2)+rotz(3,3)*xx1(3)
c
c  perspective modification
c
 1	continue
	xxr(1)=xxr(1)+xxsp(1)
	xxr(2)=xxr(2)+xxsp(2)
	xxr(3)=xxr(3)+xxsp(3)
	if(eyed.gt.0.0) then
	  xxr(1)=xxr(1)*eyed/(eyed-xxr(3))
	  xxr(2)=xxr(2)*eyed/(eyed-xxr(3))
	endif
c
	return
c
	entry pers(xx,xxr)
c
	xxr(1)=xx(1)
	xxr(2)=xx(2)
	if(eyed.gt.0.0) then
	  xxr(1)=xxr(1)*eyed/(eyed-xxr(3))
	  xxr(2)=xxr(2)*eyed/(eyed-xxr(3))
	endif
	return
c
	end
c
	logical function visibl(xx)
c
	dimension xx(3),xxaux(3)
	include 'coord.fc'
	include 'graph.fc'
c
	eps=0.00001*rsp
	if(nsp.lt.2) then
	  rp=sqrt((xx(1)-xxsp(1))**2+(xx(2)-xxsp(2))**2)
	  z =xx(3)-xxsp(3)-rsp
	  rp0=rp
	  zl=0.0
	  if(eyed.gt.0.0) then
	    rp0=rp*(eyed+rsp)/sqrt(rp**2+(eyed-z)**2)
	    zl=rsp*rsp/(eyed+rsp)
	  endif
	  visibl=rp0.ge.rsp-eps .or. rsp+z.ge.zl-eps
	else
	  visibl=.true.
	  do 10 n=1,nsp
	  call rotpt(xxspm(1,n),xxaux)
	  rp=sqrt((xx(1)-xxaux(1))**2+(xx(2)-xxaux(2))**2)
	  z =xx(3)-xxaux(3)-rspm(n)
	  rp0=rp
	  zl=0.0
	  if(eyed.gt.0.0) then
	    rp0=rp*(eyed+rspm(n))/sqrt(rp**2+(eyed-z)**2)
	    zl=rspm(n)*rspm(n)/(eyed+rspm(n))
	  endif
	  visibl=visibl .and.
     &	(rp0.ge.rspm(n)-eps .or. rspm(n)+z.ge.zl-eps)
 10	  continue
	endif
	return
	end
