c  test programs
c  file handling is not done by subr.assign
c
c  test1=genmag
c  create magnetogram by using subr.field
c  first, invoke proc.load in order to load a magnetogram
c
c  this is now included in evalpt
c
	subroutine genmag
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	integer uout
	dimension xx(3),bb(3)
	character*80 fname1
c
	entry test1
c
	lrec0=80
	uout=94
	write(msg,*)
     &	'(subr.genmag) enter magnetogram file name for output'
	read(keyin,'(a)') fname1
	call openfl(gmgram,'GMGRAM',uout,fname1,export,wrt,lrec0)
	kindmo=kindm
	mesho=mesh
c
	kx=kxloc()
	ky=kyloc()
	kz=kzloc()
	if(kx.eq.0.0 .or. ky.eq.0 .or. kz.eq.0) then
	  write(msg,*) '(subr.genmag) error: kx,ky,kz=',kx,ky,kz
	  errflg=2
	  return
	endif
c
	do 1000 j=1,ny0
	do 1000 i=1,nx0
	xx(1)=xs0+dx0*float(i-1)
	xx(2)=ys0+dy0*float(j-1)
	xx(3)=0.0
	if(mesho.eq.1) then
	  call projt(xx,xt,yt)
	else if(mesho.eq.2) then
	  call projs(xx,ap,al)
	endif
c
	call field(xx,bb,1,1,1)
c
	rdata(i,j,kx)=bb(1)
	rdata(i,j,ky)=bb(2)
	rdata(i,j,kz)=bb(3)
 1000	continue
c
	title='generated by subr.field'
	call writem (uout)
	return
	end
c
c  test2: cross check between subr.field and subr.dipole
c  first, invoke proc.load in order to load a magnetogram
c
	subroutine test2
c
	include 'sys.fc'
	include 'coord.fc'
	include 'mparam.fc'
	include 'lparam.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'auxparam.fc'
c
	integer uin
	dimension xx(3),xx0(3),b(3),bb(3),bp(3),bbp(3),bm(3),bbm(3),
     &	          db(3,3),curlb(3),ajxb(3),dbb(3,3),curlbb(3),ajxbb(3),
     &	          xxs(3),dir(3),bb2(3)
c
	uin=98
	call openfl(other1,'DIPOLE',uin,'dipole.dat',text,rdo,0)
	call readdp(uin,iproj,kindm1,nx1,ny1,xs1,ys1,dx1,dy1,rsp1)
	close (uin)
c
	do 2000 m=1,3
	xxs(m)=xxsaux(m)
 2000	dir(m)=diraux(m)
c
	if(iproj.eq.2) then
	  xxsm(1)=xxs(1)
	  xxsm(2)=xxs(2)
	  xxsm(3)=-2.0*rsp-xxs(3)
	  dirm(1)= dir(1)
	  dirm(2)= dir(2)
	  dirm(3)=-dir(3)
	endif
c
	write(lst,*) 'dipole:'
	write(lst,*) '  location=',xxsaux
	write(lst,*) '  moment=',dmom
	write(lst,*) '  direction=',diraux
	write(lst,*) '  data projection: iproj=',iproj
	istop=0
	eps=1.0e-2
c
 2001	write(msg,*) 
     &	  'cross check with dipole: enter x,y,z,stop(=1 to stop),eps'
	read(keyin,*) xx0,istop,eps
	if(istop.ne.0) return
	h=xx0(3)
c  kindl had been read in progmain
	if(mod(kindl,10).eq.1) then
	  call projt(xx0,xt,yt)
	  xx0(3)=xx0(3)+h
	else if(mod(kindl,10).eq.2) then
	  call projs(xx0,ap,al)
	  xx0(3)=xx0(3)+h
	endif
c
	call dipole(xx0,bb,ppsi,xxs,dir,dmom)
	if(iproj.eq.2) then
	  call dipole(xx0,bb2,ppsi2,xxsm,dirm,dmom)
	  do 2100 m=1,3
 2100	  bb(m)=bb(m)+bb2(m)
	  ppsi=ppsi+ppsi2
	endif
	call field(xx0,b,0,1,0)
	call pot(xx0,psi)
	msg1=msglvl
	msglvl=1
	babs=sqrt(b(1)**2+b(2)**2+b(3)**2)
	bbabs=sqrt(bb(1)**2+bb(2)**2+bb(3)**2)
	errb=sqrt((b(1)-bb(1))**2+(b(2)-bb(2))**2+(b(3)-bb(3))**2)/
     &	  bbabs
	write(msg,200) 'coordinates   :',xx0
	write(msg,200) 'dipole        :',bb,ppsi
	write(msg,200) 'field+pot     :',b,psi
	write(msg,200) 'relative error:', errb
 200	format(1x,a,1p4e15.4)
c
	do 2200 m=1,3
 2200	xx(m)=xx0(m)
c
	do 2300 m=1,3
	xx(m)=xx0(m)+eps
	call dipole(xx,bbp,ppsi,xxs,dir,dmom)
	if(iproj.eq.2) then
	  call dipole(xx,bb2,ppsi2,xxsm,dirm,dmom)
	  do 2310 mm=1,3
 2310	  bbp(mm)=bbp(mm)+bb2(mm)
	endif
	call field(xx,bp,0,1,0)
	xx(m)=xx0(m)-eps
	call dipole(xx,bbm,ppsi,xxs,dir,dmom)
	if(iproj.eq.2) then
	  call dipole(xx,bb2,ppsi2,xxsm,dirm,dmom)
	  do 2220 mm=1,3
 2220	  bbm(mm)=bbm(mm)+bb2(mm)
	endif
	call field(xx,bm,0,1,0)
	do 2400 mm=1,3
	db(mm,m) =(bp (mm)-bm (mm))/(2.0*eps*babs)
	dbb(mm,m)=(bbp(mm)-bbm(mm))/(2.0*eps*bbabs)
 2400	continue
 2300	continue
c  db(mm,m)=d(b(mm))/dx(m)/babs
c
	divb=db(1,1)+db(2,2)+db(3,3)
	curlb(1)=db(2,3)-db(3,2)
	curlb(2)=db(3,1)-db(1,3)
	curlb(3)=db(1,2)-db(2,1)
	divbb=dbb(1,1)+dbb(2,2)+dbb(3,3)
	curlbb(1)=dbb(2,3)-dbb(3,2)
	curlbb(2)=dbb(3,1)-dbb(1,3)
	curlbb(3)=dbb(1,2)-dbb(2,1)
	ajxb(1)=(curlb(2)*b(3)-curlb(3)*b(2))/babs
	ajxb(2)=(curlb(3)*b(1)-curlb(1)*b(3))/babs
	ajxb(3)=(curlb(1)*b(2)-curlb(2)*b(1))/babs
	ajxbb(1)=(curlbb(2)*bb(3)-curlbb(3)*bb(2))/bbabs
	ajxbb(2)=(curlbb(3)*bb(1)-curlbb(1)*bb(3))/bbabs
	ajxbb(3)=(curlbb(1)*bb(2)-curlbb(2)*bb(1))/bbabs
	write(msg,200) '  div (field)/b =',divb
	write(msg,200) '  curl(field)/b =',curlb
	write(msg,200) '  jxb (field)/b**2 =',ajxb
	write(msg,200) '  div (dipole)/b=',divbb
	write(msg,200) '  curl(dipole)/b=',curlbb
	write(msg,200) '  jxb (dipole)/b**2=',ajxbb
c
	msglvl=msg1
	go to 2001
	end
c
c  test3: cross check between subr.field and subr.nlfff
c  first, invoke proc.load in order to load a magnetogram
c
	subroutine test3
c
	include 'sys.fc'
	include 'coord.fc'
	include 'mparam.fc'
	include 'lparam.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'auxparam.fc'
c
	integer uin
	dimension xx(3),xx0(3),b(3),bb(3),bp(3),bbp(3),bm(3),bbm(3),
     &	          db(3,3),curlb(3),ajxb(3),dbb(3,3),curlbb(3),ajxbb(3),
     &	          xxs(3),dir(3)
c
	uin=98
	call openfl(other1,'NLFFF',uin,'nlfff.dat',text,rdo,0)
	call readff(uin,iproj,kindm1,nx1,ny1,xs1,ys1,dx1,dy1,rsp1)
	close (uin)
c
	b0=b0fff
	al=alfff
	order=odrfff
	isym=symfff
	ak=akfff
	dmu=dmufff
	nmu=nmufff
	do 3000 m=1,3
	xxs(m)=xxsaux(m)
	dir(m)=diraux(m)
 3000	continue
c
	write(lst,*) 'nonlinear force-free field:'
	write(lst,*) '  location=',xxsaux
	write(lst,*) '  b0=',b0fff
	write(lst,*) '  ak=',akfff
	write(lst,*) '  order,sym=',odrfff,symfff
	write(lst,*) '  direction=',diraux
	write(lst,*) '  data projection: iproj=',iproj
	istop=0
	eps=1.0e-2
c
 3001	write(msg,*) 
     &	  'cross check with nlfff: enter x,y,z,stop(=1 to stop),eps'
	read(keyin,*) xx0,istop,eps
	if(istop.ne.0) return
	h=xx0(3)
c  kindl had been read in progmain
	if(mod(kindl,10).eq.1) then
	  call projt(xx0,xt,yt)
	  xx0(3)=xx0(3)+h
	else if(mod(kindl,10).eq.2) then
	  call projs(xx0,ap,al)
	  xx0(3)=xx0(3)+h
	endif
c
	call nlfff(xx0,bb,alpha,xxs,dir,b0,al,order,isym,ak,
     &	           dmu,nmu,pval,pdval)
	call field(xx0,b,0,1,1)
	msg1=msglvl
	msglvl=1
	babs=sqrt(b(1)**2+b(2)**2+b(3)**2)
	bbabs=sqrt(bb(1)**2+bb(2)**2+bb(3)**2)
	errb=
     &	  sqrt((b(1)-bb(1))**2+(b(2)-bb(2))**2+(b(3)-bb(3))**2)/
     &	  bbabs
	write(msg,300) 'coordinates   :',xx0
	write(msg,300) 'nlfff         :',bb
	write(msg,300) 'field         :',b
	write(msg,300) 'relative error:', errb
 300	format(1x,a,1p4e15.4)
c
	do 3200 m=1,3
 3200	xx(m)=xx0(m)
c
	do 3300 m=1,3
	xx(m)=xx0(m)+eps
	call nlfff(xx,bbp,alpha,xxs,dir,b0,al,order,isym,ak,
     &	           dmu,nmu,pval,pdval)
	call field(xx,bp,0,1,1)
	xx(m)=xx0(m)-eps
	call nlfff(xx,bbm,alpha,xxs,dir,b0,al,order,isym,ak,
     &	           dmu,nmu,pval,pdval)
	call field(xx,bm,0,1,1)
	do 3400 mm=1,3
	db(mm,m) =(bp (mm)-bm (mm))/(2.0*eps*babs)
	dbb(mm,m)=(bbp(mm)-bbm(mm))/(2.0*eps*bbabs)
 3400	continue
 3300	continue
c  db(mm,m)=d(b(mm))/dx(m)/babs
c
	divb=db(1,1)+db(2,2)+db(3,3)
	curlb(1)=db(2,3)-db(3,2)
	curlb(2)=db(3,1)-db(1,3)
	curlb(3)=db(1,2)-db(2,1)
	divbb=dbb(1,1)+dbb(2,2)+dbb(3,3)
	curlbb(1)=dbb(2,3)-dbb(3,2)
	curlbb(2)=dbb(3,1)-dbb(1,3)
	curlbb(3)=dbb(1,2)-dbb(2,1)
	ajxb(1)=(curlb(2)*b(3)-curlb(3)*b(2))/babs
	ajxb(2)=(curlb(3)*b(1)-curlb(1)*b(3))/babs
	ajxb(3)=(curlb(1)*b(2)-curlb(2)*b(1))/babs
	ajxbb(1)=(curlbb(2)*bb(3)-curlbb(3)*bb(2))/bbabs
	ajxbb(2)=(curlbb(3)*bb(1)-curlbb(1)*bb(3))/bbabs
	ajxbb(3)=(curlbb(1)*bb(2)-curlbb(2)*bb(1))/bbabs
	write(msg,300) '  div (field)/b=',divb
	write(msg,300) '  curl(field)/b=',curlb
	write(msg,300) '  jxb (field)/b**2=',ajxb
	write(msg,300) '  div (nlfff)/b=',divbb
	write(msg,300) '  curl(nlfff)/b=',curlbb
	write(msg,300) '  jxb (nlfff)/b**2=',ajxbb
c
	msglvl=msg1
	go to 3001
	end
c
c  test4=energy
c  first, invoke proc.load in order to load a magnetogram
c
	subroutine test4
	include 'sys.fc'
	call engy
	return
	end
