c
c  check the validity of virial theorem
c
	subroutine vrl1
	include 'sys.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'auxparam.fc'
c
	dimension b(3),bb(3),xx(3),amat(3,3),vn(3),res(3),resp(3)
c
	call umake( kindm, m5, m4, m3, m2, m1 )
	kx=kxloc()
	ky=kyloc()
	kz=kzloc()
	kxp=kxploc()
	kyp=kyploc()
c
	if(mesh.gt.1) then
	  write(msg,*) '(subr.vrl1  ) error: mesh=',mesh
	  errflg=2
	  return
	endif
c
	if(mesh.le.0 .and. m5.ne.0) then
	  write(msg,*) '(subr.vrl1  ) error: kindm=',kindm
	  errflg=2
	  return
	endif
c
	if(mesh.eq.1 .and. m5.ne.1) then
	  write(msg,*) '(subr.vrl1  ) error: kindm=',kindm
	  errflg=2
	  return
	endif
c
	if(kz.eq.0 .or.
     &    (kx.eq.0 .or. ky.eq.0) .and. (kxp.eq.0 .or. kyp.eq.0)) then
	  write(msg,*) '(subr.vrl1  ) error: kx,ky,kz=',kx,ky,kz
	  errflg=2
	  return
	endif
c
	call setdu
	call settu
c  subr.settu sets at-matrix
c
	if(mesh.eq.-1) then
	  do 1000 jj=1,3
	  do 1000 ii=1,3
 1000	  amat(ii,jj)=atmat(ii,jj)
	else
	  do 1100 jj=1,3
	  do 1200 ii=1,3
 1200	  amat(ii,jj)=0.0
 1100	  amat(jj,jj)=1.0
	endif
c
c  amat=unit matrix if mesh=1, 0)
c  amat=atmat if mesh=-1
c
c  aj = Jacobian
	aj=amat(1,1)*amat(2,2)-amat(1,2)*amat(2,1)
	ulen1 = ulen*rsun/rsp
	area=dx*dy*ulen1**2/aj
	vol =dx*dy*ulen1**3/(4.0*3.141592 *aj)
	nx2=2*nx
	ny2=2*ny
	do 1300 m=1,3
 1300 vn(m)=amat(m,3)
c
	bzsump=0.0
	bzsumm=0.0
	do 1400 j=1,ny
	do 1400 i=1,nx
	if(rdata(i,j,kz).gt.0.0) bzsump=bzsump+rdata(i,j,kz)
	if(rdata(i,j,kz).lt.0.0) bzsumm=bzsumm-rdata(i,j,kz)
 1400	continue
	bl00=(bzsump-bzsumm)/float(nx*ny)
c
c  bl00 is the dc component of bz
	bn00=bl00/amat(3,3)
	bnn0=bn00**2*float(nx2*ny2)
	bx00=amat(1,3)*bn00
	by00=amat(2,3)*bn00
c  bx00 and by00 have been added to bxp and byp in subr.vector
c  (via subr.cff1)
c
	if(calpha.ne.0.0) then
	  bx00=0.0
	  by00=0.0
	  bl00=0.0
	endif
c  in the case of force-free field, DC component is not allowed
c
c  potential field or linear force-free field
c
	trpp=0.0
	engyp =0.0
	engypp=0.0
	do 2100 m=1,3
 2100	resp(m)=0.0
c
	if(kxp.eq.0 .or. kyp.eq.0) go to 2900
c
	xs1=-dx*0.5*float(nx-1)
	ys1=-dy*0.5*float(ny-1)
c
c  bb = B-field in C-coordinates
c  b  = B-field possibly in T-coordinates
c
	do 2200 j=1,ny
	do 2200 i=1,nx
c
	bb(1)=rdata(i,j,kxp)
	bb(2)=rdata(i,j,kyp)
	bb(3)=rdata(i,j,kz)
c  b=ainv*bb=bb* transpose of amat 
	b(1)=bb(1)*amat(1,1)+bb(2)*amat(2,1)+bb(3)*amat(3,1)
	b(2)=bb(1)*amat(1,2)+bb(2)*amat(2,2)+bb(3)*amat(3,2)
	b(3)=bb(1)*amat(1,3)+bb(2)*amat(2,3)+bb(3)*amat(3,3)
c
	if(mesh.eq.-1) then
	  xx(1)=xs+dx*float(i-1)
	  xx(2)=ys+dy*float(j-1)
	  call projt(xx,xt,yt)
c  projt does not alter xx
	  xx(1)=xx(1)-xxto(1)
	  xx(2)=xx(2)-xxto(2)
	  xx(3)=xx(3)-xxto(3)
	else if(mesh.eq.0) then
	  xx(1)=xs1+dx*float(i-1)
	  xx(2)=ys1+dy*float(j-1)
	  xx(3)=0.0
	  xt=xx(1)
	  yt=xx(2)
	else if(mesh.eq.1) then
	  xx(1)=xs+dx*float(i-1)
	  xx(2)=ys+dy*float(j-1)
	  xx(3)=0.0
	  xt=xx(1)
	  yt=xx(2)
	endif
c
c  b=ainv*bb=bb* transpose of amat 
c  xxt=ainv*xx
c
	engypp=engypp+b(3)*(xx(1)*(bb(1)-bx00)
     &	             +xx(2)*(bb(2)-by00)
     &	             +xx(3)*(bb(3)-bl00))
	engyp =engyp +b(3)*(xt*b(1)+yt*b(2))
	bb2=(bb(1)-bx00)**2+(bb(2)-by00)**2+(bb(3)-bl00)**2
	trpp=trpp+0.5*bb2
	resp(1)=resp(1)+0.5*bb2*vn(1)-b(3)*(bb(1)-bx00)
	resp(2)=resp(2)+0.5*bb2*vn(2)-b(3)*(bb(2)-by00)
	resp(3)=resp(3)+0.5*bb2*vn(3)-b(3)*(bb(3)-bl00)
 2200	continue
c
	engyp =engyp *vol
	engypp=engypp*vol
	resp(1)=resp(1)/trpp
	resp(2)=resp(2)/trpp
	resp(3)=resp(3)/trpp
	reshxp=resp(1)*amat(1,1)+resp(2)*amat(2,1)+resp(3)*amat(3,1)
	reshyp=resp(1)*amat(1,2)+resp(2)*amat(2,2)+resp(3)*amat(3,2)
	resnp =resp(1)*amat(1,3)+resp(2)*amat(2,3)+resp(3)*amat(3,3)
	reshp =sqrt(reshxp**2+reshyp**2)
c
	if(msglvl.gt.0) then
	  if(calpha.eq.0.0) then
	    write(lst,*) '(subr.vrl1  ) potential field, flat boundary:'
	  else
	    write(lst,*)
     &	 '(subr.vrl1  ) linear force-free field, flat boundary:'
	  endif
	  write(lst,*) '  resx,y,z          =',resp
	  write(lst,*) '  energy (blp,btp)  =',engypp,' erg'
	  if(msglvl.gt.1) then
	    write(lst,*) '  resn              =',resnp 
	    write(lst,*) '  resh              =',reshp
	    write(lst,*) '  energy (bnp,bhp)  =',engyp ,' erg'
	  endif
	endif
c
 2900	continue
c
c  calculation of energy by virial theorem
c
	trbb=0.0
	engyb= 0.0
	engybb=0.0
	do 3000 m=1,3
 3000	res(m)=0.0
c
	do 3100 j=1,ny
	do 3100 i=1,nx
	bt=sqrt(rdata(i,j,kx)**2+rdata(i,j,ky)**2)
	if(bt.lt.btlim .and.kxp.gt.0 .and. kyp.gt.0) then
	  bb(1)=rdata(i,j,kxp)
	  bb(2)=rdata(i,j,kyp)
	else
	  bb(1)=rdata(i,j,kx)
	  bb(2)=rdata(i,j,ky)
	endif
c  bt<btlim are replaced with btp, if available, for virial calculation
	bb(3)=rdata(i,j,kz)
	b(1)=bb(1)*amat(1,1)+bb(2)*amat(2,1)+bb(3)*amat(3,1)
	b(2)=bb(1)*amat(1,2)+bb(2)*amat(2,2)+bb(3)*amat(3,2)
	b(3)=bb(1)*amat(1,3)+bb(2)*amat(2,3)+bb(3)*amat(3,3)
c
      if(mesh.eq.-1) then
        xx(1)=xs+dx*float(i-1)
        xx(2)=ys+dy*float(j-1)
        call projt(xx,xt,yt)
	  xx(1)=xx(1)-xxto(1)
	  xx(2)=xx(2)-xxto(2)
	  xx(3)=xx(3)-xxto(3)
      else if(mesh.eq.0) then
        xx(1)=xs1+dx*float(i-1)
        xx(2)=ys1+dy*float(j-1)
	  xx(3)=0.0
        xt=xx(1)
        yt=xx(2)
      else if(mesh.eq.1) then
        xx(1)=xs+dx*float(i-1)
        xx(2)=ys+dy*float(j-1)
	  xx(3)=0.0
        xt=xx(1)
        yt=xx(2)
      endif
c
	engybb=engybb+b(3)*(xx(1)*(bb(1)-bx00)
     &	             +xx(2)*(bb(2)-by00)
     &	             +xx(3)*(bb(3)-bl00))
	engyb =engyb +b(3)*(xt*b(1)+yt*b(2))
	bb2=(bb(1)-bx00)**2+(bb(2)-by00)**2+(bb(3)-bl00)**2
	trbb=trbb+0.5*bb2
	res(1)=res(1)+0.5*bb2*vn(1)-b(3)*(bb(1)-bx00)
	res(2)=res(2)+0.5*bb2*vn(2)-b(3)*(bb(2)-by00)
	res(3)=res(3)+0.5*bb2*vn(3)-b(3)*(bb(3)-bl00)
 3100	continue
c
      engyb =engyb *vol
      engybb=engybb*vol
      res(1)=res(1)/trbb
      res(2)=res(2)/trbb
      res(3)=res(3)/trbb
      reshx=res(1)*amat(1,1)+res(2)*amat(2,1)+res(3)*amat(3,1)
      reshy=res(1)*amat(1,2)+res(2)*amat(2,2)+res(3)*amat(3,2)
      resn =res(1)*amat(1,3)+res(2)*amat(2,3)+res(3)*amat(3,3)
      resh =sqrt(reshx**2+reshy**2)
c
	if(engyp.ne.0.0.and.engypp.ne.0.0) then
	  engyr =(engyb -engyp )/engyp
	  engyrr=(engybb-engypp)/engypp
	endif
c
	if(msglvl.gt.0) then
	  write(lst,*)
     &	'(subr.vrl1  ) based on observed data, flat boundary:'
	  write(lst,*) '  average bz         =',bn00,' gauss'
	  write(lst,*) '  cut-off level of bt=',btlim,' gauss'
        write(lst,*) '  resx,y,z           =',res
        write(lst,*) '  energy (bl,bt)     =',engybb,' erg'
	  if(engypp.ne.0.0) write(lst,*) '  (w-w0)/w0          =',engyrr
	  if(msglvl.gt.1) then
          write(lst,*) '  resn               =',resn
          write(lst,*) '  resh               =',resh
          write(lst,*) '  energy (bn,bh)     =',engyb ,' erg'
	    if(engyp.ne.0.0) write(lst,*) '  (w-w0)/w0          =',engyr
	  endif
	endif
c
	if(msglvl.gt.2) then
	  write(lst,*) 'kx,ky,kz=',kx,ky,kz
	  write(lst,*) 'amat=',amat
	  write(lst,*) 'vol,area,bn00=',vol,area,bn00
	  write(lst,*) 'dx,dy,ulen=',dx,dy,ulen
	endif
	return
	end
c
c  check the validity of virial theorem: spherical geometry
c
	subroutine vrl2
	include 'sys.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'auxparam.fc'
c
	dimension b(3),bb(3),bb0(3),xx(3),xx1(3),vn(3),res(3)
c
      call umake( kindm, m5, m4, m3, m2, m1 )
	kx=kxloc()
	ky=kyloc()
	kz=kzloc()
	kxp=kxploc()
	kyp=kyploc()
c
	if(iabs(mesh).lt.2) then
	  write(msg,*) '(subr.vrl2  ) error: mesh=',mesh
	  errflg=2
	  return
	endif
c
	if(mesh.le.0 .and. m5.ne.0) then
	  write(msg,*) '(subr.vrl2  ) error: kindm=',kindm
	  errflg=2
	  return
	endif
c
	if(mesh.ge.2 .and. m5.ne.mesh) then
	  write(msg,*) '(subr.vrl2  ) error: kindm=',kindm
	  errflg=2
	  return
	endif
c
      if(kz.eq.0 .or. kx.eq.0 .or. ky.eq.0) then
        write(msg,*) '(subr.vrl2  ) error: kx,ky,kz=',kx,ky,kz
        errflg=2
        return
      endif
c
      call setdu
      if(iabs(mesh).eq.2) call setas
      if(iabs(mesh).ge.3) call setar
c  cartesian to spherical conversion
	m5=0
	m5new=2
c
	ulen1 = ulen*rsun/rsp
	area=dx*dy*ulen1**2
	vol =dx*dy*ulen1**3/(4.0*3.141592)
c
c  calculate dc component
c
	brsump=0.0
	brsumm=0.0
	do 1400 j=1,ny
	do 1400 i=1,nx
cx      xx(1)=xs+dx*float(i-1)
cx      xx(2)=ys+dy*float(j-1)
cx      call projs(xx,ap,al)
	b(1)=rdata(i,j,kx)
	b(2)=rdata(i,j,ky)
	b(3)=rdata(i,j,kz)
	call gridpt(i,j,xx,xs,ys,dx,dy,mesh)
	call ctovec(b,bb,m5,xx)
	call vectoc(bb,b,m5new,xx)
c  b=(br,bth,bf)
	call projs(xx,ap,al)
	aj=cos(al)*cos(ap)
	if(b(3).gt.0.0) brsump=brsump+b(3)/aj
	if(b(3).lt.0.0) brsumm=brsumm-b(3)/aj
 1400 continue
	bn00=(brsump-brsumm)/float(nx*ny)
c
c  calculation of energy by virial theorem
c
	trbb=0.0
	engybb=0.0
	do 3000 m=1,3
 3000	res(m)=0.0
c
	do 3100 j=1,ny
	do 3100 i=1,nx
	bb(3)=rdata(i,j,kz)
	bt=sqrt(rdata(i,j,kx)**2+rdata(i,j,ky)**2)
	if(bt.lt.btlim .and.kxp.gt.0 .and. kyp.gt.0) then
	  bb(1)=rdata(i,j,kxp)
	  bb(2)=rdata(i,j,kyp)
	else
	  bb(1)=rdata(i,j,kx)
	  bb(2)=rdata(i,j,ky)
	endif
c  bt<btlim are replaced with btp, if available, for virial calculation
c  this process is incorrect now, because bp were calculated
c  for cartesian geometry
c
cx      xx(1)=xs+dx*float(i-1)
cx      xx(2)=ys+dy*float(j-1)
cx      call projs(xx,ap,al)
	call gridpt(i,j,xx,xs,ys,dx,dy,mesh)
	call ctovec(b,bb,m5,xx)
	call vectoc(bb,b,m5new,xx)
c  b=(br,bth,bf)
	vn(1)=(xx(1)-xxsp(1))/rsp
	vn(2)=(xx(2)-xxsp(2))/rsp
	vn(3)=(xx(3)-xxsp(3))/rsp
c  vn is the radial vector
	bb0(1)=bn00*vn(1)
	bb0(2)=bn00*vn(2)
	bb0(3)=bn00*vn(3)
c  bb0 is the dc radial component
	call projs(xx,ap,al)
	aj=cos(al)*cos(ap)
	xx1(1)=xx(1)-xxto(1)
	xx1(2)=xx(2)-xxto(2)
	xx1(3)=xx(3)-xxto(3)
c
	bb2=(bb(1)-bb0(1))**2+(bb(2)-bb0(2))**2+(bb(3)-bb0(3))**2
	engybb=engybb+(
     &	b(3)*(xx1(1)*(bb(1)-bb0(1))
     &	     +xx1(2)*(bb(2)-bb0(2))
     &	     +xx1(3)*(bb(3)-bb0(3)))
     &	-0.5*bb2*(xx1(1)*vn(1)
     &	         +xx1(2)*vn(2)
     &	         +xx1(3)*vn(3))
     &	)/aj
	trbb=trbb+0.5*bb2/aj
c
	res(1)=res(1)+(0.5*bb2*vn(1)-b(3)*(bb(1)-bb0(1)))/aj
	res(2)=res(2)+(0.5*bb2*vn(2)-b(3)*(bb(2)-bb0(2)))/aj
	res(3)=res(3)+(0.5*bb2*vn(3)-b(3)*(bb(3)-bb0(3)))/aj
 3100	continue
c
      engybb=engybb*vol
      res(1)=res(1)/trbb
      res(2)=res(2)/trbb
      res(3)=res(3)/trbb
c
	if(msglvl.gt.0) then
	  write(lst,*)
     &	'(subr.vrl2  ) based on observed data, spherical boundary:'
	  write(lst,*) '  average br         =',bn00,' gauss'
	  write(lst,*) '  cut-off level of bt=',btlim,' gauss'
        write(lst,*) '  resx,y,z           =',res
        write(lst,*) '  energy             =',engybb,' erg'
	endif
c
	if(msglvl.gt.2) then
	  write(lst,*) 'kx,ky,kz=',kx,ky,kz
	  write(lst,*) 'vol,area,bn00=',vol,area,bn00
	  write(lst,*) 'dx,dy,ulen=',dx,dy,ulen
	endif
	return
	end
