# magpack2 makefile for sony news (MIPS cpu)
#
.EXTENSIONS: .f
# name of compilers
FC	=	wfl386
CC	=	cc
.f.obj:
	$(FC) /c /d2 $[@
	wlib alib -+ $^*

FFLAGS=
CFLAGS=
LOPT	=	/d2 /L=dos4g

IO	=	watio
MISC	=	watmisc
OBSTOP	=	oaotop
OBSTOB	=	mtktob
POLTOB	=	poltob

# PLOTDIR	=	..\plotlib
# LBPDIR	=	..\lbplib
# DISPDIR	=	..\displib
CNTLDIR	=	..\cntl
STYDIR	=	..\sty

# PRINTER	=	lips2
# PRINTER	=	lnop

# PLOTDEV	=	4013
# PLOTDEV	=	4014
# PLOTDEV	=	pnop
# PLOTLIB1	=	$(PLOTDIR)/plot-lbp.obj &
#			$(PLOTDIR)/$(PLOTDEV)lib.obj &
#			$(LBPDIR)/$(PRINTER)lib.obj
# PLOTLIB2	=	-l4013

# DISPDEV	=	x11
# DISPDEV	=	news
# DISPDEV	=	dnop
# DISPLIB1	=	$(DISPDIR)/disp-lbp.o \
#			$(DISPDIR)/kbhit.o \
#			$(DISPDIR)/$(DISPDEV)lib.o \
#			$(LBPDIR)/$(PRINTER)lib.o
# DISPLIB2	=	-lX11
# DISPLIB2	=	-lcginews

# output of plot to x-window for debug
# PLOTDEV	=	x11
# PLOTLIB1	=	$(PLOTDIR)/displib.o \
# 			$(DISPLIB1)
# PLOTLIB2	=	$(DISPLIB2)

BIN	=	prog.exe
#		plot.exe &
#		disp.exe

FFF	=	fff.exe

UTIL	=	dumpm.exe &
		dumpl.exe &
		sunparam.exe &
		dipole.exe &
		delta.exe &
		nonfff.exe &
		nlfff.exe &
		gendata.exe &
		sample1.exe &
		sample2.exe &
		sample3.exe &
            cardate.exe &
            wsoprep.exe &
            mergem.exe

STARS	=	binary.exe 
#		dispbin.exe


bin :	$(BIN) .SYMBOLIC

util :	$(UTIL) .SYMBOLIC

stars :	$(STARS) .SYMBOLIC

all :	$(BIN) $(UTIL) $(FFF) .SYMBOLIC

alib.lib : initc.obj assign.obj load.obj conv.obj diagnose.obj spec.obj &
       readm.obj writem.obj readl.obj writel.obj poltob.obj &
       $(IO).obj $(MISC).obj transc.obj transm.obj rotm.obj fits.obj &
       $(OBSTOP).obj &
       $(OBSTOB).obj &
       energy.obj &
       vector.obj virial.obj cff.obj lff.obj curlb.obj &
       sets12.obj reads1.obj fpt.obj field.obj auxfield.obj pot.obj integ.obj &
       test.obj eval.obj suncal.obj &
       mathsub.obj mnnl.obj graphsub.obj version.obj

FOBJS	= fffini.obj select.obj jxb.obj fffio.obj fffitr.obj spllof.obj

# $(PLOTDIR)\displib.obj :
#	(cd $(PLOTDIR);&
#	wmake displib.obj)

# $(PLOTDIR)\plot-lbp.obj :
#	(cd $(PLOTDIR);&
#	wmake plot-lbp.obj)

# $(PLOTDIR)\$(PLOTDEV)lib.obj :
#	(cd $(PLOTDIR);&
#	wmake $(PLOTDEV)lib.obj)

oaobook : oaobook.exe .SYMBOLIC

oaobook.exe :	oaobook.f &
		sys.fc fileio.fc string.fc coord.fc lparam.fc mparam.fc mdata.fc &
		fcntl.fc procs.fc auxparam.fc sysconf.cfg solar.fc graph.fc &
		cntr.obj $(PLOTDIR)\displib.obj $(DISPLIB1) alib.lib
	$(FC) $(LOPT) /fe oaobook oaobook.f cntr.obj $(PLOTDIR)\displib.obj &
		$(DISPLIB1) alib.lib $(DISPLIB2)

mtkbook : mtkbook.exe .SYMBOLIC

mtkbook.exe :	mtkbook.f &
		sys.fc fileio.fc string.fc coord.fc lparam.fc mparam.fc mdata.fc &
		fcntl.fc procs.fc auxparam.fc sysconf.cfg solar.fc graph.fc &
		cntr.obj $(PLOTDIR)\displib.obj $(DISPLIB1) alib.lib
	$(FC) $(LOPT) /fe=mtkbook mtkbook.f cntr.obj $(PLOTDIR)\displib.obj &
		$(DISPLIB1) alib.lib $(DISPLIB2)

# $(DISPDIR)\disp-lbp.obj :
#	(cd $(DISPDIR);&
#	wmake disp-lbp.obj)

# $(DISPDIR)\kbhit.obj :
#	(cd $(DISPDIR);&
#	wmake kbhit.obj)

# $(DISPDIR)\$(DISPDEV)lib.obj :	$(DISPDIR)\crt.h
#	(cd $(DISPDIR);&
#	wmake $(DISPDEV)lib.obj)

# $(LBPDIR)\$(PRINTER)lib.obj :	$(LBPDIR)\lbpnop.c
#	(cd $(LBPDIR); &
#	$(CC) -c $(PRINTER)lib.c)

prog : 	prog.exe .SYMBOLIC

prog.exe :	progmain.f &
		sys.fc fileio.fc string.fc coord.fc lparam.fc mparam.fc &
		mdata.fc fcntl.fc procs.fc auxparam.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=prog progmain.f alib.lib

fff : fff.exe .SYMBOLIC

fff.exe :	fffmain.f $(FOBJS) &
		sys.fc fileio.fc string.fc coord.fc lparam.fc mparam.fc &
		mdata.fc fcntl.fc procs.fc auxparam.fc ff0.fc fff.fc &
		sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=fff fffmain.f $(FOBJS) alib.lib

binary : binary.exe .SYMBOLIC

binary.exe :		binmain.f &
		sys.fc fileio.fc string.fc coord.fc	lparam.fc mparam.fc &
		mdata.fc fcntl.fc procs.fc auxparam.fc &
		sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=binary binmain.f alib.lib

# dispbin : dispbin.exe .SYMBOLIC
#
# dispbin.exe :	dispbin.f &
#		sys.fc fileio.fc string.fc coord.fc lparam.fc mparam.fc &
#		mdata.fc fcntl.fc procs.fc sysconf.cfg &
#		dispmb.obj sphere.obj $(DISPLIB1) alib.lib
#	$(FC) $(LOPT) /fe=dispbin dispbin.f dispmb.obj sphere.obj &
#	$(DISPLIB1) alib.lib $(DISPLIB2)

# plot : plot.exe .SYMBOLIC
#
# plot.exe :	plotmain.f &
#		sys.fc fileio.fc string.fc coord.fc lparam.fc mparam.fc &
#		mdata.fc fcntl.fc procs.fc sysconf.cfg &
#		plotm.obj plotr.obj cntr2.obj sphere.obj &
#		$(PLOTLIB1) alib.lib
#	$(FC) $(LOPT) /fe=plot &
#		plotmain.f plotm.obj plotr.obj cntr2.obj sphere.obj &
#		$(PLOTLIB1) alib.lib $(PLOTLIB2)

# disp : disp.exe .SYMBOLIC
#
# disp.exe :	dispmain.f &
#		sys.fc fileio.fc string.fc coord.fc lparam.fc mparam.fc &
#		mdata.fc fcntl.fc procs.fc sysconf.cfg &
#		dispm.obj dispr.obj cntr2.obj sphere.obj &
#		$(DISPLIB1) alib.lib
#	$(FC) $(LOPT) /fe=disp &
#		dispmain.f dispm.obj dispr.obj cntr2.obj sphere.obj &
#		$(DISPLIB1) alib.lib $(DISPLIB2)

dipole : dipole.exe .SYMBOLIC

dipole.exe :	gendpl.f &
		sys.fc mdata.fc mparam.fc coord.fc solar.fc fileio.fc fcntl.fc &
		string.fc auxparam.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=dipole gendpl.f alib.lib

delta : delta.exe .SYMBOLIC

delta.exe :	gendlt.f &
		sys.fc mdata.fc mparam.fc coord.fc solar.fc fileio.fc &
		fcntl.fc string.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=delta gendlt.f alib.lib

nonfff : noffff.exe .SYMBOLIC

nonfff.exe :	gennff.f &
		sys.fc mdata.fc mparam.fc coord.fc solar.fc fileio.fc fcntl.fc &
		string.fc auxparam.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=nonfff gennff.f alib.lib

nlfff : nlff.exe .SYMBOLIC

nlfff.exe :	genfff.f &
		sys.fc mdata.fc mparam.fc coord.fc solar.fc fileio.fc &
		fcntl.fc string.fc auxparam.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=nlfff genfff.f alib.lib

dumpm : dumpm.exe .SYMBOLIC

dumpm.exe :	dumpm.f &
		sys.fc mdata.fc mparam.fc coord.fc solar.fc fileio.fc &
		fcntl.fc string.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=dumpm dumpm.f alib.lib

dumpl : dumpl.exe .SYMBOLIC

dumpl.exe :	dumpl.f &
		sys.fc coord.fc fileio.fc fcntl.fc string.fc fline.fc &
		lparam.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=dumpl dumpl.f alib.lib

sunparam : sunparam.exe .SYMBOLIC

sunparam.exe :	sunparam.f &
		sys.fc alib.lib
	$(FC) $(LOPT) /fe=sunparam sunparam.f alib.lib

cardate : cardate.exe .SYMBOLIC

cardate.exe : cardate.f &
		sys.fc alib.lib
	$(FC) $(LOPT) /fe=cardate cardate.f alib.lib

gendata : gendata.exe .SYMBOLIC

gendata.exe :    gendata.f &
		sys.fc alib.lib
	$(FC) $(LOPT) /fe=gendata gendata.f alib.lib

sample1 : sample1.exe .SYMBOLIC

sample1.exe :    sample1.f &
		sys.fc mdata.fc mparam.fc coord.fc solar.fc fileio.fc fcntl.fc &
		string.fc auxparam.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=sample1 sample1.f alib.lib

sample2 : sample2.exe .SYMBOLIC

sample2.exe :    sample2.f &
		sys.fc mdata.fc mparam.fc coord.fc solar.fc fileio.fc fcntl.fc &
		string.fc sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=sample2 sample2.f alib.lib

sample3 : sample3.exe .SYMBOLIC

sample3.exe :    sample3.f &
		sys.fc coord.fc fileio.fc fcntl.fc string.fc fline.fc lparam.fc &
		sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=sample3 sample3.f alib.lib

wsoprep : wsoprep.exe .SYMBOLIC

wsoprep.exe : wsoprep.f &
		sys.fc coord.fc fileio.fc fcntl.fc string.fc fline.fc lparam.fc &
		sysconf.cfg alib.lib
	$(FC) $(LOPT) /fe=wsoprep wsoprep.f alib.lib

mergem : mergem.exe .SYMBOLIC

mergem.exe : mergem.f &
	sys.fc coord.fc fileio.fc fcntl.fc mparam.fc mdata.fc solar.fc string.fc &
	sysconf.cfg alib.lib
      ${FC} $(LOPT) /fe=mergem mergem.f alib.lib

sysconf.cfg :	sysconf.exe
	sysconf

init :	sysconf.exe .SYMBOLIC
	del sysconf.cfg
	sysconf

sysconf : sysconf.exe .SYMBOLIC

sysconf.exe :	sysconf.f &
		sys.fc diagnose.obj conv.obj $(MISC).obj
	$(FC) $(LOPT) /fe=sysconf sysconf.f diagnose.obj conv.obj $(MISC).obj

# update:;	makeupdt

# depend:
#	mkmf 


###
assign.obj : assign.f fcntl.fc procs.fc sys.fc fileio.fc auxparam.fc mdata.fc
auxfield.obj : auxfield.f sys.fc coord.fc auxparam.fc
cardate.o: cardate.f sys.fc
cff.obj : cff.f sys.fc coord.fc lparam.fc mparam.fc mdata.fc fileio.fc
cntr.obj : cntr.f sys.fc fline.fc
cntr2.obj : cntr2.f sys.fc fline.fc
conv.obj : conv.f sys.fc
curlb.obj : curlb.f sys.fc coord.fc solar.fc mdata.fc mparam.fc fileio.fc auxparam.fc
diagnose.obj : diagnose.f sys.fc
dispm.obj : dispm.f sys.fc ss.fc mdata.fc coord.fc solar.fc mparam.fc string.fc &
	fileio.fc fline.fc graph.fc
dispmb.obj : dispm.f sys.fc ss.fc mdata.fc coord.fc solar.fc mparam.fc string.fc &
	fileio.fc fline.fc graph.fc
dispr.obj : dispr.f graph.fc coord.fc fline.fc mdata.fc
energy.obj : energy.f sys.fc solar.fc coord.fc ss.fc s1.fc s2.fc s3.fc ff0.fc
eval.obj : eval.f sys.fc ss.fc coord.fc lparam.fc mparam.fc mdata.fc fline.fc &
	fileio.fc string.fc
fffini.obj : fffini.f sys.fc mparam.fc lparam.fc auxparam.fc coord.fc fline.fc ss.fc &
	s3.fc ff0.fc fff.fc
fffio.obj : fffio.f sys.fc ff0.fc fff.fc coord.fc ss.fc s1.fc s2.fc s3.fc lparam.fc &
	mparam.fc auxparam.fc solar.fc string.fc
fffitr.obj : fffitr.f sys.fc auxparam.fc ff0.fc fff.fc mdata.fc
field.obj : field.f sys.fc lparam.fc mparam.fc ss.fc s1.fc s2.fc s3.fc ff0.fc coord.fc &
	auxparam.fc
fits.obj : fits.f sys.fc coord.fc solar.fc fileio.fc mparam.fc string.fc mdata.fc
fpt.obj : fpt.f sys.fc coord.fc fline.fc mdata.fc ss.fc s1.fc s2.fc mparam.fc &
	lparam.fc fileio.fc
graphsub.obj : graphsub.f sys.fc
ibmio.obj : ibmio.f sys.fc fileio.fc fcntl.fc
ibmmisc.obj : ibmmisc.f convi.fi sys.fc
initc.obj : initc.f fcntl.fc fileio.fc procs.fc mdata.fc sys.fc coord.fc ff0.fc &
	lparam.fc mparam.fc ss.fc solar.fc string.fc auxparam.fc graph.fc
integ.obj : integ.f sys.fc fline.fc coord.fc lparam.fc mparam.fc ss.fc s1.fc s2.fc
jxb.obj : jxb.f sys.fc coord.fc mparam.fc ff0.fc fff.fc ss.fc s3.fc lparam.fc
cff.obj : cff.f sys.fc coord.fc lparam.fc mparam.fc mdata.fc fileio.fc
load.obj : load.f sys.fc coord.fc fileio.fc mparam.fc lparam.fc mdata.fc fcntl.fc
mergem.obj: mergem.f sys.fc coord.fc fileio.fc fcntl.fc mparam.fc mdata.fc &
	solar.fc string.fc
mipsio.obj : mipsio.f sys.fc fileio.fc fcntl.fc
mnnl.obj : mnnl.f sys.fc ff0.fc fff.fc
mtktob.obj : mtktob.f sys.fc coord.fc fileio.fc fcntl.fc string.fc mdata.fc mparam.fc &
	lparam.fc auxparam.fc solar.fc
oaotop.obj : oaotop.f sys.fc coord.fc fileio.fc fcntl.fc string.fc mdata.fc mparam.fc &
	lparam.fc auxparam.fc solar.fc oaolib.fi
plotm.obj : plotm.f sys.fc mdata.fc coord.fc solar.fc mparam.fc string.fc fileio.fc &
	fline.fc graph.fc
plotr.obj : plotr.f graph.fc coord.fc fline.fc mdata.fc
poltob.obj : poltob.f sys.fc string.fc mdata.fc fileio.fc mparam.fc auxparam.fc
pot.obj : pot.f sys.fc coord.fc ss.fc s1.fc s2.fc s3.fc lparam.fc auxparam.fc ff0.fc &
	fff.fc
readl.obj : readl.f sys.fc coord.fc fileio.fc string.fc fline.fc lparam.fc mparam.fc &
	ss.fc
readm.obj : readm.f sys.fc fileio.fc mdata.fc mparam.fc lparam.fc string.fc solar.fc &
	coord.fc auxparam.fc
reads1.obj : reads1.f sys.fc coord.fc solar.fc lparam.fc mparam.fc auxparam.fc ss.fc &
	s1.fc
rotm.obj : rotm.f sys.fc fileio.fc coord.fc lparam.fc auxparam.fc mparam.fc mdata.fc
select.obj : select.f sys.fc coord.fc mparam.fc lparam.fc fline.fc ff0.fc fff.fc &
	mdata.fc fileio.fc auxparam.fc
sets12.obj : sets12.f sys.fc coord.fc solar.fc lparam.fc mparam.fc auxparam.fc &
	fileio.fc mdata.fc ss.fc s1.fc s2.fc
spec.obj : spec.f mdata.fc fileio.fc sys.fc
sphere.obj : sphere.f graph.fc coord.fc fline.fc sys.fc
spllof.obj : spllof.f sys.fc fline.fc lparam.fc ff0.fc fff.fc s3.fc
suncal.obj : suncal.f sys.fc
test.obj : test.f sys.fc mdata.fc mparam.fc coord.fc fileio.fc fcntl.fc string.fc &
	lparam.fc auxparam.fc
transc.obj : transc.f coord.fc sys.fc lparam.fc
transm.obj : transm.f sys.fc fileio.fc coord.fc lparam.fc mparam.fc mdata.fc &
	auxparam.fc
unixio.obj : unixio.f sys.fc fileio.fc fcntl.fc
unixmisc.obj : unixmisc.f convu.fi sys.fc
vaxio.obj : vaxio.f sys.fc fileio.fc fcntl.fc
vaxmisc.obj : vaxmisc.f convv.fi sys.fc
vector.obj : vector.f sys.fc coord.fc mdata.fc mparam.fc fileio.fc auxparam.fc
version.obj : version.f sys.fc update.fi
virial.obj : virial.f sys.fc coord.fc solar.fc mdata.fc mparam.fc auxparam.fc
vppio.obj : vppio.f sys.fc fileio.fc fcntl.fc
vppmisc.obj : vppmisc.f convi.fi sys.fc
wsoprep.obj: wsoprep.f sys.fc coord.fc fileio.fc fcntl.fc string.fc &
	fline.fc lparam.fc
writel.obj : writel.f sys.fc string.fc fileio.fc mparam.fc lparam.fc fline.fc ff0.fc &
	ss.fc
writem.obj : writem.f sys.fc mparam.fc fileio.fc mdata.fc string.fc solar.fc coord.fc
