c  write magnetogram data onto a file
c  form of output file is specified by 'kindmo'
c  kindmo=0 means that kindmo=kindm and all the data will be written
c
	subroutine writem(ounit)
c
	include 'sys.fc'
	include 'mparam.fc'
	include 'fileio.fc'
	include 'mdata.fc'
	include 'string.fc'
	include 'solar.fc'
	include 'coord.fc'
c
	integer kolist(MZ)
	integer ounit
	deg(rad)=180.0*rad/3.141592
c
	if (ounit.le.0) then
	  write(msg,*) 
     &	  '(subr.writem) file i/o unit number not assigned'
	  if(lst.ne.msg) write(lst,*) 
     &	  '(subr.writem) file i/o unit number not assigned'
	  errflg=2
	  return
	endif
c
	if(kindmo.eq.0) kindmo=kindm
	call olist(kindmo,kolist,nframo,NSPEC0)
	if(msglvl.gt.2) then
	  write(lst,100) 'writem:kolist(iframe)=',kolist
	  write(lst,100) 'writem:kloc(lspec)   =',kloc 
	  write(lst,100) 'writem:lspecs(k)     =',lspecs
 100	  format(2x, a,10i3/(2x,22x,10i3))
	endif
c
	b0deg=deg(b0rad)
c  ypos and prad might have been set to zero in readm.f,
c  rather than being set to rad(ydeg) and rad(pdeg).
c  therefore, ydeg and pdeg are not re-calculated, but use
c  the original values from the input file
cx	ydeg=deg(ypos)
cx	pdeg=deg(prad)
	xtod=xxtod(1)
	ytod=xxtod(2)
	ftag=mktag()
c
	call outmh(ounit)
	if(msglvl.gt.0) 
     &	write(lst,*) '(subr.writem) kindm,mesh,nframe=',kindm,mesh,nframe
	if(msglvl.gt.1)
     &  call printm(nbytem,nx,ny,xs,ys,dx,dy,ydeg,
     &	          rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	          tsys,inst,wavel,mfile,dateo,stime,etime,
     &	          ftag,title)
c
	do 1000 iframe=1,nframo
	k=kolist(iframe)
 1000	call outm(ounit,k)
c
	if(msglvl.gt.0) write(lst,*)
     &	 '(subr.writem) kindmo,mesh,nframo=',kindmo,mesh,nframo
c
	return
	end
c
c  write intensity/velocity data to a file
c
	subroutine writiv(lspciv,ounit)
c
	include 'sys.fc'
	include 'mparam.fc'
	include 'fileio.fc'
	include 'mdata.fc'
	include 'string.fc'
	include 'solar.fc'
	include 'coord.fc'
	integer ounit
	integer kolist(MZ)
c
	if (ounit.le.0) then
	  write(msg,*)
     &	  '(subr.writiv) file i/o unit number not assigned'
	  if(lst.ne.msg) write(lst,*)
     &	  '(subr.writiv) file i/o unit number not assigned'
	  errflg=2
	  return
	endif
c
	if(lspciv.eq.lspec('VL')) kindmo=100
	if(lspciv.eq.lspec('I')) kindmo=1000
	nframo=1
	kolist(1)=kloc(lspciv)
	call outmh(ounit)
c
	if (msglvl.gt.0) then
	  write(lst,*) '(subr.writiv) for',specst(lspciv)
	  write(lst,*) '  kindmo,mesh,nframeo=',kindmo,mesh,nframo
	endif
	if (msglvl.gt.1)
     &  call printm(nbytem,nx,ny,xs,ys,dx,dy,ydeg,
     &	          rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	          tsys,inst,wavel,mfile,dateo,stime,etime,
     &	          ftag,title)
c
	call outm(ounit,kolist)
c
	return
	end
c
c  write magnetogram data onto a file
c  according to 'kolist' array
c  rdata(*,*,k) will be written if lspecs(k) is in kolist
c
c  access method : direct access formatted i/o with recl=80 bytes
c
c  write magnetogram header
c
	subroutine outmh(ounit)
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'string.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'solar.fc'
c
	character buf*80,spec*8
	integer ounit
	save loc
c
	lrec0=80
	loc=1
	write(buf,110) kindmo,nbytem,nframo,tsys,inst,mfile,dateo,
     &	               stime,etime,ftag
 110	format(i8,2i4,2x,a6,5a8,a16)
	if (ocode.ne.0) call cconv(ocode, buf)
	call outs( ounit, loc, buf, lrec0 )
c
	write(buf,120) nx,ny,xs,ys,dx,dy,ydeg,mesh,wavel
 120	format(2i4,5f12.5,i4,f8.2)
	if (ocode.ne.0) call cconv(ocode, buf)
	call outs( ounit, loc, buf, lrec0 )
c
	write(buf,130) rsp,pdeg,b0deg,cl0deg,xtod,ytod
 130	format(6f12.5,8x)
	if (ocode.ne.0) call cconv(ocode, buf)
	call outs( ounit, loc, buf, lrec0 )
c
	write(buf,140) title
 140	format(a80)
	if (ocode.ne.0) call cconv(ocode, buf)
	call outs( ounit, loc, buf, lrec0 )
c
	return
c
c  write magnetogram data
c
	entry outm(ounit,k)
c
c  iufl2=-32000
c  iufl4=-2 140 000 000
c  ufl=1.0e-15
c  ufl, iufl2, iufl4 are in sys.fc and defined by initfc.f
	nufl=0
c
	lrec0=80
	lspec1=lspecs(k)
	spec=specst(lspec1)
	factor=factm(lspec1)
	rmax1=framax(rdata(1,1,k), nx,ny, MX)
c
	if(iabs(nbytem).eq.2 .and. rmax1/factor.gt.float(maxi2)) then
	  factor=rnd125(rmax1/float(maxi2))
	  write(lst,*) '(subr.outm  ) factor is changed to',factor,
     &  ' in order to avoid overflow'
	endif
c
cc	if(iabs(nbytem).eq.2 .and. rmax1/factor.lt.100.0) then
cc	  factor=rnd125(rmax1/float(maxi2))
cc	  write(lst,*) '(subr.outm  ) factor is changed to',factor,
cc     &  ' in order to reduce round-off errors'
cc	endif
c
	if(iabs(nbytem).eq.4 .and. rmax1/factor.gt.float(maxi4)) then
	  factor=rnd125(rmax1/float(maxi4))
	  write(lst,*) '(subr.outm  ) factor is changed to',factor,
     &  ' in order to avoid overflow'
	endif
c
cc	if(iabs(nbytem).eq.4 .and. rmax1/factor.lt.100.0) then
cc	  factor=rnd125(rmax1/float(maxi4))
cc	  write(lst,*) '(subr.outm  ) factor is changed to',factor,
cc     &  ' in order to reduce round-off errors'
cc	endif
c
	write(buf,150) spec,factor
 150	format(a8,1pe12.5,60x)
	if (ocode.ne.0) call cconv(ocode, buf)
c
	call outs( ounit, loc, buf, lrec0 )
	if(msglvl.gt.1) then
	  write(lst,*) '(subr.outm  ) spec=',spec,' factor=',factor
	  write(lst,*) '              lspec=',lspec1,' kloc=',k
	endif
c
	if (iabs(nbytem).eq.2) then
	  call allocm(1,8,'outm')
	  if(errflg.gt.1) then
	    write(lst,*) '(subr.outm  ) error'
	    return
	  endif
	  do 10 j=1,ny
	  do 10 i=1,nx
	  if(rdata(i,j,k).ne.ufl) then
	    idata2(i,j)=rdata(i,j,k)/factor
	  else
	    idata2(i,j)=iufl2
	    nufl=nufl+1
	  endif
 10	  continue
	  call out2( ounit, loc, idata2, lrec0, nx, ny, MMX )
	  call freem(1,8)
c
	else if (iabs(nbytem).eq.4) then
	  call allocm(1,16,'outm')
	  if(errflg.gt.1) then
	    write(lst,*) '(subr.outm  ) error'
	    return
	  endif
	  do 20 j=1,ny
	  do 20 i=1,nx
	  if(rdata(i,j,k).ne.ufl) then
	    idata4(i,j)=rdata(i,j,k)/factor
	  else
	    idata4(i,j)=iufl4
	    nufl=nufl+1
	  endif
 20	  continue
	  call out4( ounit, loc, idata4, lrec0, nx, ny, MMX )
	  call freem(1,16)
c
	endif
	if(nufl.gt.0 .and. msglvl.gt.1)
     &	  write(lst,*) '(subr.outm  ) unfilled points=',nufl
	if(msglvl.gt.2)
     &	  write(lst,*) '(subr.outm  ) data first,last=',
     &	  rdata(1,1,k),rdata(nx,ny,k)
c
	return
	end
c
	function rnd125(a)
c
	pow10=log10(abs(a))
	if(pow10.ge.0.0) then
	  base=10.0*(10.0**int(pow10))
	else
	  base=10.0*(10.0**(int(pow10)-1))
	endif
	q=abs(a)/base
	if(q.gt.0.5) then
	  b=1.0
	else if (q.gt.0.2) then
	  b=0.5
	else
	  b=0.2
	endif
	rnd125=sign(b*base,a)
	return
	end
