c  convert Wilcox Solar Observatory data table
c  into magpack2 standard data file
c  output data are 'BR' by using radial field assumption
c
c  created 00/06/17
c
c  tested on data of Carrington rotation 1951 (year 1999)
c
	program stprep
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	integer iut,oum,rotno
	character*80 fnamei,fnameo,chr,line
	logical alloc
	rad(deg)=3.14159265*deg/180.0
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	chr='0'
	if(myargc().eq.1) call myargv(1,chr)
	if(chr.eq.'0') then
	  msglvl=0
	else if(chr.eq.'1') then
	  msglvl=1
	else if(chr.eq.'2') then
	  msglvl=2
	else if(chr.eq.'3') then
	  msglvl=3
	else
	  msglvl=1
	endif
c
	include 'sysconf.cfg'
c
	call initfc
	lst = lstini()
c
c  these are not initialized in initfc
	nxmax=MX
	nymax=MY
c
	if(mycode.eq.0 .or. myint.eq.0) stop
c
	lrec0=80
	iut=98
	oum=97
c
	write(msg,*)
     &	'(prog.stprep) enter the name of Stanford data table for input'
	read(keyin,'(a)') fnamei
	call openfl(other1,'STTBL',iut,fnamei,text,rdo,lrec0)
	if(errflg.gt.1) stop
c
      write(msg,*)
     &      '(prog.stprep) enter output file name'
      fnameo=' '
      read(keyin,'(a)') fnameo
      call openfl(rmgram,'RMGRAM',oum,fnameo,export,wrt,lrec0)
      if(errflg.gt.1) stop
c
	nx=72
	ny=30
c
 1000	continue
	read(iut,'(a)',end=9) line
	if(line(1:2).eq.'CT') then
c  the first valid data line is
c  CTxxxx:360 ,,,,
c  where xxxx is the Carrington rotation number
c
	  read(line(3:6),'(i4)') rotno
	  mfile=line(1:6)
	  title=mfile
	  go to 1100
	endif
 	go to 1000
 1100	do 1200 ii=1,nx+1
	if(ii.ne.1) read(iut,'(a)') line
	i=nx+2-ii
	read(line(11:80),*) (rdata(i,j,1),j=30,25,-1)
	read(iut,*) (rdata(i,j,1),j=24,17,-1)
	read(iut,*) (rdata(i,j,1),j=16, 9,-1)
	read(iut,*) (rdata(i,j,1),j= 8, 1,-1)
 1200	continue
c
c  data in file:
c     longitude=360: sin(lat)=14.5/15, 13.5.15, ,,, -14.5/15
c               355: 
c               ...:
c                 0:
c
c  data of longitude=0 and 360 are combined
c
	do 1300 j=1,ny
 1300	rdata(1,j,1)=0.5*(rdata(1,j,1)+rdata(nx+1,j,1))
c
c  rdata are in microtesla (=0.01G), last digit=0.001 microtesla
c  convert rdata into Gauss unit
c
	do 2000 j=1,ny
	do 2000 i=1,nx
 	rdata(i,j,1)=rdata(i,j,1)*0.01
 2000	continue
c
	eps=0.01
	xs=rad(eps)
	ys=-14.5/15.0
	dx=rad(5.0)
c  xs=0.01 deg, xe=355+0.01 deg
	dy= 1.0/15.0
c
	rsp=69.7
	kindm=30006
	kindmo=kindm
	mesh=4
        ftag=mktag()
        ydeg=0.0
        xtod=0.0
        ytod=0.0
        b0rad=rad(b0deg)
        prad=rad(pdeg)
        cl0=rad(cl0deg)
        xxsp(1)=0.0
        xxsp(2)=0.0
        xxsp(3)=-rsp
c
	pdeg=0.0
	b0deg=0.0
	cl0deg=180.0
c
        prad=rad(pdeg)
        b0rad=rad(b0deg)
        cl0=rad(cl0deg)
        ypos=rad(ydeg)
        cl0eff=cl0
	
	alloc=.true.
	do 10 n=1,NSPEC0
 10	kloc(n)=0
	do 20 k=1,MZ
	kmem(k)=0
	lspecs(k)=0
 20	continue
	nbytem=4
	inst='WSO'
	wavel=5250.2
	tsys='UT'
	call carcmp(rotno,dateo,stime)
	etime=stime
c
        lspec1=lspec('BR')
        factm(lspec1)=0.0001
        alloc=.true.
	nframe=0
        k=newk(lspec1, alloc)
c  nframe incremented in newk
	nframo=nframe
c
	write(lst,*)
     &	 '(prog.stprep) kindm,mesh,nframe=',kindm,mesh,nframe
	call printm(nbytem,nx,ny,xs,ys,dx,dy,ydeg,
     &	rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	tsys,inst,wavel,mfile,dateo,stime,etime,ftag,title)
c
	nx0=nx
	ny0=ny
	xs0=xs
	ys0=ys
	dx0=dx
	dy0=dy
	call synop(rdata,MX,nymax,
     &              nx0,ny0,xs0,ys0,dx0,dy0,
     &              nx, ny, xs, ys, dx, dy)
        write(lst,*) 're-gridding of synoptic data done.'
c
c  divide by cos(theta) 
c
	do 30 j=1,ny
	do 30 i=1,nx
 30	rdata(i,j,k)=rdata(i,j,k)/cos(alofy(ys+dy*float(j-1))) 
	write(lst,*) 'radial field assumption to obtain BR.'
c
	call writem(oum)
	stop
c
 9	write(msg,*) '(subr.stprep) error: end of file'
	errflg=2
	stop
	end
