c
c  spherical  harmonics
c
	subroutine subylm(z,ph,lmax,ndim,plm,ylmr,ylmi)
c
	dimension ylmr(ndim,1),ylmi(ndim,1),plm(ndim,1)
	data pi/3.14159265/
c
c	plm(1+l,1+m) = normalized Legendre's associated polynomial
c	               with degree l and azimuthal quantum number m
c
c	             =sqrt[(2l+1)(l-m)!/2(l+m)!] * Plm(mu)
c
c	where Plm(mu) is Legendre's associated polynomical in usual definition
c
c	l=0 to lmax, m=0 to lmax
c	integral of lpm^2 from mu=-1 to mu=1 is 1
c
c	Ylm=ylmr + i*ylmi is spherical harmonic function
c
	rt2pi=1.0/sqrt(2.0*pi)
	plm(1+0,1+0)=1.0/sqrt(2.0)
	do 20 l=1,lmax
 20	plm(1+l,1+l)=sqrt(1.0-z*z)*plm(1+l-1,1+l-1)
     &	            *sqrt(float(2*l+1)/float(2*l))
	do 30 l=1,lmax
 30	plm(1+l,1+l-1)=sqrt(float(2*l+1))*z*plm(1+l-1,1+l-1)
	do 40 m=0,lmax-2
	do 40 l=m+2,lmax
 40	plm(1+l,1+m)=z*plm(1+l-1,1+m)
     &	            *sqrt(float((2*l-1)*(2*l+1))/float((l-m)*(l+m)))
     &	             -plm(1+l-2,1+m)
     &	            *sqrt(float((2*l+1)*(l-m-1)*(l+m-1))
     &	             /float((2*l-3)*(l-m)*(l+m)))
	do 50 l=0,lmax
	do 50 m=0,l
	ylmr(1+l,1+m)=rt2pi*plm(1+l,1+m)*cos(float(m)*ph)
	ylmi(1+l,1+m)=rt2pi*plm(1+l,1+m)*sin(float(m)*ph)
 50	continue
	return
	end
