;	check whether magnetogram specified by oldm can be transformed to
;	newm

function chktrans, oldm, newm

	m1 = oldm(0)
	m2 = oldm(1)
	m3 = oldm(2)
	m4 = oldm(3)
	m5 = oldm(4)
	m1new = newm(0)
	m2new = newm(1)
	m3new = newm(2)
	m4new = newm(3)
	m5new = newm(4)

;  m?map(m?old,m?new)=1 if transformable (?=1,2,3,4)

;  m5=0 to m5new=0
;  map00(m1old,m1new)=1 if transformable
;  m1new
;    |
;    V  m1old=0 1 2 3 4 5 6 7 8 9
        map00 = [$
            [ 1,1,1,1,1,1,1,1,1,1 ], $
            [ 0,1,1,1,1,1,1,1,1,1 ], $
            [ 0,0,1,1,1,0,1,1,1,0 ], $
            [ 0,0,0,1,1,0,0,1,1,0 ], $
            [ 0,0,0,0,1,0,0,0,1,0 ], $
            [ 0,0,0,0,0,1,1,1,1,0 ], $
            [ 0,0,0,0,0,0,1,1,1,0 ], $
            [ 0,0,0,0,0,0,0,1,1,0 ], $
            [ 0,0,0,0,0,0,0,0,1,0 ], $
            [ 0,1,1,1,1,1,1,1,1,1 ] ]

;  m5=0 to m5new>0
;  map01(m1old,m1new)=1 if transformable
;  m1new
;    |
;    V  m1old=0 1 2 3 4 5 6 7 8 9
        map01 = [ $
            [ 1,1,1,1,1,1,1,1,1,1 ], $
            [ 0,0,0,1,1,0,0,1,1,0 ], $
            [ 0,0,0,0,1,0,0,0,1,0 ], $
            [ 0,0,0,1,1,0,0,1,1,0 ], $
            [ 0,0,0,0,1,0,0,0,1,0 ], $
            [ 0,0,0,0,0,0,0,1,1,0 ], $
            [ 0,1,1,1,1,1,1,1,1,1 ], $
            [ 0,0,0,0,0,0,0,1,1,0 ], $
            [ 0,0,0,0,0,0,0,0,1,0 ], $
            [ 0,1,1,1,1,1,1,1,1,1 ] ]

;  m5>0 to m5new=0
;  map10(m1old,m1new)=1 if transformable
;  m1new
;    |
;    V  m1old=0 1 2 3 4 5 6 7 8 9
        map10 = [ $
            [ 1,1,1,1,1,1,1,1,1,1 ], $
            [ 0,0,0,1,1,1,0,1,1,0 ], $
            [ 0,0,0,1,1,0,0,1,1,0 ], $
            [ 0,0,0,1,1,0,0,1,1,0 ], $
            [ 0,0,0,0,1,0,0,0,1,0 ], $
            [ 0,0,0,0,0,1,0,1,1,0 ], $
            [ 0,0,0,0,0,0,0,1,1,0 ], $
            [ 0,0,0,0,0,0,0,1,1,0 ], $
            [ 0,0,0,0,0,0,0,0,1,0 ], $
            [ 0,1,1,1,1,1,1,1,1,1 ] ]

;  m5>0 to m5new>0
;  map11(m1old,m1new)=1 if transformable for m5=m5new
;                    =2 if transformable for m5.ne.m5new
;  m1new
;    |
;    V  m1old=0 1 2 3 4 5 6 7 8 9
        map11 = [ $
            [ 2,2,2,2,2,2,2,2,2,2 ], $
            [ 0,1,1,2,2,0,0,2,2,0 ], $
            [ 0,0,1,0,2,0,0,0,2,0 ], $
            [ 0,0,0,2,2,0,0,2,2,0 ], $
            [ 0,0,0,0,2,0,0,0,2,0 ], $
            [ 0,0,0,0,0,2,0,2,2,0 ], $
            [ 0,2,2,2,2,0,2,2,2,2 ], $
            [ 0,0,0,0,0,0,0,2,2,0 ], $
            [ 0,0,0,0,0,0,0,0,2,0 ], $
            [ 0,2,2,2,2,0,2,2,2,2 ] ]

	m1map = intarr(10,10,2,2)
	m1map(*,*,0,0) = map00
	m1map(*,*,1,0) = map10
	m1map(*,*,0,1) = map01
	m1map(*,*,1,1) = map11

;  m2new
;    |
;    V  m2old=0 1 2 3 4 5 6 7 8 9
        m2map = [ $
            [ 1,1,1,1,1,1,1,0,0,0 ], $
            [ 0,1,0,0,1,0,0,0,0,0 ], $
            [ 0,0,1,0,0,1,0,0,0,0 ], $
            [ 0,0,0,1,0,0,1,0,0,0 ], $
            [ 0,0,0,0,1,0,0,0,0,0 ], $
            [ 0,0,0,0,0,1,0,0,0,0 ], $
            [ 0,0,0,0,0,0,1,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ] ]

;  m3new
;    |
;    V  m3old=0 1 2 3 4 5 6 7 8 9
        m3map = [ $
            [ 1,1,1,1,0,0,0,0,0,0 ], $
            [ 0,1,1,1,0,0,0,0,0,0 ], $
            [ 0,1,1,1,0,0,0,0,0,0 ], $
            [ 0,1,1,1,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ] ]

;  m4new
;    |
;    V  m4old=0 1 2 3 4 5 6 7 8 9
        m4map = [ $
            [ 1,1,1,1,1,1,1,0,0,0 ], $
            [ 0,1,0,1,0,1,0,1,0,0 ], $
            [ 0,0,1,1,0,0,1,1,0,0 ], $
            [ 0,0,0,1,0,0,0,1,0,0 ], $
            [ 0,0,0,0,1,1,0,1,0,0 ], $
            [ 0,0,0,0,0,1,0,1,0,0 ], $
            [ 0,0,0,0,0,0,1,1,0,0 ], $
            [ 0,0,0,0,0,0,0,1,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ], $
            [ 0,0,0,0,0,0,0,0,0,0 ] ]

	ok = 1
	if m4map(m4,m4new) eq 0 or $
         m3map(m3,m3new) eq 0 or $
         m2map(m2,m2new) eq 0 or $
        (m5 eq 0 or m5new eq 0 or m5 eq m5new) and $
          m1map(m1,m1new, m5<1, m5new<1 ) eq 0 or $
        (m5 gt 0 and m5new gt 0 and m5 ne m5new and $
         m1map(m1,m1new, m5<1, m5new<1 ) le 1)  then  ok = 0

	return, ok
end
