;+
; NAME :	deffactr
; PURPOSE :
;	define conversion factors between integer and real data
;	real = factor * integer
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	factors = deffactr()
; INPUTS :
;	none
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	factors (structure)
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;	2000/05 bug fix (was inconsistent with defstats)
;-
;------------------------------------------------------------------------
;
function deffactr
;
; definition of structure 'factors'
;
	factors = { factors1, $
        	i:0.0001,   ixdum:0.0, iydum:0.0, $
		v:0.0001,   q:0.0001,     u:0.0001,     $
		vi:0.0001,  qi:0.0001,    ui:0.0001,    $
		w:-1,   wxdum:-1, wydum:-1, $
		wi:-1,  wixdum:-1,wiydum:-1,$
		blp:1.0, bxp:1.0,   byp:1.0,   $
		bnp:1.0, bhxp:1.0,  bhyp:1.0,  $
		brp:1.0, bphp:1.0,  bthp:1.0,   $
		bl:1.0,  bx:1.0,    by:1.0,    $
		bn:1.0,  bhx:1.0,   bhy:1.0,   $
		br:1.0,  bph:1.0,   bth:1.0,    $
		vl:1.0,  vx:1.0,    vy:1.0,    $
		vn:1.0,  vhx:1.0,   vhy:1.0,   $
		vr:1.0,  vph:1.0,   vth:1.0,    $
		jl:1.0,  jxdum:1.0, jydum:1.0, $
		jn:1.0,  jhxdum:1.0,jhydum:1.0,$
		jr:1.0,  jphdum:1.0,jthdum:1.0, $
		fl:1.0,  fxdum:1.0, fydum:1.0, $
		fn:1.0,  fhxdum:1.0,fhydum:1.0,$
		fr:1.0,  fphdum:1.0,fthdum:1.0, $
		alpha:-1,axdum:-1,  aydum:-1, $
		divx:-1, dxdum:-1,  dydum:-1, $
		s1:-1,  x1:-1,    y1:-1,    $
		s2:-1,  x2:-1,    y2:-1,    $
		s3:-1,  x3:-1,    y3:-1,    $
		s4:-1,  x4:-1,    y4:-1     $
		}
	return, factors
;	the tags should be consistent with structures status and specs
end
