;+
; NAME :	deflh1
; PURPOSE :
;	define field-line header part-1
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	lhdr1 = deflh1()
; INPUTS :
;	none
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	np = number of points
;	nex = number of extra control records
; OUTPUTS :
;	lhdr1 (structure)
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;-
;------------------------------------------------------------------------
;
function deflh1, np=np, nex=nex
;
; definition of MAGPACK2 field line header part-1
;
	lof1={lhdr1, $
		np:   string(' ', format='(a8)'), $
		nex:  string(' ', format='(a4)'), $
		blank2:'  ', $
		nfinit:	string(' ', format='(a4)'), $
		ns1:	string(' ', format='(a8)'), $
		ns2:	string(' ', format='(a8)'), $
		ns3:	string(' ', format='(a8)'), $
		bmin1:	string(' ', format='(a12)'), $
		bmin2:	string(' ', format='(a12)'), $
		flxpwr:	string(' ', format='(a12)'), $
		dummy:string(' ',format='(a2)') }

	if keyword_set(np) then $
		lof1.np = string( np, format='(i8)') $
	else $
		lof1.np = string( 0, format='(i8)')
	
	if keyword_set(nex) then $
		lof1.nex = string( nex, format='(i4)') $
	else $
		lof1.nex = string( 0, format='(i4)')

	return, lof1
end
