;+
; NAME :	defmh1
; PURPOSE :
;	define magnetogram header part-1
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	mhdr1 = defmh1()
; INPUTS :
;	none
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	mhdr1 (structure)
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;	TS 95/10/31: add wavel
;-
;------------------------------------------------------------------------
;
function defmh1
;
	str4=string(' ',format='(a4)')
	str8=string(' ',format='(a8)')
	str12=string(' ',format='(a12)')
	str16=string(' ',format='(a16)')

	mag1={mhdr1, kindm:str8, $
		nbytem:str4, $
		nframe:str4, $
		blank2:'  ', $
		tsys:'      ', $
		inst:str8, $
		mfile:str8, $
		dateo:str8, $ 
		stime:str8, $
	 	etime:str8, $
		ftag:str16, $
		nx:str4, $
		ny:str4, $
		xs:str12, $
		ys:str12, $
		dx:str12, $
		dy:str12, $
		ydeg:str12, $
		mesh:str4, $
		wavel:str8, $
		rsp:str12, $
		pdeg:str12, $
		b0deg:str12, $
		cl0deg:str12, $
		xt:str12, $
		yt:str12, $
		dummy3:str8, $
		title:string(' ',format='(a80)') }

	return,mag1
end
