;+
; NAME :	defstats
; PURPOSE :
;	define magnetogram status stored in rdata
;	if data BL exist in rdata(*,*,k), status.bl = k
;	if data BL are not in rdata, status.bl = -1
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	status = defstats
; INPUTS :
;	none
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	status (structure)
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none	
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;-
;------------------------------------------------------------------------
;
function defstats
;
	status = { status1, $
        	i:-1,   ixdum:-1, iydum:-1, $
		v:-1,   q:-1,     u:-1,     $
		vi:-1,  qi:-1,    ui:-1,    $
		w:-1,   wxdum:-1, wydum:-1, $
		wi:-1,  wixdum:-1,wiydum:-1,$
		blp:-1, bxp:-1,   byp:-1,   $
		bnp:-1, bhxp:-1,  bhyp:-1,  $
		brp:-1, bphp:-1,  bthp:-1,  $
		bl:-1,  bx:-1,    by:-1,    $
		bn:-1,  bhx:-1,   bhy:-1,   $
		br:-1,  bph:-1,   bth:-1,   $
		vl:-1,  vx:-1,    vy:-1,    $
		vn:-1,  vhx:-1,   vhy:-1,   $
		vr:-1,  vph:-1,   vth:-1,   $
		jl:-1,  jxdum:-1, jydum:-1, $
		jn:-1,  jhxdum:-1,jhydum:-1,$
		jr:-1,  jphdum:-1,jthdum:-1,$
		fl:-1,  fxdum:-1, fydum:-1, $
		fn:-1,  fhxdum:-1,fhydum:-1,$
		fr:-1,  fphdum:-1,fthdum:-1,$
		alpha:-1,axdum:-1,aydum:-1, $
		divb:-1, xdum:-1, ydum:-1,  $
		s1:-1,  x1:-1,    y1:-1,    $
		s2:-1,  x2:-1,    y2:-1,    $
		s3:-1,  x3:-1,    y3:-1,    $
		s4:-1,  x4:-1,    y4:-1     $
		}
	return, status
;	the tags should be consistent with structures specs and factors
end
