;	test divb1, divbp1, db2dz by using a dipole field

	common blkd, coord_d
	common blkt, coord_t

	nx = 41
	ny = 41
	xc = 0.0
	yc = 0.0
	dx = 0.5
	dy = 0.5
	rsp = 70.0
	bmax = 1000.0
	dir = [1.0, 0.0, 0.0]
	dir = dir/sqrt(total(dir*dir))
	iproj = 1

	height=0.01

;	xxs = [35.0, 0.0, -12.0]
;	xs = 25.0
;	ys = -10.0

	xxs = [0.0, 35.0, -12.0]
	xs = -10.0
	ys = 25.0

;	xxs = [0.0, 0.0, -2.0]
;	xs = -10
;	ys = -10

	xc = xs + dx*(nx/2)
	yc = ys + dy*(nx/2)

	mparam = defmp()

;	mparam.kindm = 2L	; pseudo vector
	mparam.kindm = 3L	; vector
	mparam.nbytem = 2
	mparam.nframe = 3
	mparam.tsys='GMT+09'
	mparam.inst='DUMMY'
	mparam.mfile='DIPOLE'
	mparam.nx = nx
	mparam.ny = ny
	mparam.xs = xs
	mparam.ys = ys
	mparam.dx = dx
	mparam.dy = dy
	mparam.xxtod=[xc,yc]
	mparam.rsp = rsp
	mparam.mesh = 0
	mparam.title='DIPOLE'

	rdata = fltarr(nx,ny,8)
	kz=0
	kx=1
	ky=2
	mparam.status.bl = kz
	mparam.status.bx = kx
	mparam.status.by = ky
	mparam.factors.bl=0.2
	mparam.factors.bx=0.2
	mparam.factors.by=0.2

	dmom=1.0

	setdu, mparam
	settu, mparam

	x = fltarr(nx,ny)
	y = x
	z = x


	for j=0,ny-1 do x(*,j) = xs + dx*indgen(nx)
	for i=0,nx-1 do y(i,*) = ys + dy*indgen(ny)

	if iproj eq 1 then begin
		projt, x,y,z
		ctot, xxs(0),xxs(1),xxs(2), xx,yy,zz
		depth = -zz
	endif else $
	if iproj ge 2 then begin
		projs, x,y,z
		projt, x,y,z
		ctot, xxs(0),xxs(1),xxs(2), xx,yy,zz
		depth = -zz
	endif else begin
		depth = -xxs(2)
	endelse

	dipole, x,y,z,bx,by,bz,dmom=dmom,xxs=xxs,dir=dir

;	mirror source
	if iproj eq 2 then begin
		xxsm=[ xxs(0),xxs(1), -2*rsp -xxs(2)]
		dirm=[dir(0), dir(1), -dir(2)]
		dipole, x,y,z,bx2,by2,bz2,dmom=dmom,xxs=xxsm,dir=dirm
		bx = bx+bx2
		by = by+by2
		bz = bz+bz2
	endif

	bmax1 = sqrt( max( bx*bx+by*by+bz*bz) )
	dmom=bmax/bmax1

		rdata(*,*,kx)=bx*dmom
		rdata(*,*,ky)=by*dmom
		rdata(*,*,kz)=bz*dmom

        print, 'dipole:'
        print, '  location=',xxs
        print, '  depth=',depth
        print, '  moment=',dmom
        print, '  direction=',dir
        if iproj eq 1 then $
		print, '  xtod,ytod=',mparam.xxtod(0:1)
        print, '  nx,ny=',nx,ny
        print, '  xs,ys=',xs,ys,'  rsp=',rsp
        print, '  dx,dy=',dx,dy
        print, '  data projection: iproj=',iproj
        print, '  kindmo=',mparam.kindm

	rx = coord_t.atmat(0,2)
	ry = coord_t.atmat(1,2)
	rz = coord_t.atmat(2,2)
	bn = rx*rdata(*,*,kx)+ry*rdata(*,*,ky)+rz*rdata(*,*,kz)

	dipole, x,y,z+height,bxp,byp,bzp,dmom=dmom,xxs=xxs,dir=dir
	dipole, x,y,z-height,bxm,bym,bzm,dmom=dmom,xxs=xxs,dir=dir
	dbl = (bzp-bzm)/(2*height) * bn

	dipole, x+rx*height,y+ry*height,z+rz*height, $
		bxp,byp,bzp,dmom=dmom,xxs=xxs,dir=dir
	dipole, x-rx*height,y-ry*height,z-rz*height, $
		bxm,bym,bzm,dmom=dmom,xxs=xxs,dir=dir
	dbn = 0.5*((rx*bxp+ry*byp+rz*bzp)^2-(rx*bxm+ry*bym+rz*bzm)^2)/(2*height)
	db2 = 0.5*(bxp^2+byp^2+bzp^2-bxm^2-bym^2-bzm^2)/(2*height)

	curlb1,mparam,rdata
	divb1,mparam,rdata
	divb = rdata(*,*,4)
	print,'max(bt)=',sqrt(max(rdata(*,*,1)^2+rdata(*,*,2)^2))
	print,'max(curlb)=',max(abs(rdata(*,*,3)))
	print,'max(divb)=',max(abs(rdata(*,*,4)))/max(bn)
	print,'max(dbl)=',max(abs(dbl))/max(bn)
	print,'max(divb+dbl)=',max(abs(rdata(*,*,4)+dbl))/max(bn)

	divbp1, mparam,rdata
	divbp = rdata(*,*,4)
	print,'max(divbp)=',max(abs(rdata(*,*,4)))/max(bn)
	print,'max(dbn)=',max(abs(dbn))/max(bn)
	print,'max(divbp+dbn)=',max(abs(rdata(*,*,4)+dbn))/max(bn)

	db2dz, mparam,rdata
	print,'max(db2dz)=',max(abs(rdata(*,*,4)))/max(bn)
	print,'max(db2dz)=',max(abs(db2))/max(bn)
	print,'max(db2dz+db2dz)=',max(abs(rdata(*,*,4)+db2))/max(bn)

end

