;	Green's funtion monopole, kindL=12

pro field12, x,y,z,bx,by,bz, psi, xxs=xxs, a0=a0, b0=b0, $
	npoint=npoint, rsp=rsp, rrss=rrss

	common crssl, rrsssave, ain,aout,amout1

;       when x,y,z are 1-D vectors, xxs should be a 3-element vector
;       bx,by,bz are 1-D vectors representing field vectors at (x,y,z)

;       when xxs is a 2-D vector [xxs(0:2,*)], x,y,z should be scalars
;       bx,by,bz are sums of contributions from xxs, and are scalars


	ss = size(xxs)
	if ss(0) eq 2 then begin
		xsrc=xxs(0,*)
		ysrc=xxs(1,*)
		zsrc=xxs(2,*)
		bx = 0.0*xsrc
	endif else begin
		xsrc=xxs(0)
		ysrc=xxs(1)
		zsrc=xxs(2)
		bx = 0.0*x
	endelse
	by = bx
	bz = bx
	psi = bx

	if not keyword_set(rrss) then rrss=0.0
	if not keyword_set(rrsssave) then rrsssave=0.0

	pi=3.141592

	xxsp = [0.0, 0.0, -rsp]
	zsrc = sqrt(rsp^2 - xsrc^2 -ysrc^2) -rsp
	nvecx = (xsrc-xxsp(0))/rsp
	nvecy = (ysrc-xxsp(1))/rsp
	nvecz = (zsrc-xxsp(2))/rsp
	lvec = [0.0, 0.0, 1.0]
	flx = b0*a0*a0*pi

	if rrss gt 1.0 and rrss ne rrsssave then begin
;  data for source surface model generated by rssl.f + convrssl.f
;  rsstbl is a table of relative source surface radii rrss = rss/rsp
;  aotbl = ao/rrss**2, ao=normalized outer radius of monopole
;  aout  = ao*rsp, ain=rsp**2/aout
;  am*rrss = sum(j=0 to 8) [ coeff(j)*cos(float(2*j+1)*th) ]

		rsstbl = [0.10, 0.2, 0.3, 0.4, 0.5, 0.6, $
			0.7, 0.8, 0.85, 0.90, 0.95] 
		aoutbl = [0.75, 0.75, 0.75, 0.75, 0.75, 0.75, 0.75, $
			0.8576, 0.91035,  0.9639, 0.9639 ]
        	coeff = [ $
			[-5.550643,  0.291150,  0.776798,  0.495543,  0.409210, $
			  0.301419,  0.250631,  0.208004,  0.192339 ], $
			[-4.534327,  0.421385,  0.676358,  0.336765,  0.214059, $
			  0.112404,  0.071672,  0.042096,  0.032918 ], $
			[-3.778797,  0.271335,  0.478262,  0.205486,  0.110049, $
			  0.044792,  0.024544,  0.010270,  0.007143 ], $
			[-3.185766,  0.040860,  0.294018,  0.125474,  0.062106, $
			  0.022042,  0.011302,  0.003822,  0.002599 ], $
			[-2.660593, -0.193669,  0.121586,  0.065620,  0.035254, $
			  0.012771,  0.006413,  0.002090,  0.001373 ], $
			[-2.152467, -0.363366, -0.041561, -0.004744,  0.004063, $
			  0.000965,  0.000632, -0.000576, -0.000607 ], $
			[-1.653699, -0.393237, -0.145229, -0.074905, -0.041447, $
			 -0.027110, -0.018801, -0.014990, -0.013131 ], $
			[-1.372272, -0.393443, -0.201454, -0.121272, -0.076077, $
			 -0.053910, -0.041693, -0.035459, -0.032552 ], $
			[-0.976871, -0.596509, -0.203784, -0.071028, -0.104964, $
			 -0.093301, -0.023562, -0.013447, -0.061295 ] , $
			[-0.522680, -0.468979, -0.375856, -0.266501, -0.164615, $
			 -0.086640, -0.037829, -0.013556, -0.004792 ] ]


		rssinv = 1.0/rrss
      	if rssinv gt rsstbl(10) then begin
			print, 'error: rrss too small',rrss
			stop
		endif
		if rssinv lt rsstbl(0) then begin
			print, 'warning: rrss is too large: set rrss=infinity'
			rrss=0.0
		endif else begin
			loc = where(rssinv lt rsstbl)
			n = loc(0)
			f=(rssinv-rsstbl(n-1))/(rsstbl(n)-rsstbl(n-1))
			ao=aoutbl(n-1)+f*(aoutbl(n)-aoutbl(n-1))
			ao=ao*rrss^2
			if ao le rrss then begin
				print, 'error: rrss too small',rrss
				stop
			endif

			aout=ao*rsp
			ain=rsp^2/aout
			r=sqrt( (xsrc-xxsp(0))^2 $
				+(ysrc-xxsp(1))^2 $
				+(zsrc-xxsp(2))^2 )
          		rl=lvec(0)*(xsrc-xxsp(0)) $
				+lvec(1)*(ysrc-xxsp(1)) $
				+lvec(2)*(zsrc-xxsp(2))
			th = acos(rl/r)
			amout1 = 0.0*th
			for i=0,8 do begin
				amout1= amout1 + $
				( coeff(n-1,i)+f*(coeff(n,i)-coeff(n-1,i)) ) $
				*cos((2*i+1)*th) /rrss
			endfor

;  coeff was calculated for the source am=1 on the solar surface.
;  to make emergent flux=pi, am should be am=0.5.

		endelse
	endif

	am = [7.699525, -20.40468, 17.55048, -4.345321, 1.0,-0.5, 0.5]
	dm = [2.200483,  1.741699, 1.353484,  1.123245, 0.5, 1.0, 0.0]

	if not keyword_set(npoint) then npoint=4
	if npoint eq 1 then begin
		n1=6
		n2=6
	endif else $
	if npoint eq 2 then begin
		n1=4
		n2=5
	endif else begin
		n1=0
		n2=3
	endelse

;  sum(m)=0.5
;  sum(m/d**2)=1.0
;  normalized bb = roughly gaussian
;	 flux(z>0)=3.141592
;	 radius   =1.0
;	 bn at center=1.0
;  b=sum(bb*flux/area)


	x0 = x -xxsp(0)
	y0 = y -xxsp(1)
	z0 = z -xxsp(2)
	r0 = sqrt(x0*x0 +y0*y0 +z0*z0)

	bbx=0.0*bx
	bby=0.0*bx
	bbz=0.0*bx
	pp=0.0*bx

      dotnl = lvec(0)*nvecx +lvec(1)*nvecy +lvec(2)*nvecz
      amux = nvecx-dotnl*lvec(0)
      amuy = nvecy-dotnl*lvec(1)
      amuz = nvecz-dotnl*lvec(2)

	vnx1=nvecx
	vny1=nvecy
	vnz1=nvecz
	vnx2=vnx1-2.0*dotnl*lvec(0)
	vny2=vny1-2.0*dotnl*lvec(1)
	vnz2=vnz1-2.0*dotnl*lvec(2)

	for n=n1,n2 do begin
		x1=x-xsrc + a0*dm(n)*vnx1
		y1=y-ysrc + a0*dm(n)*vny1
		z1=z-zsrc + a0*dm(n)*vnz1
		x2=x-xsrc + a0*dm(n)*vnx2 +2*dotnl*rsp*lvec(0)
		y2=y-ysrc + a0*dm(n)*vny2 +2*dotnl*rsp*lvec(1)
		z2=z-zsrc + a0*dm(n)*vnz2 +2*dotnl*rsp*lvec(2)
		r1 =sqrt(x1*x1+y1*y1+z1*z1)
		r2 =sqrt(x2*x2+y2*y2+z2*z2)
		rm = x1*amux+y1*amuy+z1*amuz
		dr=lvec(0)*(x-xxsp(0)) $
			+lvec(1)*(y-xxsp(1)) $
		      +lvec(2)*(z-xxsp(2))
		dr1=lvec(0)*x1+lvec(1)*y1+lvec(2)*z1
		dr2=lvec(0)*x2+lvec(1)*y2+lvec(2)*z2
 
		sig = 0.0*r1 +1.0
		den1=r1+dr1
		den2=r2+dr2
		loc = where(dr lt 0.0, count)
		if count gt 0 then begin
			sig(loc) = -1.0
			den1(loc)=r1(loc)-dr1(loc)
			den2(loc)=r2(loc)-dr2(loc)
		endif

        	bbx=bbx+am(n)*( $
			dotnl*(x1/r1^3+x2/r2^3) $
			+rm*sig*(  x1/r1^3/den1 - x2/r2^3/den2 $
			+(x1/r1+sig*lvec(0))/r1/den1^2 $
			-(x2/r2+sig*lvec(0))/r2/den2^2 ) $
			-amux*sig*(1.0/(r1*den1)-1.0/(r2*den2)) $
			+( (sig*x1/r1+lvec(0))/den1 $
			- (sig*x2/r2+lvec(0))/den2 ) /(2.0*rsp)  )

        	bby=bby+am(n)*( $
			dotnl*(y1/r1^3+y2/r2^3) $
			+rm*sig*(  y1/r1^3/den1 - y2/r2^3/den2 $
			+(y1/r1+sig*lvec(1))/r1/den1^2 $
			-(y2/r2+sig*lvec(1))/r2/den2^2 ) $
			-amuy*sig*(1.0/(r1*den1)-1.0/(r2*den2)) $
			+( (sig*y1/r1+lvec(1))/den1 $
			- (sig*y2/r2+lvec(1))/den2 ) /(2.0*rsp)  )
        	bbz=bbz+am(n)*( $
			dotnl*(z1/r1^3+z2/r2^3) $
			+rm*sig*(  z1/r1^3/den1 - z2/r2^3/den2 $
			+(z1/r1+sig*lvec(2))/r1/den1^2 $
			-(z2/r2+sig*lvec(2))/r2/den2^2 ) $
			-amuz*sig*(1.0/(r1*den1)-1.0/(r2*den2)) $
			+( (sig*z1/r1+lvec(2))/den1 $
			- (sig*z2/r2+lvec(2))/den2 ) /(2.0*rsp)  )
		pp=pp+am(n)*( $
			dotnl*(1.0/r1+1.0/r2) $
			+rm*sig*(1.0/r1/den1-1.0/r2/den2) $
			+0.5*sig/rsp*alog(den2/den1) )
	endfor

	bx=bx+bbx*flx/pi
	by=by+bby*flx/pi
	bz=bz+bbz*flx/pi
	psi=psi+pp*flx/pi

;  inclusion of source surface

	if rrss gt 1.0 then begin
		x0 = x-xxsp(0)
		y0 = y-xxsp(1)
		z0 = z-xxsp(2)
		xo1 =x0- aout*vnx1
		yo1 =y0- aout*vny1
		zo1 =z0- aout*vnz1
		xo2 =x0- aout*vnx2
		yo2 =y0- aout*vny2
		zo2 =z0- aout*vnz2
		xi1 =x0- ain *vnx1
		yi1 =y0- ain *vny1
		zi1 =z0- ain *vnz1
		xi2 =x0- ain *vnx2
		yi2 =y0- ain *vny2
		zi2 =z0- ain *vnz2

		ro1=sqrt(xo1^2+yo1^2+zo1^2)
		ro2=sqrt(xo2^2+yo2^2+zo2^2)
		ri1=sqrt(xi1^2+yi1^2+zi1^2)
		ri2=sqrt(xi2^2+yi2^2+zi2^2)
		dro1=lvec(0)*xo1+lvec(1)*yo1+lvec(2)*zo1
		dro2=lvec(0)*xo2+lvec(1)*yo2+lvec(2)*zo2
		dri1=lvec(0)*xi1+lvec(1)*yi1+lvec(2)*zi1
		dri2=lvec(0)*xi2+lvec(1)*yi2+lvec(2)*zi2

		deni1=ri1+dri1
		deni2=ri2+dri2

		loc = where(dr lt 0.0, count)
		if count gt 0 then begin
			deni1(loc) = ri1(loc)-dri1(loc)
			deni2(loc) = ri2(loc)-dri2(loc)
		endif
		deno1 = ro1-dro1
		deno2 = ro2+dro2

;  sum(am)=0.5, amout=0.5
           	amout=0.5
           	amin= -(rsp/aout)*amout
		bbbx= - 0.5*amin/rsp*( $
			(sig*xi1/ri1+lvec(0))/deni1 $
			-(sig*xi2/ri2+lvec(0))/deni2 ) $
			+ 0.5*amout/rsp*( $
			(xo1/ro1-lvec(0))/deno1 +(xo2/ro2+lvec(0))/deno2)
 
		bbby= - 0.5*amin/rsp*( $
			(sig*yi1/ri1+lvec(1))/deni1 $
			-(sig*yi2/ri2+lvec(1))/deni2 ) $
			+ 0.5*amout/rsp*( $
			(yo1/ro1-lvec(1))/deno1 +(yo2/ro2+lvec(1))/deno2)
 
		bbbz= - 0.5*amin/rsp*( $
			(sig*zi1/ri1+lvec(2))/deni1 $
			-(sig*zi2/ri2+lvec(2))/deni2 ) $
			+ 0.5*amout/rsp*( $
			(zo1/ro1-lvec(2))/deno1 +(zo2/ro2+lvec(2))/deno2)
 
            ppp= 0.5d0*amin/rsp*sig*alog(deni1/deni2) $
			-0.5d0*amout/rsp*alog(deno1*deno2)

		flxm = flx*amout1
		bx=bx+bbbx*flxm/pi
		by=by+bbby*flxm/pi
		bz=bz+bbbz*flxm/pi
		psi=psi+ppp*flxm/pi
	endif

	if ss(0) eq 2 then begin
		bx = total(bx)
		by = total(by)
		bz = total(bz)
		psi = total(psi)
	endif


	return
end

;	generate a simulated magnetogram based on a
;	Green function monopole source

	common blkd, coord_d
	common blkt, coord_t

	nx = 81
	ny = 81
	xc = 0.0
	yc = 0.0
	dx = 0.2
	dy = 0.2
	rsp = 70.0
	bmax = 1000.0

	xxs = [0.0, 0.0, 0.0]
	xs=xxs(0)-8.0
	ys=xxs(1)-8.0

	xc = xs + dx*(nx/2)
	yc = ys + dy*(nx/2)

	mparam = defmp()

;	mparam.kindm = 2L	; pseudo vector
	mparam.kindm = 3L	; vector
	mparam.nbytem = 2
	mparam.nframe = 3
	mparam.tsys='GMT+09'
	mparam.inst='DUMMY'
	mparam.mfile='MONOPL'
	mparam.nx = nx
	mparam.ny = ny
	mparam.xs = xs
	mparam.ys = ys
	mparam.dx = dx
	mparam.dy = dy
	mparam.xxtod=[xc,yc]
	mparam.rsp = rsp
	mparam.mesh = 0
	mparam.title='MONOPOLE(SPHERICAL:BL)'

	rdata = fltarr(nx,ny,8)
	kz=0
	kx=1
	ky=2
	mparam.status.bl = kz
	mparam.status.bx = kx
	mparam.status.by = ky
	mparam.factors.bl=0.2
	mparam.factors.bx=0.2
	mparam.factors.by=0.2

	setdu, mparam
	settu, mparam
	setas, mparam

	xxsp = [0.0, 0.0, -rsp]

	x = fltarr(nx,ny)
	y = x
	z = x

	for j=0,ny-1 do x(*,j) = xs + dx*indgen(nx)
	for i=0,nx-1 do y(i,*) = ys + dy*indgen(ny)

	projs, x,y,z
	vnx = (x-xxsp(0))/rsp
	vny = (y-xxsp(1))/rsp
	vnz = (z-xxsp(2))/rsp

	a0=1.0
	b0=1000.0
	rrss=2.5
	field12, x,y,z,bx,by,bz,psi, a0=a0,b0=b0,xxs=xxs,rsp=rsp, rrss=rrss

	rdata(*,*,kx)=bx
	rdata(*,*,ky)=by
	rdata(*,*,kz)=bz
	br = bx*vnx+by*vny+bz*vnz

	pi=3.141592
	dx1 = 2*pi/(nx-1)
	dy1 = pi/(ny-1)
	ap = fltarr(nx,ny)
	al = ap
	h = 0*ap +rsp*(rrss-1)

	for j=0,ny-1 do ap(*,j) = -pi + dx1*indgen(nx)
	for i=0,nx-1 do al(i,*) = -0.5*pi + dy1*indgen(ny)
	stoc, ap,al,h, x1,y1,z1
	vnx = (x1-xxsp(0))/(rsp*rrss)
	vny = (y1-xxsp(1))/(rsp*rrss)
	vnz = (z1-xxsp(2))/(rsp*rrss)
	field12, x1,y1,z1,bx1,by1,bz1,psi, a0=a0,b0=b0,xxs=xxs,rsp=rsp, rrss=rrss
	br1 = bx1*vnx+by1*vny+bz1*vnz
	bp1 = sqrt( (bx1-br1*vnx)^2+(by1-br1*vny)^2+(bz1-br1*vnz)^2 )

	print, 'monopole (kindl=12) :'
	print, '  location=',xxs
	print, '  a0,b0=',a0,b0
	print, '  rsp=',rsp
	if rrss gt 1.0 then $
	print, '  rrss=',rrss
	print, '  nx,ny=',nx,ny
	print, '  xs,ys=',xs,ys,'  rsp=',rsp
	print, '  dx,dy=',dx,dy
	print, '  kindmo=',mparam.kindm

        xxs = [ [1.,0.,0.], [-1.,0.,0.] ]
        a0 = [1.0,1.0]
        b0=[1.0,1.0]
        for j=0,ny-1 do for i=0,nx-1 do begin
                field12, x(i,j),y(i,j),z(i,j),bx1,by1,bz1,psi1, $
                        a0=a0,b0=b0,xxs=xxs, rsp=rsp
                bx(i,j)=bx1
                by(i,j)=by1
                bz(i,j)=bz1
                psi(i,j)=psi1
        endfor

end

