;	called from vector1.pro

function fitmap, mparam,rdata, cosbp,cosbm,cosb1, bxp,byp,bt2,alpha2d, $
		alphas,btlim

	nx = long(mparam.nx)
	ny = long(mparam.ny)

	nbin = min([!d.x_vsize/(2*nx),!d.y_vsize/(2*ny)]) >1
	nxb = nx*nbin
	nyb = ny*nbin

	kx = kloc( mparam, /x)
	ky = kloc( mparam, /y)
	kz = kloc( mparam, /z)

	setcolor, bandwidth, w_start, rb_start, g_start, color8
	erase
	tv,w_start + bandwidth*bytscl( $
		rebin(cosb1^2,nxb,nyb))/256.0, $
		0, order=0
	tv,w_start + bandwidth*bytscl( $
		rebin(rdata(*,*,kz),nxb,nyb),min=-500,max=500)/256.0, $
		1, order=0
	tv,w_start + bandwidth*bytscl( $
		rebin(alpha2d,nxb,nyb))/256.0, $
		2, order=0

	buf = 0*cosb1 +color8.black
		; Bt < btlim (obs.Bt low accuracy)

	eps = 1.0e-3
	loc = where(bt2 gt btlim^2 and bxp^2 + byp^2 le btlim^2, count1)
	if count1 gt 0 then buf(loc) = color8.white
		; Btp < btlim (reference vector too small)

	loc = where(bt2 gt btlim^2 and bxp^2+byp^2 gt btlim and $
		cosbp*cosbm le 0, count2)
	if count2 gt 0 then buf(loc)= color8.yellow
		; Bt nearly perpendicular to Btp

	loc = where(bt2 gt btlim^2 and bxp^2+byp^2 gt btlim^2 and $
		cosbp*cosbm gt 0 and alpha2d ge 0 and $
		alpha2d lt max(alphas)-eps, count3)
	if count3 gt 0 then buf(loc) = color8.magenta
		; positive alpha fits better

	loc = where(bt2 gt btlim^2 and bxp^2+byp^2 gt btlim^2 and $
		cosbp*cosbm gt 0 and alpha2d lt 0 and $
		alpha2d gt min(alphas)+eps, count4)
	if count4 gt 0 then buf(loc) = color8.cyan
		; negative alpha fits better

	loc = where(bt2 gt btlim^2 and bxp^2+byp^2 gt btlim^2 and $
		cosbp*cosbm gt 0 and $
		alpha2d ge max(alphas)-eps, count5)
	if count5 gt 0 then buf(loc) = color8.red
		; maximum positive alpha fits better

	loc = where(bt2 gt btlim^2 and bxp^2+byp^2 gt btlim^2 and $
		cosbp*cosbm gt 0 and $
		alpha2d le min(alphas)+eps, count6)
	if count6 gt 0 then buf(loc) = color8.blue
		; maximum negative alpha fits better

	tv,rebin(buf,nxb,nyb),3, order=0

	print,'Btcal < btlim   : white, ', count1
	print,'Btobs perp Btcal: yellow,', count2
	print,'alpha > 0       : pink,  ', count3
	print,'alpha < 0       : cyan,  ', count4
	print,'alpha = +max    : red,   ', count5
	print,'alpha = -max    : blue,  ', count6

	return, buf
end

