pro ftconv, h,img,q,u,v
;
; write flare telescope data to a file with MAGPACK2's standard format
 -- ftconv, h,img,q,u,v
;
	magfile = ' '
	read,'enter output file name > ',magfile
	openw, u_mag, magfile, /get_lun

	mhdr1 = def_mhdr1()

	kindm	= -1011L
	nbytem	=h.nbyt
	nframe	=4
	nx	=h.nx
	ny	=h.ny
	xs	=0.0
	ys	=0.0
	dx	=0.05
	dy	=-0.05
	ydeg	=0.0
	mesh	=0
	rsp	=69.7
	pdeg	=0.0
	b0deg	=0.0
	cl0deg	=0.0
	xt	=0.0
	yt	=0.0

	mhdr1.kindm	=string(kindm, format='(i8)')
	mhdr1.nbytem	=string(nbytem, format='(i4)')
	mhdr1.nframe	=string(nframe, format='(i4)')
	mhdr1.nx	=string(nx, format='(i4)')
	mhdr1.ny	=string(ny, format='(i4)')
	mhdr1.xs	=string(xs, format='(f12.5)')
	mhdr1.ys	=string(ys, format='(f12.5)')
	mhdr1.dx	=string(dx, format='(f12.5)')
	mhdr1.dy	=string(dy, format='(f12.5)')
	mhdr1.ydeg	=string(ydeg, format='(f12.5)')
	mhdr1.mesh	=string(mesh, format='(i4)')
	mhdr1.rsp 	=string(rsp,  format='(f12.5)')
	mhdr1.pdeg	=string(pdeg, format='(f12.5)')
	mhdr1.b0deg	=string(b0deg, format='(f12.5)')
	mhdr1.cl0deg	=string(cl0deg, format='(f12.5)')
	mhdr1.xt  	=string(xt  , format='(f12.5)')
	mhdr1.yt  	=string(yt  , format='(f12.5)')

	mhdr1.inst='MTK/FT1 '
	mhdr1.tsys=	string( h.time_sys, format='(a6)')
	mhdr1.obsdate = string( h.date1, format='(a8)')
	mhdr1.stime	= string( h.time1, format='(a8)')
	mhdr1.etime	= string( h.time2, format='(a8)')
	mhdr1.mfile	= string( h.obs_id, format='(a8)')
	mhdr1.inst	= string( h.observatory, h.telescope, format='(a4,a4)')

	writeu, u_mag, mhdr1

	print,'parameters written to ',magfile
	print,'kind,nbyte,nframe=',kindm,nbytem,nframe
	print,'fileid=',mhdr1.mfile
	print,'inst=',mhdr1.inst
	print,'systime=',mhdr1.tsys
	print,'obsdate=',mhdr1.obsdate
	print,'stime,etime=',mhdr1.stime,'  ',mhdr1.etime
	print,'ftag=',mhdr1.ftag
	print,'nx,ny=',nx,ny
	print,'xs,ys=',xs,ys
	print,'dx,dy=',dx,dy
	print,'ydeg,mesh=',ydeg,mesh
	print,'rsp,p,b0,cl0=',rsp,pdeg,b0deg,cl0deg
	print,'xt,yt=',xt,yt
	print,'title=',mhdr1.title

	factor = 1.0/float(max(img))
	mhdr2 = def_mhdr2( spec='I       ', factor=factor )
	print,'spec,factor=',mhdr2.spec,mhdr2.factor

	writeu, u_mag, mhdr2
	writeu, u_mag, img

	nlast = (long(nbytem)*long(nx)*long(ny)) mod 80
	if ( nlast ne 0 ) then begin
		padstr = replicate(' ', 80 - nlast )
		writeu, u_mag, padstr
		end

	factor	=0.0001
	mhdr2 = def_mhdr2( spec='Q       ', factor=factor )
	print,'spec,factor=',mhdr2.spec,mhdr2.factor

	writeu, u_mag, mhdr2
	writeu, u_mag, q
	if ( nlast ne 0 ) then begin
		padstr = replicate(' ', 80 - nlast )
		writeu,u_mag,padstr
		end

	mhdr2 = def_mhdr2( spec='U       ', factor=factor )
	print,'spec,factor=',mhdr2.spec,mhdr2.factor

	writeu, u_mag, mhdr2
	writeu, u_mag, u
	if ( nlast ne 0 ) then begin
		padstr = replicate(' ', 80 - nlast )
		writeu,u_mag,padstr
		end

	mhdr2 = def_mhdr2( spec='V       ', factor=factor )
	print,'spec,factor=',mhdr2.spec,mhdr2.factor

	writeu, u_mag, mhdr2
	writeu, u_mag, v
	if ( nlast ne 0 ) then begin
		padstr = replicate(' ', 80 - nlast )
		writeu,u_mag,padstr
		end
	stat = fstat(u_mag)
	print, 'data size in bytes = ',stat.cur_ptr
	return
	end
