;  for a specified location (x,y),
;  get a new mesh location (i,j) and fractional coordinates (xr,yr)
;  old mesh : origin at (xs,ys), increment=(dx,dy)
;
function getij, nx,ny,xs,ys,dx,dy,x,y,i,j,xr,yr
;
	eps=0.01
	bordercheck = 1
;
	i=fix( (x-xs)/dx )
	j=fix( (y-ys)/dy )
	xr=(x-xs)/dx-i
	yr=(y-ys)/dy-j

	if bordercheck eq 0 then goto, skip

	loc = where( i eq -1 and xr gt 1.0-eps )
	if (loc(0) ge 0) then begin
		i(loc)=0
		xr(loc)=xr(loc)-1.0
	endif
	loc = where( j eq -1 and yr gt 1.0-eps)
	if (loc(0) ge 0) then begin
		j(loc)=0
		yr(loc)=yr(loc)-1.0
	endif
	loc = where( i eq nx-1 and xr lt eps)
	if (loc(0) ge 0) then begin
		i(loc)=nx-2
		xr(loc)=xr(loc)+1.0
	endif
	loc = where( j eq ny-1 and yr lt eps )
	if (loc(0) ge 0) then begin
		j(loc)=ny-2
		yr(loc)=yr(loc)+1.0
	endif

skip:
	loc = where( i ge 0 and i lt nx and j ge 0 and j lt ny)
	return, loc
end
