;+
; NAME :	lof
; PURPOSE :
;	submit background job for computing field lines based on
;	a magnetogram of Solar Flare Telescope
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	.run lof
; INPUTS :
;	following data should be on the memory
;	h = norikura header
;	img = intensity image
;	q, u, v = Stokes polarization parameters
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; OUTPUTS :
;	data file of magpack2 standard format will be created
; COMMON BLOCKS : 	none
; SIDE EFFECTS :	arrays mparam and rdata will be created
; RESTRICTIONS :	X-window environment is assumed
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1994/10
;-
;------------------------------------------------------------------------
;
convft1, h,img,q,u,v, mparam, rdata, nxnew=64
pol2b, mparam, rdata

if strmid(fnam0,13,2) eq '.p' then app='' else app='.'
dir='/solar/flare/fieldlines/'
mfile = dir +'FB'+strmid(fnam0, 2,12) +app+'D'
lfile = dir +'FB'+strmid(fnam0, 2,12) +app+'L'

control = dir + 'control.dat'
spawn,'echo $$',processid
fnamefile = dir + getenv('HOST') + '_' +processid(0) + '.dat'
listfile  = dir + getenv('HOST') + '_' +processid(0) + '.lst'

writem, mparam, rdata, filename=mfile
print,'filenames written to :',fnamefile

openw,unit,fnamefile,/get_lun
printf, unit, control
printf, unit, mfile
printf, unit, lfile
free_lun, unit
close, unit

yn=' '
read,'submit this job? ',yn
str = '/home/sakurai/magpack2/prog < '+ fnamefile
if yn eq 'y' or yn eq 'Y' then begin
	spawn, str +' >& '+ listfile + ' &'
	spawn,'ps -x'
	print,'list output written to :',listfile
endif else begin
	print, 'this job can be executed by typing:'
	print, str
endelse
	
end


