;+
; NAME :	lspec
; PURPOSE :
;	find the tag number of status structure corresponding to 
;	the data in rdata(*,*,k)
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	tagno = lspec( mparam, k)
; INPUTS :
;	mparam, k
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;
; OUTPUTS :
;	if rdata(*,*,k) contains 'BL', 
;	mparam.status.(tagno) is mparam.status.bl, and
;	specs(tagno) = 'BL'
;
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 2000/10/11
;-
;------------------------------------------------------------------------
;
function lspec, mparam, k

	specs = defspecs(nspec)
	for i=0, nspec-1 do begin
		k1 = mparam.status.(i)
		if k eq k1 then return, i
	endfor
	return, -1
end
