;  add/subtract 2*pi and make ap's compatible with longitudes of
;  spherical coordinates specified by 'mesh'

pro modulo, ap,mesh1

	np = n_elements(ap)

;  np = 2 or 6

	pi = 3.14159265
	halfpi = 1.5707963
	pi2=2.0*pi
	e=1.0e-3

;  mesh points 0,2,4 are eastern mesh points
;  mesh points 1,3,5 are western mesh points
;  modulo 2*pi adjustments are done for all odd- or even-numbered
;  mesh points as a group

;  for mesh=2,3: -pi < ap < pi, cl0eff=0
;  for mesh=4:     0 < ap, cl0eff < 2*pi

	if mesh1 eq 4 then begin
		if ap(0) lt 0.0-e then begin
			ap(0)=ap(0)+ pi2*fix((-ap(0)+pi2)/pi2)
		endif else $
		if ap(0) gt pi2+e then begin
			ap(0)=ap(0)- pi2*fix((ap(0)-pi2+pi2)/pi2)
		endif else $
		if ap(0) gt pi2+e then begin
			ap(0)=ap(0)- pi2*fix((ap(0)-pi2+pi2)/pi2)
		endif
	endif else begin
		if ap(0) lt -pi-e then begin
			ap(0)=ap(0)+ pi2*fix((pi-ap(0))/pi2)
		endif else $
		if ap(0) gt pi+e then begin
			ap(0)=ap(0)- pi2*fix((ap(0)+pi)/pi2)
		endif
	endelse

;  points 0,2,4 should have nearly the same ap
;  points 1,3,5 should have nealry the same ap

	if np gt 2 then begin
		for n=2,np-1,2 do begin
			if ap(n)-ap(0) lt -pi then begin
				ap(n)=ap(n)+pi2*fix((pi+ap(0)-ap(n))/pi2)
			endif else $
			if ap(n)-ap(0) gt pi then begin
				ap(n)=ap(n)-pi2*fix((pi+ap(n)-ap(0))/pi2)
			endif
		endfor
		for n=3,np-1,2 do begin
			if ap(n)-ap(1) lt -pi then begin
				ap(n)=ap(n)+pi2*fix((pi+ap(1)-ap(n))/pi2)
			endif else $
			if ap(n)-ap(1) gt pi then begin
				ap(n)=ap(n)-pi2*fix((pi+ap(n)-ap(1))/pi2)
			endif
		endfor
	endif

;  longitude extent should be smaller than 360 deg
;  points 1,3,5 must be westward of point 0

	if ap(1)-ap(0) gt pi2+e then begin
		for n=1,np-1,2 do $
			ap(n)=ap(n)- pi2*fix((ap(n)-ap(0))/pi2)
	endif else $
	if ap(1)-ap(0) lt 0.0-e then begin
		for n=1,np-1,2 do $
			ap(n)=ap(n)+ pi2*fix((ap(0)-ap(n)+pi2)/pi2)
	endif

;  as a result, -pi < ap < 3*pi for mesh1=2,3
;                 0 < ap < 4*pi for mesh1=4

	return
end
