;+
; NAME :	printmp
; PURPOSE :
;	printmp, mparam
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	print the contents of mparam
; INPUTS :
;	mparam
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	print mparam on screen
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;-
;------------------------------------------------------------------------
;
pro printmp, mparam
;
	pi = 3.141592
	ydeg = 180.0*mparam.ypos/pi
	pdeg = 180.0*mparam.prad/pi
	b0deg = 180.0*mparam.b0rad/pi
	cl0deg = 180.0*mparam.cl0rad/pi

	print,'kindm,nbytem,nframe=',mparam.kindm,mparam.nbytem,mparam.nframe
	print,'fileid=',mparam.mfile
	print,'inst=',mparam.inst
	print,'systime=',mparam.tsys
	print,'dateo=',mparam.dateo
	print,'stime,etime=',mparam.stime,'  ',mparam.etime
	print,'ftag=',mparam.ftag
	print,'nx,ny=',mparam.nx,mparam.ny
	print,'xs,ys=',mparam.xs,mparam.ys
	print,'dx,dy=',mparam.dx,mparam.dy
	print,'ydeg,mesh=',ydeg,mparam.mesh
	print,'rsp,p,b0,cl0=',mparam.rsp,pdeg,b0deg,cl0deg
	print,'xxtod=',mparam.xxtod
	print,'title=',mparam.title

	return
end
