;**************************************************************************
; NAME       : projtest (main)
; PURPOSE    : make face-on magnetograms (plane or spherical)
; CALLING SEQUENCE :
;	.run projtest
; INPUTS :
;     none
; KEYWORD PARAMETERS :
;     none
; OUTPUTS :
;     none
; SIDE EFFECTS : 
; 
; MODIFICATION HISTORY :
;	T.Sakurai,  1993/2
;==========================================================================
;

@transc.pro

dir='/scr1/sakurai/920814/'
fnam='f1a'
spawn,'pwd',olddir	&	olddir=olddir(0)
cd,dir
;
; whole obs.
spawn,'ls  '+fnam+'??0',files
iref=2
;
; first peak
; spawn,'ls  '+fnam+'{12?,13?}',files
; iref=1
;
; second peak
; spawn,'ls  '+fnam+'{15?,160}',files
; iref=0

mesho=0
print,'convert to face-on data? 0=no, 1=to planar, 3=to spherical'
read,mesho

norder=0
ndiv=1
monitor=0
print,'correlation tracking: -1=no, or norder(0,1,2) for polywarp'
read,norder

diff=0
; print,'take difference, 0=no, 1=yes, 2=interactive'
print,'take difference, 0=no, 1=yes'
read,diff
;
cd,olddir
factx=1.0
facty=1.0

;	correct errors in guide stage read-out
dxs0=0.0
dys0=0.0
; print,'enter dxs0,dys0'
; read, dxs0,dys0
dxs0=3.64
dys0=0.7
print,'assumed dxs0,dys0=',dxs0,dys0

pause='y'
print,'pause when screen is full? (y/n)'
read,pause

; wx=1140 ;x-width of basic window
; wy=800	;y-width of basic window
wx=900 ;x-width of basic window
wy=300	;y-width of basic window
dx=5	;x-interval bitween images
dy=5	;y-interval bitween images

window, xsize=wx, ysize=wy

n=n_elements(files)
bin=2
times=strarr(n)

loadct,0
f1data,files(iref),h0,img0,bx0,by0,bl0,dir=dir
convft1, h0,img0,bx0,by0,bl0, mparam0,rdata0, bin=bin
ki=mparam0.status.i
kz=mparam0.status.bl
kx=mparam0.status.bx
ky=mparam0.status.by
mparam0.status.bx=-1
mparam0.status.by=-1
mparam0.nframe=2
mparam0.xs = mparam0.xs+ dxs0
mparam0.ys = mparam0.ys+ dys0
date0 = mparam0.obsdate
time0 = mparam0.stime

cgspot,rdata0(*,*,ki),ic0,jc0
; print,'ic0,jc0 before transm=',ic0,jc0
times(0)=mparam0.stime
	
if (mesho eq 1) then begin
	mparam0.xxtod(0) = mparam0.xs + mparam0.dx*ic0
	mparam0.xxtod(1) = mparam0.ys + mparam0.dy*jc0
endif
if (mesho eq 3) then begin
	mparam0.cl0rad = 0.0
	coord_d = setdu(mparam0)
	coord_r = setar(mparam0)
	xs0 = mparam0.xs
	ys0 = mparam0.ys
	projr, xs0,ys0,zs0, apr0,alr0, coord_d,coord_r
	print,'xs0,ys0,zs0=',xs0,ys0,zs0
	print,'apr0,alr0=',180*apr0/!pi,180*alr0/!pi
;	rtod, apr0,alr0,0.0, xs,ys,zs, coord_r, coord_d
;	print,'check xs0,ys0=',xs,ys
endif

bl0 = rdata0(*,*,kz)

if (mesho ge 1) then transm, mparam0, rdata0, mesho=mesho
nx0=mparam0.nx
ny0=mparam0.ny
blsave=intarr(nx0,ny0,n)

mx0 = fix(factx*nx0)	&	my0 = fix(facty*ny0)
kx=wx/(mx0+dx)
ky=wy/(my0+dy)
cgspot, rdata0(*,*,ki),ic0,jc0
center0=[ic0,jc0]
x0 = dx
y0 = wy -(my0+dy)
; print,'ic0,jc0 after transm=',ic0,jc0

bmax = max(abs(rdata0(*,*,kz)))
rb= byte( rdata0(*,*,kz)/bmax*127.0 + 128.0)
tv,rebin(rb, mx0,my0), x0,y0,/dev,order=0

xyouts,x0+80,y0+10,time0,/dev,charsize=2,color=230

omega = 13.2	; carringron rate is 13.2

for i=0, n-1 do begin
	f1data,files(i),h,img,bx,by,bl,dir=dir
	convft1, h,img,bx,by,bl, mparam,rdata, bin=bin
	cgspot, rdata(*,*,ki),ic,jc
;	print,'ic,jc before transm=',ic,jc
	times(i)=mparam.stime
	mparam.status.bx=-1
	mparam.status.by=-1
	mparam.nframe=2
	
	bl = rdata(*,*,kz)
	bl1=bl

	cgspot, rdata(*,*,ki),ic,jc
;	print,'ic,jc after transm=',ic,jc
	center=[ic,jc]
	deli = 0.0 & delj = 0.0 

	if(norder ge 0) then $
      		corralgn, bl0,bl, center0,center, $
      		ndiv=ndiv,norder=norder, $
      		monitor=monitor,  $
      		warpedimage=bl1 $
	else $
		bl1 = rshift(bl,ic0-ic+deli,jc0-jc+delj,missing=0)

	if (mesho eq 1) then begin
		mparam.xxtod(0) = mparam.xs + mparam.dx*ic
		mparam.xxtod(1) = mparam.ys + mparam.dy*jc
	endif
	if (mesho eq 3) then begin
		mparam.cl0rad =  $
		- timediff(date0,time0, mparam.obsdate,mparam.stime, $
			/day)*omega/180.0*3.141592
		coord_r = setar( mparam )
		rtod, apr0,alr0,0.0, xs,ys,zs, coord_r, coord_d
		mparam.xs = xs
		mparam.ys = ys
		print,'xs,ys=',xs,ys
;		projr, xs,ys,zs, apr,alr, coord_d, coord_r
;		print,'check apr,alr=',180*apr/!pi,180*alr/!pi
	endif

	rdata(*,*,kz)=bl1
	if (mesho ge 1) then transm, mparam, rdata, mesho=mesho
	nx=mparam.nx	&	ny=mparam.ny

	mx = min([nx,nx0]) 	&	my = min([ny,ny0]) 
	blsave(*,*,i)=intarr(nx0,ny0)

	if (mesho eq 3) then begin
		deli = mparam.xs/mparam.dx - mparam0.xs/mparam0.dx
		delj = mparam.ys/mparam.dy - mparam0.ys/mparam0.dy
		rdata(*,*,kz) = shift(rdata(*,*,kz), deli, delj)
print,deli,delj

	endif
	
	blsave( 0:(mx-1), 0:(my-1),i)=fix(10.0*rdata(0:(mx-1),0:(my-1),kz))
; 		unit=0.1 gauss
	bldiff = blsave(*,*,i) - blsave(*,*,iref)
	x0 = dx + (mx0+dx) * ( i-i/kx*kx ) 
	y0 = wy-(my0+dy) - (my0+dy) * ( i/kx - (i/kx)/ky*ky )
	if diff eq 0 then begin
		bmax = float(max(abs(blsave(*,*,i))))
		rb= byte( blsave(*,*,i)/bmax*127.0 + 128.0)
		tv,rebin(rb, mx0,my0), x0,y0,/dev,order=0
	endif else begin
		bmax = float(max(abs(bldiff)))
		rb= byte( bldiff/bmax*127.0 + 128.0)
		tv,rebin(rb, mx0,my0), x0,y0,/dev,order=0
	endelse
;
	date=mparam.obsdate
	time=mparam.stime
	xyouts,x0+80,y0+10,time,/dev,charsize=2,color=230
	if(i+1-(i+1)/(kx*ky)*(kx*ky) eq 0) and (pause eq 'y') then begin
		ret=''
		read,'pause;  hit <RET> to continue (e <RET> to escape) : ',ret
		if( ret eq 'e' ) then goto,endl
		erase
	endif
endfor

endl:
end
