;+
; NAME :	saveft1
; PURPOSE : convert data of solar flare telescope to the standard
;		data format of MAGPACK2
;
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;		.run saveft1
; INPUTS :
;		name of the input data file should be given as fnam0
;		(show.pro sets fnam0)
;		arrays h,img,q,u,v (or bx,by,bl) should exist in the memory
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; OUTPUTS :
;
; COMMON BLOCKS : 	none
; SIDE EFFECTS :
; RESTRICTIONS :	X-window environment is assumed
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;	1995.7 distinction between (q,u,v) and (bx,by,bl)
;-
;------------------------------------------------------------------------
;
nx=h(0).nx
nxnew=nx
print,'enter nxnew, now nx=',nx
read,nxnew

if h(1).correct gt 100 then $
	convft1, h,img,bx,by,bl, mparam, rdata, nxnew=nxnew $
else $
	convft1, h,img,q,u,v, mparam, rdata, nxnew=nxnew

pol2b, mparam, rdata
curlb1, mparam, rdata, /keep_bp

if strmid(fnam0,13,2) eq '.p' then app='' else app='.'

mfile = '/solar/flare/fieldlines/FB'+strmid(fnam0, 2,12) +app+'d'

; 	mfile = '/solar/flare/fieldlines/FB'+strmid(fnam0, 2,12) +app+'D'

lfile = '/solar/flare/fieldlines/FB'+strmid(fnam0, 2,12) +app+'L'

writem, mparam, rdata, filename=mfile
print,'output file=',mfile
print,'create data file for field line computation? (y/n)'
yn=''
read,yn
if yn eq 'n' or yn eq 'N' then goto, nofile

seqno=0
countup:	seqno=seqno+1
	datafile='/home/wind/solar/data/fname'+string(seqno,format='(i2.2)')+'.dat'
	exist=findfile(datafile,count=count)
	if count gt 0 then goto, countup

print,'data file =',datafile
openw, unit, datafile, /get_lun
printf, unit, ''
printf, unit, mfile
printf, unit, lfile
close, unit
free_lun, unit
nofile:
dispm, mparam, rdata, /nomenu
end

