;+
; NAME :	setlevel
; PURPOSE :
;	set contour levels for magnetograms (dispm,plotm)
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	
; OUTPUTS :
;	none
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	produce arrays 
; RESTRICTIONS :	X-window environment is assumed
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1994
;-
;------------------------------------------------------------------------
;
pro setlevel,mparam,rdata, $
	oaodefault=oaodefault, $
	title1,intlevels,dummylevels,bplevels,bmlevels,dplevels,dmlevels, $
	jplevels,jmlevels,fplevels,fmlevels, $
	bunit,dunit,iunit,junit,funit

	title1 = strtrim(mparam.inst,2) +'  '+ mparam.dateo +' '+ $
		mparam.stime +' - '+ mparam.etime +'('+ $
		strtrim(mparam.tsys,2)  +')  '+ mparam.mfile

	intlevels = [ 0.05, 0.5, 0.6, 0.7, 0.8, 0.85, 0.9 ]
	dummylevels = - rotate(intlevels, 2)

	if keyword_set(oaodefault) then $
		bplevels = [ 18.,36.,91.,182.,370.,1030.,2800. ] $
;		this gives the same contours as in old calibration with
;		levels=10,20,50,100,200,500,1000 for OAO magnetogram
;
	else $
		bplevels = [ 10.,20.,50.,100.,200.,500.,1000. ]	

	bmlevels = - rotate(bplevels, 2)
	dplevels = [200.,400.,600.,800.,1000.]
	dmlevels = - rotate(dplevels, 2)
;	jplevels  = [100.0, 200.0, 500.0, 1000.0, 2000.0, 5000.0, 10000.0]
;	jplevels  = [200.0, 500.0, 1000.0, 2000.0, 5000.0, 10000.0]
	jplevels  = [500.0, 1000.0, 2000.0, 5000.0, 10000.0]
	jmlevels = - rotate(jplevels, 2)
	fplevels = [100.0, 200.0, 500.0, 1000.0, 2000.0, 5000.0, 10000.0]
	fmlevels = - rotate(fplevels, 2)

	bunit= '(G)'
	dunit= '(m/sec)'
	iunit= ' '
	junit= '(G/10**4 km)'
	funit= ' '

return
end

