;+
; NAME :	strlevel
; PURPOSE :
;	set a string indicating contour levels
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	str = strlevel(plevels)
; INPUTS :
;	plevels : an array of positive values indicating contour levels
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	str : a string
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1993
;	TS 1994/10: bug fix ( ii=long(...) instead of fix(...) )
;-
;------------------------------------------------------------------------
;
function strlevel, plevels

	str = ''
	dim = size(plevels)
	n = fix(dim(1))

	for i=0, n-1 do begin
		if plevels(i) ge 10.0 then begin
			ii = long(plevels(i) + 0.1)
			str = str+ $ 
			strcompress( string( ii,format='(i10)'), /remove_all) + ','
		endif else begin
			str1 = strcompress( string( plevels(i) + 0.0000001, $ 
				format='(f10.8)') )
			for j=2, 7 do begin
				if strmid(str1, j, 1) ne '0' then goto, escape1
			endfor
			j = 7
		escape1:
			jj = strpos( str1, '0', j) < j+3
			str = str + strmid(str1, 0, jj) +','
		endelse
	endfor
	len = strlen(str)
	str = strmid( str, 0, len-1)
	return, str
	end
