;	transformation of (nx,ny),(xs,ys),(dx,dy)
;	called from transm.pro

pro transf, mparam, mesh2, $
	nx2,ny2,xs2,ys2,dx2,dy2,xe2,ye2

	common blkr, coord_r

	pi = 3.141592

	parity=1
;  if parity=true, mesh sizes before and after the transform
;  have the same 'parity' (if nxold is even, nxnew is even, for example)

;  mesh points 1,3,5 are eastern mesh points
;  mesh points 2,4,6 are western mesh points
;  modulo 2*pi adjustments are done for all odd- or even-numbered
;  mesh points as a group

	xs1 = mparam.xs
	ys1 = mparam.ys
	dx1 = mparam.dx
	dy1 = mparam.dy
	nx1 = mparam.nx
	ny1 = mparam.ny
	rsp = mparam.rsp
	mesh1 = mparam.mesh

;  from T- to D-grid
	if mesh1 eq 1 then begin
		xtmesh=[xs1, xs1+dx1*(nx1-1), xs1+dx1*(nx1-1), xs1]
		ytmesh=[ys1, ys1, ys1+dy1*(ny1-1), ys1+dy1*(ny1-1)]
		ztmesh=[0,0,0,0]

		ttod, xtmesh,ytmesh,ztmesh, xdmesh,ydmesh,zdmesh

		xs2=min(xdmesh)
		ys2=min(ydmesh)
		xe2=max(xdmesh)
		ye2=max(ydmesh)
		dx2=abs(dx1)
		dy2=abs(dy1)
		nx2 = fix( (xe2 - xs2 )/dx2 +1.5 )
		ny2 = fix( (ye2 - ys2 )/dy2 +1.5 )
		if parity then begin
			if (nx2 mod 2) ne (nx1 mod 2) then nx2=nx2+1
			if (ny2 mod 2) ne (ny1 mod 2) then ny2=ny2+1
		endif

		dx2 = (xe2 - xs2 )/float(nx2-1)
		dy2 = (ye2 - ys2 )/float(ny2-1)

;  from S- or R-grid to D-grid
        endif else if mesh1 ge 2 then begin

		cl0eff = coord_r.cl0eff

		apmesh = [xs1, xs1+dx1*(nx1-1), xs1+dx1*(nx1-1), xs1, $
			xs1, xs1+dx1*(nx1-1) ]
		almesh = [alofy(ys1), alofy(ys1), $
			alofy(ys1+dy1*(ny1-1)), alofy(ys1+dy1*(ny1-1)), $
			0, 0 ]
		if apmesh(0)-cl0eff ge -pi and $
		   apmesh(0)-cl0eff lt -0.5*pi then begin
			apmesh(4)=cl0eff-0.5*pi
		endif else $
		if apmesh(0)-cl0eff gt 0.5*pi and $
		   apmesh(0)-cl0eff lt pi then begin
			apmesh(4)=cl0eff+0.5*pi
		endif else $
		if apmesh(0)-cl0eff ge pi and $
		   apmesh(0)-cl0eff lt 1.5*pi then begin
			apmesh(4)=cl0eff+1.5*pi
		endif

		if apmesh(1)-cl0eff ge -pi and $
		   apmesh(1)-cl0eff lt -0.5*pi then begin
			apmesh(5)=cl0eff-0.5*pi
		endif else $
		if apmesh(1)-cl0eff gt 0.5*pi and $
		   apmesh(1)-cl0eff lt pi then begin
			apmesh(5)=cl0eff+0.5*pi
		endif else $
		if apmesh(1)-cl0eff ge pi and $
		   apmesh(1)-cl0eff lt 1.5*pi then begin
			apmesh(5)=cl0eff+1.5*pi
		endif else $
		if apmesh(1)-cl0eff gt 2.5*pi and $
		   apmesh(1)-cl0eff lt 3.0*pi then begin
			apmesh(5)=cl0eff+2.5*pi
		endif else $
		if apmesh(1)-cl0eff ge 3.0*pi and $
		   apmesh(2)-cl0eff lt 3.5*pi then begin
			apmesh(5)=cl0eff+3.5*pi
		endif

		if almesh(0)*almesh(2) lt 0 then begin
			almesh(4)=0.0
		endif else begin
			if abs(almesh(0)) lt abs(almesh(2)) then $
				almesh(4)=almesh(0) $
			else	almesh(4)=almesh(2)
		endelse

		if almesh(1)*almesh(3) lt 0 then begin
			almesh(5)=0.0
		endif else begin
			if abs(almesh(1)) lt abs(almesh(3)) then $
				almesh(5)=almesh(1) $
			else	almesh(5)=almesh(3)
		endelse

		modulo,apmesh,mesh1

;  data behind the limb have been eliminated

		hmesh = 0.0*apmesh
		rtod, apmesh,almesh,hmesh, xdmesh,ydmesh,zdmesh

		xs2=min(xdmesh)
		ys2=min(ydmesh)
		xe2=max(xdmesh)
		ye2=max(ydmesh)
		dx2=abs(dx1)*rsp
		dy2=alofy(abs(dy1))*rsp
		nx2 = fix( (xe2 - xs2 )/dx2 +1.5 )
		ny2 = fix( (ye2 - ys2 )/dy2 +1.5 )
		if parity then begin
			if (nx2 mod 2) ne (nx1 mod 2) then nx2=nx2+1
			if (ny2 mod 2) ne (ny1 mod 2) then ny2=ny2+1
		endif
		dx2 = ( xe2 - xs2 )/(nx2-1)
		dy2 = ( ye2 - ys2 )/(ny2-1)
	endif

;  from D- to T-grids

	if mesh2 eq 1 then begin
		xdmesh=[xs1,xs1+dx1*(nx1-1),xs1+dx1*(nx1-1),xs1]
		ydmesh=[ys1,ys1, ys1+dy1*(ny1-1),ys1+dy1*(ny1-1)]
		zdmesh = 0.0*xdmesh

		dtoc, xdmesh,ydmesh,zdmesh, xmesh,ymesh,zmesh
		projt, xmesh,ymesh,zmesh, xtmesh,ytmesh, /extend

		xs2=min(xtmesh)
		ys2=min(ytmesh)
		xe2=max(xtmesh)
		ye2=max(ytmesh)
		dx2=abs(dx1)
		dy2=abs(dy1)
		nx2 = fix( (xe2 - xs2 )/dx2 +1.5 )
		ny2 = fix( (ye2 - ys2 )/dy2 +1.5 )
		if parity then begin
			if (nx2 mod 2) ne (nx1 mod 2) then nx2=nx2+1
			if (ny2 mod 2) ne (ny1 mod 2) then ny2=ny2+1
		endif

		dx2 = (xe2 - xs2 )/float(nx2-1)
		dy2 = (ye2 - ys2 )/float(ny2-1)

;  from D- to S- or R-grid
	endif else if mesh2 ge 2 then begin

		xdmesh=[xs1,xs1+dx1*(nx1-1),xs1+dx1*(nx1-1),xs1, $
			  xs1, xs1+dx1*(nx1-1)]
		ydmesh=[ys1,ys1, ys1+dy1*(ny1-1),ys1+dy1*(ny1-1), $
			  0, 0 ]
		zdmesh = 0.0*xdmesh

		if ydmesh(0)*ydmesh(2) lt 0 then begin
			ydmesh(4)=0.0
		endif else begin
			if abs(ydmesh(0)) lt abs(ydmesh(2)) then $
				ydmesh(4)=ydmesh(0) $
			else	ydmesh(4)=ydmesh(2)
		endelse

		if ydmesh(1)*ydmesh(3) lt 0 then begin
			ydmesh(5)=0.0
		endif else begin
			if abs(ydmesh(1)) lt abs(ydmesh(3)) then $
				ydmesh(5)=ydmesh(1) $
			else	ydmesh(5)=ydmesh(3)
		endelse

		dtoc, xdmesh,ydmesh,zdmesh, xmesh,ymesh,zmesh
		projr, xmesh,ymesh,zmesh, apmesh,almesh, /extend

		modulo,apmesh,mesh2
		xs2=min(apmesh)
		xe2=max(apmesh)
		dx2=abs(dx1)/rsp
		ys2=yofal(min(almesh))
		ye2=yofal(max(almesh))
		dy2=yofal(abs(dy1)/rsp)
		nx2 = fix( (xe2 - xs2 )/dx2 +1.5 )
		ny2 = fix( (ye2 - ys2 )/dy2 +1.5 )
		if parity then begin
			if (nx2 mod 2) ne (nx1 mod 2) then nx2=nx2+1
			if (ny2 mod 2) ne (ny1 mod 2) then ny2=ny2+1
		endif
		dx2 = ( xe2 - xs2 )/(nx2-1)
		dy2 = ( ye2 - ys2 )/(ny2-1)

	endif

	return
end

