;  conversion of velocity field
;  from (v, m3 of kindm1) to (vnew, m3new of kindm2) by assuming V//n
;  called from transm.pro

;  m3=1(VL),2(Vn),3(Vr)

pro transv, m3,m3new,v,vnew,vxnew,vynew,x,y,z, $
	cfmax=cfmax

	common blkd, coord_d
	common blkt, coord_t
	common blks, coord_s
	common blkr, coord_r

;  cfmax in mparam.fc (default=5.0) is the maximum correction factor
;  to be applied
;  if the correction factor is larger than this, make the data as
;  unfilled

	uflval, ufl
	if not keyword_set(cfmax) then cfmax=5.0

	zdu = coord_d.zdu
	ztu = coord_t.ztu

	vnew=v

; from vl
	if m3 eq 1 then begin
		if m3new eq 2 then begin
;   to vn
			vnvl=total(zdu*ztu)
			if abs(vnvl) gt 1.0/cfmax then $
				vnew=v/vnvl $
			else	vnew=v*0 + ufl
		endif else $
		if m3new eq 3 then begin
;   to vr
			projs, x,y,z, ap,al
			svu, ap,al, apu,alu,hu
			vnvl=zdu(0)*hu(0,*)+zdu(1)*hu(1,*)+zdu(2)*hu(2,*)
			vnew= v*0 + ufl
			loc = where(abs(vnvl) gt 1.0/cfmax and ap ne ufl, count)
			if count gt 0 then vnew(loc)=v(loc)/vnvl
		endif

	  vxnew=v*0.0
	  vynew=v*0.0
	  return
	endif

;  from vn
	if m3 eq 2 then begin
;    to vvect
		vx=ztu(0)*v
		vy=ztu(1)*v
		vz=ztu(2)*v

;  from vr
	endif else $
	if m3 eq 3 then begin
;    to vvect
		projs, x,y,z, ap,al
		svu, ap,al, apu,alu,hu
		vx=hu(0,*)*v
		vy=hu(1,*)*v
		vz=hu(2,*)*v
		loc = where(ap eq ufl,count)
		if count gt 0 then begin
			vx(loc)=ufl
			vy(loc)=ufl
			vz(loc)=ufl
		endif
	endif

;  from vvect to vnew
	vectoc, vx,vy,vz, vxnew,vynew,vnew, x,y,z

	return
end

