c  calcomp to cgi/xcgi(displib) interface subroutines
c
c  plots(x,y,imode)
c  plot(x,y,mode)
c  symbol(x,y,h,str,angle,nchar)
c  scale(f)
c  newpen(ipen)
c  plote()
c
c  f77 ,,, /home/common/plotlib/displib.o
c          /home/common/displib/disp-lbp.o
c          /home/common/lbplib/lips2lib.o (or other printer driver)
c	     /home/common/displib/x11lib.o -lX11 (or other display driver)
c
      subroutine plots(x,y,imode)
c
c  initialize the device and set the origin at (x,y)
c
c	imode: 1 -- lbp = portrait  orientation, with cgi/xcgi output
c	       2 --       landscape orientation, with cgi/xcgi output
c	      -1 -- lbp = portrait  orientation, no   cgi/xcgi output
c	      -2 --       landscape orientation, no   cgi/xcgi output
c	       0 -- no lbp output (cgi/xcgi only)
c
	character str*(*)
	dimension ixx(2),iyy(2)
	integer line,pconv
	save xo,yo,scalefactor,imode0,ixx,iyy,line
	dimension ir(8),ig(8),ib(8)
c
	data ir/255, 255,   0,   0,  255,  255,   0, 0/
	data ig/255,   0, 255,   0,  255,    0, 255, 0/
	data ib/255,   0,   0, 255,    0,  255, 255, 0/
c  color no.   1     2     3     4     5     6     7     8
c            white  red  green  blue yellow pink  cyan  black
c
c  calcomp routines: unit=1cm
c  lbp               unit=1/10mm
c
c  scale conversion :
	pconv(coord, org) = 100.0 * ( scalefactor * coord + org )
c  x-size = B5-size, y-size = screen height -2cm
	maxy=2010
	maxx=1820
c
	imode0=imode
	scalefactor = 1.0
	xo = 0.0
	yo = 0.0
	ixx(1) = pconv(x, xo)
	iyy(1) = pconv(y, yo)
	xo = x
	yo = y
	line=1
	call initialize(imode)
	call vdcextent(0,0,maxx,maxy)
c  viewport units in 1/10mm 
c  origin = lower left corner
	call viewportunits(1)
	call viewport(0,maxy,maxx,0)
c
c*  origin = upper left
c*     call viewport(0,0,maxx,maxy)
c
c*	call fontindex(2)
c*	call chrwidth(0.5)
c*     call chrspacing(-0.4) 
c
	do 10 i=1,8
 10	call colortable(i,1,ir(i),ig(i),ib(i))
c
c  color specification = indexed color
	return
c
	entry plot(x,y,mode)
c
c  |mode|=3: move point to (x,y)
c        12: draw short-dashed line to (x,y)
c        22: draw dotted line to (x,y)
c        32: draw dot-dashed line to (x,y)
c        42: draw long-dhashed line to (x,y)
c       999: print out
c      >999: erase output
c  if mode<0, origin is moved to (x,y)
c
	if(mode.ge.999) then
	  ixx(1) = pconv(x, xo)
	  iyy(1) = pconv(y, yo)
	  if(mode.eq.999) then
	    call hcopy
	  else
	    call clear
	  endif
	  return
	endif
c
	ixx(2)= pconv( x , xo )
	iyy(2)= pconv( y , yo )
c
	if(iabs(mode)/10+1.ne.line) then
	  line=iabs(mode)/10+1
	  call linetype(line)
	endif
c
	if (mod(iabs(mode),10).eq.2) then
	  call polyline(2,ixx,iyy)
	else 
	  call polyline(1,ixx(2),iyy(2))
	endif
	ixx(1)=ixx(2)
	iyy(1)=iyy(2)
	if (mode.lt.0) then
	  xo=xo+x*scalefactor
	  yo=yo+y*scalefactor
	endif
	return
c
	entry symbol(x,y,h,str,angle,nchar)
c
	ixx(1) = pconv( x , xo)
	iyy(1) = pconv( y , yo)
	angleu=angle+90.0
c
	if (nchar.ge.0) then
	  call chrorientation(angle,angleu)
	  call chrheight(pconv(h, 0.0))
 	  call text(ixx(1),iyy(1),str)
	else
c	  call markersize(ih)
	  n = -nchar
	  if ( n .lt. 1 ) n = 1
	  if ( n .gt. 5 ) n = 1
	  call markertype(n)
	  call polymarker(1,ixx(1),iyy(1))
	endif
	return
c 
	entry factor(f)
	scalefactor = f
	return
c
	entry newpen(ipen)
c
	ipen1=mod(ipen,10)
	call linecolor(ipen1,0,0)
	call markercolor(ipen1,0,0)
	call textcolor(ipen1,0,0)
c
	fpen=ipen/10+1
	call linefwidth(fpen)
	return
c
      entry plote
c
      call terminate
      return
      end
